<?xml version="1.0"?>


<st-source>


<do-it>| aString aParcel |
aString := 'Jpl'.
aParcel := Parcel parcelNamed: aString.
aParcel isNil ifTrue: [aParcel := Parcel createParcelNamed: aString]</do-it>


<class>
<name>JplStreamEncoder</name>
<environment>Smalltalk</environment>
<super>Core.StreamEncoder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Localization-Japan</category>
<attributes>
<package>Jpl</package>
</attributes>
</class>


<class>
<name>JplEucStreamEncoder</name>
<environment>Smalltalk</environment>
<super>JplStreamEncoder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Localization-Japan</category>
<attributes>
<package>Jpl</package>
</attributes>
</class>


<class>
<name>JplJisStreamEncoder</name>
<environment>Smalltalk</environment>
<super>JplStreamEncoder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>rstate wstate </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Localization-Japan</category>
<attributes>
<package>Jpl</package>
</attributes>
</class>


<class>
<name>JplSjisStreamEncoder</name>
<environment>Smalltalk</environment>
<super>JplStreamEncoder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Localization-Japan</category>
<attributes>
<package>Jpl</package>
</attributes>
</class>


<class>
<name>JplAutoStreamEncoder</name>
<environment>Smalltalk</environment>
<super>JplJisStreamEncoder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>readEncodingType writeEncodingType </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Localization-Japan</category>
<attributes>
<package>Jpl</package>
</attributes>
</class>


<class>
<name>JplSystem</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars>enhancements </class-inst-vars>
<imports></imports>
<category>Jpl-System-Support</category>
<attributes>
<package>Jpl</package>
</attributes>
</class>


<do-it>#(
'JplStreamEncoder.st'
'JplEucStreamEncoder.st'
'JplJisStreamEncoder.st'
'JplSjisStreamEncoder.st'
'JplAutoStreamEncoder.st'
'JplSystem.st'
)
	 do:
		[:aString |
		| parcelName jplVersion separatorString directoryString |
		parcelName := 'Jpl'.
		jplVersion := 'Jpl023'.
		separatorString := String with: Filename separator.
		directoryString := Filename currentDirectory asString.
		directoryString last = Filename separator
			ifTrue: [directoryString := directoryString , jplVersion , separatorString]
			ifFalse: [directoryString := directoryString , separatorString , jplVersion , separatorString].
		(Parcel parcelNamed: parcelName) fileIntoFrom: (Filename named: directoryString , aString).
		ScheduledControllers restore.
		ObjectMemory globalGarbageCollect]</do-it>


<do-it>JplSystem install</do-it>


</st-source>
