<?xml version="1.0"?>

<st-source>


<class>
<name>JplAutoStreamEncoder</name>
<environment>Smalltalk</environment>
<super>JplJisStreamEncoder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>readEncodingType writeEncodingType </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Localization-Japan</category>
<attributes>
<package>Jpl</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>JplAutoStreamEncoder class</class-id> <category>class initialization</category>

<body package="Jpl" selector="install">install
	"JplAutoStreamEncoder install."

	StreamEncoder updateEncoderDirectory</body>
</methods>

<methods>
<class-id>JplAutoStreamEncoder class</class-id> <category>accessing</category>

<body package="Jpl" selector="streamEncodingType">streamEncodingType
	^#JapaneseAutoDetect</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>JplAutoStreamEncoder</class-id>
<body>Jpl022 (2007/03/12)</body>
</comment>

<methods>
<class-id>JplAutoStreamEncoder</class-id> <category>accessing</category>

<body package="Jpl" selector="encodingType:">encodingType: aSymbol 
	readEncodingType := aSymbol.
	writeEncodingType := aSymbol</body>

<body package="Jpl" selector="nextFrom:">nextFrom: aStream 
	| c1 c2 |
	readEncodingType == #JIS ifTrue: [^self jisNextFrom: aStream].
	readEncodingType == #JapaneseEUC ifTrue: [^self eucjisNextFrom: aStream].
	readEncodingType == #ShiftJIS ifTrue: [^self sjisNextFrom: aStream].
	[(c1 := aStream next) == 27] whileTrue: 
			[c2 := aStream next.
			c2 == 40 
				ifTrue: 
					[| c3 |
					c3 := aStream next.
					c3 == 66 
						ifTrue: 
							[rstate := #ascii.
							readEncodingType := #JIS]
						ifFalse: 
							[(c3 == 74 or: [c3 == 72]) 
								ifTrue: 
									[rstate := #jisRoman.
									readEncodingType := #JIS]
								ifFalse: 
									[c3 == 73 
										ifTrue: 
											[rstate := #halfKana.
											readEncodingType := #JIS]
										ifFalse: 
											[aStream skip: (c3 == nil ifTrue: [-1] ifFalse: [-2]).
											^Character esc]]]]
				ifFalse: 
					[c2 == 36 
						ifTrue: 
							[| c3 |
							c3 := aStream next.
							(c3 == 66 or: [c3 == 64]) 
								ifTrue: 
									[rstate := #kanji.
									readEncodingType := #JIS]
								ifFalse: 
									[c3 == 40 
										ifTrue: 
											[| c4 |
											c4 := aStream next.
											c4 == 68 
												ifTrue: 
													[rstate := #hojoKanji.
													readEncodingType := #JIS]
												ifFalse: 
													[aStream skip: (c4 == nil ifTrue: [-2] ifFalse: [-3]).
													^Character esc]]
										ifFalse: 
											[aStream skip: (c3 == nil ifTrue: [-1] ifFalse: [-2]).
											^Character esc]]]
						ifFalse: 
							[c2 == nil ifFalse: [aStream skip: -1].
							^Character esc]]].
	c1 == nil ifTrue: [^nil].
	readEncodingType == #JIS 
		ifTrue: 
			[rstate == #ascii 
				ifTrue: 
					[c1 &lt;= 16r7F ifTrue: [^c1 asCharacter] ifFalse: [^JISX201Encoder decode: c1]].
			rstate == #jisRoman ifTrue: [^JISX201Encoder decode: c1].
			rstate == #kanji 
				ifTrue: 
					[c2 := aStream next.
					c2 == nil ifTrue: [^nil].
					^JISX208Encoder decode: (c1 bitShift: 8) + c2].
			rstate == #hojoKanji 
				ifTrue: 
					[c2 := aStream next.
					c2 == nil ifTrue: [^nil].
					^JISX212Encoder decode: (c1 bitShift: 8) + c2].
			(rstate == #halfKana and: [16r21 &lt;= c1 and: [c1 &lt;= 16r5F]]) 
				ifTrue: [^JISX201Encoder decode: c1 + 16r80].
			^Character illegalCode asCharacter].
	c1 &lt;= 16r7F ifTrue: [^c1 asCharacter].
	c1 &lt; 16rA0 
		ifTrue: 
			[readEncodingType := #ShiftJIS.
			^self 
				sjisNextFrom: aStream
				with: c1
				with: aStream next].
	c1 &lt; 16rE0 
		ifTrue: 
			[readEncodingType := #JapaneseEUC.
			^self 
				eucjisNextFrom: aStream
				with: c1
				with: aStream next].
	c2 := aStream next.
	c2 &lt; 16rA0 
		ifTrue: 
			[readEncodingType := #ShiftJIS.
			^self 
				sjisNextFrom: aStream
				with: c1
				with: c2].
	^self 
		eucjisNextFrom: aStream
		with: c1
		with: c2</body>

<body package="Jpl" selector="nextPut:on:">nextPut: aCharacter on: aStream 
	writeEncodingType == #JIS 
		ifTrue: [^self jisNextPut: aCharacter on: aStream].
	writeEncodingType == #JapaneseEUC 
		ifTrue: [^self eucjisNextPut: aCharacter on: aStream].
	writeEncodingType == #ShiftJIS 
		ifTrue: [^self sjisNextPut: aCharacter on: aStream].
	^self noEncodingFor: aCharacter</body>

<body package="Jpl" selector="prepareToClose:">prepareToClose: aStream 
	writeEncodingType == #JIS ifTrue: [super prepareToClose: aStream]</body>

<body package="Jpl" selector="readEncodingType">readEncodingType
	^readEncodingType</body>

<body package="Jpl" selector="readEncodingType:">readEncodingType: aSymbol 
	readEncodingType := aSymbol</body>

<body package="Jpl" selector="reset">reset
	super reset.
	readEncodingType := nil</body>

<body package="Jpl" selector="writeEncodingType">writeEncodingType
	^writeEncodingType</body>

<body package="Jpl" selector="writeEncodingType:">writeEncodingType: aSymbol 
	writeEncodingType := aSymbol</body>
</methods>

<methods>
<class-id>JplAutoStreamEncoder</class-id> <category>private</category>

<body package="Jpl" selector="eucjisNextFrom:with:with:">eucjisNextFrom: aStream with: c1 with: c2 
	c2 == nil ifTrue: [^nil].
	(16rA1 &lt;= c1 and: [c1 &lt;= 16rFE]) 
		ifFalse: 
			[c1 == 16r8E 
				ifTrue: [^JISX201Encoder decode: c2]
				ifFalse: 
					[c1 == 16r8F 
						ifTrue: 
							[| c3 |
							c3 := aStream next.
							c3 == nil ifTrue: [^nil].
							^JISX212Encoder decode: ((c2 bitShift: 8) + c3 bitXor: 16r8080)]
						ifFalse: [^Character illegalCode asCharacter]]].
	^JISX208Encoder decode: ((c1 bitShift: 8) + c2 bitXor: 16r8080)</body>

<body package="Jpl" selector="sjisNextFrom:with:with:">sjisNextFrom: aStream with: c1 with: c2 
	c2 == nil ifTrue: [^nil].
	^ShiftJISEncoder decode: (c1 bitShift: 8) + c2</body>
</methods>

<methods>
<class-id>JplAutoStreamEncoder</class-id> <category>initialize-release</category>

<body package="Jpl" selector="initialize">initialize
	super initialize.
	writeEncodingType := Locale current defaultStreamEncoder 
				streamEncodingType</body>
</methods>

</st-source>
