<?xml version="1.0"?>

<st-source>


<class>
<name>JplJisStreamEncoder</name>
<environment>Smalltalk</environment>
<super>JplStreamEncoder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>rstate wstate </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Localization-Japan</category>
<attributes>
<package>Jpl</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>JplJisStreamEncoder class</class-id> <category>class initialization</category>

<body package="Jpl" selector="install">install
	"JplJisStreamEncoder install."

	StreamEncoder updateEncoderDirectory</body>
</methods>

<methods>
<class-id>JplJisStreamEncoder class</class-id> <category>accessing</category>

<body package="Jpl" selector="streamEncodingType">streamEncodingType
	^#JIS</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>JplJisStreamEncoder</class-id>
<body>Jpl022 (2007/03/12)</body>
</comment>

<methods>
<class-id>JplJisStreamEncoder</class-id> <category>accessing</category>

<body package="Jpl" selector="jisNextFrom:">jisNextFrom: aStream 
	| c1 c2 |
	[(c1 := aStream next) == 27] whileTrue: 
			[c2 := aStream next.
			c2 == 40 
				ifTrue: 
					[| c3 |
					c3 := aStream next.
					c3 == 66 
						ifTrue: [rstate := #ascii]
						ifFalse: 
							[(c3 == 74 or: [c3 == 72]) 
								ifTrue: [rstate := #jisRoman]
								ifFalse: 
									[c3 == 73 
										ifTrue: [rstate := #halfKana]
										ifFalse: 
											[aStream skip: (c3 == nil ifTrue: [-1] ifFalse: [-2]).
											^Character esc]]]]
				ifFalse: 
					[c2 == 36 
						ifTrue: 
							[| c3 |
							c3 := aStream next.
							(c3 == 66 or: [c3 == 64]) 
								ifTrue: [rstate := #kanji]
								ifFalse: 
									[c3 == 40 
										ifTrue: 
											[| c4 |
											c4 := aStream next.
											c4 == 68 
												ifTrue: [rstate := #hojoKanji]
												ifFalse: 
													[aStream skip: (c4 == nil ifTrue: [-2] ifFalse: [-3]).
													^Character esc]]
										ifFalse: 
											[aStream skip: (c3 == nil ifTrue: [-1] ifFalse: [-2]).
											^Character esc]]]
						ifFalse: 
							[c2 == nil ifFalse: [aStream skip: -1].
							^Character esc]]].
	c1 == nil ifTrue: [^nil].
	rstate == #ascii 
		ifTrue: 
			[c1 &lt;= 16r7F ifTrue: [^c1 asCharacter] ifFalse: [^JISX201Encoder decode: c1]].
	rstate == #jisRoman ifTrue: [^JISX201Encoder decode: c1].
	rstate == #kanji 
		ifTrue: 
			[c2 := aStream next.
			c2 == nil ifTrue: [^nil].
			^JISX208Encoder decode: (c1 bitShift: 8) + c2].
	rstate == #hojoKanji 
		ifTrue: 
			[c2 := aStream next.
			c2 == nil ifTrue: [^nil].
			^JISX212Encoder decode: (c1 bitShift: 8) + c2].
	(rstate == #halfKana and: [16r21 &lt;= c1 and: [c1 &lt;= 16r5F]]) 
		ifTrue: [^JISX201Encoder decode: c1 + 16r80].
	^Character illegalCode asCharacter</body>

<body package="Jpl" selector="jisNextPut:on:">jisNextPut: aCharacter on: aStream 
	| jis |
	jis := aCharacter asInteger.
	jis &lt;= 16r7F 
		ifTrue: 
			[wstate == #ascii 
				ifFalse: 
					[aStream nextPutAll: #[27 40 66].
					wstate := #ascii].
			aStream nextPut: jis.
			^aCharacter].
	jis := JISX208Encoder encode: aCharacter.
	jis &lt; 16rFFFF 
		ifTrue: 
			[wstate == #kanji 
				ifFalse: 
					[aStream nextPutAll: #[27 36 66].
					wstate := #kanji].
			aStream
				nextPut: (jis bitShift: -8);
				nextPut: (jis bitAnd: 16rFF).
			^aCharacter].
	jis := JISX212Encoder encode: aCharacter.
	jis &lt; 16rFFFF 
		ifTrue: 
			[wstate == #hojoKanji 
				ifFalse: 
					[aStream nextPutAll: #[27 36 40 68].
					wstate := #hojoKanji].
			aStream
				nextPut: (jis bitShift: -8);
				nextPut: (jis bitAnd: 16rFF).
			^aCharacter].
	jis := JISX201Encoder encode: aCharacter.
	jis &lt;= 16rFF 
		ifTrue: 
			[jis &lt;= 16r7F 
				ifTrue: 
					[wstate == #jisRoman 
						ifFalse: 
							[aStream nextPutAll: #[27 40 74].
							wstate := #jisRoman].
					aStream nextPut: jis]
				ifFalse: 
					[wstate == #halfKana 
						ifFalse: 
							[aStream nextPutAll: #[27 40 73].
							wstate := #halfKana].
					aStream nextPut: jis - 16r80].
			^aCharacter].
	^self noEncodingFor: aCharacter</body>

<body package="Jpl" selector="nextFrom:">nextFrom: aStream 
	^self jisNextFrom: aStream</body>

<body package="Jpl" selector="nextPut:on:">nextPut: aCharacter on: aStream 
	^self jisNextPut: aCharacter on: aStream</body>

<body package="Jpl" selector="prepareToClose:">prepareToClose: aStream 
	(aStream isWritable and: [wstate ~~ #ascii]) 
		ifTrue: 
			[aStream nextPutAll: #[27 40 66].
			wstate := #ascii]</body>

<body package="Jpl" selector="reset">reset
	rstate := #ascii.
	wstate := #ascii</body>
</methods>

</st-source>
