<?xml version="1.0"?>

<st-source>


<class>
<name>JplStreamEncoder</name>
<environment>Smalltalk</environment>
<super>Core.StreamEncoder</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Localization-Japan</category>
<attributes>
<package>Jpl</package>
</attributes>
</class>

<shared-variable>
<name>JISX212Encoder</name>
<environment>JplStreamEncoder</environment>
<private>false</private>
<constant>false</constant>
<category>Localization-Japan</category>
<attributes>
<package>Jpl</package>
</attributes>
</shared-variable>

<shared-variable>
<name>JISX201Encoder</name>
<environment>JplStreamEncoder</environment>
<private>false</private>
<constant>false</constant>
<category>Localization-Japan</category>
<attributes>
<package>Jpl</package>
</attributes>
</shared-variable>

<shared-variable>
<name>JISX208Encoder</name>
<environment>JplStreamEncoder</environment>
<private>false</private>
<constant>false</constant>
<category>Localization-Japan</category>
<attributes>
<package>Jpl</package>
</attributes>
</shared-variable>

<shared-variable>
<name>ShiftJISEncoder</name>
<environment>JplStreamEncoder</environment>
<private>false</private>
<constant>false</constant>
<category>Localization-Japan</category>
<attributes>
<package>Jpl</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>JplStreamEncoder class</class-id> <category>class initialization</category>

<body package="Jpl" selector="install">install
	"JplStreamEncoder install."

	CharacterEncoder checkMiscCharacterSets.
	StreamEncoder updateEncoderDirectory.
	JISX201Encoder := CharacterEncoder encoderNamed: #'jisx0201.1976-0'.
	JISX208Encoder := CharacterEncoder encoderNamed: #'jisx0208.1983-0'.
	JISX212Encoder := CharacterEncoder encoderNamed: #'jisx0212.1990-0'.
	Object errorSignal 
		handle: [:exception | ShiftJISEncoder := CharacterEncoder encoderNamed: #kanji]
		do: [ShiftJISEncoder := CharacterEncoder encoderNamed: #ShiftJIS]</body>
</methods>

<methods>
<class-id>JplStreamEncoder class</class-id> <category>accessing</category>

<body package="Jpl" selector="streamEncodingType">streamEncodingType
	^nil</body>
</methods>

<methods>
<class-id>JplStreamEncoder class</class-id> <category>private</category>

<body package="Jpl" selector="defaultCharacterEncoder">defaultCharacterEncoder
	^nil</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>JplStreamEncoder</class-id>
<body>Jpl022 (2007/03/12)</body>
</comment>

<methods>
<class-id>JplStreamEncoder</class-id> <category>accessing</category>

<body package="Jpl" selector="eucjisNextFrom:">eucjisNextFrom: aStream 
	| c1 c2 |
	c1 := aStream next.
	c1 == nil ifTrue: [^nil].
	c1 &lt;= 16r7F ifTrue: [^c1 asCharacter].
	c2 := aStream next.
	c2 == nil ifTrue: [^nil].
	(16rA1 &lt;= c1 and: [c1 &lt;= 16rFE]) 
		ifFalse: 
			[c1 == 16r8E 
				ifTrue: [^JISX201Encoder decode: c2]
				ifFalse: 
					[c1 == 16r8F 
						ifTrue: 
							[| c3 |
							c3 := aStream next.
							c3 == nil ifTrue: [^nil].
							^JISX212Encoder decode: ((c2 bitShift: 8) + c3 bitXor: 16r8080)]
						ifFalse: [^Character illegalCode asCharacter]]].
	^JISX208Encoder decode: ((c1 bitShift: 8) + c2 bitXor: 16r8080)</body>

<body package="Jpl" selector="eucjisNextPut:on:">eucjisNextPut: aCharacter on: aStream 
	| euc |
	euc := aCharacter asInteger.
	euc &lt;= 16r7F 
		ifTrue: 
			[aStream nextPut: euc.
			^aCharacter].
	euc := JISX208Encoder encode: aCharacter.
	euc &lt;= 16rFFFF 
		ifTrue: 
			[aStream
				nextPut: (euc bitShift: -8) + 16r80;
				nextPut: (euc bitAnd: 16rFF) + 16r80.
			^aCharacter].
	euc := JISX212Encoder encode: aCharacter.
	euc &lt;= 16rFFFF 
		ifTrue: 
			[aStream
				nextPut: 16r8F;
				nextPut: (euc bitShift: -8) + 16r80;
				nextPut: (euc bitAnd: 16rFF) + 16r80.
			^aCharacter].
	euc := JISX201Encoder encode: aCharacter.
	euc &lt;= 16rFF 
		ifTrue: 
			[aStream
				nextPut: 16r8E;
				nextPut: euc.
			^aCharacter].
	^self noEncodingFor: aCharacter</body>

<body package="Jpl" selector="sjisNextFrom:">sjisNextFrom: aStream 
	| c1 c2 |
	c1 := aStream next.
	c1 == nil ifTrue: [^nil].
	((16r81 &lt;= c1 and: [c1 &lt;= 16r9F]) or: [16rE0 &lt;= c1 and: [c1 &lt;= 16rFC]]) 
		ifFalse: [^ShiftJISEncoder decode: c1].
	c2 := aStream next.
	c2 == nil ifTrue: [^nil].
	"((16r40 &lt;= c2 and: [c2 &lt;= 16r7E]) or: [16r80 &lt;= c2 and:[c2 &lt;= 16rFC]])
		ifTrue: [^ShiftJISEncoder decode: (c1 bitShift: 8) + c2]
		ifFalse: [^Character illegalCode asCharacter]"
	^ShiftJISEncoder decode: (c1 bitShift: 8) + c2</body>

<body package="Jpl" selector="sjisNextPut:on:">sjisNextPut: aCharacter on: aStream 
	| sjis |
	sjis := ShiftJISEncoder encode: aCharacter.
	sjis &lt;= 16rFF 
		ifTrue: 
			[aStream nextPut: sjis.
			^aCharacter].
	sjis &lt;= 16rFFFF 
		ifTrue: 
			[aStream
				nextPut: (sjis bitShift: -8);
				nextPut: (sjis bitAnd: 16rFF).
			^aCharacter].
	^self noEncodingFor: aCharacter</body>
</methods>

<methods>
<class-id>JplStreamEncoder</class-id> <category>querying</category>

<body package="Jpl" selector="characterSize:">characterSize: aCharacter 
	^aCharacter asInteger &lt;= 127 ifTrue: [1] ifFalse: [2]</body>
</methods>

</st-source>
