<?xml version="1.0"?>

<st-source>


<class>
<name>JplSystem</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars>enhancements </class-inst-vars>
<imports></imports>
<category>Jpl-System-Support</category>
<attributes>
<package>Jpl</package>
</attributes>
</class>

<shared-variable>
<name>MemorisedFonts</name>
<environment>JplSystem</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>Jpl</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>JplSystem class</class-id> <category>class initialization</category>

<body package="Jpl" selector="initialize">initialize
	"JplSystem initialize."

	enhancements := nil.
	"self install"</body>

<body package="Jpl" selector="initializeDefaultFont">initializeDefaultFont
	"JplSystem initializeDefaultFont."

	(UISettings preferenceModelFor: #textSize)
		value: #default.
	UISettings textSizeReset.
	TextAttributes setDefaultTo: #default.
	TextAttributes resetViews.
	InputManager platformHookup.
	Locale setDefault.
	Filename defaultClass install.
	Screen default receiveAndProcessAllEvents</body>

<body package="Jpl" selector="initializeEnhancements">initializeEnhancements
	"JplSystem initializeEnhancements."

	self
		encoderNamedInCharacterEncoderClass;
		encoderNamedIfAbsentInCharacterEncoderClass;
		yourself;
		checkMiscCharacterSetsInCharacterEncoderClass;
		createByteEncoderInCharacterEncoderClass;
		createLargeCharacterEncoderInCharacterEncoderClass;
		installMiscCharacterSetsInCharacterEncoderClass;
		uninstallMiscCharacterSetsInCharacterEncoderClass;
		yourself;
		iso885914EncoderInCharacterEncoderClass;
		iso885915EncoderInCharacterEncoderClass;
		iso88591EncoderInCharacterEncoderClass;
		iso88592EncoderInCharacterEncoderClass;
		iso88593EncoderInCharacterEncoderClass;
		iso88594EncoderInCharacterEncoderClass;
		iso88595EncoderInCharacterEncoderClass;
		iso88596EncoderInCharacterEncoderClass;
		iso88597EncoderInCharacterEncoderClass;
		iso88598EncoderInCharacterEncoderClass;
		iso88599EncoderInCharacterEncoderClass;
		yourself;
		jisx0201EncoderInCharacterEncoderClass;
		jisx0208EncoderInCharacterEncoderClass;
		jisx0212EncoderInCharacterEncoderClass;
		shiftJISEncoderInCharacterEncoderClass;
		yourself;
		cp437EncoderInCharacterEncoderClass;
		cp737EncoderInCharacterEncoderClass;
		cp775EncoderInCharacterEncoderClass;
		cp850EncoderInCharacterEncoderClass;
		cp852EncoderInCharacterEncoderClass;
		cp855EncoderInCharacterEncoderClass;
		cp857EncoderInCharacterEncoderClass;
		cp860EncoderInCharacterEncoderClass;
		cp861EncoderInCharacterEncoderClass;
		cp862EncoderInCharacterEncoderClass;
		cp863EncoderInCharacterEncoderClass;
		cp864EncoderInCharacterEncoderClass;
		cp865EncoderInCharacterEncoderClass;
		cp866EncoderInCharacterEncoderClass;
		cp869EncoderInCharacterEncoderClass;
		cp874EncoderInCharacterEncoderClass;
		yourself;
		cp1250EncoderInCharacterEncoderClass;
		cp1251EncoderInCharacterEncoderClass;
		cp1252EncoderInCharacterEncoderClass;
		cp1253EncoderInCharacterEncoderClass;
		cp1254EncoderInCharacterEncoderClass;
		cp1255EncoderInCharacterEncoderClass;
		cp1256EncoderInCharacterEncoderClass;
		cp1257EncoderInCharacterEncoderClass;
		cp1258EncoderInCharacterEncoderClass;
		yourself.
	self
		nextInEncodedStream;
		nextPutInEncodedStream;
		skipInEncodedStream;
		yourself.
	self
		installJapaneseUtf8LocaleX11InLocaleClass;
		installJapaneseEucLocaleX11InLocaleClass;
		installJapaneseSjisLocaleWindowsInLocaleClass;
		installJapaneseLocalesInLocaleClass;
		uninstallJapaneseLocalesInLocaleClass;
		yourself.
	self
		installJapaneseEncodingsInScreenFontClass;
		uninstallJapaneseEncodingsInScreenFontClass;
		yourself.
	self
		displayInsertionPointForOnInTextEditorView;
		yourself.
	self
		redefineWindowsInputManager;
		initializeInWindowsInputManager;
		reinitializeInWindowsInputManager;
		retrieveConvertedTextInWindowsInputManager;
		styleInWindowsInputManager;
		yourself</body>

<body package="Jpl" selector="initializeKanjiFamiliesForWinFont">initializeKanjiFamiliesForWinFont
	"JplSystem initializeKanjiFamiliesForWinFont."

	| aCollection |
	Locale platformName = #win32 ifFalse: [^nil].
	aCollection := OrderedCollection new.
	aCollection add: #('terminal' 8 #small).
	aCollection add: #('terminal' 13 #default).
	aCollection add: #('terminal' 13 #systemDefault).
	aCollection add: #('terminal' 18 #large).
	aCollection add: #('terminal' 13 #fixed).
	aCollection
		do: 
			[:anArray | 
			| fontDescription characterAttributes textAttributes deviceFont |
			fontDescription := FontDescription new.
			fontDescription family: (anArray at: 1).
			fontDescription pixelSize: (anArray at: 2).
			fontDescription boldness: 0.5.
			fontDescription italic: false.
			fontDescription outline: false.
			fontDescription shadow: false.
			fontDescription underline: false.
			fontDescription fixedWidth: false.
			fontDescription serif: false.
			fontDescription strikeout: false.
			fontDescription encodings: Locale current preferredEncodings.
			characterAttributes := CharacterAttributes newWithDefaultAttributes.
			characterAttributes setDefaultQuery: fontDescription.
			textAttributes := TextAttributes new.
			textAttributes setCharacterAttributes: characterAttributes.
			self errorSignal handle: [:exception | ]
				do: 
					[deviceFont := Screen default defaultFontPolicy findFont: fontDescription.
					textAttributes lineGrid: deviceFont height.
					textAttributes baseline: deviceFont ascent].
			TextAttributes styleNamed: (anArray at: 3)
				put: textAttributes]</body>

<body package="Jpl" selector="install">install
	"JplSystem install."

	self initializeEnhancements.
	self classes 
		do: [:each | (each ~= self and: [each respondsTo: #install]) ifTrue: [each install]].
	Locale installJapaneseLocales.
	self installFont</body>

<body package="Jpl" selector="installFont">installFont
	"JplSystem installFont."

	MemorisedFonts ifNil: 
			[MemorisedFonts := Dictionary new.
			MemorisedFonts at: #systemDefault
				ifAbsentPut: [TextAttributes styleNamed: #systemDefault ifAbsent: [nil]].
			MemorisedFonts at: #default
				ifAbsentPut: [TextAttributes styleNamed: #default ifAbsent: [nil]].
			MemorisedFonts at: #small
				ifAbsentPut: [TextAttributes styleNamed: #small ifAbsent: [nil]].
			MemorisedFonts at: #large
				ifAbsentPut: [TextAttributes styleNamed: #large ifAbsent: [nil]].
			MemorisedFonts at: #fixed
				ifAbsentPut: [TextAttributes styleNamed: #fixed ifAbsent: [nil]]].
	2 timesRepeat: 
			[self initializeKanjiFamiliesForWinFont.
			self initializeDefaultFont]</body>

<body package="Jpl" selector="uninstall">uninstall
	"JplSystem uninstall."

	Locale uninstallJapaneseLocales.
	
	[enhancements notNil 
		ifTrue: 
			[enhancements copy do: 
					[:anArray | 
					| aClass aSelector |
					aClass := Compiler evaluate: (anArray at: 1) logged: false.
					aSelector := anArray at: 3.
					self uninstallEnhanceClass: aClass selector: aSelector].
			enhancements := nil].
	self yourself] 
			value.
	
	[| aParcel aCollection anArray |
	aParcel := Parcel parcelNamed: self system.
	aCollection := OrderedCollection new.
	self classes do: 
			[:aClass | 
			aCollection add: aClass.
			aCollection add: aClass class].
	anArray := aParcel changedClasses asArray 
				reject: [:each | aCollection includes: each].
	aParcel removeClasses: anArray.
	self yourself] 
			value.
	
	[| aPackage aCollection |
	aPackage := Store.Registry packageNamed: self system.
	aPackage ifNil: [aPackage := Store.PackageModel named: self system].
	aCollection := aPackage allClasses 
				reject: [:each | JplSystem classes includes: each actual].
	aCollection do: [:each | aPackage removeModel: each].
	self yourself] 
			value.
	
	[self uninstallFont.
	self yourself] value</body>

<body package="Jpl" selector="uninstallFont">uninstallFont
	"JplSystem uninstallFont."

	MemorisedFonts ifNotNil: 
			[MemorisedFonts keysAndValuesDo: 
					[:key :value | 
					value ifNotNil: [:it | TextAttributes styleNamed: key put: it]].
			MemorisedFonts := nil].
	TextAttributes setDefaultTo: #default.
	TextAttributes resetViews.
	InputManager platformHookup.
	Locale set: #C.
	Filename defaultClass install.
	Screen default receiveAndProcessAllEvents</body>
</methods>

<methods>
<class-id>JplSystem class</class-id> <category>saving</category>

<body package="Jpl" selector="save">save
	"JplSystem save."

	| currentSetting |
	self 
		assert: 
			[currentSetting := UISettings preferenceFor: #fileOutType.
			UISettings preferenceFor: #fileOutType put: #XMLSourceFileFormat]
		do: [self saveAll]
		ensure: [UISettings preferenceFor: #fileOutType put: currentSetting]</body>

<body package="Jpl" selector="saveAll">saveAll
	"JplSystem saveAll."

	| aDirectory aStream |
	aDirectory := Filename defaultDirectory 
				construct: self system , self version.
	aDirectory exists 
		ifTrue: 
			[aDirectory directoryContents 
				do: [:each | (aDirectory construct: each) delete]]
		ifFalse: [aDirectory makeDirectory].
	self 
		assert: [aStream := (aDirectory construct: 'Install.st') writeStream]
		do: 
			[aStream 
				nextPutAll: '&lt;?xml version="1.0"?&gt;


&lt;st-source&gt;


&lt;do-it&gt;| aString aParcel |
aString := '.
			aStream nextPutAll: self system printString.
			aStream 
				nextPutAll: '.
aParcel := Parcel parcelNamed: aString.
aParcel isNil ifTrue: [aParcel := Parcel createParcelNamed: aString]&lt;/do-it&gt;
'.
			self classes do: 
					[:aClass | 
					((SourceCodeStream on: aStream)
						sourceFormatter: XMLSourceFileFormat new forFragment;
						yourself) storeObjectDefinition: aClass.
					aStream cr].
			aStream cr.
			aStream nextPutAll: '
&lt;do-it&gt;#(
'.
			self classes do: 
					[:aClass | 
					aStream
						nextPutAll: (aClass name asString , '.st') printString;
						cr].
			aStream 
				nextPutAll: ')
	 do:
		[:aString |
		| parcelName jplVersion separatorString directoryString |
		parcelName := '.
			aStream nextPutAll: self system printString.
			aStream nextPutAll: '.
		jplVersion := '.
			aStream nextPutAll: (self system , self version) printString.
			aStream 
				nextPutAll: '.
		separatorString := String with: Filename separator.
		directoryString := Filename currentDirectory asString.
		directoryString last = Filename separator
			ifTrue: [directoryString := directoryString , jplVersion , separatorString]
			ifFalse: [directoryString := directoryString , separatorString , jplVersion , separatorString].
		(Parcel parcelNamed: parcelName) fileIntoFrom: (Filename named: directoryString , aString).
		ScheduledControllers restore.
		ObjectMemory globalGarbageCollect]&lt;/do-it&gt;


'.
			aStream nextPutAll: '&lt;do-it&gt;'.
			aStream nextPutAll: self name asString , ' install'.
			aStream nextPutAll: '&lt;/do-it&gt;


&lt;/st-source&gt;
'.
			aStream flush]
		ensure: [aStream close].
	self classes do: 
			[:aClass | 
			| aSourceCodeStream |
			self 
				assert: 
					[aStream := (aDirectory construct: aClass name asString , '.st') 
								writeStream.
					aSourceCodeStream := (SourceCodeStream on: aStream)
								sourceFormatter: XMLSourceFileFormat new;
								yourself]
				do: [aClass fileOutSourceOn: aSourceCodeStream]
				ensure: [aSourceCodeStream close]]</body>
</methods>

<methods>
<class-id>JplSystem class</class-id> <category>parcel</category>

<body package="Jpl" selector="postLoadParcel:">postLoadParcel: aParcel 
	"This method will be hooked after Jpl (Japanese Locale) parcel loading."

	self install</body>

<body package="Jpl" selector="preUnloadParcel:">preUnloadParcel: aParcel 
	"This method will be unhooked before Jpl (Japanese Locale) parcel unloading."

	self uninstall</body>

<body package="Jpl" selector="saveAsParcel">saveAsParcel
	"JplSystem saveAsParcel."

	| aParcel aCollection anArray |
	aParcel := (Parcel parcelNamed: self system) copy.
	aParcel isNil ifTrue: [aParcel := Parcel createParcelNamed: self system].
	aParcel isEmpty ifTrue: [^nil].
	aParcel comment: self system , self version , ' (' , self date , ')'.
	aParcel version: self version.
	aCollection := OrderedCollection new.
	self classes do: 
			[:aClass | 
			aCollection add: aClass.
			aCollection add: aClass class].
	anArray := aParcel changedClasses asArray 
				reject: [:each | aCollection includes: each].
	aParcel removeClasses: anArray.
	aParcel postLoadBlock: '[:aParcel | #{' , self name asString , '} value postLoadParcel: aParcel]'.
	aParcel preUnloadBlock: '[:aParcel | #{' , self name asString , '} value preUnloadParcel: aParcel]'.
	aParcel 
		parcelOutOn: self system , self version , '.pcl'
		withSource: self system , self version , '.pst'
		hideOnLoad: false
		republish: false
		backup: false</body>
</methods>

<methods>
<class-id>JplSystem class</class-id> <category>examples</category>

<body package="Jpl" selector="example1">example1
	"JplSystem example1."

	| aSet anArray aMenu |
	aSet := Set new.
	Screen default defaultFontPolicy availableFonts
		do: 
			[:each | 
			| familyName |
			familyName := each family.
			familyName isNil ifFalse: [aSet add: each family]].
	anArray := aSet asSortedCollection asArray select: [:each | each isKindOf: TwoByteString].
	anArray isEmpty ifTrue: [^anArray].
	aMenu := Menu labelArray: anArray.
	aMenu startUp.
	^anArray</body>

<body package="Jpl" selector="example2">example2
	"JplSystem example2."

	| aSet anArray aStream aModel |
	aSet := Set new.
	Screen default defaultFontPolicy availableFonts
		do: 
			[:each | 
			| familyName |
			familyName := each family.
			familyName isNil ifFalse: [aSet add: each family]].
	anArray := aSet asSortedCollection asArray select: [:each | each isKindOf: TwoByteString].
	anArray isEmpty ifTrue: [^anArray].
	aStream := String new writeStream.
	[anArray do: [:each | aStream nextPutAll: each; cr]]
		ensure: 
			[aModel := ValueHolder with: aStream contents.
			aStream close].
	ComposedTextView
		open: aModel
		label: String new
		icon: (Icon constantNamed: #workspace)
		extent: 300 @ 300.
	^anArray</body>
</methods>

<methods>
<class-id>JplSystem class</class-id> <category>private</category>

<body package="Jpl" selector="assert:do:ensure:">assert: assertBlock do: doBlock ensure: ensureBlock 
	| returnValue |
	assertBlock value.
	[returnValue := doBlock value] ensure: [ensureBlock value].
	^returnValue</body>

<body package="Jpl" selector="installEnhanceClass:protocol:attributes:code:">installEnhanceClass: aClass protocol: aProtocol attributes: aDictionary code: aCode 
	| aSelector anArray |
	aClass isBehavior ifFalse: [^self].
	aSelector := Parser new parseSelector: aCode.
	aSelector isNil ifTrue: [^self].
	enhancements isNil ifTrue: [enhancements := OrderedCollection new].
	anArray := enhancements detect: 
					[:array | 
					| bool |
					bool := aClass name asString = (array at: 1).
					bool := bool and: [aSelector = (array at: 3)].
					bool yourself]
				ifNone: [nil].
	anArray isNil 
		ifTrue: 
			[| oldCode aCategory |
			(aClass includesSelector: aSelector) 
				ifTrue: 
					[oldCode := aClass sourceCodeAt: aSelector.
					aCategory := aClass organization categoryOfElement: aSelector.
					aCategory isNil ifTrue: [aCategory := #undefined]]
				ifFalse: 
					[oldCode := nil.
					aCategory := aProtocol].
			enhancements add: (Array 
						with: aClass name asString
						with: aCategory asString
						with: aSelector
						with: oldCode)].
	aClass 
		compile: aCode
		classified: aProtocol asSymbol
		attributes: aDictionary</body>

<body package="Jpl" selector="uninstallEnhanceClass:selector:">uninstallEnhanceClass: aClass selector: aSelector 
	| anArray aProtocol oldCode |
	aClass isBehavior ifFalse: [^self].
	(aSelector isKindOf: Symbol) ifFalse: [^self].
	enhancements isNil ifTrue: [^self].
	anArray := enhancements detect: 
					[:array | 
					| bool |
					bool := aClass name asString = (array at: 1).
					bool := bool and: [aSelector = (array at: 3)].
					bool yourself]
				ifNone: [nil].
	anArray isNil ifTrue: [^self].
	aProtocol := anArray at: 2.
	oldCode := anArray at: 4.
	oldCode isNil 
		ifTrue: 
			["remove method"
			aClass removeSelector: aSelector]
		ifFalse: 
			["restore method"
			aClass compile: oldCode classified: aProtocol asSymbol].
	enhancements remove: anArray</body>
</methods>

<methods>
<class-id>JplSystem class</class-id> <category>enhancements TextEditorView</category>

<body package="Jpl" selector="displayInsertionPointForOnInTextEditorView">displayInsertionPointForOnInTextEditorView
	self 
		installEnhanceClass: TextEditorView
		protocol: 'private'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'displayInsertionPointFor: aCharacterBlock on: aGraphicsContext 
	self insertionPointManager 
		displayInsertionPointFor: aCharacterBlock
		in: self
		on: aGraphicsContext.
	InputManager default 
		setSpot: (aCharacterBlock topLeft corner: aCharacterBlock right 
						@ (aCharacterBlock top + self textStyle baseline))
		on: self
		gc: aGraphicsContext'</body>
</methods>

<methods>
<class-id>JplSystem class</class-id> <category>enhancements EncodesStream</category>

<body package="Jpl" selector="nextInEncodedStream">nextInEncodedStream
	self releaseVersionOfSmalltalk &gt;= 75 ifTrue: [^self].
	self 
		installEnhanceClass: EncodedStream
		protocol: 'accessing'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'next
	"Answer the next object in the Stream represented by the receiver."

	| pos ch |
	binary ifTrue: [^stream next].
	pos := stream position.
	ch := encoder nextFrom: stream.
	ch == nil 
		ifTrue: 
			[skipSize := nil.
			^nil].
	skipSize := stream position - pos.
	lineEndCharacter == ch ifFalse: [^ch].
	lineEndConvention == LineEndLF ifTrue: [^CR].
	lineEndConvention == LineEndCRLF 
		ifTrue: 
			[| pos2 char |
			pos2 := stream position.
			char := encoder nextFrom: stream.
			char == nil ifTrue: [^CR].
			char == LF 
				ifTrue: [skipSize := stream position - pos]
				ifFalse: [stream position: pos2].
			^CR].
	^ch'</body>

<body package="Jpl" selector="nextPutInEncodedStream">nextPutInEncodedStream
	self releaseVersionOfSmalltalk &gt;= 75 ifTrue: [^self].
	self 
		installEnhanceClass: EncodedStream
		protocol: 'accessing'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'nextPut: anObject 
	"Write the argument at the next position in the stream.
	 Answer the argument."

	| pos |
	binary ifTrue: [^stream nextPut: anObject].
	pos := stream position.
	anObject == CR 
		ifFalse: 
			[encoder nextPut: anObject on: stream.
			skipSize := stream position - pos.
			^anObject].
	lineEndConvention == LineEndLF 
		ifTrue: [encoder nextPut: LF on: stream]
		ifFalse: 
			[encoder nextPut: CR on: stream.
			lineEndConvention == LineEndCRLF ifTrue: [encoder nextPut: LF on: stream]].
	skipSize := stream position - pos.
	^anObject'</body>

<body package="Jpl" selector="skipInEncodedStream">skipInEncodedStream
	self releaseVersionOfSmalltalk &gt;= 75 ifTrue: [^self].
	self 
		installEnhanceClass: EncodedStream
		protocol: 'accessing'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'skip: anInteger 
	"Skip anInteger of characters. 
	You can skip back only one character on encoded stream. 
	You can not back two characters."

	binary ifTrue: [^stream skip: anInteger].
	anInteger &gt; 0 
		ifTrue: [anInteger timesRepeat: [self next isNil ifTrue: [^self]]].
	skipSize == nil ifTrue: [^self].
	anInteger &lt; 0 
		ifTrue: 
			[anInteger &lt; -1 
				ifTrue: [self error: ''You can not skip back more than one character.''].
			self position: stream position - skipSize].
	^self'</body>
</methods>

<methods>
<class-id>JplSystem class</class-id> <category>enhancements Locale</category>

<body package="Jpl" selector="installJapaneseEucLocaleX11InLocaleClass">installJapaneseEucLocaleX11InLocaleClass
	self 
		installEnhanceClass: Locale class
		protocol: 'install japanese'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'installJapaneseEucLocaleX11
	| locale |
	locale := self new.
	locale
		name: #''ja_JP.eucJP'';
		collationPolicy: nil;
		compoundTextEncodeOrder: #(#ascii #iso1);
		currencyPolicy: nil;
		numberPolicy: nil;
		timePolicy: nil;
		cutPasteEncoding: #CompoundText;
		defaultPaperSize: ["A4 paper size in inch" 8.2677 @ 11.6929] value;
		defaultStreamEncoder: JplEucStreamEncoder;
		ignoreSerifEncodings: #(''jisx0208.1983-0'' ''jisx0201.1976-0'');
		needsInputMethod: true;
		preferredEncodings: #(''iso8859-1'' ''jisx0208.1983-0'' ''jisx0201.1976-0'');
		preferredFontFamily: #();
		preferredPixelSize: 12.
	self addLocale: locale platform: #unix.
	LocaleMap
		at: #(''* linux'' #ja) put: #''ja_JP.eucJP'';
		at: #(''* linux'' #ja_JP) put: #''ja_JP.eucJP'';
		at: #(''* linux'' #''ja_JP.ujis'') put: #''ja_JP.eucJP'';
		at: #(''* linux'' #''ja_JP.eucJP'') put: #''ja_JP.eucJP'';
		at: #(''* linux'' #''ja_JP.EUC'') put: #''ja_JP.eucJP'';
		at: #(''* linux'' #japan) put: #''ja_JP.eucJP'';
		at: #(''* linux'' #japanese) put: #''ja_JP.eucJP'';
		at: #(''* linux'' #''japanese.euc'') put: #''ja_JP.eucJP'''</body>

<body package="Jpl" selector="installJapaneseLocalesInLocaleClass">installJapaneseLocalesInLocaleClass
	self 
		installEnhanceClass: Locale class
		protocol: 'install japanese'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'installJapaneseLocales
	"Locale installJapaneseLocales."

	CharacterEncoder checkMiscCharacterSets.
	ScreenFont installJapaneseEncodings.
	JplStreamEncoder install.
	StreamEncoder updateEncoderDirectory.
	self installJapaneseUtf8LocaleX11.
	self installJapaneseEucLocaleX11.
	self installJapaneseSjisLocaleWindows'</body>

<body package="Jpl" selector="installJapaneseSjisLocaleWindowsInLocaleClass">installJapaneseSjisLocaleWindowsInLocaleClass
	self 
		installEnhanceClass: Locale class
		protocol: 'install japanese'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'installJapaneseSjisLocaleWindows
	| locale |
	locale := self new.
	locale
		name: #''ja_JP.SJIS'';
		collationPolicy: nil;
		compoundTextEncodeOrder: #(#ascii #iso1);
		currencyPolicy: nil;
		numberPolicy: nil;
		timePolicy: nil;
		cutPasteEncoding: #ShiftJIS;
		defaultPaperSize: ["A4 paper size in inch" 8.2677 @ 11.6929] value;
		defaultStreamEncoder: JplSjisStreamEncoder;
		ignoreSerifEncodings: #(''kanji'');
		needsInputMethod: true;
		preferredEncodings: #(''kanji'' ''ansi'');
		preferredFontFamily: (Array with: (TwoByteString 
							fromIntegerArray: #(65325 65331 32 12468 12471 12483 12463)));
		preferredPixelSize: 14.
	self addLocale: locale platform: #win32.
	LocaleMap
		at: #(''win32 *'' #JPN) put: #''ja_JP.SJIS'';
		at: #(''win32 *'' #jpn) put: #''ja_JP.SJIS'''</body>

<body package="Jpl" selector="installJapaneseUtf8LocaleX11InLocaleClass">installJapaneseUtf8LocaleX11InLocaleClass
	self 
		installEnhanceClass: Locale class
		protocol: 'install japanese'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'installJapaneseUtf8LocaleX11
	| locale |
	locale := self new.
	locale
		name: #''ja_JP.UTF-8'';
		collationPolicy: nil;
		compoundTextEncodeOrder: #(#ascii #iso1);
		currencyPolicy: nil;
		numberPolicy: nil;
		timePolicy: nil;
		cutPasteEncoding: #CompoundText;
		defaultPaperSize: ["A4 paper size in inch" 8.2677 @ 11.6929] value;
		defaultStreamEncoder: (StreamEncoder lookupEncoderDirectory: #''UTF-8'');
		ignoreSerifEncodings: #(''jisx0208.1983-0'' ''jisx0201.1976-0'');
		needsInputMethod: true;
		preferredEncodings: #(''iso8859-1'' ''jisx0208.1983-0'' ''jisx0201.1976-0'');
		preferredFontFamily: #();
		preferredPixelSize: 12.
	self addLocale: locale platform: #unix.
	LocaleMap
		at: #(''* linux'' #ja) put: #''ja_JP.UTF-8'';
		at: #(''* linux'' #ja_JP) put: #''ja_JP.UTF-8'';
		at: #(''* linux'' #''ja_JP.UTF-8'') put: #''ja_JP.UTF-8'''</body>

<body package="Jpl" selector="uninstallJapaneseLocalesInLocaleClass">uninstallJapaneseLocalesInLocaleClass
	self 
		installEnhanceClass: Locale class
		protocol: 'install japanese'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'uninstallJapaneseLocales
	"Locale uninstallJapaneseLocales."

	StreamEncoder encoderDirectory removeKey: #JIS ifAbsent: [].
	StreamEncoder encoderDirectory removeKey: #JapaneseEUC ifAbsent: [].
	StreamEncoder encoderDirectory removeKey: #ShiftJIS ifAbsent: [].
	StreamEncoder encoderDirectory removeKey: #JapaneseAutoDetect ifAbsent: [].
	ExternalStream commitOpenStreams.
	(LocaleDictionary at: #unix) removeKey: #''ja_JP.eucJP'' ifAbsent: [].
	LocaleMap
		removeKey: #(''* linux'' #ja) ifAbsent: [];
		removeKey: #(''* linux'' #ja_JP) ifAbsent: [];
		removeKey: #(''* linux'' #''ja_JP.ujis'') ifAbsent: [];
		removeKey: #(''* linux'' #''ja_JP.eucJP'') ifAbsent: [];
		removeKey: #(''* linux'' #''ja_JP.EUC'') ifAbsent: [];
		removeKey: #(''* linux'' #''ja_JP.UTF-8'') ifAbsent: [];
		removeKey: #(''* linux'' #japan) ifAbsent: [];
		removeKey: #(''* linux'' #japanese) ifAbsent: [];
		removeKey: #(''* linux'' #''japanese.euc'') ifAbsent: [].
	(LocaleDictionary at: #win32) removeKey: #''ja_JP.SJIS'' ifAbsent: [].
	LocaleMap
		removeKey: #(''win32 *'' #JPN) ifAbsent: [];
		removeKey: #(''win32 *'' #jpn) ifAbsent: [].
	self initialHookup.
	InputManager setDefault.
	Filename install.
	ScreenFont uninstallJapaneseEncodings.
	CharacterEncoder uninstallMiscCharacterSets'</body>
</methods>

<methods>
<class-id>JplSystem class</class-id> <category>enhancements ScreenFont</category>

<body package="Jpl" selector="installJapaneseEncodingsInScreenFontClass">installJapaneseEncodingsInScreenFontClass
	self 
		installEnhanceClass: ScreenFont class
		protocol: 'japanese font'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'installJapaneseEncodings
	"ScreenFont installJapaneseEncodings."

	CharacterEncoder checkMiscCharacterSets.
	(FontEncodings at: ''X11'')
		add: ''jisx0201.1976-0'' 
					-&gt; (CharacterEncoder encoderNamed: #''jisx0201.1976-0'');
		add: ''jisx0208.1983-0'' 
					-&gt; (CharacterEncoder encoderNamed: #''jisx0208.1983-0'');
		add: ''jisx0212.1990-0'' 
					-&gt; (CharacterEncoder encoderNamed: #''jisx0212.1990-0'').
	(FontEncodings at: ''MS-Windows'')
		add: ''kanji'' -&gt; (CharacterEncoder encoderNamed: #ShiftJIS);
		add: ''ShiftJIS'' -&gt; (CharacterEncoder encoderNamed: #ShiftJIS).
	self yourself'</body>

<body package="Jpl" selector="uninstallJapaneseEncodingsInScreenFontClass">uninstallJapaneseEncodingsInScreenFontClass
	self 
		installEnhanceClass: ScreenFont class
		protocol: 'japanese font'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'uninstallJapaneseEncodings
	"ScreenFont uninstallJapaneseEncodings."

	(FontEncodings at: ''X11'')
		removeKey: ''jisx0201.1976-0'' ifAbsent: [];
		removeKey: ''jisx0208.1983-0'' ifAbsent: [];
		removeKey: ''jisx0212.1990-0'' ifAbsent: [].
	(FontEncodings at: ''MS-Windows'')
		removeKey: ''kanji'' ifAbsent: [];
		removeKey: ''ShiftJIS'' ifAbsent: [];
		removeKey: ''JIS'' ifAbsent: [];
		removeKey: ''JapaneseEUC'' ifAbsent: [].
	self yourself'</body>
</methods>

<methods>
<class-id>JplSystem class</class-id> <category>enhancements CharacterEncoder</category>

<body package="Jpl" selector="checkMiscCharacterSetsInCharacterEncoderClass">checkMiscCharacterSetsInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'checkMiscCharacterSets
	"CharacterEncoder checkMiscCharacterSets."

	Encoders at: #common ifAbsent: [^CharacterEncoder installMiscCharacterSets].
	CharacterEncoder encoderNamed: #''jisx0208.1983-0''
		ifAbsent: [CharacterEncoder installMiscCharacterSets]'</body>

<body package="Jpl" selector="cp1250EncoderInCharacterEncoderClass">cp1250EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-windows character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp1250Encoder
	"CharacterEncoder cp1250Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r20AC 16r82 16r201A 16r84 16r201E 16r85 16r2026 16r86 16r2020 16r87 16r2021 16r89 16r2030 16r8A 16r160 16r8B 16r2039 16r8C 16r15A 16r8D 16r164 16r8E 16r17D 16r8F 16r179 16r91 16r2018 16r92 16r2019 16r93 16r201C 16r94 16r201D 16r95 16r2022 16r96 16r2013 16r97 16r2014 16r99 16r2122 16r9A 16r161 16r9B 16r203A 16r9C 16r15B 16r9D 16r165 16r9E 16r17E 16r9F 16r17A 16rA0 16rA0 16rA1 16r2C7 16rA2 16r2D8 16rA3 16r141 16rA4 16rA4 16rA5 16r104 16rA6 16rA6 16rA7 16rA7 16rA8 16rA8 16rA9 16rA9 16rAA 16r15E 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16r17B 16rB0 16rB0 16rB1 16rB1 16rB2 16r2DB 16rB3 16r142 16rB4 16rB4 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16rB8 16rB9 16r105 16rBA 16r15F 16rBB 16rBB 16rBC 16r13D 16rBD 16r2DD 16rBE 16r13E 16rBF 16r17C 16rC0 16r154 16rC1 16rC1 16rC2 16rC2 16rC3 16r102 16rC4 16rC4 16rC5 16r139 16rC6 16r106 16rC7 16rC7 16rC8 16r10C 16rC9 16rC9 16rCA 16r118 16rCB 16rCB 16rCC 16r11A 16rCD 16rCD 16rCE 16rCE 16rCF 16r10E 16rD0 16r110 16rD1 16r143 16rD2 16r147 16rD3 16rD3 16rD4 16rD4 16rD5 16r150 16rD6 16rD6 16rD7 16rD7 16rD8 16r158 16rD9 16r16E 16rDA 16rDA 16rDB 16r170 16rDC 16rDC 16rDD 16rDD 16rDE 16r162 16rDF 16rDF 16rE0 16r155 16rE1 16rE1 16rE2 16rE2 16rE3 16r103 16rE4 16rE4 16rE5 16r13A 16rE6 16r107 16rE7 16rE7 16rE8 16r10D 16rE9 16rE9 16rEA 16r119 16rEB 16rEB 16rEC 16r11B 16rED 16rED 16rEE 16rEE 16rEF 16r10F 16rF0 16r111 16rF1 16r144 16rF2 16r148 16rF3 16rF3 16rF4 16rF4 16rF5 16r151 16rF6 16rF6 16rF7 16rF7 16rF8 16r159 16rF9 16r16F 16rFA 16rFA 16rFB 16r171 16rFC 16rFC 16rFD 16rFD 16rFE 16r163 16rFF 16r2D9).
	encoder name: #cp1250.
	encoder streamEncodingType: #CP1250.
	^encoder'</body>

<body package="Jpl" selector="cp1251EncoderInCharacterEncoderClass">cp1251EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-windows character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp1251Encoder
	"CharacterEncoder cp1251Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r402 16r81 16r403 16r82 16r201A 16r83 16r453 16r84 16r201E 16r85 16r2026 16r86 16r2020 16r87 16r2021 16r88 16r20AC 16r89 16r2030 16r8A 16r409 16r8B 16r2039 16r8C 16r40A 16r8D 16r40C 16r8E 16r40B 16r8F 16r40F 16r90 16r452 16r91 16r2018 16r92 16r2019 16r93 16r201C 16r94 16r201D 16r95 16r2022 16r96 16r2013 16r97 16r2014 16r99 16r2122 16r9A 16r459 16r9B 16r203A 16r9C 16r45A 16r9D 16r45C 16r9E 16r45B 16r9F 16r45F 16rA0 16rA0 16rA1 16r40E 16rA2 16r45E 16rA3 16r408 16rA4 16rA4 16rA5 16r490 16rA6 16rA6 16rA7 16rA7 16rA8 16r401 16rA9 16rA9 16rAA 16r404 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16r407 16rB0 16rB0 16rB1 16rB1 16rB2 16r406 16rB3 16r456 16rB4 16r491 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16r451 16rB9 16r2116 16rBA 16r454 16rBB 16rBB 16rBC 16r458 16rBD 16r405 16rBE 16r455 16rBF 16r457 16rC0 16r410 16rC1 16r411 16rC2 16r412 16rC3 16r413 16rC4 16r414 16rC5 16r415 16rC6 16r416 16rC7 16r417 16rC8 16r418 16rC9 16r419 16rCA 16r41A 16rCB 16r41B 16rCC 16r41C 16rCD 16r41D 16rCE 16r41E 16rCF 16r41F 16rD0 16r420 16rD1 16r421 16rD2 16r422 16rD3 16r423 16rD4 16r424 16rD5 16r425 16rD6 16r426 16rD7 16r427 16rD8 16r428 16rD9 16r429 16rDA 16r42A 16rDB 16r42B 16rDC 16r42C 16rDD 16r42D 16rDE 16r42E 16rDF 16r42F 16rE0 16r430 16rE1 16r431 16rE2 16r432 16rE3 16r433 16rE4 16r434 16rE5 16r435 16rE6 16r436 16rE7 16r437 16rE8 16r438 16rE9 16r439 16rEA 16r43A 16rEB 16r43B 16rEC 16r43C 16rED 16r43D 16rEE 16r43E 16rEF 16r43F 16rF0 16r440 16rF1 16r441 16rF2 16r442 16rF3 16r443 16rF4 16r444 16rF5 16r445 16rF6 16r446 16rF7 16r447 16rF8 16r448 16rF9 16r449 16rFA 16r44A 16rFB 16r44B 16rFC 16r44C 16rFD 16r44D 16rFE 16r44E 16rFF 16r44F).
	encoder name: #cp1251.
	encoder streamEncodingType: #CP1251.
	^encoder'</body>

<body package="Jpl" selector="cp1252EncoderInCharacterEncoderClass">cp1252EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-windows character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp1252Encoder
	"CharacterEncoder cp1252Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r20AC 16r82 16r201A 16r83 16r192 16r84 16r201E 16r85 16r2026 16r86 16r2020 16r87 16r2021 16r88 16r2C6 16r89 16r2030 16r8A 16r160 16r8B 16r2039 16r8C 16r152 16r8E 16r17D 16r91 16r2018 16r92 16r2019 16r93 16r201C 16r94 16r201D 16r95 16r2022 16r96 16r2013 16r97 16r2014 16r98 16r2DC 16r99 16r2122 16r9A 16r161 16r9B 16r203A 16r9C 16r153 16r9E 16r17E 16r9F 16r178 16rA0 16rA0 16rA1 16rA1 16rA2 16rA2 16rA3 16rA3 16rA4 16rA4 16rA5 16rA5 16rA6 16rA6 16rA7 16rA7 16rA8 16rA8 16rA9 16rA9 16rAA 16rAA 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16rAF 16rB0 16rB0 16rB1 16rB1 16rB2 16rB2 16rB3 16rB3 16rB4 16rB4 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16rB8 16rB9 16rB9 16rBA 16rBA 16rBB 16rBB 16rBC 16rBC 16rBD 16rBD 16rBE 16rBE 16rBF 16rBF 16rC0 16rC0 16rC1 16rC1 16rC2 16rC2 16rC3 16rC3 16rC4 16rC4 16rC5 16rC5 16rC6 16rC6 16rC7 16rC7 16rC8 16rC8 16rC9 16rC9 16rCA 16rCA 16rCB 16rCB 16rCC 16rCC 16rCD 16rCD 16rCE 16rCE 16rCF 16rCF 16rD0 16rD0 16rD1 16rD1 16rD2 16rD2 16rD3 16rD3 16rD4 16rD4 16rD5 16rD5 16rD6 16rD6 16rD7 16rD7 16rD8 16rD8 16rD9 16rD9 16rDA 16rDA 16rDB 16rDB 16rDC 16rDC 16rDD 16rDD 16rDE 16rDE 16rDF 16rDF 16rE0 16rE0 16rE1 16rE1 16rE2 16rE2 16rE3 16rE3 16rE4 16rE4 16rE5 16rE5 16rE6 16rE6 16rE7 16rE7 16rE8 16rE8 16rE9 16rE9 16rEA 16rEA 16rEB 16rEB 16rEC 16rEC 16rED 16rED 16rEE 16rEE 16rEF 16rEF 16rF0 16rF0 16rF1 16rF1 16rF2 16rF2 16rF3 16rF3 16rF4 16rF4 16rF5 16rF5 16rF6 16rF6 16rF7 16rF7 16rF8 16rF8 16rF9 16rF9 16rFA 16rFA 16rFB 16rFB 16rFC 16rFC 16rFD 16rFD 16rFE 16rFE 16rFF 16rFF).
	encoder name: #cp1252.
	encoder streamEncodingType: #CP1252.
	^encoder'</body>

<body package="Jpl" selector="cp1253EncoderInCharacterEncoderClass">cp1253EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-windows character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp1253Encoder
	"CharacterEncoder cp1253Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r20AC 16r82 16r201A 16r83 16r192 16r84 16r201E 16r85 16r2026 16r86 16r2020 16r87 16r2021 16r89 16r2030 16r8B 16r2039 16r91 16r2018 16r92 16r2019 16r93 16r201C 16r94 16r201D 16r95 16r2022 16r96 16r2013 16r97 16r2014 16r99 16r2122 16r9B 16r203A 16rA0 16rA0 16rA1 16r385 16rA2 16r386 16rA3 16rA3 16rA4 16rA4 16rA5 16rA5 16rA6 16rA6 16rA7 16rA7 16rA8 16rA8 16rA9 16rA9 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16r2015 16rB0 16rB0 16rB1 16rB1 16rB2 16rB2 16rB3 16rB3 16rB4 16r384 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16r388 16rB9 16r389 16rBA 16r38A 16rBB 16rBB 16rBC 16r38C 16rBD 16rBD 16rBE 16r38E 16rBF 16r38F 16rC0 16r390 16rC1 16r391 16rC2 16r392 16rC3 16r393 16rC4 16r394 16rC5 16r395 16rC6 16r396 16rC7 16r397 16rC8 16r398 16rC9 16r399 16rCA 16r39A 16rCB 16r39B 16rCC 16r39C 16rCD 16r39D 16rCE 16r39E 16rCF 16r39F 16rD0 16r3A0 16rD1 16r3A1 16rD3 16r3A3 16rD4 16r3A4 16rD5 16r3A5 16rD6 16r3A6 16rD7 16r3A7 16rD8 16r3A8 16rD9 16r3A9 16rDA 16r3AA 16rDB 16r3AB 16rDC 16r3AC 16rDD 16r3AD 16rDE 16r3AE 16rDF 16r3AF 16rE0 16r3B0 16rE1 16r3B1 16rE2 16r3B2 16rE3 16r3B3 16rE4 16r3B4 16rE5 16r3B5 16rE6 16r3B6 16rE7 16r3B7 16rE8 16r3B8 16rE9 16r3B9 16rEA 16r3BA 16rEB 16r3BB 16rEC 16r3BC 16rED 16r3BD 16rEE 16r3BE 16rEF 16r3BF 16rF0 16r3C0 16rF1 16r3C1 16rF2 16r3C2 16rF3 16r3C3 16rF4 16r3C4 16rF5 16r3C5 16rF6 16r3C6 16rF7 16r3C7 16rF8 16r3C8 16rF9 16r3C9 16rFA 16r3CA 16rFB 16r3CB 16rFC 16r3CC 16rFD 16r3CD 16rFE 16r3CE).
	encoder name: #cp1253.
	encoder streamEncodingType: #CP1253.
	^encoder'</body>

<body package="Jpl" selector="cp1254EncoderInCharacterEncoderClass">cp1254EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-windows character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp1254Encoder
	"CharacterEncoder cp1254Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r20AC 16r82 16r201A 16r83 16r192 16r84 16r201E 16r85 16r2026 16r86 16r2020 16r87 16r2021 16r88 16r2C6 16r89 16r2030 16r8A 16r160 16r8B 16r2039 16r8C 16r152 16r91 16r2018 16r92 16r2019 16r93 16r201C 16r94 16r201D 16r95 16r2022 16r96 16r2013 16r97 16r2014 16r98 16r2DC 16r99 16r2122 16r9A 16r161 16r9B 16r203A 16r9C 16r153 16r9F 16r178 16rA0 16rA0 16rA1 16rA1 16rA2 16rA2 16rA3 16rA3 16rA4 16rA4 16rA5 16rA5 16rA6 16rA6 16rA7 16rA7 16rA8 16rA8 16rA9 16rA9 16rAA 16rAA 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16rAF 16rB0 16rB0 16rB1 16rB1 16rB2 16rB2 16rB3 16rB3 16rB4 16rB4 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16rB8 16rB9 16rB9 16rBA 16rBA 16rBB 16rBB 16rBC 16rBC 16rBD 16rBD 16rBE 16rBE 16rBF 16rBF 16rC0 16rC0 16rC1 16rC1 16rC2 16rC2 16rC3 16rC3 16rC4 16rC4 16rC5 16rC5 16rC6 16rC6 16rC7 16rC7 16rC8 16rC8 16rC9 16rC9 16rCA 16rCA 16rCB 16rCB 16rCC 16rCC 16rCD 16rCD 16rCE 16rCE 16rCF 16rCF 16rD0 16r11E 16rD1 16rD1 16rD2 16rD2 16rD3 16rD3 16rD4 16rD4 16rD5 16rD5 16rD6 16rD6 16rD7 16rD7 16rD8 16rD8 16rD9 16rD9 16rDA 16rDA 16rDB 16rDB 16rDC 16rDC 16rDD 16r130 16rDE 16r15E 16rDF 16rDF 16rE0 16rE0 16rE1 16rE1 16rE2 16rE2 16rE3 16rE3 16rE4 16rE4 16rE5 16rE5 16rE6 16rE6 16rE7 16rE7 16rE8 16rE8 16rE9 16rE9 16rEA 16rEA 16rEB 16rEB 16rEC 16rEC 16rED 16rED 16rEE 16rEE 16rEF 16rEF 16rF0 16r11F 16rF1 16rF1 16rF2 16rF2 16rF3 16rF3 16rF4 16rF4 16rF5 16rF5 16rF6 16rF6 16rF7 16rF7 16rF8 16rF8 16rF9 16rF9 16rFA 16rFA 16rFB 16rFB 16rFC 16rFC 16rFD 16r131 16rFE 16r15F 16rFF 16rFF).
	encoder name: #cp1254.
	encoder streamEncodingType: #CP1254.
	^encoder'</body>

<body package="Jpl" selector="cp1255EncoderInCharacterEncoderClass">cp1255EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-windows character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp1255Encoder
	"CharacterEncoder cp1255Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r20AC 16r82 16r201A 16r83 16r192 16r84 16r201E 16r85 16r2026 16r86 16r2020 16r87 16r2021 16r88 16r2C6 16r89 16r2030 16r8B 16r2039 16r91 16r2018 16r92 16r2019 16r93 16r201C 16r94 16r201D 16r95 16r2022 16r96 16r2013 16r97 16r2014 16r98 16r2DC 16r99 16r2122 16r9B 16r203A 16rA0 16rA0 16rA1 16rA1 16rA2 16rA2 16rA3 16rA3 16rA4 16r20AA 16rA5 16rA5 16rA6 16rA6 16rA7 16rA7 16rA8 16rA8 16rA9 16rA9 16rAA 16rD7 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16rAF 16rB0 16rB0 16rB1 16rB1 16rB2 16rB2 16rB3 16rB3 16rB4 16rB4 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16rB8 16rB9 16rB9 16rBA 16rF7 16rBB 16rBB 16rBC 16rBC 16rBD 16rBD 16rBE 16rBE 16rBF 16rBF 16rC0 16r5B0 16rC1 16r5B1 16rC2 16r5B2 16rC3 16r5B3 16rC4 16r5B4 16rC5 16r5B5 16rC6 16r5B6 16rC7 16r5B7 16rC8 16r5B8 16rC9 16r5B9 16rCB 16r5BB 16rCC 16r5BC 16rCD 16r5BD 16rCE 16r5BE 16rCF 16r5BF 16rD0 16r5C0 16rD1 16r5C1 16rD2 16r5C2 16rD3 16r5C3 16rD4 16r5F0 16rD5 16r5F1 16rD6 16r5F2 16rD7 16r5F3 16rD8 16r5F4 16rE0 16r5D0 16rE1 16r5D1 16rE2 16r5D2 16rE3 16r5D3 16rE4 16r5D4 16rE5 16r5D5 16rE6 16r5D6 16rE7 16r5D7 16rE8 16r5D8 16rE9 16r5D9 16rEA 16r5DA 16rEB 16r5DB 16rEC 16r5DC 16rED 16r5DD 16rEE 16r5DE 16rEF 16r5DF 16rF0 16r5E0 16rF1 16r5E1 16rF2 16r5E2 16rF3 16r5E3 16rF4 16r5E4 16rF5 16r5E5 16rF6 16r5E6 16rF7 16r5E7 16rF8 16r5E8 16rF9 16r5E9 16rFA 16r5EA 16rFD 16r200E 16rFE 16r200F).
	encoder name: #cp1255.
	encoder streamEncodingType: #CP1255.
	^encoder'</body>

<body package="Jpl" selector="cp1256EncoderInCharacterEncoderClass">cp1256EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-windows character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp1256Encoder
	"CharacterEncoder cp1256Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r20AC 16r81 16r67E 16r82 16r201A 16r83 16r192 16r84 16r201E 16r85 16r2026 16r86 16r2020 16r87 16r2021 16r88 16r2C6 16r89 16r2030 16r8B 16r2039 16r8C 16r152 16r8D 16r686 16r8E 16r698 16r90 16r6AF 16r91 16r2018 16r92 16r2019 16r93 16r201C 16r94 16r201D 16r95 16r2022 16r96 16r2013 16r97 16r2014 16r99 16r2122 16r9B 16r203A 16r9C 16r153 16r9D 16r200C 16r9E 16r200D 16rA0 16rA0 16rA1 16r60C 16rA2 16rA2 16rA3 16rA3 16rA4 16rA4 16rA5 16rA5 16rA6 16rA6 16rA7 16rA7 16rA8 16rA8 16rA9 16rA9 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16rAF 16rB0 16rB0 16rB1 16rB1 16rB2 16rB2 16rB3 16rB3 16rB4 16rB4 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16rB8 16rB9 16rB9 16rBA 16r61B 16rBB 16rBB 16rBC 16rBC 16rBD 16rBD 16rBE 16rBE 16rBF 16r61F 16rC1 16r621 16rC2 16r622 16rC3 16r623 16rC4 16r624 16rC5 16r625 16rC6 16r626 16rC7 16r627 16rC8 16r628 16rC9 16r629 16rCA 16r62A 16rCB 16r62B 16rCC 16r62C 16rCD 16r62D 16rCE 16r62E 16rCF 16r62F 16rD0 16r630 16rD1 16r631 16rD2 16r632 16rD3 16r633 16rD4 16r634 16rD5 16r635 16rD6 16r636 16rD7 16rD7 16rD8 16r637 16rD9 16r638 16rDA 16r639 16rDB 16r63A 16rDC 16r640 16rDD 16r641 16rDE 16r642 16rDF 16r643 16rE0 16rE0 16rE1 16r644 16rE2 16rE2 16rE3 16r645 16rE4 16r646 16rE5 16r647 16rE6 16r648 16rE7 16rE7 16rE8 16rE8 16rE9 16rE9 16rEA 16rEA 16rEB 16rEB 16rEC 16r649 16rED 16r64A 16rEE 16rEE 16rEF 16rEF 16rF0 16r64B 16rF1 16r64C 16rF2 16r64D 16rF3 16r64E 16rF4 16rF4 16rF5 16r64F 16rF6 16r650 16rF7 16rF7 16rF8 16r651 16rF9 16rF9 16rFA 16r652 16rFB 16rFB 16rFC 16rFC 16rFD 16r200E 16rFE 16r200F).
	encoder name: #cp1256.
	encoder streamEncodingType: #CP1256.
	^encoder'</body>

<body package="Jpl" selector="cp1257EncoderInCharacterEncoderClass">cp1257EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-windows character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp1257Encoder
	"CharacterEncoder cp1257Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r20AC 16r82 16r201A 16r84 16r201E 16r85 16r2026 16r86 16r2020 16r87 16r2021 16r89 16r2030 16r8B 16r2039 16r8D 16rA8 16r8E 16r2C7 16r8F 16rB8 16r91 16r2018 16r92 16r2019 16r93 16r201C 16r94 16r201D 16r95 16r2022 16r96 16r2013 16r97 16r2014 16r99 16r2122 16r9B 16r203A 16r9D 16rAF 16r9E 16r2DB 16rA0 16rA0 16rA2 16rA2 16rA3 16rA3 16rA4 16rA4 16rA6 16rA6 16rA7 16rA7 16rA8 16rD8 16rA9 16rA9 16rAA 16r156 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16rC6 16rB0 16rB0 16rB1 16rB1 16rB2 16rB2 16rB3 16rB3 16rB4 16rB4 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16rF8 16rB9 16rB9 16rBA 16r157 16rBB 16rBB 16rBC 16rBC 16rBD 16rBD 16rBE 16rBE 16rBF 16rE6 16rC0 16r104 16rC1 16r12E 16rC2 16r100 16rC3 16r106 16rC4 16rC4 16rC5 16rC5 16rC6 16r118 16rC7 16r112 16rC8 16r10C 16rC9 16rC9 16rCA 16r179 16rCB 16r116 16rCC 16r122 16rCD 16r136 16rCE 16r12A 16rCF 16r13B 16rD0 16r160 16rD1 16r143 16rD2 16r145 16rD3 16rD3 16rD4 16r14C 16rD5 16rD5 16rD6 16rD6 16rD7 16rD7 16rD8 16r172 16rD9 16r141 16rDA 16r15A 16rDB 16r16A 16rDC 16rDC 16rDD 16r17B 16rDE 16r17D 16rDF 16rDF 16rE0 16r105 16rE1 16r12F 16rE2 16r101 16rE3 16r107 16rE4 16rE4 16rE5 16rE5 16rE6 16r119 16rE7 16r113 16rE8 16r10D 16rE9 16rE9 16rEA 16r17A 16rEB 16r117 16rEC 16r123 16rED 16r137 16rEE 16r12B 16rEF 16r13C 16rF0 16r161 16rF1 16r144 16rF2 16r146 16rF3 16rF3 16rF4 16r14D 16rF5 16rF5 16rF6 16rF6 16rF7 16rF7 16rF8 16r173 16rF9 16r142 16rFA 16r15B 16rFB 16r16B 16rFC 16rFC 16rFD 16r17C 16rFE 16r17E 16rFF 16r2D9).
	encoder name: #cp1257.
	encoder streamEncodingType: #CP1257.
	^encoder'</body>

<body package="Jpl" selector="cp1258EncoderInCharacterEncoderClass">cp1258EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-windows character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp1258Encoder
	"CharacterEncoder cp1258Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r20AC 16r82 16r201A 16r83 16r192 16r84 16r201E 16r85 16r2026 16r86 16r2020 16r87 16r2021 16r88 16r2C6 16r89 16r2030 16r8B 16r2039 16r8C 16r152 16r91 16r2018 16r92 16r2019 16r93 16r201C 16r94 16r201D 16r95 16r2022 16r96 16r2013 16r97 16r2014 16r98 16r2DC 16r99 16r2122 16r9B 16r203A 16r9C 16r153 16r9F 16r178 16rA0 16rA0 16rA1 16rA1 16rA2 16rA2 16rA3 16rA3 16rA4 16rA4 16rA5 16rA5 16rA6 16rA6 16rA7 16rA7 16rA8 16rA8 16rA9 16rA9 16rAA 16rAA 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16rAF 16rB0 16rB0 16rB1 16rB1 16rB2 16rB2 16rB3 16rB3 16rB4 16rB4 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16rB8 16rB9 16rB9 16rBA 16rBA 16rBB 16rBB 16rBC 16rBC 16rBD 16rBD 16rBE 16rBE 16rBF 16rBF 16rC0 16rC0 16rC1 16rC1 16rC2 16rC2 16rC3 16r102 16rC4 16rC4 16rC5 16rC5 16rC6 16rC6 16rC7 16rC7 16rC8 16rC8 16rC9 16rC9 16rCA 16rCA 16rCB 16rCB 16rCC 16r300 16rCD 16rCD 16rCE 16rCE 16rCF 16rCF 16rD0 16r110 16rD1 16rD1 16rD2 16r309 16rD3 16rD3 16rD4 16rD4 16rD5 16r1A0 16rD6 16rD6 16rD7 16rD7 16rD8 16rD8 16rD9 16rD9 16rDA 16rDA 16rDB 16rDB 16rDC 16rDC 16rDD 16r1AF 16rDE 16r303 16rDF 16rDF 16rE0 16rE0 16rE1 16rE1 16rE2 16rE2 16rE3 16r103 16rE4 16rE4 16rE5 16rE5 16rE6 16rE6 16rE7 16rE7 16rE8 16rE8 16rE9 16rE9 16rEA 16rEA 16rEB 16rEB 16rEC 16r301 16rED 16rED 16rEE 16rEE 16rEF 16rEF 16rF0 16r111 16rF1 16rF1 16rF2 16r323 16rF3 16rF3 16rF4 16rF4 16rF5 16r1A1 16rF6 16rF6 16rF7 16rF7 16rF8 16rF8 16rF9 16rF9 16rFA 16rFA 16rFB 16rFB 16rFC 16rFC 16rFD 16r1B0 16rFE 16r20AB 16rFF 16rFF).
	encoder name: #cp1258.
	encoder streamEncodingType: #CP1258.
	^encoder'</body>

<body package="Jpl" selector="cp437EncoderInCharacterEncoderClass">cp437EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp437Encoder
	"CharacterEncoder cp437Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16rC7 16r81 16rFC 16r82 16rE9 16r83 16rE2 16r84 16rE4 16r85 16rE0 16r86 16rE5 16r87 16rE7 16r88 16rEA 16r89 16rEB 16r8A 16rE8 16r8B 16rEF 16r8C 16rEE 16r8D 16rEC 16r8E 16rC4 16r8F 16rC5 16r90 16rC9 16r91 16rE6 16r92 16rC6 16r93 16rF4 16r94 16rF6 16r95 16rF2 16r96 16rFB 16r97 16rF9 16r98 16rFF 16r99 16rD6 16r9A 16rDC 16r9B 16rA2 16r9C 16rA3 16r9D 16rA5 16r9E 16r20A7 16r9F 16r192 16rA0 16rE1 16rA1 16rED 16rA2 16rF3 16rA3 16rFA 16rA4 16rF1 16rA5 16rD1 16rA6 16rAA 16rA7 16rBA 16rA8 16rBF 16rA9 16r2310 16rAA 16rAC 16rAB 16rBD 16rAC 16rBC 16rAD 16rA1 16rAE 16rAB 16rAF 16rBB 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16r2561 16rB6 16r2562 16rB7 16r2556 16rB8 16r2555 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16r255C 16rBE 16r255B 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16r255E 16rC7 16r255F 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16r2567 16rD0 16r2568 16rD1 16r2564 16rD2 16r2565 16rD3 16r2559 16rD4 16r2558 16rD5 16r2552 16rD6 16r2553 16rD7 16r256B 16rD8 16r256A 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16r258C 16rDE 16r2590 16rDF 16r2580 16rE0 16r3B1 16rE1 16rDF 16rE2 16r393 16rE3 16r3C0 16rE4 16r3A3 16rE5 16r3C3 16rE6 16rB5 16rE7 16r3C4 16rE8 16r3A6 16rE9 16r398 16rEA 16r3A9 16rEB 16r3B4 16rEC 16r221E 16rED 16r3C6 16rEE 16r3B5 16rEF 16r2229 16rF0 16r2261 16rF1 16rB1 16rF2 16r2265 16rF3 16r2264 16rF4 16r2320 16rF5 16r2321 16rF6 16rF7 16rF7 16r2248 16rF8 16rB0 16rF9 16r2219 16rFA 16rB7 16rFB 16r221A 16rFC 16r207F 16rFD 16rB2 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp437.
	encoder streamEncodingType: #CP437.
	^encoder'</body>

<body package="Jpl" selector="cp737EncoderInCharacterEncoderClass">cp737EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp737Encoder
	"CharacterEncoder cp737Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r391 16r81 16r392 16r82 16r393 16r83 16r394 16r84 16r395 16r85 16r396 16r86 16r397 16r87 16r398 16r88 16r399 16r89 16r39A 16r8A 16r39B 16r8B 16r39C 16r8C 16r39D 16r8D 16r39E 16r8E 16r39F 16r8F 16r3A0 16r90 16r3A1 16r91 16r3A3 16r92 16r3A4 16r93 16r3A5 16r94 16r3A6 16r95 16r3A7 16r96 16r3A8 16r97 16r3A9 16r98 16r3B1 16r99 16r3B2 16r9A 16r3B3 16r9B 16r3B4 16r9C 16r3B5 16r9D 16r3B6 16r9E 16r3B7 16r9F 16r3B8 16rA0 16r3B9 16rA1 16r3BA 16rA2 16r3BB 16rA3 16r3BC 16rA4 16r3BD 16rA5 16r3BE 16rA6 16r3BF 16rA7 16r3C0 16rA8 16r3C1 16rA9 16r3C3 16rAA 16r3C2 16rAB 16r3C4 16rAC 16r3C5 16rAD 16r3C6 16rAE 16r3C7 16rAF 16r3C8 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16r2561 16rB6 16r2562 16rB7 16r2556 16rB8 16r2555 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16r255C 16rBE 16r255B 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16r255E 16rC7 16r255F 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16r2567 16rD0 16r2568 16rD1 16r2564 16rD2 16r2565 16rD3 16r2559 16rD4 16r2558 16rD5 16r2552 16rD6 16r2553 16rD7 16r256B 16rD8 16r256A 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16r258C 16rDE 16r2590 16rDF 16r2580 16rE0 16r3C9 16rE1 16r3AC 16rE2 16r3AD 16rE3 16r3AE 16rE4 16r3CA 16rE5 16r3AF 16rE6 16r3CC 16rE7 16r3CD 16rE8 16r3CB 16rE9 16r3CE 16rEA 16r386 16rEB 16r388 16rEC 16r389 16rED 16r38A 16rEE 16r38C 16rEF 16r38E 16rF0 16r38F 16rF1 16rB1 16rF2 16r2265 16rF3 16r2264 16rF4 16r3AA 16rF5 16r3AB 16rF6 16rF7 16rF7 16r2248 16rF8 16rB0 16rF9 16r2219 16rFA 16rB7 16rFB 16r221A 16rFC 16r207F 16rFD 16rB2 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp737.
	encoder streamEncodingType: #CP737.
	^encoder'</body>

<body package="Jpl" selector="cp775EncoderInCharacterEncoderClass">cp775EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp775Encoder
	"CharacterEncoder cp775Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r106 16r81 16rFC 16r82 16rE9 16r83 16r101 16r84 16rE4 16r85 16r123 16r86 16rE5 16r87 16r107 16r88 16r142 16r89 16r113 16r8A 16r156 16r8B 16r157 16r8C 16r12B 16r8D 16r179 16r8E 16rC4 16r8F 16rC5 16r90 16rC9 16r91 16rE6 16r92 16rC6 16r93 16r14D 16r94 16rF6 16r95 16r122 16r96 16rA2 16r97 16r15A 16r98 16r15B 16r99 16rD6 16r9A 16rDC 16r9B 16rF8 16r9C 16rA3 16r9D 16rD8 16r9E 16rD7 16r9F 16rA4 16rA0 16r100 16rA1 16r12A 16rA2 16rF3 16rA3 16r17B 16rA4 16r17C 16rA5 16r17A 16rA6 16r201D 16rA7 16rA6 16rA8 16rA9 16rA9 16rAE 16rAA 16rAC 16rAB 16rBD 16rAC 16rBC 16rAD 16r141 16rAE 16rAB 16rAF 16rBB 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16r104 16rB6 16r10C 16rB7 16r118 16rB8 16r116 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16r12E 16rBE 16r160 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16r172 16rC7 16r16A 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16r17D 16rD0 16r105 16rD1 16r10D 16rD2 16r119 16rD3 16r117 16rD4 16r12F 16rD5 16r161 16rD6 16r173 16rD7 16r16B 16rD8 16r17E 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16r258C 16rDE 16r2590 16rDF 16r2580 16rE0 16rD3 16rE1 16rDF 16rE2 16r14C 16rE3 16r143 16rE4 16rF5 16rE5 16rD5 16rE6 16rB5 16rE7 16r144 16rE8 16r136 16rE9 16r137 16rEA 16r13B 16rEB 16r13C 16rEC 16r146 16rED 16r112 16rEE 16r145 16rEF 16r2019 16rF0 16rAD 16rF1 16rB1 16rF2 16r201C 16rF3 16rBE 16rF4 16rB6 16rF5 16rA7 16rF6 16rF7 16rF7 16r201E 16rF8 16rB0 16rF9 16r2219 16rFA 16rB7 16rFB 16rB9 16rFC 16rB3 16rFD 16rB2 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp775.
	encoder streamEncodingType: #CP775.
	^encoder'</body>

<body package="Jpl" selector="cp850EncoderInCharacterEncoderClass">cp850EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp850Encoder
	"CharacterEncoder cp850Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16rC7 16r81 16rFC 16r82 16rE9 16r83 16rE2 16r84 16rE4 16r85 16rE0 16r86 16rE5 16r87 16rE7 16r88 16rEA 16r89 16rEB 16r8A 16rE8 16r8B 16rEF 16r8C 16rEE 16r8D 16rEC 16r8E 16rC4 16r8F 16rC5 16r90 16rC9 16r91 16rE6 16r92 16rC6 16r93 16rF4 16r94 16rF6 16r95 16rF2 16r96 16rFB 16r97 16rF9 16r98 16rFF 16r99 16rD6 16r9A 16rDC 16r9B 16rF8 16r9C 16rA3 16r9D 16rD8 16r9E 16rD7 16r9F 16r192 16rA0 16rE1 16rA1 16rED 16rA2 16rF3 16rA3 16rFA 16rA4 16rF1 16rA5 16rD1 16rA6 16rAA 16rA7 16rBA 16rA8 16rBF 16rA9 16rAE 16rAA 16rAC 16rAB 16rBD 16rAC 16rBC 16rAD 16rA1 16rAE 16rAB 16rAF 16rBB 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16rC1 16rB6 16rC2 16rB7 16rC0 16rB8 16rA9 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16rA2 16rBE 16rA5 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16rE3 16rC7 16rC3 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16rA4 16rD0 16rF0 16rD1 16rD0 16rD2 16rCA 16rD3 16rCB 16rD4 16rC8 16rD5 16r131 16rD6 16rCD 16rD7 16rCE 16rD8 16rCF 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16rA6 16rDE 16rCC 16rDF 16r2580 16rE0 16rD3 16rE1 16rDF 16rE2 16rD4 16rE3 16rD2 16rE4 16rF5 16rE5 16rD5 16rE6 16rB5 16rE7 16rFE 16rE8 16rDE 16rE9 16rDA 16rEA 16rDB 16rEB 16rD9 16rEC 16rFD 16rED 16rDD 16rEE 16rAF 16rEF 16rB4 16rF0 16rAD 16rF1 16rB1 16rF2 16r2017 16rF3 16rBE 16rF4 16rB6 16rF5 16rA7 16rF6 16rF7 16rF7 16rB8 16rF8 16rB0 16rF9 16rA8 16rFA 16rB7 16rFB 16rB9 16rFC 16rB3 16rFD 16rB2 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp850.
	encoder streamEncodingType: #CP850.
	^encoder'</body>

<body package="Jpl" selector="cp852EncoderInCharacterEncoderClass">cp852EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp852Encoder
	"CharacterEncoder cp852Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16rC7 16r81 16rFC 16r82 16rE9 16r83 16rE2 16r84 16rE4 16r85 16r16F 16r86 16r107 16r87 16rE7 16r88 16r142 16r89 16rEB 16r8A 16r150 16r8B 16r151 16r8C 16rEE 16r8D 16r179 16r8E 16rC4 16r8F 16r106 16r90 16rC9 16r91 16r139 16r92 16r13A 16r93 16rF4 16r94 16rF6 16r95 16r13D 16r96 16r13E 16r97 16r15A 16r98 16r15B 16r99 16rD6 16r9A 16rDC 16r9B 16r164 16r9C 16r165 16r9D 16r141 16r9E 16rD7 16r9F 16r10D 16rA0 16rE1 16rA1 16rED 16rA2 16rF3 16rA3 16rFA 16rA4 16r104 16rA5 16r105 16rA6 16r17D 16rA7 16r17E 16rA8 16r118 16rA9 16r119 16rAA 16rAC 16rAB 16r17A 16rAC 16r10C 16rAD 16r15F 16rAE 16rAB 16rAF 16rBB 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16rC1 16rB6 16rC2 16rB7 16r11A 16rB8 16r15E 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16r17B 16rBE 16r17C 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16r102 16rC7 16r103 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16rA4 16rD0 16r111 16rD1 16r110 16rD2 16r10E 16rD3 16rCB 16rD4 16r10F 16rD5 16r147 16rD6 16rCD 16rD7 16rCE 16rD8 16r11B 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16r162 16rDE 16r16E 16rDF 16r2580 16rE0 16rD3 16rE1 16rDF 16rE2 16rD4 16rE3 16r143 16rE4 16r144 16rE5 16r148 16rE6 16r160 16rE7 16r161 16rE8 16r154 16rE9 16rDA 16rEA 16r155 16rEB 16r170 16rEC 16rFD 16rED 16rDD 16rEE 16r163 16rEF 16rB4 16rF0 16rAD 16rF1 16r2DD 16rF2 16r2DB 16rF3 16r2C7 16rF4 16r2D8 16rF5 16rA7 16rF6 16rF7 16rF7 16rB8 16rF8 16rB0 16rF9 16rA8 16rFA 16r2D9 16rFB 16r171 16rFC 16r158 16rFD 16r159 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp852.
	encoder streamEncodingType: #CP852.
	^encoder'</body>

<body package="Jpl" selector="cp855EncoderInCharacterEncoderClass">cp855EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp855Encoder
	"CharacterEncoder cp855Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r452 16r81 16r402 16r82 16r453 16r83 16r403 16r84 16r451 16r85 16r401 16r86 16r454 16r87 16r404 16r88 16r455 16r89 16r405 16r8A 16r456 16r8B 16r406 16r8C 16r457 16r8D 16r407 16r8E 16r458 16r8F 16r408 16r90 16r459 16r91 16r409 16r92 16r45A 16r93 16r40A 16r94 16r45B 16r95 16r40B 16r96 16r45C 16r97 16r40C 16r98 16r45E 16r99 16r40E 16r9A 16r45F 16r9B 16r40F 16r9C 16r44E 16r9D 16r42E 16r9E 16r44A 16r9F 16r42A 16rA0 16r430 16rA1 16r410 16rA2 16r431 16rA3 16r411 16rA4 16r446 16rA5 16r426 16rA6 16r434 16rA7 16r414 16rA8 16r435 16rA9 16r415 16rAA 16r444 16rAB 16r424 16rAC 16r433 16rAD 16r413 16rAE 16rAB 16rAF 16rBB 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16r445 16rB6 16r425 16rB7 16r438 16rB8 16r418 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16r439 16rBE 16r419 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16r43A 16rC7 16r41A 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16rA4 16rD0 16r43B 16rD1 16r41B 16rD2 16r43C 16rD3 16r41C 16rD4 16r43D 16rD5 16r41D 16rD6 16r43E 16rD7 16r41E 16rD8 16r43F 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16r41F 16rDE 16r44F 16rDF 16r2580 16rE0 16r42F 16rE1 16r440 16rE2 16r420 16rE3 16r441 16rE4 16r421 16rE5 16r442 16rE6 16r422 16rE7 16r443 16rE8 16r423 16rE9 16r436 16rEA 16r416 16rEB 16r432 16rEC 16r412 16rED 16r44C 16rEE 16r42C 16rEF 16r2116 16rF0 16rAD 16rF1 16r44B 16rF2 16r42B 16rF3 16r437 16rF4 16r417 16rF5 16r448 16rF6 16r428 16rF7 16r44D 16rF8 16r42D 16rF9 16r449 16rFA 16r429 16rFB 16r447 16rFC 16r427 16rFD 16rA7 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp855.
	encoder streamEncodingType: #CP855.
	^encoder'</body>

<body package="Jpl" selector="cp857EncoderInCharacterEncoderClass">cp857EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp857Encoder
	"CharacterEncoder cp857Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16rC7 16r81 16rFC 16r82 16rE9 16r83 16rE2 16r84 16rE4 16r85 16rE0 16r86 16rE5 16r87 16rE7 16r88 16rEA 16r89 16rEB 16r8A 16rE8 16r8B 16rEF 16r8C 16rEE 16r8D 16r131 16r8E 16rC4 16r8F 16rC5 16r90 16rC9 16r91 16rE6 16r92 16rC6 16r93 16rF4 16r94 16rF6 16r95 16rF2 16r96 16rFB 16r97 16rF9 16r98 16r130 16r99 16rD6 16r9A 16rDC 16r9B 16rF8 16r9C 16rA3 16r9D 16rD8 16r9E 16r15E 16r9F 16r15F 16rA0 16rE1 16rA1 16rED 16rA2 16rF3 16rA3 16rFA 16rA4 16rF1 16rA5 16rD1 16rA6 16r11E 16rA7 16r11F 16rA8 16rBF 16rA9 16rAE 16rAA 16rAC 16rAB 16rBD 16rAC 16rBC 16rAD 16rA1 16rAE 16rAB 16rAF 16rBB 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16rC1 16rB6 16rC2 16rB7 16rC0 16rB8 16rA9 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16rA2 16rBE 16rA5 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16rE3 16rC7 16rC3 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16rA4 16rD0 16rBA 16rD1 16rAA 16rD2 16rCA 16rD3 16rCB 16rD4 16rC8 16rD6 16rCD 16rD7 16rCE 16rD8 16rCF 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16rA6 16rDE 16rCC 16rDF 16r2580 16rE0 16rD3 16rE1 16rDF 16rE2 16rD4 16rE3 16rD2 16rE4 16rF5 16rE5 16rD5 16rE6 16rB5 16rE8 16rD7 16rE9 16rDA 16rEA 16rDB 16rEB 16rD9 16rEC 16rEC 16rED 16rFF 16rEE 16rAF 16rEF 16rB4 16rF0 16rAD 16rF1 16rB1 16rF3 16rBE 16rF4 16rB6 16rF5 16rA7 16rF6 16rF7 16rF7 16rB8 16rF8 16rB0 16rF9 16rA8 16rFA 16rB7 16rFB 16rB9 16rFC 16rB3 16rFD 16rB2 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp857.
	encoder streamEncodingType: #CP857.
	^encoder'</body>

<body package="Jpl" selector="cp860EncoderInCharacterEncoderClass">cp860EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp860Encoder
	"CharacterEncoder cp860Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16rC7 16r81 16rFC 16r82 16rE9 16r83 16rE2 16r84 16rE3 16r85 16rE0 16r86 16rC1 16r87 16rE7 16r88 16rEA 16r89 16rCA 16r8A 16rE8 16r8B 16rCD 16r8C 16rD4 16r8D 16rEC 16r8E 16rC3 16r8F 16rC2 16r90 16rC9 16r91 16rC0 16r92 16rC8 16r93 16rF4 16r94 16rF5 16r95 16rF2 16r96 16rDA 16r97 16rF9 16r98 16rCC 16r99 16rD5 16r9A 16rDC 16r9B 16rA2 16r9C 16rA3 16r9D 16rD9 16r9E 16r20A7 16r9F 16rD3 16rA0 16rE1 16rA1 16rED 16rA2 16rF3 16rA3 16rFA 16rA4 16rF1 16rA5 16rD1 16rA6 16rAA 16rA7 16rBA 16rA8 16rBF 16rA9 16rD2 16rAA 16rAC 16rAB 16rBD 16rAC 16rBC 16rAD 16rA1 16rAE 16rAB 16rAF 16rBB 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16r2561 16rB6 16r2562 16rB7 16r2556 16rB8 16r2555 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16r255C 16rBE 16r255B 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16r255E 16rC7 16r255F 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16r2567 16rD0 16r2568 16rD1 16r2564 16rD2 16r2565 16rD3 16r2559 16rD4 16r2558 16rD5 16r2552 16rD6 16r2553 16rD7 16r256B 16rD8 16r256A 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16r258C 16rDE 16r2590 16rDF 16r2580 16rE0 16r3B1 16rE1 16rDF 16rE2 16r393 16rE3 16r3C0 16rE4 16r3A3 16rE5 16r3C3 16rE6 16rB5 16rE7 16r3C4 16rE8 16r3A6 16rE9 16r398 16rEA 16r3A9 16rEB 16r3B4 16rEC 16r221E 16rED 16r3C6 16rEE 16r3B5 16rEF 16r2229 16rF0 16r2261 16rF1 16rB1 16rF2 16r2265 16rF3 16r2264 16rF4 16r2320 16rF5 16r2321 16rF6 16rF7 16rF7 16r2248 16rF8 16rB0 16rF9 16r2219 16rFA 16rB7 16rFB 16r221A 16rFC 16r207F 16rFD 16rB2 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp860.
	encoder streamEncodingType: #CP860.
	^encoder'</body>

<body package="Jpl" selector="cp861EncoderInCharacterEncoderClass">cp861EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp861Encoder
	"CharacterEncoder cp861Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16rC7 16r81 16rFC 16r82 16rE9 16r83 16rE2 16r84 16rE4 16r85 16rE0 16r86 16rE5 16r87 16rE7 16r88 16rEA 16r89 16rEB 16r8A 16rE8 16r8B 16rD0 16r8C 16rF0 16r8D 16rDE 16r8E 16rC4 16r8F 16rC5 16r90 16rC9 16r91 16rE6 16r92 16rC6 16r93 16rF4 16r94 16rF6 16r95 16rFE 16r96 16rFB 16r97 16rDD 16r98 16rFD 16r99 16rD6 16r9A 16rDC 16r9B 16rF8 16r9C 16rA3 16r9D 16rD8 16r9E 16r20A7 16r9F 16r192 16rA0 16rE1 16rA1 16rED 16rA2 16rF3 16rA3 16rFA 16rA4 16rC1 16rA5 16rCD 16rA6 16rD3 16rA7 16rDA 16rA8 16rBF 16rA9 16r2310 16rAA 16rAC 16rAB 16rBD 16rAC 16rBC 16rAD 16rA1 16rAE 16rAB 16rAF 16rBB 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16r2561 16rB6 16r2562 16rB7 16r2556 16rB8 16r2555 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16r255C 16rBE 16r255B 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16r255E 16rC7 16r255F 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16r2567 16rD0 16r2568 16rD1 16r2564 16rD2 16r2565 16rD3 16r2559 16rD4 16r2558 16rD5 16r2552 16rD6 16r2553 16rD7 16r256B 16rD8 16r256A 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16r258C 16rDE 16r2590 16rDF 16r2580 16rE0 16r3B1 16rE1 16rDF 16rE2 16r393 16rE3 16r3C0 16rE4 16r3A3 16rE5 16r3C3 16rE6 16rB5 16rE7 16r3C4 16rE8 16r3A6 16rE9 16r398 16rEA 16r3A9 16rEB 16r3B4 16rEC 16r221E 16rED 16r3C6 16rEE 16r3B5 16rEF 16r2229 16rF0 16r2261 16rF1 16rB1 16rF2 16r2265 16rF3 16r2264 16rF4 16r2320 16rF5 16r2321 16rF6 16rF7 16rF7 16r2248 16rF8 16rB0 16rF9 16r2219 16rFA 16rB7 16rFB 16r221A 16rFC 16r207F 16rFD 16rB2 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp861.
	encoder streamEncodingType: #CP861.
	^encoder'</body>

<body package="Jpl" selector="cp862EncoderInCharacterEncoderClass">cp862EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp862Encoder
	"CharacterEncoder cp862Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r5D0 16r81 16r5D1 16r82 16r5D2 16r83 16r5D3 16r84 16r5D4 16r85 16r5D5 16r86 16r5D6 16r87 16r5D7 16r88 16r5D8 16r89 16r5D9 16r8A 16r5DA 16r8B 16r5DB 16r8C 16r5DC 16r8D 16r5DD 16r8E 16r5DE 16r8F 16r5DF 16r90 16r5E0 16r91 16r5E1 16r92 16r5E2 16r93 16r5E3 16r94 16r5E4 16r95 16r5E5 16r96 16r5E6 16r97 16r5E7 16r98 16r5E8 16r99 16r5E9 16r9A 16r5EA 16r9B 16rA2 16r9C 16rA3 16r9D 16rA5 16r9E 16r20A7 16r9F 16r192 16rA0 16rE1 16rA1 16rED 16rA2 16rF3 16rA3 16rFA 16rA4 16rF1 16rA5 16rD1 16rA6 16rAA 16rA7 16rBA 16rA8 16rBF 16rA9 16r2310 16rAA 16rAC 16rAB 16rBD 16rAC 16rBC 16rAD 16rA1 16rAE 16rAB 16rAF 16rBB 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16r2561 16rB6 16r2562 16rB7 16r2556 16rB8 16r2555 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16r255C 16rBE 16r255B 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16r255E 16rC7 16r255F 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16r2567 16rD0 16r2568 16rD1 16r2564 16rD2 16r2565 16rD3 16r2559 16rD4 16r2558 16rD5 16r2552 16rD6 16r2553 16rD7 16r256B 16rD8 16r256A 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16r258C 16rDE 16r2590 16rDF 16r2580 16rE0 16r3B1 16rE1 16rDF 16rE2 16r393 16rE3 16r3C0 16rE4 16r3A3 16rE5 16r3C3 16rE6 16rB5 16rE7 16r3C4 16rE8 16r3A6 16rE9 16r398 16rEA 16r3A9 16rEB 16r3B4 16rEC 16r221E 16rED 16r3C6 16rEE 16r3B5 16rEF 16r2229 16rF0 16r2261 16rF1 16rB1 16rF2 16r2265 16rF3 16r2264 16rF4 16r2320 16rF5 16r2321 16rF6 16rF7 16rF7 16r2248 16rF8 16rB0 16rF9 16r2219 16rFA 16rB7 16rFB 16r221A 16rFC 16r207F 16rFD 16rB2 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp862.
	encoder streamEncodingType: #CP862.
	^encoder'</body>

<body package="Jpl" selector="cp863EncoderInCharacterEncoderClass">cp863EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp863Encoder
	"CharacterEncoder cp863Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16rC7 16r81 16rFC 16r82 16rE9 16r83 16rE2 16r84 16rC2 16r85 16rE0 16r86 16rB6 16r87 16rE7 16r88 16rEA 16r89 16rEB 16r8A 16rE8 16r8B 16rEF 16r8C 16rEE 16r8D 16r2017 16r8E 16rC0 16r8F 16rA7 16r90 16rC9 16r91 16rC8 16r92 16rCA 16r93 16rF4 16r94 16rCB 16r95 16rCF 16r96 16rFB 16r97 16rF9 16r98 16rA4 16r99 16rD4 16r9A 16rDC 16r9B 16rA2 16r9C 16rA3 16r9D 16rD9 16r9E 16rDB 16r9F 16r192 16rA0 16rA6 16rA1 16rB4 16rA2 16rF3 16rA3 16rFA 16rA4 16rA8 16rA5 16rB8 16rA6 16rB3 16rA7 16rAF 16rA8 16rCE 16rA9 16r2310 16rAA 16rAC 16rAB 16rBD 16rAC 16rBC 16rAD 16rBE 16rAE 16rAB 16rAF 16rBB 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16r2561 16rB6 16r2562 16rB7 16r2556 16rB8 16r2555 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16r255C 16rBE 16r255B 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16r255E 16rC7 16r255F 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16r2567 16rD0 16r2568 16rD1 16r2564 16rD2 16r2565 16rD3 16r2559 16rD4 16r2558 16rD5 16r2552 16rD6 16r2553 16rD7 16r256B 16rD8 16r256A 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16r258C 16rDE 16r2590 16rDF 16r2580 16rE0 16r3B1 16rE1 16rDF 16rE2 16r393 16rE3 16r3C0 16rE4 16r3A3 16rE5 16r3C3 16rE6 16rB5 16rE7 16r3C4 16rE8 16r3A6 16rE9 16r398 16rEA 16r3A9 16rEB 16r3B4 16rEC 16r221E 16rED 16r3C6 16rEE 16r3B5 16rEF 16r2229 16rF0 16r2261 16rF1 16rB1 16rF2 16r2265 16rF3 16r2264 16rF4 16r2320 16rF5 16r2321 16rF6 16rF7 16rF7 16r2248 16rF8 16rB0 16rF9 16r2219 16rFA 16rB7 16rFB 16r221A 16rFC 16r207F 16rFD 16rB2 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp863.
	encoder streamEncodingType: #CP863.
	^encoder'</body>

<body package="Jpl" selector="cp864EncoderInCharacterEncoderClass">cp864EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp864Encoder
	"CharacterEncoder cp864Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r66A 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16rB0 16r81 16rB7 16r82 16r2219 16r83 16r221A 16r84 16r2592 16r85 16r2500 16r86 16r2502 16r87 16r253C 16r88 16r2524 16r89 16r252C 16r8A 16r251C 16r8B 16r2534 16r8C 16r2510 16r8D 16r250C 16r8E 16r2514 16r8F 16r2518 16r90 16r3B2 16r91 16r221E 16r92 16r3C6 16r93 16rB1 16r94 16rBD 16r95 16rBC 16r96 16r2248 16r97 16rAB 16r98 16rBB 16r99 16rFEF7 16r9A 16rFEF8 16r9D 16rFEFB 16r9E 16rFEFC 16rA0 16rA0 16rA1 16rAD 16rA2 16rFE82 16rA3 16rA3 16rA4 16rA4 16rA5 16rFE84 16rA8 16rFE8E 16rA9 16rFE8F 16rAA 16rFE95 16rAB 16rFE99 16rAC 16r60C 16rAD 16rFE9D 16rAE 16rFEA1 16rAF 16rFEA5 16rB0 16r660 16rB1 16r661 16rB2 16r662 16rB3 16r663 16rB4 16r664 16rB5 16r665 16rB6 16r666 16rB7 16r667 16rB8 16r668 16rB9 16r669 16rBA 16rFED1 16rBB 16r61B 16rBC 16rFEB1 16rBD 16rFEB5 16rBE 16rFEB9 16rBF 16r61F 16rC0 16rA2 16rC1 16rFE80 16rC2 16rFE81 16rC3 16rFE83 16rC4 16rFE85 16rC5 16rFECA 16rC6 16rFE8B 16rC7 16rFE8D 16rC8 16rFE91 16rC9 16rFE93 16rCA 16rFE97 16rCB 16rFE9B 16rCC 16rFE9F 16rCD 16rFEA3 16rCE 16rFEA7 16rCF 16rFEA9 16rD0 16rFEAB 16rD1 16rFEAD 16rD2 16rFEAF 16rD3 16rFEB3 16rD4 16rFEB7 16rD5 16rFEBB 16rD6 16rFEBF 16rD7 16rFEC1 16rD8 16rFEC5 16rD9 16rFECB 16rDA 16rFECF 16rDB 16rA6 16rDC 16rAC 16rDD 16rF7 16rDE 16rD7 16rDF 16rFEC9 16rE0 16r640 16rE1 16rFED3 16rE2 16rFED7 16rE3 16rFEDB 16rE4 16rFEDF 16rE5 16rFEE3 16rE6 16rFEE7 16rE7 16rFEEB 16rE8 16rFEED 16rE9 16rFEEF 16rEA 16rFEF3 16rEB 16rFEBD 16rEC 16rFECC 16rED 16rFECE 16rEE 16rFECD 16rEF 16rFEE1 16rF0 16rFE7D 16rF1 16r651 16rF2 16rFEE5 16rF3 16rFEE9 16rF4 16rFEEC 16rF5 16rFEF0 16rF6 16rFEF2 16rF7 16rFED0 16rF8 16rFED5 16rF9 16rFEF5 16rFA 16rFEF6 16rFB 16rFEDD 16rFC 16rFED9 16rFD 16rFEF1 16rFE 16r25A0).
	encoder name: #cp864.
	encoder streamEncodingType: #CP864.
	^encoder'</body>

<body package="Jpl" selector="cp865EncoderInCharacterEncoderClass">cp865EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp865Encoder
	"CharacterEncoder cp865Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16rC7 16r81 16rFC 16r82 16rE9 16r83 16rE2 16r84 16rE4 16r85 16rE0 16r86 16rE5 16r87 16rE7 16r88 16rEA 16r89 16rEB 16r8A 16rE8 16r8B 16rEF 16r8C 16rEE 16r8D 16rEC 16r8E 16rC4 16r8F 16rC5 16r90 16rC9 16r91 16rE6 16r92 16rC6 16r93 16rF4 16r94 16rF6 16r95 16rF2 16r96 16rFB 16r97 16rF9 16r98 16rFF 16r99 16rD6 16r9A 16rDC 16r9B 16rF8 16r9C 16rA3 16r9D 16rD8 16r9E 16r20A7 16r9F 16r192 16rA0 16rE1 16rA1 16rED 16rA2 16rF3 16rA3 16rFA 16rA4 16rF1 16rA5 16rD1 16rA6 16rAA 16rA7 16rBA 16rA8 16rBF 16rA9 16r2310 16rAA 16rAC 16rAB 16rBD 16rAC 16rBC 16rAD 16rA1 16rAE 16rAB 16rAF 16rA4 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16r2561 16rB6 16r2562 16rB7 16r2556 16rB8 16r2555 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16r255C 16rBE 16r255B 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16r255E 16rC7 16r255F 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16r2567 16rD0 16r2568 16rD1 16r2564 16rD2 16r2565 16rD3 16r2559 16rD4 16r2558 16rD5 16r2552 16rD6 16r2553 16rD7 16r256B 16rD8 16r256A 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16r258C 16rDE 16r2590 16rDF 16r2580 16rE0 16r3B1 16rE1 16rDF 16rE2 16r393 16rE3 16r3C0 16rE4 16r3A3 16rE5 16r3C3 16rE6 16rB5 16rE7 16r3C4 16rE8 16r3A6 16rE9 16r398 16rEA 16r3A9 16rEB 16r3B4 16rEC 16r221E 16rED 16r3C6 16rEE 16r3B5 16rEF 16r2229 16rF0 16r2261 16rF1 16rB1 16rF2 16r2265 16rF3 16r2264 16rF4 16r2320 16rF5 16r2321 16rF6 16rF7 16rF7 16r2248 16rF8 16rB0 16rF9 16r2219 16rFA 16rB7 16rFB 16r221A 16rFC 16r207F 16rFD 16rB2 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp865.
	encoder streamEncodingType: #CP865.
	^encoder'</body>

<body package="Jpl" selector="cp866EncoderInCharacterEncoderClass">cp866EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp866Encoder
	"CharacterEncoder cp866Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r410 16r81 16r411 16r82 16r412 16r83 16r413 16r84 16r414 16r85 16r415 16r86 16r416 16r87 16r417 16r88 16r418 16r89 16r419 16r8A 16r41A 16r8B 16r41B 16r8C 16r41C 16r8D 16r41D 16r8E 16r41E 16r8F 16r41F 16r90 16r420 16r91 16r421 16r92 16r422 16r93 16r423 16r94 16r424 16r95 16r425 16r96 16r426 16r97 16r427 16r98 16r428 16r99 16r429 16r9A 16r42A 16r9B 16r42B 16r9C 16r42C 16r9D 16r42D 16r9E 16r42E 16r9F 16r42F 16rA0 16r430 16rA1 16r431 16rA2 16r432 16rA3 16r433 16rA4 16r434 16rA5 16r435 16rA6 16r436 16rA7 16r437 16rA8 16r438 16rA9 16r439 16rAA 16r43A 16rAB 16r43B 16rAC 16r43C 16rAD 16r43D 16rAE 16r43E 16rAF 16r43F 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16r2561 16rB6 16r2562 16rB7 16r2556 16rB8 16r2555 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16r255C 16rBE 16r255B 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16r255E 16rC7 16r255F 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16r2567 16rD0 16r2568 16rD1 16r2564 16rD2 16r2565 16rD3 16r2559 16rD4 16r2558 16rD5 16r2552 16rD6 16r2553 16rD7 16r256B 16rD8 16r256A 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16r258C 16rDE 16r2590 16rDF 16r2580 16rE0 16r440 16rE1 16r441 16rE2 16r442 16rE3 16r443 16rE4 16r444 16rE5 16r445 16rE6 16r446 16rE7 16r447 16rE8 16r448 16rE9 16r449 16rEA 16r44A 16rEB 16r44B 16rEC 16r44C 16rED 16r44D 16rEE 16r44E 16rEF 16r44F 16rF0 16r401 16rF1 16r451 16rF2 16r404 16rF3 16r454 16rF4 16r407 16rF5 16r457 16rF6 16r40E 16rF7 16r45E 16rF8 16rB0 16rF9 16r2219 16rFA 16rB7 16rFB 16r221A 16rFC 16r2116 16rFD 16rA4 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp866.
	encoder streamEncodingType: #CP866.
	^encoder'</body>

<body package="Jpl" selector="cp869EncoderInCharacterEncoderClass">cp869EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp869Encoder
	"CharacterEncoder cp869Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r86 16r386 16r88 16rB7 16r89 16rAC 16r8A 16rA6 16r8B 16r2018 16r8C 16r2019 16r8D 16r388 16r8E 16r2015 16r8F 16r389 16r90 16r38A 16r91 16r3AA 16r92 16r38C 16r95 16r38E 16r96 16r3AB 16r97 16rA9 16r98 16r38F 16r99 16rB2 16r9A 16rB3 16r9B 16r3AC 16r9C 16rA3 16r9D 16r3AD 16r9E 16r3AE 16r9F 16r3AF 16rA0 16r3CA 16rA1 16r390 16rA2 16r3CC 16rA3 16r3CD 16rA4 16r391 16rA5 16r392 16rA6 16r393 16rA7 16r394 16rA8 16r395 16rA9 16r396 16rAA 16r397 16rAB 16rBD 16rAC 16r398 16rAD 16r399 16rAE 16rAB 16rAF 16rBB 16rB0 16r2591 16rB1 16r2592 16rB2 16r2593 16rB3 16r2502 16rB4 16r2524 16rB5 16r39A 16rB6 16r39B 16rB7 16r39C 16rB8 16r39D 16rB9 16r2563 16rBA 16r2551 16rBB 16r2557 16rBC 16r255D 16rBD 16r39E 16rBE 16r39F 16rBF 16r2510 16rC0 16r2514 16rC1 16r2534 16rC2 16r252C 16rC3 16r251C 16rC4 16r2500 16rC5 16r253C 16rC6 16r3A0 16rC7 16r3A1 16rC8 16r255A 16rC9 16r2554 16rCA 16r2569 16rCB 16r2566 16rCC 16r2560 16rCD 16r2550 16rCE 16r256C 16rCF 16r3A3 16rD0 16r3A4 16rD1 16r3A5 16rD2 16r3A6 16rD3 16r3A7 16rD4 16r3A8 16rD5 16r3A9 16rD6 16r3B1 16rD7 16r3B2 16rD8 16r3B3 16rD9 16r2518 16rDA 16r250C 16rDB 16r2588 16rDC 16r2584 16rDD 16r3B4 16rDE 16r3B5 16rDF 16r2580 16rE0 16r3B6 16rE1 16r3B7 16rE2 16r3B8 16rE3 16r3B9 16rE4 16r3BA 16rE5 16r3BB 16rE6 16r3BC 16rE7 16r3BD 16rE8 16r3BE 16rE9 16r3BF 16rEA 16r3C0 16rEB 16r3C1 16rEC 16r3C3 16rED 16r3C2 16rEE 16r3C4 16rEF 16r384 16rF0 16rAD 16rF1 16rB1 16rF2 16r3C5 16rF3 16r3C6 16rF4 16r3C7 16rF5 16rA7 16rF6 16r3C8 16rF7 16r385 16rF8 16rB0 16rF9 16rA8 16rFA 16r3C9 16rFB 16r3CB 16rFC 16r3B0 16rFD 16r3CE 16rFE 16r25A0 16rFF 16rA0).
	encoder name: #cp869.
	encoder streamEncodingType: #CP869.
	^encoder'</body>

<body package="Jpl" selector="cp874EncoderInCharacterEncoderClass">cp874EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-pc character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'cp874Encoder
	"CharacterEncoder cp874Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r0 16r0 16r1 16r1 16r2 16r2 16r3 16r3 16r4 16r4 16r5 16r5 16r6 16r6 16r7 16r7 16r8 16r8 16r9 16r9 16rA 16rA 16rB 16rB 16rC 16rC 16rD 16rD 16rE 16rE 16rF 16rF 16r10 16r10 16r11 16r11 16r12 16r12 16r13 16r13 16r14 16r14 16r15 16r15 16r16 16r16 16r17 16r17 16r18 16r18 16r19 16r19 16r1A 16r1A 16r1B 16r1B 16r1C 16r1C 16r1D 16r1D 16r1E 16r1E 16r1F 16r1F 16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16r7F 16r7F 16r80 16r20AC 16r85 16r2026 16r91 16r2018 16r92 16r2019 16r93 16r201C 16r94 16r201D 16r95 16r2022 16r96 16r2013 16r97 16r2014 16rA0 16rA0 16rA1 16rE01 16rA2 16rE02 16rA3 16rE03 16rA4 16rE04 16rA5 16rE05 16rA6 16rE06 16rA7 16rE07 16rA8 16rE08 16rA9 16rE09 16rAA 16rE0A 16rAB 16rE0B 16rAC 16rE0C 16rAD 16rE0D 16rAE 16rE0E 16rAF 16rE0F 16rB0 16rE10 16rB1 16rE11 16rB2 16rE12 16rB3 16rE13 16rB4 16rE14 16rB5 16rE15 16rB6 16rE16 16rB7 16rE17 16rB8 16rE18 16rB9 16rE19 16rBA 16rE1A 16rBB 16rE1B 16rBC 16rE1C 16rBD 16rE1D 16rBE 16rE1E 16rBF 16rE1F 16rC0 16rE20 16rC1 16rE21 16rC2 16rE22 16rC3 16rE23 16rC4 16rE24 16rC5 16rE25 16rC6 16rE26 16rC7 16rE27 16rC8 16rE28 16rC9 16rE29 16rCA 16rE2A 16rCB 16rE2B 16rCC 16rE2C 16rCD 16rE2D 16rCE 16rE2E 16rCF 16rE2F 16rD0 16rE30 16rD1 16rE31 16rD2 16rE32 16rD3 16rE33 16rD4 16rE34 16rD5 16rE35 16rD6 16rE36 16rD7 16rE37 16rD8 16rE38 16rD9 16rE39 16rDA 16rE3A 16rDF 16rE3F 16rE0 16rE40 16rE1 16rE41 16rE2 16rE42 16rE3 16rE43 16rE4 16rE44 16rE5 16rE45 16rE6 16rE46 16rE7 16rE47 16rE8 16rE48 16rE9 16rE49 16rEA 16rE4A 16rEB 16rE4B 16rEC 16rE4C 16rED 16rE4D 16rEE 16rE4E 16rEF 16rE4F 16rF0 16rE50 16rF1 16rE51 16rF2 16rE52 16rF3 16rE53 16rF4 16rE54 16rF5 16rE55 16rF6 16rE56 16rF7 16rE57 16rF8 16rE58 16rF9 16rE59 16rFA 16rE5A 16rFB 16rE5B).
	encoder name: #cp874.
	encoder streamEncodingType: #CP874.
	^encoder'</body>

<body package="Jpl" selector="createByteEncoderInCharacterEncoderClass">createByteEncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'createByteEncoder: table 
	| encoder |
	encoder := ByteCharacterEncoder new.
	(0 to: 16r1F) , #(16r7F) do: 
			[:i | "control-code"
			encoder encode: i asCharacter as: i].
	1 to: table size
		by: 2
		do: 
			[:i | 
			| charcode unicode |
			charcode := table at: i.
			unicode := table at: i + 1.
			encoder encode: unicode asCharacter as: charcode].
	^encoder'</body>

<body package="Jpl" selector="createLargeCharacterEncoderInCharacterEncoderClass">createLargeCharacterEncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'createLargeCharacterEncoder: table 
	| encoder |
	encoder := LargeCharacterEncoder new.
	1 to: table size
		by: 2
		do: 
			[:i | 
			| charcode unicode |
			charcode := table at: i.
			unicode := table at: i + 1.
			encoder encode: unicode asCharacter as: charcode].
	^encoder'</body>

<body package="Jpl" selector="encoderNamedIfAbsentInCharacterEncoderClass">encoderNamedIfAbsentInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'accessing'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'encoderNamed: aString 
	^(Encoders at: self platformName) at: aString asLowercase asSymbol
		ifAbsent: [(Encoders at: #common) at: aString asLowercase asSymbol]'</body>

<body package="Jpl" selector="encoderNamedInCharacterEncoderClass">encoderNamedInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'accessing'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'encoderNamed: aString ifAbsent: aBlock 
	^(Encoders at: self platformName) at: aString asLowercase asSymbol
		ifAbsent: 
			[(Encoders at: #common) at: aString asLowercase asSymbol ifAbsent: aBlock]'</body>

<body package="Jpl" selector="installMiscCharacterSetsInCharacterEncoderClass">installMiscCharacterSetsInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'installMiscCharacterSets
	"CharacterEncoder installMiscCharacterSets."

	| sjencoder |
	Encoders at: #common put: Dictionary new.
	#(#iso88591Encoder #iso88592Encoder #iso88593Encoder #iso88594Encoder #iso88595Encoder #iso88596Encoder #iso88597Encoder #iso88598Encoder #iso88599Encoder #iso885914Encoder #iso885915Encoder #cp437Encoder #cp737Encoder #cp775Encoder #cp850Encoder #cp852Encoder #cp855Encoder #cp857Encoder #cp860Encoder #cp861Encoder #cp862Encoder #cp863Encoder #cp864Encoder #cp865Encoder #cp866Encoder #cp869Encoder #cp874Encoder #cp1250Encoder #cp1251Encoder #cp1252Encoder #cp1253Encoder #cp1254Encoder #cp1255Encoder #cp1256Encoder #cp1257Encoder #cp1258Encoder #jisx0201Encoder #jisx0208Encoder #jisx0212Encoder) 
		do: 
			[:msg | 
			| encoder |
			encoder := CharacterEncoder perform: msg.
			CharacterEncoder 
				installEncoder: encoder
				named: encoder name
				platform: #common].
	sjencoder := CharacterEncoder shiftJISEncoder.
	CharacterEncoder 
		installEncoder: sjencoder
		named: ["#ShiftJIS" sjencoder name] value
		platform: #common.
	CharacterEncoder 
		installEncoder: sjencoder
		named: #kanji
		platform: #win32.
	CharacterEncoder 
		installEncoder: sjencoder
		named: #kanji
		platform: #mac'</body>

<body package="Jpl" selector="iso885914EncoderInCharacterEncoderClass">iso885914EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-iso character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'iso885914Encoder
	"CharacterEncoder iso885914Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16rA0 16rA0 16rA1 16r1E02 16rA2 16r1E03 16rA3 16rA3 16rA4 16r10A 16rA5 16r10B 16rA6 16r1E0A 16rA7 16rA7 16rA8 16r1E80 16rA9 16rA9 16rAA 16r1E82 16rAB 16r1E0B 16rAC 16r1EF2 16rAD 16rAD 16rAE 16rAE 16rAF 16r178 16rB0 16r1E1E 16rB1 16r1E1F 16rB2 16r120 16rB3 16r121 16rB4 16r1E40 16rB5 16r1E41 16rB6 16rB6 16rB7 16r1E56 16rB8 16r1E81 16rB9 16r1E57 16rBA 16r1E83 16rBB 16r1E60 16rBC 16r1EF3 16rBD 16r1E84 16rBE 16r1E85 16rBF 16r1E61 16rC0 16rC0 16rC1 16rC1 16rC2 16rC2 16rC3 16rC3 16rC4 16rC4 16rC5 16rC5 16rC6 16rC6 16rC7 16rC7 16rC8 16rC8 16rC9 16rC9 16rCA 16rCA 16rCB 16rCB 16rCC 16rCC 16rCD 16rCD 16rCE 16rCE 16rCF 16rCF 16rD0 16r174 16rD1 16rD1 16rD2 16rD2 16rD3 16rD3 16rD4 16rD4 16rD5 16rD5 16rD6 16rD6 16rD7 16r1E6A 16rD8 16rD8 16rD9 16rD9 16rDA 16rDA 16rDB 16rDB 16rDC 16rDC 16rDD 16rDD 16rDE 16r176 16rDF 16rDF 16rE0 16rE0 16rE1 16rE1 16rE2 16rE2 16rE3 16rE3 16rE4 16rE4 16rE5 16rE5 16rE6 16rE6 16rE7 16rE7 16rE8 16rE8 16rE9 16rE9 16rEA 16rEA 16rEB 16rEB 16rEC 16rEC 16rED 16rED 16rEE 16rEE 16rEF 16rEF 16rF0 16r175 16rF1 16rF1 16rF2 16rF2 16rF3 16rF3 16rF4 16rF4 16rF5 16rF5 16rF6 16rF6 16rF7 16r1E6B 16rF8 16rF8 16rF9 16rF9 16rFA 16rFA 16rFB 16rFB 16rFC 16rFC 16rFD 16rFD 16rFE 16r177 16rFF 16rFF).
	encoder name: #''iso8859-14''.
	encoder streamEncodingType: #ISO8859_14.
	^encoder'</body>

<body package="Jpl" selector="iso885915EncoderInCharacterEncoderClass">iso885915EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-iso character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'iso885915Encoder
	"CharacterEncoder iso885915Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16rA0 16rA0 16rA1 16rA1 16rA2 16rA2 16rA3 16rA3 16rA4 16r20AC 16rA5 16rA5 16rA6 16r160 16rA7 16rA7 16rA8 16r161 16rA9 16rA9 16rAA 16rAA 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16rAF 16rB0 16rB0 16rB1 16rB1 16rB2 16rB2 16rB3 16rB3 16rB4 16r17D 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16r17E 16rB9 16rB9 16rBA 16rBA 16rBB 16rBB 16rBC 16r152 16rBD 16r153 16rBE 16r178 16rBF 16rBF 16rC0 16rC0 16rC1 16rC1 16rC2 16rC2 16rC3 16rC3 16rC4 16rC4 16rC5 16rC5 16rC6 16rC6 16rC7 16rC7 16rC8 16rC8 16rC9 16rC9 16rCA 16rCA 16rCB 16rCB 16rCC 16rCC 16rCD 16rCD 16rCE 16rCE 16rCF 16rCF 16rD0 16rD0 16rD1 16rD1 16rD2 16rD2 16rD3 16rD3 16rD4 16rD4 16rD5 16rD5 16rD6 16rD6 16rD7 16rD7 16rD8 16rD8 16rD9 16rD9 16rDA 16rDA 16rDB 16rDB 16rDC 16rDC 16rDD 16rDD 16rDE 16rDE 16rDF 16rDF 16rE0 16rE0 16rE1 16rE1 16rE2 16rE2 16rE3 16rE3 16rE4 16rE4 16rE5 16rE5 16rE6 16rE6 16rE7 16rE7 16rE8 16rE8 16rE9 16rE9 16rEA 16rEA 16rEB 16rEB 16rEC 16rEC 16rED 16rED 16rEE 16rEE 16rEF 16rEF 16rF0 16rF0 16rF1 16rF1 16rF2 16rF2 16rF3 16rF3 16rF4 16rF4 16rF5 16rF5 16rF6 16rF6 16rF7 16rF7 16rF8 16rF8 16rF9 16rF9 16rFA 16rFA 16rFB 16rFB 16rFC 16rFC 16rFD 16rFD 16rFE 16rFE 16rFF 16rFF).
	encoder name: #''iso8859-15''.
	encoder streamEncodingType: #ISO8859_15.
	^encoder'</body>

<body package="Jpl" selector="iso88591EncoderInCharacterEncoderClass">iso88591EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-iso character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'iso88591Encoder
	"CharacterEncoder iso88591Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16rA0 16rA0 16rA1 16rA1 16rA2 16rA2 16rA3 16rA3 16rA4 16rA4 16rA5 16rA5 16rA6 16rA6 16rA7 16rA7 16rA8 16rA8 16rA9 16rA9 16rAA 16rAA 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16rAF 16rB0 16rB0 16rB1 16rB1 16rB2 16rB2 16rB3 16rB3 16rB4 16rB4 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16rB8 16rB9 16rB9 16rBA 16rBA 16rBB 16rBB 16rBC 16rBC 16rBD 16rBD 16rBE 16rBE 16rBF 16rBF 16rC0 16rC0 16rC1 16rC1 16rC2 16rC2 16rC3 16rC3 16rC4 16rC4 16rC5 16rC5 16rC6 16rC6 16rC7 16rC7 16rC8 16rC8 16rC9 16rC9 16rCA 16rCA 16rCB 16rCB 16rCC 16rCC 16rCD 16rCD 16rCE 16rCE 16rCF 16rCF 16rD0 16rD0 16rD1 16rD1 16rD2 16rD2 16rD3 16rD3 16rD4 16rD4 16rD5 16rD5 16rD6 16rD6 16rD7 16rD7 16rD8 16rD8 16rD9 16rD9 16rDA 16rDA 16rDB 16rDB 16rDC 16rDC 16rDD 16rDD 16rDE 16rDE 16rDF 16rDF 16rE0 16rE0 16rE1 16rE1 16rE2 16rE2 16rE3 16rE3 16rE4 16rE4 16rE5 16rE5 16rE6 16rE6 16rE7 16rE7 16rE8 16rE8 16rE9 16rE9 16rEA 16rEA 16rEB 16rEB 16rEC 16rEC 16rED 16rED 16rEE 16rEE 16rEF 16rEF 16rF0 16rF0 16rF1 16rF1 16rF2 16rF2 16rF3 16rF3 16rF4 16rF4 16rF5 16rF5 16rF6 16rF6 16rF7 16rF7 16rF8 16rF8 16rF9 16rF9 16rFA 16rFA 16rFB 16rFB 16rFC 16rFC 16rFD 16rFD 16rFE 16rFE 16rFF 16rFF).
	encoder name: #''iso8859-1''.
	encoder streamEncodingType: #ISO8859_1.
	^encoder'</body>

<body package="Jpl" selector="iso88592EncoderInCharacterEncoderClass">iso88592EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-iso character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'iso88592Encoder
	"CharacterEncoder iso88592Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16rA0 16rA0 16rA1 16r104 16rA2 16r2D8 16rA3 16r141 16rA4 16rA4 16rA5 16r13D 16rA6 16r15A 16rA7 16rA7 16rA8 16rA8 16rA9 16r160 16rAA 16r15E 16rAB 16r164 16rAC 16r179 16rAD 16rAD 16rAE 16r17D 16rAF 16r17B 16rB0 16rB0 16rB1 16r105 16rB2 16r2DB 16rB3 16r142 16rB4 16rB4 16rB5 16r13E 16rB6 16r15B 16rB7 16r2C7 16rB8 16rB8 16rB9 16r161 16rBA 16r15F 16rBB 16r165 16rBC 16r17A 16rBD 16r2DD 16rBE 16r17E 16rBF 16r17C 16rC0 16r154 16rC1 16rC1 16rC2 16rC2 16rC3 16r102 16rC4 16rC4 16rC5 16r139 16rC6 16r106 16rC7 16rC7 16rC8 16r10C 16rC9 16rC9 16rCA 16r118 16rCB 16rCB 16rCC 16r11A 16rCD 16rCD 16rCE 16rCE 16rCF 16r10E 16rD0 16r110 16rD1 16r143 16rD2 16r147 16rD3 16rD3 16rD4 16rD4 16rD5 16r150 16rD6 16rD6 16rD7 16rD7 16rD8 16r158 16rD9 16r16E 16rDA 16rDA 16rDB 16r170 16rDC 16rDC 16rDD 16rDD 16rDE 16r162 16rDF 16rDF 16rE0 16r155 16rE1 16rE1 16rE2 16rE2 16rE3 16r103 16rE4 16rE4 16rE5 16r13A 16rE6 16r107 16rE7 16rE7 16rE8 16r10D 16rE9 16rE9 16rEA 16r119 16rEB 16rEB 16rEC 16r11B 16rED 16rED 16rEE 16rEE 16rEF 16r10F 16rF0 16r111 16rF1 16r144 16rF2 16r148 16rF3 16rF3 16rF4 16rF4 16rF5 16r151 16rF6 16rF6 16rF7 16rF7 16rF8 16r159 16rF9 16r16F 16rFA 16rFA 16rFB 16r171 16rFC 16rFC 16rFD 16rFD 16rFE 16r163 16rFF 16r2D9).
	encoder name: #''iso8859-2''.
	encoder streamEncodingType: #ISO8859_2.
	^encoder'</body>

<body package="Jpl" selector="iso88593EncoderInCharacterEncoderClass">iso88593EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-iso character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'iso88593Encoder
	"CharacterEncoder iso88593Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16rA0 16rA0 16rA1 16r126 16rA2 16r2D8 16rA3 16rA3 16rA4 16rA4 16rA6 16r124 16rA7 16rA7 16rA8 16rA8 16rA9 16r130 16rAA 16r15E 16rAB 16r11E 16rAC 16r134 16rAD 16rAD 16rAF 16r17B 16rB0 16rB0 16rB1 16r127 16rB2 16rB2 16rB3 16rB3 16rB4 16rB4 16rB5 16rB5 16rB6 16r125 16rB7 16rB7 16rB8 16rB8 16rB9 16r131 16rBA 16r15F 16rBB 16r11F 16rBC 16r135 16rBD 16rBD 16rBF 16r17C 16rC0 16rC0 16rC1 16rC1 16rC2 16rC2 16rC4 16rC4 16rC5 16r10A 16rC6 16r108 16rC7 16rC7 16rC8 16rC8 16rC9 16rC9 16rCA 16rCA 16rCB 16rCB 16rCC 16rCC 16rCD 16rCD 16rCE 16rCE 16rCF 16rCF 16rD1 16rD1 16rD2 16rD2 16rD3 16rD3 16rD4 16rD4 16rD5 16r120 16rD6 16rD6 16rD7 16rD7 16rD8 16r11C 16rD9 16rD9 16rDA 16rDA 16rDB 16rDB 16rDC 16rDC 16rDD 16r16C 16rDE 16r15C 16rDF 16rDF 16rE0 16rE0 16rE1 16rE1 16rE2 16rE2 16rE4 16rE4 16rE5 16r10B 16rE6 16r109 16rE7 16rE7 16rE8 16rE8 16rE9 16rE9 16rEA 16rEA 16rEB 16rEB 16rEC 16rEC 16rED 16rED 16rEE 16rEE 16rEF 16rEF 16rF1 16rF1 16rF2 16rF2 16rF3 16rF3 16rF4 16rF4 16rF5 16r121 16rF6 16rF6 16rF7 16rF7 16rF8 16r11D 16rF9 16rF9 16rFA 16rFA 16rFB 16rFB 16rFC 16rFC 16rFD 16r16D 16rFE 16r15D 16rFF 16r2D9).
	encoder name: #''iso8859-3''.
	encoder streamEncodingType: #ISO8859_3.
	^encoder'</body>

<body package="Jpl" selector="iso88594EncoderInCharacterEncoderClass">iso88594EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-iso character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'iso88594Encoder
	"CharacterEncoder iso88594Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16rA0 16rA0 16rA1 16r104 16rA2 16r138 16rA3 16r156 16rA4 16rA4 16rA5 16r128 16rA6 16r13B 16rA7 16rA7 16rA8 16rA8 16rA9 16r160 16rAA 16r112 16rAB 16r122 16rAC 16r166 16rAD 16rAD 16rAE 16r17D 16rAF 16rAF 16rB0 16rB0 16rB1 16r105 16rB2 16r2DB 16rB3 16r157 16rB4 16rB4 16rB5 16r129 16rB6 16r13C 16rB7 16r2C7 16rB8 16rB8 16rB9 16r161 16rBA 16r113 16rBB 16r123 16rBC 16r167 16rBD 16r14A 16rBE 16r17E 16rBF 16r14B 16rC0 16r100 16rC1 16rC1 16rC2 16rC2 16rC3 16rC3 16rC4 16rC4 16rC5 16rC5 16rC6 16rC6 16rC7 16r12E 16rC8 16r10C 16rC9 16rC9 16rCA 16r118 16rCB 16rCB 16rCC 16r116 16rCD 16rCD 16rCE 16rCE 16rCF 16r12A 16rD0 16r110 16rD1 16r145 16rD2 16r14C 16rD3 16r136 16rD4 16rD4 16rD5 16rD5 16rD6 16rD6 16rD7 16rD7 16rD8 16rD8 16rD9 16r172 16rDA 16rDA 16rDB 16rDB 16rDC 16rDC 16rDD 16r168 16rDE 16r16A 16rDF 16rDF 16rE0 16r101 16rE1 16rE1 16rE2 16rE2 16rE3 16rE3 16rE4 16rE4 16rE5 16rE5 16rE6 16rE6 16rE7 16r12F 16rE8 16r10D 16rE9 16rE9 16rEA 16r119 16rEB 16rEB 16rEC 16r117 16rED 16rED 16rEE 16rEE 16rEF 16r12B 16rF0 16r111 16rF1 16r146 16rF2 16r14D 16rF3 16r137 16rF4 16rF4 16rF5 16rF5 16rF6 16rF6 16rF7 16rF7 16rF8 16rF8 16rF9 16r173 16rFA 16rFA 16rFB 16rFB 16rFC 16rFC 16rFD 16r169 16rFE 16r16B 16rFF 16r2D9).
	encoder name: #''iso8859-4''.
	encoder streamEncodingType: #ISO8859_4.
	^encoder'</body>

<body package="Jpl" selector="iso88595EncoderInCharacterEncoderClass">iso88595EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-iso character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'iso88595Encoder
	"CharacterEncoder iso88595Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16rA0 16rA0 16rA1 16r401 16rA2 16r402 16rA3 16r403 16rA4 16r404 16rA5 16r405 16rA6 16r406 16rA7 16r407 16rA8 16r408 16rA9 16r409 16rAA 16r40A 16rAB 16r40B 16rAC 16r40C 16rAD 16rAD 16rAE 16r40E 16rAF 16r40F 16rB0 16r410 16rB1 16r411 16rB2 16r412 16rB3 16r413 16rB4 16r414 16rB5 16r415 16rB6 16r416 16rB7 16r417 16rB8 16r418 16rB9 16r419 16rBA 16r41A 16rBB 16r41B 16rBC 16r41C 16rBD 16r41D 16rBE 16r41E 16rBF 16r41F 16rC0 16r420 16rC1 16r421 16rC2 16r422 16rC3 16r423 16rC4 16r424 16rC5 16r425 16rC6 16r426 16rC7 16r427 16rC8 16r428 16rC9 16r429 16rCA 16r42A 16rCB 16r42B 16rCC 16r42C 16rCD 16r42D 16rCE 16r42E 16rCF 16r42F 16rD0 16r430 16rD1 16r431 16rD2 16r432 16rD3 16r433 16rD4 16r434 16rD5 16r435 16rD6 16r436 16rD7 16r437 16rD8 16r438 16rD9 16r439 16rDA 16r43A 16rDB 16r43B 16rDC 16r43C 16rDD 16r43D 16rDE 16r43E 16rDF 16r43F 16rE0 16r440 16rE1 16r441 16rE2 16r442 16rE3 16r443 16rE4 16r444 16rE5 16r445 16rE6 16r446 16rE7 16r447 16rE8 16r448 16rE9 16r449 16rEA 16r44A 16rEB 16r44B 16rEC 16r44C 16rED 16r44D 16rEE 16r44E 16rEF 16r44F 16rF0 16r2116 16rF1 16r451 16rF2 16r452 16rF3 16r453 16rF4 16r454 16rF5 16r455 16rF6 16r456 16rF7 16r457 16rF8 16r458 16rF9 16r459 16rFA 16r45A 16rFB 16r45B 16rFC 16r45C 16rFD 16rA7 16rFE 16r45E 16rFF 16r45F).
	encoder name: #''iso8859-5''.
	encoder streamEncodingType: #ISO8859_5.
	^encoder'</body>

<body package="Jpl" selector="iso88596EncoderInCharacterEncoderClass">iso88596EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-iso character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'iso88596Encoder
	"CharacterEncoder iso88596Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r660 16r31 16r661 16r32 16r662 16r33 16r663 16r34 16r664 16r35 16r665 16r36 16r666 16r37 16r667 16r38 16r668 16r39 16r669 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16rA0 16rA0 16rA4 16rA4 16rAC 16r60C 16rAD 16rAD 16rBB 16r61B 16rBF 16r61F 16rC1 16r621 16rC2 16r622 16rC3 16r623 16rC4 16r624 16rC5 16r625 16rC6 16r626 16rC7 16r627 16rC8 16r628 16rC9 16r629 16rCA 16r62A 16rCB 16r62B 16rCC 16r62C 16rCD 16r62D 16rCE 16r62E 16rCF 16r62F 16rD0 16r630 16rD1 16r631 16rD2 16r632 16rD3 16r633 16rD4 16r634 16rD5 16r635 16rD6 16r636 16rD7 16r637 16rD8 16r638 16rD9 16r639 16rDA 16r63A 16rE0 16r640 16rE1 16r641 16rE2 16r642 16rE3 16r643 16rE4 16r644 16rE5 16r645 16rE6 16r646 16rE7 16r647 16rE8 16r648 16rE9 16r649 16rEA 16r64A 16rEB 16r64B 16rEC 16r64C 16rED 16r64D 16rEE 16r64E 16rEF 16r64F 16rF0 16r650 16rF1 16r651 16rF2 16r652).
	encoder name: #''iso8859-6''.
	encoder streamEncodingType: #ISO8859_6.
	^encoder'</body>

<body package="Jpl" selector="iso88597EncoderInCharacterEncoderClass">iso88597EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-iso character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'iso88597Encoder
	"CharacterEncoder iso88597Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16rA0 16rA0 16rA1 16r2BD 16rA2 16r2BC 16rA3 16rA3 16rA6 16rA6 16rA7 16rA7 16rA8 16rA8 16rA9 16rA9 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAF 16r2015 16rB0 16rB0 16rB1 16rB1 16rB2 16rB2 16rB3 16rB3 16rB4 16r384 16rB5 16r385 16rB6 16r386 16rB7 16rB7 16rB8 16r388 16rB9 16r389 16rBA 16r38A 16rBB 16rBB 16rBC 16r38C 16rBD 16rBD 16rBE 16r38E 16rBF 16r38F 16rC0 16r390 16rC1 16r391 16rC2 16r392 16rC3 16r393 16rC4 16r394 16rC5 16r395 16rC6 16r396 16rC7 16r397 16rC8 16r398 16rC9 16r399 16rCA 16r39A 16rCB 16r39B 16rCC 16r39C 16rCD 16r39D 16rCE 16r39E 16rCF 16r39F 16rD0 16r3A0 16rD1 16r3A1 16rD3 16r3A3 16rD4 16r3A4 16rD5 16r3A5 16rD6 16r3A6 16rD7 16r3A7 16rD8 16r3A8 16rD9 16r3A9 16rDA 16r3AA 16rDB 16r3AB 16rDC 16r3AC 16rDD 16r3AD 16rDE 16r3AE 16rDF 16r3AF 16rE0 16r3B0 16rE1 16r3B1 16rE2 16r3B2 16rE3 16r3B3 16rE4 16r3B4 16rE5 16r3B5 16rE6 16r3B6 16rE7 16r3B7 16rE8 16r3B8 16rE9 16r3B9 16rEA 16r3BA 16rEB 16r3BB 16rEC 16r3BC 16rED 16r3BD 16rEE 16r3BE 16rEF 16r3BF 16rF0 16r3C0 16rF1 16r3C1 16rF2 16r3C2 16rF3 16r3C3 16rF4 16r3C4 16rF5 16r3C5 16rF6 16r3C6 16rF7 16r3C7 16rF8 16r3C8 16rF9 16r3C9 16rFA 16r3CA 16rFB 16r3CB 16rFC 16r3CC 16rFD 16r3CD 16rFE 16r3CE).
	encoder name: #''iso8859-7''.
	encoder streamEncodingType: #ISO8859_7.
	^encoder'</body>

<body package="Jpl" selector="iso88598EncoderInCharacterEncoderClass">iso88598EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-iso character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'iso88598Encoder
	"CharacterEncoder iso88598Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16rA0 16rA0 16rA2 16rA2 16rA3 16rA3 16rA4 16rA4 16rA5 16rA5 16rA6 16rA6 16rA7 16rA7 16rA8 16rA8 16rA9 16rA9 16rAA 16rD7 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16r203E 16rB0 16rB0 16rB1 16rB1 16rB2 16rB2 16rB3 16rB3 16rB4 16rB4 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16rB8 16rB9 16rB9 16rBA 16rF7 16rBB 16rBB 16rBC 16rBC 16rBD 16rBD 16rBE 16rBE 16rDF 16r2017 16rE0 16r5D0 16rE1 16r5D1 16rE2 16r5D2 16rE3 16r5D3 16rE4 16r5D4 16rE5 16r5D5 16rE6 16r5D6 16rE7 16r5D7 16rE8 16r5D8 16rE9 16r5D9 16rEA 16r5DA 16rEB 16r5DB 16rEC 16r5DC 16rED 16r5DD 16rEE 16r5DE 16rEF 16r5DF 16rF0 16r5E0 16rF1 16r5E1 16rF2 16r5E2 16rF3 16r5E3 16rF4 16r5E4 16rF5 16r5E5 16rF6 16r5E6 16rF7 16r5E7 16rF8 16r5E8 16rF9 16r5E9 16rFA 16r5EA).
	encoder name: #''iso8859-8''.
	encoder streamEncodingType: #ISO8859_8.
	^encoder'</body>

<body package="Jpl" selector="iso88599EncoderInCharacterEncoderClass">iso88599EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-iso character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'iso88599Encoder
	"CharacterEncoder iso88599Encoder."

	| encoder |
	encoder := self createByteEncoder:
		#(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16r5C 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r7E 16rA0 16rA0 16rA1 16rA1 16rA2 16rA2 16rA3 16rA3 16rA4 16rA4 16rA5 16rA5 16rA6 16rA6 16rA7 16rA7 16rA8 16rA8 16rA9 16rA9 16rAA 16rAA 16rAB 16rAB 16rAC 16rAC 16rAD 16rAD 16rAE 16rAE 16rAF 16rAF 16rB0 16rB0 16rB1 16rB1 16rB2 16rB2 16rB3 16rB3 16rB4 16rB4 16rB5 16rB5 16rB6 16rB6 16rB7 16rB7 16rB8 16rB8 16rB9 16rB9 16rBA 16rBA 16rBB 16rBB 16rBC 16rBC 16rBD 16rBD 16rBE 16rBE 16rBF 16rBF 16rC0 16rC0 16rC1 16rC1 16rC2 16rC2 16rC3 16rC3 16rC4 16rC4 16rC5 16rC5 16rC6 16rC6 16rC7 16rC7 16rC8 16rC8 16rC9 16rC9 16rCA 16rCA 16rCB 16rCB 16rCC 16rCC 16rCD 16rCD 16rCE 16rCE 16rCF 16rCF 16rD0 16r11E 16rD1 16rD1 16rD2 16rD2 16rD3 16rD3 16rD4 16rD4 16rD5 16rD5 16rD6 16rD6 16rD7 16rD7 16rD8 16rD8 16rD9 16rD9 16rDA 16rDA 16rDB 16rDB 16rDC 16rDC 16rDD 16r130 16rDE 16r15E 16rDF 16rDF 16rE0 16rE0 16rE1 16rE1 16rE2 16rE2 16rE3 16rE3 16rE4 16rE4 16rE5 16rE5 16rE6 16rE6 16rE7 16rE7 16rE8 16rE8 16rE9 16rE9 16rEA 16rEA 16rEB 16rEB 16rEC 16rEC 16rED 16rED 16rEE 16rEE 16rEF 16rEF 16rF0 16r11F 16rF1 16rF1 16rF2 16rF2 16rF3 16rF3 16rF4 16rF4 16rF5 16rF5 16rF6 16rF6 16rF7 16rF7 16rF8 16rF8 16rF9 16rF9 16rFA 16rFA 16rFB 16rFB 16rFC 16rFC 16rFD 16r131 16rFE 16r15F 16rFF 16rFF).
	encoder name: #''iso8859-9''.
	encoder streamEncodingType: #ISO8859_9.
	^encoder'</body>

<body package="Jpl" selector="jisx0201EncoderInCharacterEncoderClass">jisx0201EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-jis character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'jisx0201Encoder
	"CharacterEncoder jisx0201Encoder."

	| encoder |
	encoder := self 
				createByteEncoder: #(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16rA5 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r203E 16rA1 16rFF61 16rA2 16rFF62 16rA3 16rFF63 16rA4 16rFF64 16rA5 16rFF65 16rA6 16rFF66 16rA7 16rFF67 16rA8 16rFF68 16rA9 16rFF69 16rAA 16rFF6A 16rAB 16rFF6B 16rAC 16rFF6C 16rAD 16rFF6D 16rAE 16rFF6E 16rAF 16rFF6F 16rB0 16rFF70 16rB1 16rFF71 16rB2 16rFF72 16rB3 16rFF73 16rB4 16rFF74 16rB5 16rFF75 16rB6 16rFF76 16rB7 16rFF77 16rB8 16rFF78 16rB9 16rFF79 16rBA 16rFF7A 16rBB 16rFF7B 16rBC 16rFF7C 16rBD 16rFF7D 16rBE 16rFF7E 16rBF 16rFF7F 16rC0 16rFF80 16rC1 16rFF81 16rC2 16rFF82 16rC3 16rFF83 16rC4 16rFF84 16rC5 16rFF85 16rC6 16rFF86 16rC7 16rFF87 16rC8 16rFF88 16rC9 16rFF89 16rCA 16rFF8A 16rCB 16rFF8B 16rCC 16rFF8C 16rCD 16rFF8D 16rCE 16rFF8E 16rCF 16rFF8F 16rD0 16rFF90 16rD1 16rFF91 16rD2 16rFF92 16rD3 16rFF93 16rD4 16rFF94 16rD5 16rFF95 16rD6 16rFF96 16rD7 16rFF97 16rD8 16rFF98 16rD9 16rFF99 16rDA 16rFF9A 16rDB 16rFF9B 16rDC 16rFF9C 16rDD 16rFF9D 16rDE 16rFF9E 16rDF 16rFF9F).
	encoder name: #''jisx0201.1976-0''.
	^encoder'</body>

<body package="Jpl" selector="jisx0208EncoderInCharacterEncoderClass">jisx0208EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-jis character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'jisx0208Encoder
	"CharacterEncoder jisx0208Encoder."

	| encoder |
	encoder := self 
				createLargeCharacterEncoder: #(16r2121 16r3000 16r2122 16r3001 16r2123 16r3002 16r2124 16rFF0C 16r2125 16rFF0E 16r2126 16r30FB 16r2127 16rFF1A 16r2128 16rFF1B 16r2129 16rFF1F 16r212A 16rFF01 16r212B 16r309B 16r212C 16r309C 16r212D 16rB4 16r212E 16rFF40 16r212F 16rA8 16r2130 16rFF3E 16r2131 16rFFE3 16r2132 16rFF3F 16r2133 16r30FD 16r2134 16r30FE 16r2135 16r309D 16r2136 16r309E 16r2137 16r3003 16r2138 16r4EDD 16r2139 16r3005 16r213A 16r3006 16r213B 16r3007 16r213C 16r30FC 16r213D 16r2015 16r213E 16r2010 16r213F 16rFF0F 16r2140 16r5C 16r2141 16r301C 16r2142 16r2016 16r2143 16rFF5C 16r2144 16r2026 16r2145 16r2025 16r2146 16r2018 16r2147 16r2019 16r2148 16r201C 16r2149 16r201D 16r214A 16rFF08 16r214B 16rFF09 16r214C 16r3014 16r214D 16r3015 16r214E 16rFF3B 16r214F 16rFF3D 16r2150 16rFF5B 16r2151 16rFF5D 16r2152 16r3008 16r2153 16r3009 16r2154 16r300A 16r2155 16r300B 16r2156 16r300C 16r2157 16r300D 16r2158 16r300E 16r2159 16r300F 16r215A 16r3010 16r215B 16r3011 16r215C 16rFF0B 16r215D 16r2212 16r215E 16rB1 16r215F 16rD7 16r2160 16rF7 16r2161 16rFF1D 16r2162 16r2260 16r2163 16rFF1C 16r2164 16rFF1E 16r2165 16r2266 16r2166 16r2267 16r2167 16r221E 16r2168 16r2234 16r2169 16r2642 16r216A 16r2640 16r216B 16rB0 16r216C 16r2032 16r216D 16r2033 16r216E 16r2103 16r216F 16rFFE5 16r2170 16rFF04 16r2171 16rA2 16r2172 16rA3 16r2173 16rFF05 16r2174 16rFF03 16r2175 16rFF06 16r2176 16rFF0A 16r2177 16rFF20 16r2178 16rA7 16r2179 16r2606 16r217A 16r2605 16r217B 16r25CB 16r217C 16r25CF 16r217D 16r25CE 16r217E 16r25C7 16r2221 16r25C6 16r2222 16r25A1 16r2223 16r25A0 16r2224 16r25B3 16r2225 16r25B2 16r2226 16r25BD 16r2227 16r25BC 16r2228 16r203B 16r2229 16r3012 16r222A 16r2192 16r222B 16r2190 16r222C 16r2191 16r222D 16r2193 16r222E 16r3013 16r223A 16r2208 16r223B 16r220B 16r223C 16r2286 16r223D 16r2287 16r223E 16r2282 16r223F 16r2283 16r2240 16r222A 16r2241 16r2229 16r224A 16r2227 16r224B 16r2228 16r224C 16rAC 16r224D 16r21D2 16r224E 16r21D4 16r224F 16r2200 16r2250 16r2203 16r225C 16r2220 16r225D 16r22A5 16r225E 16r2312 16r225F 16r2202 16r2260 16r2207 16r2261 16r2261 16r2262 16r2252 16r2263 16r226A 16r2264 16r226B 16r2265 16r221A 16r2266 16r223D 16r2267 16r221D 16r2268 16r2235 16r2269 16r222B 16r226A 16r222C 16r2272 16r212B 16r2273 16r2030 16r2274 16r266F 16r2275 16r266D 16r2276 16r266A 16r2277 16r2020 16r2278 16r2021 16r2279 16rB6 16r227E 16r25EF 16r2330 16rFF10 16r2331 16rFF11 16r2332 16rFF12 16r2333 16rFF13 16r2334 16rFF14 16r2335 16rFF15 16r2336 16rFF16 16r2337 16rFF17 16r2338 16rFF18 16r2339 16rFF19 16r2341 16rFF21 16r2342 16rFF22 16r2343 16rFF23 16r2344 16rFF24 16r2345 16rFF25 16r2346 16rFF26 16r2347 16rFF27 16r2348 16rFF28 16r2349 16rFF29 16r234A 16rFF2A 16r234B 16rFF2B 16r234C 16rFF2C 16r234D 16rFF2D 16r234E 16rFF2E 16r234F 16rFF2F 16r2350 16rFF30 16r2351 16rFF31 16r2352 16rFF32 16r2353 16rFF33 16r2354 16rFF34 16r2355 16rFF35 16r2356 16rFF36 16r2357 16rFF37 16r2358 16rFF38 16r2359 16rFF39 16r235A 16rFF3A 16r2361 16rFF41 16r2362 16rFF42 16r2363 16rFF43 16r2364 16rFF44 16r2365 16rFF45 16r2366 16rFF46 16r2367 16rFF47 16r2368 16rFF48 16r2369 16rFF49 16r236A 16rFF4A 16r236B 16rFF4B 16r236C 16rFF4C 16r236D 16rFF4D 16r236E 16rFF4E 16r236F 16rFF4F 16r2370 16rFF50 16r2371 16rFF51 16r2372 16rFF52 16r2373 16rFF53 16r2374 16rFF54 16r2375 16rFF55 16r2376 16rFF56 16r2377 16rFF57 16r2378 16rFF58 16r2379 16rFF59 16r237A 16rFF5A 16r2421 16r3041 16r2422 16r3042 16r2423 16r3043 16r2424 16r3044 16r2425 16r3045 16r2426 16r3046 16r2427 16r3047 16r2428 16r3048 16r2429 16r3049 16r242A 16r304A 16r242B 16r304B 16r242C 16r304C 16r242D 16r304D 16r242E 16r304E 16r242F 16r304F 16r2430 16r3050 16r2431 16r3051 16r2432 16r3052 16r2433 16r3053 16r2434 16r3054 16r2435 16r3055 16r2436 16r3056 16r2437 16r3057 16r2438 16r3058 16r2439 16r3059 16r243A 16r305A 16r243B 16r305B 16r243C 16r305C 16r243D 16r305D 16r243E 16r305E 16r243F 16r305F 16r2440 16r3060 16r2441 16r3061 16r2442 16r3062 16r2443 16r3063 16r2444 16r3064 16r2445 16r3065 16r2446 16r3066 16r2447 16r3067 16r2448 16r3068 16r2449 16r3069 16r244A 16r306A 16r244B 16r306B 16r244C 16r306C 16r244D 16r306D 16r244E 16r306E 16r244F 16r306F 16r2450 16r3070 16r2451 16r3071 16r2452 16r3072 16r2453 16r3073 16r2454 16r3074 16r2455 16r3075 16r2456 16r3076 16r2457 16r3077 16r2458 16r3078 16r2459 16r3079 16r245A 16r307A 16r245B 16r307B 16r245C 16r307C 16r245D 16r307D 16r245E 16r307E 16r245F 16r307F 16r2460 16r3080 16r2461 16r3081 16r2462 16r3082 16r2463 16r3083 16r2464 16r3084 16r2465 16r3085 16r2466 16r3086 16r2467 16r3087 16r2468 16r3088 16r2469 16r3089 16r246A 16r308A 16r246B 16r308B 16r246C 16r308C 16r246D 16r308D 16r246E 16r308E 16r246F 16r308F 16r2470 16r3090 16r2471 16r3091 16r2472 16r3092 16r2473 16r3093 16r2521 16r30A1 16r2522 16r30A2 16r2523 16r30A3 16r2524 16r30A4 16r2525 16r30A5 16r2526 16r30A6 16r2527 16r30A7 16r2528 16r30A8 16r2529 16r30A9 16r252A 16r30AA 16r252B 16r30AB 16r252C 16r30AC 16r252D 16r30AD 16r252E 16r30AE 16r252F 16r30AF 16r2530 16r30B0 16r2531 16r30B1 16r2532 16r30B2 16r2533 16r30B3 16r2534 16r30B4 16r2535 16r30B5 16r2536 16r30B6 16r2537 16r30B7 16r2538 16r30B8 16r2539 16r30B9 16r253A 16r30BA 16r253B 16r30BB 16r253C 16r30BC 16r253D 16r30BD 16r253E 16r30BE 16r253F 16r30BF 16r2540 16r30C0 16r2541 16r30C1 16r2542 16r30C2 16r2543 16r30C3 16r2544 16r30C4 16r2545 16r30C5 16r2546 16r30C6 16r2547 16r30C7 16r2548 16r30C8 16r2549 16r30C9 16r254A 16r30CA 16r254B 16r30CB 16r254C 16r30CC 16r254D 16r30CD 16r254E 16r30CE 16r254F 16r30CF 16r2550 16r30D0 16r2551 16r30D1 16r2552 16r30D2 16r2553 16r30D3 16r2554 16r30D4 16r2555 16r30D5 16r2556 16r30D6 16r2557 16r30D7 16r2558 16r30D8 16r2559 16r30D9 16r255A 16r30DA 16r255B 16r30DB 16r255C 16r30DC 16r255D 16r30DD 16r255E 16r30DE 16r255F 16r30DF 16r2560 16r30E0 16r2561 16r30E1 16r2562 16r30E2 16r2563 16r30E3 16r2564 16r30E4 16r2565 16r30E5 16r2566 16r30E6 16r2567 16r30E7 16r2568 16r30E8 16r2569 16r30E9 16r256A 16r30EA 16r256B 16r30EB 16r256C 16r30EC 16r256D 16r30ED 16r256E 16r30EE 16r256F 16r30EF 16r2570 16r30F0 16r2571 16r30F1 16r2572 16r30F2 16r2573 16r30F3 16r2574 16r30F4 16r2575 16r30F5 16r2576 16r30F6 16r2621 16r391 16r2622 16r392 16r2623 16r393 16r2624 16r394 16r2625 16r395 16r2626 16r396 16r2627 16r397 16r2628 16r398 16r2629 16r399 16r262A 16r39A 16r262B 16r39B 16r262C 16r39C 16r262D 16r39D 16r262E 16r39E 16r262F 16r39F 16r2630 16r3A0 16r2631 16r3A1 16r2632 16r3A3 16r2633 16r3A4 16r2634 16r3A5 16r2635 16r3A6 16r2636 16r3A7 16r2637 16r3A8 16r2638 16r3A9 16r2641 16r3B1 16r2642 16r3B2 16r2643 16r3B3 16r2644 16r3B4 16r2645 16r3B5 16r2646 16r3B6 16r2647 16r3B7 16r2648 16r3B8 16r2649 16r3B9 16r264A 16r3BA 16r264B 16r3BB 16r264C 16r3BC 16r264D 16r3BD 16r264E 16r3BE 16r264F 16r3BF 16r2650 16r3C0 16r2651 16r3C1 16r2652 16r3C3 16r2653 16r3C4 16r2654 16r3C5 16r2655 16r3C6 16r2656 16r3C7 16r2657 16r3C8 16r2658 16r3C9 16r2721 16r410 16r2722 16r411 16r2723 16r412 16r2724 16r413 16r2725 16r414 16r2726 16r415 16r2727 16r401 16r2728 16r416 16r2729 16r417 16r272A 16r418 16r272B 16r419 16r272C 16r41A 16r272D 16r41B 16r272E 16r41C 16r272F 16r41D 16r2730 16r41E 16r2731 16r41F 16r2732 16r420 16r2733 16r421 16r2734 16r422 16r2735 16r423 16r2736 16r424 16r2737 16r425 16r2738 16r426 16r2739 16r427 16r273A 16r428 16r273B 16r429 16r273C 16r42A 16r273D 16r42B 16r273E 16r42C 16r273F 16r42D 16r2740 16r42E 16r2741 16r42F 16r2751 16r430 16r2752 16r431 16r2753 16r432 16r2754 16r433 16r2755 16r434 16r2756 16r435 16r2757 16r451 16r2758 16r436 16r2759 16r437 16r275A 16r438 16r275B 16r439 16r275C 16r43A 16r275D 16r43B 16r275E 16r43C 16r275F 16r43D 16r2760 16r43E 16r2761 16r43F 16r2762 16r440 16r2763 16r441 16r2764 16r442 16r2765 16r443 16r2766 16r444 16r2767 16r445 16r2768 16r446 16r2769 16r447 16r276A 16r448 16r276B 16r449 16r276C 16r44A 16r276D 16r44B 16r276E 16r44C 16r276F 16r44D 16r2770 16r44E 16r2771 16r44F 16r2821 16r2500 16r2822 16r2502 16r2823 16r250C 16r2824 16r2510 16r2825 16r2518 16r2826 16r2514 16r2827 16r251C 16r2828 16r252C 16r2829 16r2524 16r282A 16r2534 16r282B 16r253C 16r282C 16r2501 16r282D 16r2503 16r282E 16r250F 16r282F 16r2513 16r2830 16r251B 16r2831 16r2517 16r2832 16r2523 16r2833 16r2533 16r2834 16r252B 16r2835 16r253B 16r2836 16r254B 16r2837 16r2520 16r2838 16r252F 16r2839 16r2528 16r283A 16r2537 16r283B 16r253F 16r283C 16r251D 16r283D 16r2530 16r283E 16r2525 16r283F 16r2538 16r2840 16r2542 16r3021 16r4E9C 16r3022 16r5516 16r3023 16r5A03 16r3024 16r963F 16r3025 16r54C0 16r3026 16r611B 16r3027 16r6328 16r3028 16r59F6 16r3029 16r9022 16r302A 16r8475 16r302B 16r831C 16r302C 16r7A50 16r302D 16r60AA 16r302E 16r63E1 16r302F 16r6E25 16r3030 16r65ED 16r3031 16r8466 16r3032 16r82A6 16r3033 16r9BF5 16r3034 16r6893 16r3035 16r5727 16r3036 16r65A1 16r3037 16r6271 16r3038 16r5B9B 16r3039 16r59D0 16r303A 16r867B 16r303B 16r98F4 16r303C 16r7D62 16r303D 16r7DBE 16r303E 16r9B8E 16r303F 16r6216 16r3040 16r7C9F 16r3041 16r88B7 16r3042 16r5B89 16r3043 16r5EB5 16r3044 16r6309 16r3045 16r6697 16r3046 16r6848 16r3047 16r95C7 16r3048 16r978D 16r3049 16r674F 16r304A 16r4EE5 16r304B 16r4F0A 16r304C 16r4F4D 16r304D 16r4F9D 16r304E 16r5049 16r304F 16r56F2 16r3050 16r5937 16r3051 16r59D4 16r3052 16r5A01 16r3053 16r5C09 16r3054 16r60DF 16r3055 16r610F 16r3056 16r6170 16r3057 16r6613 16r3058 16r6905 16r3059 16r70BA 16r305A 16r754F 16r305B 16r7570 16r305C 16r79FB 16r305D 16r7DAD 16r305E 16r7DEF 16r305F 16r80C3 16r3060 16r840E 16r3061 16r8863 16r3062 16r8B02 16r3063 16r9055 16r3064 16r907A 16r3065 16r533B 16r3066 16r4E95 16r3067 16r4EA5 16r3068 16r57DF 16r3069 16r80B2 16r306A 16r90C1 16r306B 16r78EF 16r306C 16r4E00 16r306D 16r58F1 16r306E 16r6EA2 16r306F 16r9038 16r3070 16r7A32 16r3071 16r8328 16r3072 16r828B 16r3073 16r9C2F 16r3074 16r5141 16r3075 16r5370 16r3076 16r54BD 16r3077 16r54E1 16r3078 16r56E0 16r3079 16r59FB 16r307A 16r5F15 16r307B 16r98F2 16r307C 16r6DEB 16r307D 16r80E4 16r307E 16r852D 16r3121 16r9662 16r3122 16r9670 16r3123 16r96A0 16r3124 16r97FB 16r3125 16r540B 16r3126 16r53F3 16r3127 16r5B87 16r3128 16r70CF 16r3129 16r7FBD 16r312A 16r8FC2 16r312B 16r96E8 16r312C 16r536F 16r312D 16r9D5C 16r312E 16r7ABA 16r312F 16r4E11 16r3130 16r7893 16r3131 16r81FC 16r3132 16r6E26 16r3133 16r5618 16r3134 16r5504 16r3135 16r6B1D 16r3136 16r851A 16r3137 16r9C3B 16r3138 16r59E5 16r3139 16r53A9 16r313A 16r6D66 16r313B 16r74DC 16r313C 16r958F 16r313D 16r5642 16r313E 16r4E91 16r313F 16r904B 16r3140 16r96F2 16r3141 16r834F 16r3142 16r990C 16r3143 16r53E1 16r3144 16r55B6 16r3145 16r5B30 16r3146 16r5F71 16r3147 16r6620 16r3148 16r66F3 16r3149 16r6804 16r314A 16r6C38 16r314B 16r6CF3 16r314C 16r6D29 16r314D 16r745B 16r314E 16r76C8 16r314F 16r7A4E 16r3150 16r9834 16r3151 16r82F1 16r3152 16r885B 16r3153 16r8A60 16r3154 16r92ED 16r3155 16r6DB2 16r3156 16r75AB 16r3157 16r76CA 16r3158 16r99C5 16r3159 16r60A6 16r315A 16r8B01 16r315B 16r8D8A 16r315C 16r95B2 16r315D 16r698E 16r315E 16r53AD 16r315F 16r5186 16r3160 16r5712 16r3161 16r5830 16r3162 16r5944 16r3163 16r5BB4 16r3164 16r5EF6 16r3165 16r6028 16r3166 16r63A9 16r3167 16r63F4 16r3168 16r6CBF 16r3169 16r6F14 16r316A 16r708E 16r316B 16r7114 16r316C 16r7159 16r316D 16r71D5 16r316E 16r733F 16r316F 16r7E01 16r3170 16r8276 16r3171 16r82D1 16r3172 16r8597 16r3173 16r9060 16r3174 16r925B 16r3175 16r9D1B 16r3176 16r5869 16r3177 16r65BC 16r3178 16r6C5A 16r3179 16r7525 16r317A 16r51F9 16r317B 16r592E 16r317C 16r5965 16r317D 16r5F80 16r317E 16r5FDC 16r3221 16r62BC 16r3222 16r65FA 16r3223 16r6A2A 16r3224 16r6B27 16r3225 16r6BB4 16r3226 16r738B 16r3227 16r7FC1 16r3228 16r8956 16r3229 16r9D2C 16r322A 16r9D0E 16r322B 16r9EC4 16r322C 16r5CA1 16r322D 16r6C96 16r322E 16r837B 16r322F 16r5104 16r3230 16r5C4B 16r3231 16r61B6 16r3232 16r81C6 16r3233 16r6876 16r3234 16r7261 16r3235 16r4E59 16r3236 16r4FFA 16r3237 16r5378 16r3238 16r6069 16r3239 16r6E29 16r323A 16r7A4F 16r323B 16r97F3 16r323C 16r4E0B 16r323D 16r5316 16r323E 16r4EEE 16r323F 16r4F55 16r3240 16r4F3D 16r3241 16r4FA1 16r3242 16r4F73 16r3243 16r52A0 16r3244 16r53EF 16r3245 16r5609 16r3246 16r590F 16r3247 16r5AC1 16r3248 16r5BB6 16r3249 16r5BE1 16r324A 16r79D1 16r324B 16r6687 16r324C 16r679C 16r324D 16r67B6 16r324E 16r6B4C 16r324F 16r6CB3 16r3250 16r706B 16r3251 16r73C2 16r3252 16r798D 16r3253 16r79BE 16r3254 16r7A3C 16r3255 16r7B87 16r3256 16r82B1 16r3257 16r82DB 16r3258 16r8304 16r3259 16r8377 16r325A 16r83EF 16r325B 16r83D3 16r325C 16r8766 16r325D 16r8AB2 16r325E 16r5629 16r325F 16r8CA8 16r3260 16r8FE6 16r3261 16r904E 16r3262 16r971E 16r3263 16r868A 16r3264 16r4FC4 16r3265 16r5CE8 16r3266 16r6211 16r3267 16r7259 16r3268 16r753B 16r3269 16r81E5 16r326A 16r82BD 16r326B 16r86FE 16r326C 16r8CC0 16r326D 16r96C5 16r326E 16r9913 16r326F 16r99D5 16r3270 16r4ECB 16r3271 16r4F1A 16r3272 16r89E3 16r3273 16r56DE 16r3274 16r584A 16r3275 16r58CA 16r3276 16r5EFB 16r3277 16r5FEB 16r3278 16r602A 16r3279 16r6094 16r327A 16r6062 16r327B 16r61D0 16r327C 16r6212 16r327D 16r62D0 16r327E 16r6539 16r3321 16r9B41 16r3322 16r6666 16r3323 16r68B0 16r3324 16r6D77 16r3325 16r7070 16r3326 16r754C 16r3327 16r7686 16r3328 16r7D75 16r3329 16r82A5 16r332A 16r87F9 16r332B 16r958B 16r332C 16r968E 16r332D 16r8C9D 16r332E 16r51F1 16r332F 16r52BE 16r3330 16r5916 16r3331 16r54B3 16r3332 16r5BB3 16r3333 16r5D16 16r3334 16r6168 16r3335 16r6982 16r3336 16r6DAF 16r3337 16r788D 16r3338 16r84CB 16r3339 16r8857 16r333A 16r8A72 16r333B 16r93A7 16r333C 16r9AB8 16r333D 16r6D6C 16r333E 16r99A8 16r333F 16r86D9 16r3340 16r57A3 16r3341 16r67FF 16r3342 16r86CE 16r3343 16r920E 16r3344 16r5283 16r3345 16r5687 16r3346 16r5404 16r3347 16r5ED3 16r3348 16r62E1 16r3349 16r64B9 16r334A 16r683C 16r334B 16r6838 16r334C 16r6BBB 16r334D 16r7372 16r334E 16r78BA 16r334F 16r7A6B 16r3350 16r899A 16r3351 16r89D2 16r3352 16r8D6B 16r3353 16r8F03 16r3354 16r90ED 16r3355 16r95A3 16r3356 16r9694 16r3357 16r9769 16r3358 16r5B66 16r3359 16r5CB3 16r335A 16r697D 16r335B 16r984D 16r335C 16r984E 16r335D 16r639B 16r335E 16r7B20 16r335F 16r6A2B 16r3360 16r6A7F 16r3361 16r68B6 16r3362 16r9C0D 16r3363 16r6F5F 16r3364 16r5272 16r3365 16r559D 16r3366 16r6070 16r3367 16r62EC 16r3368 16r6D3B 16r3369 16r6E07 16r336A 16r6ED1 16r336B 16r845B 16r336C 16r8910 16r336D 16r8F44 16r336E 16r4E14 16r336F 16r9C39 16r3370 16r53F6 16r3371 16r691B 16r3372 16r6A3A 16r3373 16r9784 16r3374 16r682A 16r3375 16r515C 16r3376 16r7AC3 16r3377 16r84B2 16r3378 16r91DC 16r3379 16r938C 16r337A 16r565B 16r337B 16r9D28 16r337C 16r6822 16r337D 16r8305 16r337E 16r8431 16r3421 16r7CA5 16r3422 16r5208 16r3423 16r82C5 16r3424 16r74E6 16r3425 16r4E7E 16r3426 16r4F83 16r3427 16r51A0 16r3428 16r5BD2 16r3429 16r520A 16r342A 16r52D8 16r342B 16r52E7 16r342C 16r5DFB 16r342D 16r559A 16r342E 16r582A 16r342F 16r59E6 16r3430 16r5B8C 16r3431 16r5B98 16r3432 16r5BDB 16r3433 16r5E72 16r3434 16r5E79 16r3435 16r60A3 16r3436 16r611F 16r3437 16r6163 16r3438 16r61BE 16r3439 16r63DB 16r343A 16r6562 16r343B 16r67D1 16r343C 16r6853 16r343D 16r68FA 16r343E 16r6B3E 16r343F 16r6B53 16r3440 16r6C57 16r3441 16r6F22 16r3442 16r6F97 16r3443 16r6F45 16r3444 16r74B0 16r3445 16r7518 16r3446 16r76E3 16r3447 16r770B 16r3448 16r7AFF 16r3449 16r7BA1 16r344A 16r7C21 16r344B 16r7DE9 16r344C 16r7F36 16r344D 16r7FF0 16r344E 16r809D 16r344F 16r8266 16r3450 16r839E 16r3451 16r89B3 16r3452 16r8ACC 16r3453 16r8CAB 16r3454 16r9084 16r3455 16r9451 16r3456 16r9593 16r3457 16r9591 16r3458 16r95A2 16r3459 16r9665 16r345A 16r97D3 16r345B 16r9928 16r345C 16r8218 16r345D 16r4E38 16r345E 16r542B 16r345F 16r5CB8 16r3460 16r5DCC 16r3461 16r73A9 16r3462 16r764C 16r3463 16r773C 16r3464 16r5CA9 16r3465 16r7FEB 16r3466 16r8D0B 16r3467 16r96C1 16r3468 16r9811 16r3469 16r9854 16r346A 16r9858 16r346B 16r4F01 16r346C 16r4F0E 16r346D 16r5371 16r346E 16r559C 16r346F 16r5668 16r3470 16r57FA 16r3471 16r5947 16r3472 16r5B09 16r3473 16r5BC4 16r3474 16r5C90 16r3475 16r5E0C 16r3476 16r5E7E 16r3477 16r5FCC 16r3478 16r63EE 16r3479 16r673A 16r347A 16r65D7 16r347B 16r65E2 16r347C 16r671F 16r347D 16r68CB 16r347E 16r68C4 16r3521 16r6A5F 16r3522 16r5E30 16r3523 16r6BC5 16r3524 16r6C17 16r3525 16r6C7D 16r3526 16r757F 16r3527 16r7948 16r3528 16r5B63 16r3529 16r7A00 16r352A 16r7D00 16r352B 16r5FBD 16r352C 16r898F 16r352D 16r8A18 16r352E 16r8CB4 16r352F 16r8D77 16r3530 16r8ECC 16r3531 16r8F1D 16r3532 16r98E2 16r3533 16r9A0E 16r3534 16r9B3C 16r3535 16r4E80 16r3536 16r507D 16r3537 16r5100 16r3538 16r5993 16r3539 16r5B9C 16r353A 16r622F 16r353B 16r6280 16r353C 16r64EC 16r353D 16r6B3A 16r353E 16r72A0 16r353F 16r7591 16r3540 16r7947 16r3541 16r7FA9 16r3542 16r87FB 16r3543 16r8ABC 16r3544 16r8B70 16r3545 16r63AC 16r3546 16r83CA 16r3547 16r97A0 16r3548 16r5409 16r3549 16r5403 16r354A 16r55AB 16r354B 16r6854 16r354C 16r6A58 16r354D 16r8A70 16r354E 16r7827 16r354F 16r6775 16r3550 16r9ECD 16r3551 16r5374 16r3552 16r5BA2 16r3553 16r811A 16r3554 16r8650 16r3555 16r9006 16r3556 16r4E18 16r3557 16r4E45 16r3558 16r4EC7 16r3559 16r4F11 16r355A 16r53CA 16r355B 16r5438 16r355C 16r5BAE 16r355D 16r5F13 16r355E 16r6025 16r355F 16r6551 16r3560 16r673D 16r3561 16r6C42 16r3562 16r6C72 16r3563 16r6CE3 16r3564 16r7078 16r3565 16r7403 16r3566 16r7A76 16r3567 16r7AAE 16r3568 16r7B08 16r3569 16r7D1A 16r356A 16r7CFE 16r356B 16r7D66 16r356C 16r65E7 16r356D 16r725B 16r356E 16r53BB 16r356F 16r5C45 16r3570 16r5DE8 16r3571 16r62D2 16r3572 16r62E0 16r3573 16r6319 16r3574 16r6E20 16r3575 16r865A 16r3576 16r8A31 16r3577 16r8DDD 16r3578 16r92F8 16r3579 16r6F01 16r357A 16r79A6 16r357B 16r9B5A 16r357C 16r4EA8 16r357D 16r4EAB 16r357E 16r4EAC 16r3621 16r4F9B 16r3622 16r4FA0 16r3623 16r50D1 16r3624 16r5147 16r3625 16r7AF6 16r3626 16r5171 16r3627 16r51F6 16r3628 16r5354 16r3629 16r5321 16r362A 16r537F 16r362B 16r53EB 16r362C 16r55AC 16r362D 16r5883 16r362E 16r5CE1 16r362F 16r5F37 16r3630 16r5F4A 16r3631 16r602F 16r3632 16r6050 16r3633 16r606D 16r3634 16r631F 16r3635 16r6559 16r3636 16r6A4B 16r3637 16r6CC1 16r3638 16r72C2 16r3639 16r72ED 16r363A 16r77EF 16r363B 16r80F8 16r363C 16r8105 16r363D 16r8208 16r363E 16r854E 16r363F 16r90F7 16r3640 16r93E1 16r3641 16r97FF 16r3642 16r9957 16r3643 16r9A5A 16r3644 16r4EF0 16r3645 16r51DD 16r3646 16r5C2D 16r3647 16r6681 16r3648 16r696D 16r3649 16r5C40 16r364A 16r66F2 16r364B 16r6975 16r364C 16r7389 16r364D 16r6850 16r364E 16r7C81 16r364F 16r50C5 16r3650 16r52E4 16r3651 16r5747 16r3652 16r5DFE 16r3653 16r9326 16r3654 16r65A4 16r3655 16r6B23 16r3656 16r6B3D 16r3657 16r7434 16r3658 16r7981 16r3659 16r79BD 16r365A 16r7B4B 16r365B 16r7DCA 16r365C 16r82B9 16r365D 16r83CC 16r365E 16r887F 16r365F 16r895F 16r3660 16r8B39 16r3661 16r8FD1 16r3662 16r91D1 16r3663 16r541F 16r3664 16r9280 16r3665 16r4E5D 16r3666 16r5036 16r3667 16r53E5 16r3668 16r533A 16r3669 16r72D7 16r366A 16r7396 16r366B 16r77E9 16r366C 16r82E6 16r366D 16r8EAF 16r366E 16r99C6 16r366F 16r99C8 16r3670 16r99D2 16r3671 16r5177 16r3672 16r611A 16r3673 16r865E 16r3674 16r55B0 16r3675 16r7A7A 16r3676 16r5076 16r3677 16r5BD3 16r3678 16r9047 16r3679 16r9685 16r367A 16r4E32 16r367B 16r6ADB 16r367C 16r91E7 16r367D 16r5C51 16r367E 16r5C48 16r3721 16r6398 16r3722 16r7A9F 16r3723 16r6C93 16r3724 16r9774 16r3725 16r8F61 16r3726 16r7AAA 16r3727 16r718A 16r3728 16r9688 16r3729 16r7C82 16r372A 16r6817 16r372B 16r7E70 16r372C 16r6851 16r372D 16r936C 16r372E 16r52F2 16r372F 16r541B 16r3730 16r85AB 16r3731 16r8A13 16r3732 16r7FA4 16r3733 16r8ECD 16r3734 16r90E1 16r3735 16r5366 16r3736 16r8888 16r3737 16r7941 16r3738 16r4FC2 16r3739 16r50BE 16r373A 16r5211 16r373B 16r5144 16r373C 16r5553 16r373D 16r572D 16r373E 16r73EA 16r373F 16r578B 16r3740 16r5951 16r3741 16r5F62 16r3742 16r5F84 16r3743 16r6075 16r3744 16r6176 16r3745 16r6167 16r3746 16r61A9 16r3747 16r63B2 16r3748 16r643A 16r3749 16r656C 16r374A 16r666F 16r374B 16r6842 16r374C 16r6E13 16r374D 16r7566 16r374E 16r7A3D 16r374F 16r7CFB 16r3750 16r7D4C 16r3751 16r7D99 16r3752 16r7E4B 16r3753 16r7F6B 16r3754 16r830E 16r3755 16r834A 16r3756 16r86CD 16r3757 16r8A08 16r3758 16r8A63 16r3759 16r8B66 16r375A 16r8EFD 16r375B 16r981A 16r375C 16r9D8F 16r375D 16r82B8 16r375E 16r8FCE 16r375F 16r9BE8 16r3760 16r5287 16r3761 16r621F 16r3762 16r6483 16r3763 16r6FC0 16r3764 16r9699 16r3765 16r6841 16r3766 16r5091 16r3767 16r6B20 16r3768 16r6C7A 16r3769 16r6F54 16r376A 16r7A74 16r376B 16r7D50 16r376C 16r8840 16r376D 16r8A23 16r376E 16r6708 16r376F 16r4EF6 16r3770 16r5039 16r3771 16r5026 16r3772 16r5065 16r3773 16r517C 16r3774 16r5238 16r3775 16r5263 16r3776 16r55A7 16r3777 16r570F 16r3778 16r5805 16r3779 16r5ACC 16r377A 16r5EFA 16r377B 16r61B2 16r377C 16r61F8 16r377D 16r62F3 16r377E 16r6372 16r3821 16r691C 16r3822 16r6A29 16r3823 16r727D 16r3824 16r72AC 16r3825 16r732E 16r3826 16r7814 16r3827 16r786F 16r3828 16r7D79 16r3829 16r770C 16r382A 16r80A9 16r382B 16r898B 16r382C 16r8B19 16r382D 16r8CE2 16r382E 16r8ED2 16r382F 16r9063 16r3830 16r9375 16r3831 16r967A 16r3832 16r9855 16r3833 16r9A13 16r3834 16r9E78 16r3835 16r5143 16r3836 16r539F 16r3837 16r53B3 16r3838 16r5E7B 16r3839 16r5F26 16r383A 16r6E1B 16r383B 16r6E90 16r383C 16r7384 16r383D 16r73FE 16r383E 16r7D43 16r383F 16r8237 16r3840 16r8A00 16r3841 16r8AFA 16r3842 16r9650 16r3843 16r4E4E 16r3844 16r500B 16r3845 16r53E4 16r3846 16r547C 16r3847 16r56FA 16r3848 16r59D1 16r3849 16r5B64 16r384A 16r5DF1 16r384B 16r5EAB 16r384C 16r5F27 16r384D 16r6238 16r384E 16r6545 16r384F 16r67AF 16r3850 16r6E56 16r3851 16r72D0 16r3852 16r7CCA 16r3853 16r88B4 16r3854 16r80A1 16r3855 16r80E1 16r3856 16r83F0 16r3857 16r864E 16r3858 16r8A87 16r3859 16r8DE8 16r385A 16r9237 16r385B 16r96C7 16r385C 16r9867 16r385D 16r9F13 16r385E 16r4E94 16r385F 16r4E92 16r3860 16r4F0D 16r3861 16r5348 16r3862 16r5449 16r3863 16r543E 16r3864 16r5A2F 16r3865 16r5F8C 16r3866 16r5FA1 16r3867 16r609F 16r3868 16r68A7 16r3869 16r6A8E 16r386A 16r745A 16r386B 16r7881 16r386C 16r8A9E 16r386D 16r8AA4 16r386E 16r8B77 16r386F 16r9190 16r3870 16r4E5E 16r3871 16r9BC9 16r3872 16r4EA4 16r3873 16r4F7C 16r3874 16r4FAF 16r3875 16r5019 16r3876 16r5016 16r3877 16r5149 16r3878 16r516C 16r3879 16r529F 16r387A 16r52B9 16r387B 16r52FE 16r387C 16r539A 16r387D 16r53E3 16r387E 16r5411 16r3921 16r540E 16r3922 16r5589 16r3923 16r5751 16r3924 16r57A2 16r3925 16r597D 16r3926 16r5B54 16r3927 16r5B5D 16r3928 16r5B8F 16r3929 16r5DE5 16r392A 16r5DE7 16r392B 16r5DF7 16r392C 16r5E78 16r392D 16r5E83 16r392E 16r5E9A 16r392F 16r5EB7 16r3930 16r5F18 16r3931 16r6052 16r3932 16r614C 16r3933 16r6297 16r3934 16r62D8 16r3935 16r63A7 16r3936 16r653B 16r3937 16r6602 16r3938 16r6643 16r3939 16r66F4 16r393A 16r676D 16r393B 16r6821 16r393C 16r6897 16r393D 16r69CB 16r393E 16r6C5F 16r393F 16r6D2A 16r3940 16r6D69 16r3941 16r6E2F 16r3942 16r6E9D 16r3943 16r7532 16r3944 16r7687 16r3945 16r786C 16r3946 16r7A3F 16r3947 16r7CE0 16r3948 16r7D05 16r3949 16r7D18 16r394A 16r7D5E 16r394B 16r7DB1 16r394C 16r8015 16r394D 16r8003 16r394E 16r80AF 16r394F 16r80B1 16r3950 16r8154 16r3951 16r818F 16r3952 16r822A 16r3953 16r8352 16r3954 16r884C 16r3955 16r8861 16r3956 16r8B1B 16r3957 16r8CA2 16r3958 16r8CFC 16r3959 16r90CA 16r395A 16r9175 16r395B 16r9271 16r395C 16r783F 16r395D 16r92FC 16r395E 16r95A4 16r395F 16r964D 16r3960 16r9805 16r3961 16r9999 16r3962 16r9AD8 16r3963 16r9D3B 16r3964 16r525B 16r3965 16r52AB 16r3966 16r53F7 16r3967 16r5408 16r3968 16r58D5 16r3969 16r62F7 16r396A 16r6FE0 16r396B 16r8C6A 16r396C 16r8F5F 16r396D 16r9EB9 16r396E 16r514B 16r396F 16r523B 16r3970 16r544A 16r3971 16r56FD 16r3972 16r7A40 16r3973 16r9177 16r3974 16r9D60 16r3975 16r9ED2 16r3976 16r7344 16r3977 16r6F09 16r3978 16r8170 16r3979 16r7511 16r397A 16r5FFD 16r397B 16r60DA 16r397C 16r9AA8 16r397D 16r72DB 16r397E 16r8FBC 16r3A21 16r6B64 16r3A22 16r9803 16r3A23 16r4ECA 16r3A24 16r56F0 16r3A25 16r5764 16r3A26 16r58BE 16r3A27 16r5A5A 16r3A28 16r6068 16r3A29 16r61C7 16r3A2A 16r660F 16r3A2B 16r6606 16r3A2C 16r6839 16r3A2D 16r68B1 16r3A2E 16r6DF7 16r3A2F 16r75D5 16r3A30 16r7D3A 16r3A31 16r826E 16r3A32 16r9B42 16r3A33 16r4E9B 16r3A34 16r4F50 16r3A35 16r53C9 16r3A36 16r5506 16r3A37 16r5D6F 16r3A38 16r5DE6 16r3A39 16r5DEE 16r3A3A 16r67FB 16r3A3B 16r6C99 16r3A3C 16r7473 16r3A3D 16r7802 16r3A3E 16r8A50 16r3A3F 16r9396 16r3A40 16r88DF 16r3A41 16r5750 16r3A42 16r5EA7 16r3A43 16r632B 16r3A44 16r50B5 16r3A45 16r50AC 16r3A46 16r518D 16r3A47 16r6700 16r3A48 16r54C9 16r3A49 16r585E 16r3A4A 16r59BB 16r3A4B 16r5BB0 16r3A4C 16r5F69 16r3A4D 16r624D 16r3A4E 16r63A1 16r3A4F 16r683D 16r3A50 16r6B73 16r3A51 16r6E08 16r3A52 16r707D 16r3A53 16r91C7 16r3A54 16r7280 16r3A55 16r7815 16r3A56 16r7826 16r3A57 16r796D 16r3A58 16r658E 16r3A59 16r7D30 16r3A5A 16r83DC 16r3A5B 16r88C1 16r3A5C 16r8F09 16r3A5D 16r969B 16r3A5E 16r5264 16r3A5F 16r5728 16r3A60 16r6750 16r3A61 16r7F6A 16r3A62 16r8CA1 16r3A63 16r51B4 16r3A64 16r5742 16r3A65 16r962A 16r3A66 16r583A 16r3A67 16r698A 16r3A68 16r80B4 16r3A69 16r54B2 16r3A6A 16r5D0E 16r3A6B 16r57FC 16r3A6C 16r7895 16r3A6D 16r9DFA 16r3A6E 16r4F5C 16r3A6F 16r524A 16r3A70 16r548B 16r3A71 16r643E 16r3A72 16r6628 16r3A73 16r6714 16r3A74 16r67F5 16r3A75 16r7A84 16r3A76 16r7B56 16r3A77 16r7D22 16r3A78 16r932F 16r3A79 16r685C 16r3A7A 16r9BAD 16r3A7B 16r7B39 16r3A7C 16r5319 16r3A7D 16r518A 16r3A7E 16r5237 16r3B21 16r5BDF 16r3B22 16r62F6 16r3B23 16r64AE 16r3B24 16r64E6 16r3B25 16r672D 16r3B26 16r6BBA 16r3B27 16r85A9 16r3B28 16r96D1 16r3B29 16r7690 16r3B2A 16r9BD6 16r3B2B 16r634C 16r3B2C 16r9306 16r3B2D 16r9BAB 16r3B2E 16r76BF 16r3B2F 16r6652 16r3B30 16r4E09 16r3B31 16r5098 16r3B32 16r53C2 16r3B33 16r5C71 16r3B34 16r60E8 16r3B35 16r6492 16r3B36 16r6563 16r3B37 16r685F 16r3B38 16r71E6 16r3B39 16r73CA 16r3B3A 16r7523 16r3B3B 16r7B97 16r3B3C 16r7E82 16r3B3D 16r8695 16r3B3E 16r8B83 16r3B3F 16r8CDB 16r3B40 16r9178 16r3B41 16r9910 16r3B42 16r65AC 16r3B43 16r66AB 16r3B44 16r6B8B 16r3B45 16r4ED5 16r3B46 16r4ED4 16r3B47 16r4F3A 16r3B48 16r4F7F 16r3B49 16r523A 16r3B4A 16r53F8 16r3B4B 16r53F2 16r3B4C 16r55E3 16r3B4D 16r56DB 16r3B4E 16r58EB 16r3B4F 16r59CB 16r3B50 16r59C9 16r3B51 16r59FF 16r3B52 16r5B50 16r3B53 16r5C4D 16r3B54 16r5E02 16r3B55 16r5E2B 16r3B56 16r5FD7 16r3B57 16r601D 16r3B58 16r6307 16r3B59 16r652F 16r3B5A 16r5B5C 16r3B5B 16r65AF 16r3B5C 16r65BD 16r3B5D 16r65E8 16r3B5E 16r679D 16r3B5F 16r6B62 16r3B60 16r6B7B 16r3B61 16r6C0F 16r3B62 16r7345 16r3B63 16r7949 16r3B64 16r79C1 16r3B65 16r7CF8 16r3B66 16r7D19 16r3B67 16r7D2B 16r3B68 16r80A2 16r3B69 16r8102 16r3B6A 16r81F3 16r3B6B 16r8996 16r3B6C 16r8A5E 16r3B6D 16r8A69 16r3B6E 16r8A66 16r3B6F 16r8A8C 16r3B70 16r8AEE 16r3B71 16r8CC7 16r3B72 16r8CDC 16r3B73 16r96CC 16r3B74 16r98FC 16r3B75 16r6B6F 16r3B76 16r4E8B 16r3B77 16r4F3C 16r3B78 16r4F8D 16r3B79 16r5150 16r3B7A 16r5B57 16r3B7B 16r5BFA 16r3B7C 16r6148 16r3B7D 16r6301 16r3B7E 16r6642 16r3C21 16r6B21 16r3C22 16r6ECB 16r3C23 16r6CBB 16r3C24 16r723E 16r3C25 16r74BD 16r3C26 16r75D4 16r3C27 16r78C1 16r3C28 16r793A 16r3C29 16r800C 16r3C2A 16r8033 16r3C2B 16r81EA 16r3C2C 16r8494 16r3C2D 16r8F9E 16r3C2E 16r6C50 16r3C2F 16r9E7F 16r3C30 16r5F0F 16r3C31 16r8B58 16r3C32 16r9D2B 16r3C33 16r7AFA 16r3C34 16r8EF8 16r3C35 16r5B8D 16r3C36 16r96EB 16r3C37 16r4E03 16r3C38 16r53F1 16r3C39 16r57F7 16r3C3A 16r5931 16r3C3B 16r5AC9 16r3C3C 16r5BA4 16r3C3D 16r6089 16r3C3E 16r6E7F 16r3C3F 16r6F06 16r3C40 16r75BE 16r3C41 16r8CEA 16r3C42 16r5B9F 16r3C43 16r8500 16r3C44 16r7BE0 16r3C45 16r5072 16r3C46 16r67F4 16r3C47 16r829D 16r3C48 16r5C61 16r3C49 16r854A 16r3C4A 16r7E1E 16r3C4B 16r820E 16r3C4C 16r5199 16r3C4D 16r5C04 16r3C4E 16r6368 16r3C4F 16r8D66 16r3C50 16r659C 16r3C51 16r716E 16r3C52 16r793E 16r3C53 16r7D17 16r3C54 16r8005 16r3C55 16r8B1D 16r3C56 16r8ECA 16r3C57 16r906E 16r3C58 16r86C7 16r3C59 16r90AA 16r3C5A 16r501F 16r3C5B 16r52FA 16r3C5C 16r5C3A 16r3C5D 16r6753 16r3C5E 16r707C 16r3C5F 16r7235 16r3C60 16r914C 16r3C61 16r91C8 16r3C62 16r932B 16r3C63 16r82E5 16r3C64 16r5BC2 16r3C65 16r5F31 16r3C66 16r60F9 16r3C67 16r4E3B 16r3C68 16r53D6 16r3C69 16r5B88 16r3C6A 16r624B 16r3C6B 16r6731 16r3C6C 16r6B8A 16r3C6D 16r72E9 16r3C6E 16r73E0 16r3C6F 16r7A2E 16r3C70 16r816B 16r3C71 16r8DA3 16r3C72 16r9152 16r3C73 16r9996 16r3C74 16r5112 16r3C75 16r53D7 16r3C76 16r546A 16r3C77 16r5BFF 16r3C78 16r6388 16r3C79 16r6A39 16r3C7A 16r7DAC 16r3C7B 16r9700 16r3C7C 16r56DA 16r3C7D 16r53CE 16r3C7E 16r5468 16r3D21 16r5B97 16r3D22 16r5C31 16r3D23 16r5DDE 16r3D24 16r4FEE 16r3D25 16r6101 16r3D26 16r62FE 16r3D27 16r6D32 16r3D28 16r79C0 16r3D29 16r79CB 16r3D2A 16r7D42 16r3D2B 16r7E4D 16r3D2C 16r7FD2 16r3D2D 16r81ED 16r3D2E 16r821F 16r3D2F 16r8490 16r3D30 16r8846 16r3D31 16r8972 16r3D32 16r8B90 16r3D33 16r8E74 16r3D34 16r8F2F 16r3D35 16r9031 16r3D36 16r914B 16r3D37 16r916C 16r3D38 16r96C6 16r3D39 16r919C 16r3D3A 16r4EC0 16r3D3B 16r4F4F 16r3D3C 16r5145 16r3D3D 16r5341 16r3D3E 16r5F93 16r3D3F 16r620E 16r3D40 16r67D4 16r3D41 16r6C41 16r3D42 16r6E0B 16r3D43 16r7363 16r3D44 16r7E26 16r3D45 16r91CD 16r3D46 16r9283 16r3D47 16r53D4 16r3D48 16r5919 16r3D49 16r5BBF 16r3D4A 16r6DD1 16r3D4B 16r795D 16r3D4C 16r7E2E 16r3D4D 16r7C9B 16r3D4E 16r587E 16r3D4F 16r719F 16r3D50 16r51FA 16r3D51 16r8853 16r3D52 16r8FF0 16r3D53 16r4FCA 16r3D54 16r5CFB 16r3D55 16r6625 16r3D56 16r77AC 16r3D57 16r7AE3 16r3D58 16r821C 16r3D59 16r99FF 16r3D5A 16r51C6 16r3D5B 16r5FAA 16r3D5C 16r65EC 16r3D5D 16r696F 16r3D5E 16r6B89 16r3D5F 16r6DF3 16r3D60 16r6E96 16r3D61 16r6F64 16r3D62 16r76FE 16r3D63 16r7D14 16r3D64 16r5DE1 16r3D65 16r9075 16r3D66 16r9187 16r3D67 16r9806 16r3D68 16r51E6 16r3D69 16r521D 16r3D6A 16r6240 16r3D6B 16r6691 16r3D6C 16r66D9 16r3D6D 16r6E1A 16r3D6E 16r5EB6 16r3D6F 16r7DD2 16r3D70 16r7F72 16r3D71 16r66F8 16r3D72 16r85AF 16r3D73 16r85F7 16r3D74 16r8AF8 16r3D75 16r52A9 16r3D76 16r53D9 16r3D77 16r5973 16r3D78 16r5E8F 16r3D79 16r5F90 16r3D7A 16r6055 16r3D7B 16r92E4 16r3D7C 16r9664 16r3D7D 16r50B7 16r3D7E 16r511F 16r3E21 16r52DD 16r3E22 16r5320 16r3E23 16r5347 16r3E24 16r53EC 16r3E25 16r54E8 16r3E26 16r5546 16r3E27 16r5531 16r3E28 16r5617 16r3E29 16r5968 16r3E2A 16r59BE 16r3E2B 16r5A3C 16r3E2C 16r5BB5 16r3E2D 16r5C06 16r3E2E 16r5C0F 16r3E2F 16r5C11 16r3E30 16r5C1A 16r3E31 16r5E84 16r3E32 16r5E8A 16r3E33 16r5EE0 16r3E34 16r5F70 16r3E35 16r627F 16r3E36 16r6284 16r3E37 16r62DB 16r3E38 16r638C 16r3E39 16r6377 16r3E3A 16r6607 16r3E3B 16r660C 16r3E3C 16r662D 16r3E3D 16r6676 16r3E3E 16r677E 16r3E3F 16r68A2 16r3E40 16r6A1F 16r3E41 16r6A35 16r3E42 16r6CBC 16r3E43 16r6D88 16r3E44 16r6E09 16r3E45 16r6E58 16r3E46 16r713C 16r3E47 16r7126 16r3E48 16r7167 16r3E49 16r75C7 16r3E4A 16r7701 16r3E4B 16r785D 16r3E4C 16r7901 16r3E4D 16r7965 16r3E4E 16r79F0 16r3E4F 16r7AE0 16r3E50 16r7B11 16r3E51 16r7CA7 16r3E52 16r7D39 16r3E53 16r8096 16r3E54 16r83D6 16r3E55 16r848B 16r3E56 16r8549 16r3E57 16r885D 16r3E58 16r88F3 16r3E59 16r8A1F 16r3E5A 16r8A3C 16r3E5B 16r8A54 16r3E5C 16r8A73 16r3E5D 16r8C61 16r3E5E 16r8CDE 16r3E5F 16r91A4 16r3E60 16r9266 16r3E61 16r937E 16r3E62 16r9418 16r3E63 16r969C 16r3E64 16r9798 16r3E65 16r4E0A 16r3E66 16r4E08 16r3E67 16r4E1E 16r3E68 16r4E57 16r3E69 16r5197 16r3E6A 16r5270 16r3E6B 16r57CE 16r3E6C 16r5834 16r3E6D 16r58CC 16r3E6E 16r5B22 16r3E6F 16r5E38 16r3E70 16r60C5 16r3E71 16r64FE 16r3E72 16r6761 16r3E73 16r6756 16r3E74 16r6D44 16r3E75 16r72B6 16r3E76 16r7573 16r3E77 16r7A63 16r3E78 16r84B8 16r3E79 16r8B72 16r3E7A 16r91B8 16r3E7B 16r9320 16r3E7C 16r5631 16r3E7D 16r57F4 16r3E7E 16r98FE 16r3F21 16r62ED 16r3F22 16r690D 16r3F23 16r6B96 16r3F24 16r71ED 16r3F25 16r7E54 16r3F26 16r8077 16r3F27 16r8272 16r3F28 16r89E6 16r3F29 16r98DF 16r3F2A 16r8755 16r3F2B 16r8FB1 16r3F2C 16r5C3B 16r3F2D 16r4F38 16r3F2E 16r4FE1 16r3F2F 16r4FB5 16r3F30 16r5507 16r3F31 16r5A20 16r3F32 16r5BDD 16r3F33 16r5BE9 16r3F34 16r5FC3 16r3F35 16r614E 16r3F36 16r632F 16r3F37 16r65B0 16r3F38 16r664B 16r3F39 16r68EE 16r3F3A 16r699B 16r3F3B 16r6D78 16r3F3C 16r6DF1 16r3F3D 16r7533 16r3F3E 16r75B9 16r3F3F 16r771F 16r3F40 16r795E 16r3F41 16r79E6 16r3F42 16r7D33 16r3F43 16r81E3 16r3F44 16r82AF 16r3F45 16r85AA 16r3F46 16r89AA 16r3F47 16r8A3A 16r3F48 16r8EAB 16r3F49 16r8F9B 16r3F4A 16r9032 16r3F4B 16r91DD 16r3F4C 16r9707 16r3F4D 16r4EBA 16r3F4E 16r4EC1 16r3F4F 16r5203 16r3F50 16r5875 16r3F51 16r58EC 16r3F52 16r5C0B 16r3F53 16r751A 16r3F54 16r5C3D 16r3F55 16r814E 16r3F56 16r8A0A 16r3F57 16r8FC5 16r3F58 16r9663 16r3F59 16r976D 16r3F5A 16r7B25 16r3F5B 16r8ACF 16r3F5C 16r9808 16r3F5D 16r9162 16r3F5E 16r56F3 16r3F5F 16r53A8 16r3F60 16r9017 16r3F61 16r5439 16r3F62 16r5782 16r3F63 16r5E25 16r3F64 16r63A8 16r3F65 16r6C34 16r3F66 16r708A 16r3F67 16r7761 16r3F68 16r7C8B 16r3F69 16r7FE0 16r3F6A 16r8870 16r3F6B 16r9042 16r3F6C 16r9154 16r3F6D 16r9310 16r3F6E 16r9318 16r3F6F 16r968F 16r3F70 16r745E 16r3F71 16r9AC4 16r3F72 16r5D07 16r3F73 16r5D69 16r3F74 16r6570 16r3F75 16r67A2 16r3F76 16r8DA8 16r3F77 16r96DB 16r3F78 16r636E 16r3F79 16r6749 16r3F7A 16r6919 16r3F7B 16r83C5 16r3F7C 16r9817 16r3F7D 16r96C0 16r3F7E 16r88FE 16r4021 16r6F84 16r4022 16r647A 16r4023 16r5BF8 16r4024 16r4E16 16r4025 16r702C 16r4026 16r755D 16r4027 16r662F 16r4028 16r51C4 16r4029 16r5236 16r402A 16r52E2 16r402B 16r59D3 16r402C 16r5F81 16r402D 16r6027 16r402E 16r6210 16r402F 16r653F 16r4030 16r6574 16r4031 16r661F 16r4032 16r6674 16r4033 16r68F2 16r4034 16r6816 16r4035 16r6B63 16r4036 16r6E05 16r4037 16r7272 16r4038 16r751F 16r4039 16r76DB 16r403A 16r7CBE 16r403B 16r8056 16r403C 16r58F0 16r403D 16r88FD 16r403E 16r897F 16r403F 16r8AA0 16r4040 16r8A93 16r4041 16r8ACB 16r4042 16r901D 16r4043 16r9192 16r4044 16r9752 16r4045 16r9759 16r4046 16r6589 16r4047 16r7A0E 16r4048 16r8106 16r4049 16r96BB 16r404A 16r5E2D 16r404B 16r60DC 16r404C 16r621A 16r404D 16r65A5 16r404E 16r6614 16r404F 16r6790 16r4050 16r77F3 16r4051 16r7A4D 16r4052 16r7C4D 16r4053 16r7E3E 16r4054 16r810A 16r4055 16r8CAC 16r4056 16r8D64 16r4057 16r8DE1 16r4058 16r8E5F 16r4059 16r78A9 16r405A 16r5207 16r405B 16r62D9 16r405C 16r63A5 16r405D 16r6442 16r405E 16r6298 16r405F 16r8A2D 16r4060 16r7A83 16r4061 16r7BC0 16r4062 16r8AAC 16r4063 16r96EA 16r4064 16r7D76 16r4065 16r820C 16r4066 16r8749 16r4067 16r4ED9 16r4068 16r5148 16r4069 16r5343 16r406A 16r5360 16r406B 16r5BA3 16r406C 16r5C02 16r406D 16r5C16 16r406E 16r5DDD 16r406F 16r6226 16r4070 16r6247 16r4071 16r64B0 16r4072 16r6813 16r4073 16r6834 16r4074 16r6CC9 16r4075 16r6D45 16r4076 16r6D17 16r4077 16r67D3 16r4078 16r6F5C 16r4079 16r714E 16r407A 16r717D 16r407B 16r65CB 16r407C 16r7A7F 16r407D 16r7BAD 16r407E 16r7DDA 16r4121 16r7E4A 16r4122 16r7FA8 16r4123 16r817A 16r4124 16r821B 16r4125 16r8239 16r4126 16r85A6 16r4127 16r8A6E 16r4128 16r8CCE 16r4129 16r8DF5 16r412A 16r9078 16r412B 16r9077 16r412C 16r92AD 16r412D 16r9291 16r412E 16r9583 16r412F 16r9BAE 16r4130 16r524D 16r4131 16r5584 16r4132 16r6F38 16r4133 16r7136 16r4134 16r5168 16r4135 16r7985 16r4136 16r7E55 16r4137 16r81B3 16r4138 16r7CCE 16r4139 16r564C 16r413A 16r5851 16r413B 16r5CA8 16r413C 16r63AA 16r413D 16r66FE 16r413E 16r66FD 16r413F 16r695A 16r4140 16r72D9 16r4141 16r758F 16r4142 16r758E 16r4143 16r790E 16r4144 16r7956 16r4145 16r79DF 16r4146 16r7C97 16r4147 16r7D20 16r4148 16r7D44 16r4149 16r8607 16r414A 16r8A34 16r414B 16r963B 16r414C 16r9061 16r414D 16r9F20 16r414E 16r50E7 16r414F 16r5275 16r4150 16r53CC 16r4151 16r53E2 16r4152 16r5009 16r4153 16r55AA 16r4154 16r58EE 16r4155 16r594F 16r4156 16r723D 16r4157 16r5B8B 16r4158 16r5C64 16r4159 16r531D 16r415A 16r60E3 16r415B 16r60F3 16r415C 16r635C 16r415D 16r6383 16r415E 16r633F 16r415F 16r63BB 16r4160 16r64CD 16r4161 16r65E9 16r4162 16r66F9 16r4163 16r5DE3 16r4164 16r69CD 16r4165 16r69FD 16r4166 16r6F15 16r4167 16r71E5 16r4168 16r4E89 16r4169 16r75E9 16r416A 16r76F8 16r416B 16r7A93 16r416C 16r7CDF 16r416D 16r7DCF 16r416E 16r7D9C 16r416F 16r8061 16r4170 16r8349 16r4171 16r8358 16r4172 16r846C 16r4173 16r84BC 16r4174 16r85FB 16r4175 16r88C5 16r4176 16r8D70 16r4177 16r9001 16r4178 16r906D 16r4179 16r9397 16r417A 16r971C 16r417B 16r9A12 16r417C 16r50CF 16r417D 16r5897 16r417E 16r618E 16r4221 16r81D3 16r4222 16r8535 16r4223 16r8D08 16r4224 16r9020 16r4225 16r4FC3 16r4226 16r5074 16r4227 16r5247 16r4228 16r5373 16r4229 16r606F 16r422A 16r6349 16r422B 16r675F 16r422C 16r6E2C 16r422D 16r8DB3 16r422E 16r901F 16r422F 16r4FD7 16r4230 16r5C5E 16r4231 16r8CCA 16r4232 16r65CF 16r4233 16r7D9A 16r4234 16r5352 16r4235 16r8896 16r4236 16r5176 16r4237 16r63C3 16r4238 16r5B58 16r4239 16r5B6B 16r423A 16r5C0A 16r423B 16r640D 16r423C 16r6751 16r423D 16r905C 16r423E 16r4ED6 16r423F 16r591A 16r4240 16r592A 16r4241 16r6C70 16r4242 16r8A51 16r4243 16r553E 16r4244 16r5815 16r4245 16r59A5 16r4246 16r60F0 16r4247 16r6253 16r4248 16r67C1 16r4249 16r8235 16r424A 16r6955 16r424B 16r9640 16r424C 16r99C4 16r424D 16r9A28 16r424E 16r4F53 16r424F 16r5806 16r4250 16r5BFE 16r4251 16r8010 16r4252 16r5CB1 16r4253 16r5E2F 16r4254 16r5F85 16r4255 16r6020 16r4256 16r614B 16r4257 16r6234 16r4258 16r66FF 16r4259 16r6CF0 16r425A 16r6EDE 16r425B 16r80CE 16r425C 16r817F 16r425D 16r82D4 16r425E 16r888B 16r425F 16r8CB8 16r4260 16r9000 16r4261 16r902E 16r4262 16r968A 16r4263 16r9EDB 16r4264 16r9BDB 16r4265 16r4EE3 16r4266 16r53F0 16r4267 16r5927 16r4268 16r7B2C 16r4269 16r918D 16r426A 16r984C 16r426B 16r9DF9 16r426C 16r6EDD 16r426D 16r7027 16r426E 16r5353 16r426F 16r5544 16r4270 16r5B85 16r4271 16r6258 16r4272 16r629E 16r4273 16r62D3 16r4274 16r6CA2 16r4275 16r6FEF 16r4276 16r7422 16r4277 16r8A17 16r4278 16r9438 16r4279 16r6FC1 16r427A 16r8AFE 16r427B 16r8338 16r427C 16r51E7 16r427D 16r86F8 16r427E 16r53EA 16r4321 16r53E9 16r4322 16r4F46 16r4323 16r9054 16r4324 16r8FB0 16r4325 16r596A 16r4326 16r8131 16r4327 16r5DFD 16r4328 16r7AEA 16r4329 16r8FBF 16r432A 16r68DA 16r432B 16r8C37 16r432C 16r72F8 16r432D 16r9C48 16r432E 16r6A3D 16r432F 16r8AB0 16r4330 16r4E39 16r4331 16r5358 16r4332 16r5606 16r4333 16r5766 16r4334 16r62C5 16r4335 16r63A2 16r4336 16r65E6 16r4337 16r6B4E 16r4338 16r6DE1 16r4339 16r6E5B 16r433A 16r70AD 16r433B 16r77ED 16r433C 16r7AEF 16r433D 16r7BAA 16r433E 16r7DBB 16r433F 16r803D 16r4340 16r80C6 16r4341 16r86CB 16r4342 16r8A95 16r4343 16r935B 16r4344 16r56E3 16r4345 16r58C7 16r4346 16r5F3E 16r4347 16r65AD 16r4348 16r6696 16r4349 16r6A80 16r434A 16r6BB5 16r434B 16r7537 16r434C 16r8AC7 16r434D 16r5024 16r434E 16r77E5 16r434F 16r5730 16r4350 16r5F1B 16r4351 16r6065 16r4352 16r667A 16r4353 16r6C60 16r4354 16r75F4 16r4355 16r7A1A 16r4356 16r7F6E 16r4357 16r81F4 16r4358 16r8718 16r4359 16r9045 16r435A 16r99B3 16r435B 16r7BC9 16r435C 16r755C 16r435D 16r7AF9 16r435E 16r7B51 16r435F 16r84C4 16r4360 16r9010 16r4361 16r79E9 16r4362 16r7A92 16r4363 16r8336 16r4364 16r5AE1 16r4365 16r7740 16r4366 16r4E2D 16r4367 16r4EF2 16r4368 16r5B99 16r4369 16r5FE0 16r436A 16r62BD 16r436B 16r663C 16r436C 16r67F1 16r436D 16r6CE8 16r436E 16r866B 16r436F 16r8877 16r4370 16r8A3B 16r4371 16r914E 16r4372 16r92F3 16r4373 16r99D0 16r4374 16r6A17 16r4375 16r7026 16r4376 16r732A 16r4377 16r82E7 16r4378 16r8457 16r4379 16r8CAF 16r437A 16r4E01 16r437B 16r5146 16r437C 16r51CB 16r437D 16r558B 16r437E 16r5BF5 16r4421 16r5E16 16r4422 16r5E33 16r4423 16r5E81 16r4424 16r5F14 16r4425 16r5F35 16r4426 16r5F6B 16r4427 16r5FB4 16r4428 16r61F2 16r4429 16r6311 16r442A 16r66A2 16r442B 16r671D 16r442C 16r6F6E 16r442D 16r7252 16r442E 16r753A 16r442F 16r773A 16r4430 16r8074 16r4431 16r8139 16r4432 16r8178 16r4433 16r8776 16r4434 16r8ABF 16r4435 16r8ADC 16r4436 16r8D85 16r4437 16r8DF3 16r4438 16r929A 16r4439 16r9577 16r443A 16r9802 16r443B 16r9CE5 16r443C 16r52C5 16r443D 16r6357 16r443E 16r76F4 16r443F 16r6715 16r4440 16r6C88 16r4441 16r73CD 16r4442 16r8CC3 16r4443 16r93AE 16r4444 16r9673 16r4445 16r6D25 16r4446 16r589C 16r4447 16r690E 16r4448 16r69CC 16r4449 16r8FFD 16r444A 16r939A 16r444B 16r75DB 16r444C 16r901A 16r444D 16r585A 16r444E 16r6802 16r444F 16r63B4 16r4450 16r69FB 16r4451 16r4F43 16r4452 16r6F2C 16r4453 16r67D8 16r4454 16r8FBB 16r4455 16r8526 16r4456 16r7DB4 16r4457 16r9354 16r4458 16r693F 16r4459 16r6F70 16r445A 16r576A 16r445B 16r58F7 16r445C 16r5B2C 16r445D 16r7D2C 16r445E 16r722A 16r445F 16r540A 16r4460 16r91E3 16r4461 16r9DB4 16r4462 16r4EAD 16r4463 16r4F4E 16r4464 16r505C 16r4465 16r5075 16r4466 16r5243 16r4467 16r8C9E 16r4468 16r5448 16r4469 16r5824 16r446A 16r5B9A 16r446B 16r5E1D 16r446C 16r5E95 16r446D 16r5EAD 16r446E 16r5EF7 16r446F 16r5F1F 16r4470 16r608C 16r4471 16r62B5 16r4472 16r633A 16r4473 16r63D0 16r4474 16r68AF 16r4475 16r6C40 16r4476 16r7887 16r4477 16r798E 16r4478 16r7A0B 16r4479 16r7DE0 16r447A 16r8247 16r447B 16r8A02 16r447C 16r8AE6 16r447D 16r8E44 16r447E 16r9013 16r4521 16r90B8 16r4522 16r912D 16r4523 16r91D8 16r4524 16r9F0E 16r4525 16r6CE5 16r4526 16r6458 16r4527 16r64E2 16r4528 16r6575 16r4529 16r6EF4 16r452A 16r7684 16r452B 16r7B1B 16r452C 16r9069 16r452D 16r93D1 16r452E 16r6EBA 16r452F 16r54F2 16r4530 16r5FB9 16r4531 16r64A4 16r4532 16r8F4D 16r4533 16r8FED 16r4534 16r9244 16r4535 16r5178 16r4536 16r586B 16r4537 16r5929 16r4538 16r5C55 16r4539 16r5E97 16r453A 16r6DFB 16r453B 16r7E8F 16r453C 16r751C 16r453D 16r8CBC 16r453E 16r8EE2 16r453F 16r985B 16r4540 16r70B9 16r4541 16r4F1D 16r4542 16r6BBF 16r4543 16r6FB1 16r4544 16r7530 16r4545 16r96FB 16r4546 16r514E 16r4547 16r5410 16r4548 16r5835 16r4549 16r5857 16r454A 16r59AC 16r454B 16r5C60 16r454C 16r5F92 16r454D 16r6597 16r454E 16r675C 16r454F 16r6E21 16r4550 16r767B 16r4551 16r83DF 16r4552 16r8CED 16r4553 16r9014 16r4554 16r90FD 16r4555 16r934D 16r4556 16r7825 16r4557 16r783A 16r4558 16r52AA 16r4559 16r5EA6 16r455A 16r571F 16r455B 16r5974 16r455C 16r6012 16r455D 16r5012 16r455E 16r515A 16r455F 16r51AC 16r4560 16r51CD 16r4561 16r5200 16r4562 16r5510 16r4563 16r5854 16r4564 16r5858 16r4565 16r5957 16r4566 16r5B95 16r4567 16r5CF6 16r4568 16r5D8B 16r4569 16r60BC 16r456A 16r6295 16r456B 16r642D 16r456C 16r6771 16r456D 16r6843 16r456E 16r68BC 16r456F 16r68DF 16r4570 16r76D7 16r4571 16r6DD8 16r4572 16r6E6F 16r4573 16r6D9B 16r4574 16r706F 16r4575 16r71C8 16r4576 16r5F53 16r4577 16r75D8 16r4578 16r7977 16r4579 16r7B49 16r457A 16r7B54 16r457B 16r7B52 16r457C 16r7CD6 16r457D 16r7D71 16r457E 16r5230 16r4621 16r8463 16r4622 16r8569 16r4623 16r85E4 16r4624 16r8A0E 16r4625 16r8B04 16r4626 16r8C46 16r4627 16r8E0F 16r4628 16r9003 16r4629 16r900F 16r462A 16r9419 16r462B 16r9676 16r462C 16r982D 16r462D 16r9A30 16r462E 16r95D8 16r462F 16r50CD 16r4630 16r52D5 16r4631 16r540C 16r4632 16r5802 16r4633 16r5C0E 16r4634 16r61A7 16r4635 16r649E 16r4636 16r6D1E 16r4637 16r77B3 16r4638 16r7AE5 16r4639 16r80F4 16r463A 16r8404 16r463B 16r9053 16r463C 16r9285 16r463D 16r5CE0 16r463E 16r9D07 16r463F 16r533F 16r4640 16r5F97 16r4641 16r5FB3 16r4642 16r6D9C 16r4643 16r7279 16r4644 16r7763 16r4645 16r79BF 16r4646 16r7BE4 16r4647 16r6BD2 16r4648 16r72EC 16r4649 16r8AAD 16r464A 16r6803 16r464B 16r6A61 16r464C 16r51F8 16r464D 16r7A81 16r464E 16r6934 16r464F 16r5C4A 16r4650 16r9CF6 16r4651 16r82EB 16r4652 16r5BC5 16r4653 16r9149 16r4654 16r701E 16r4655 16r5678 16r4656 16r5C6F 16r4657 16r60C7 16r4658 16r6566 16r4659 16r6C8C 16r465A 16r8C5A 16r465B 16r9041 16r465C 16r9813 16r465D 16r5451 16r465E 16r66C7 16r465F 16r920D 16r4660 16r5948 16r4661 16r90A3 16r4662 16r5185 16r4663 16r4E4D 16r4664 16r51EA 16r4665 16r8599 16r4666 16r8B0E 16r4667 16r7058 16r4668 16r637A 16r4669 16r934B 16r466A 16r6962 16r466B 16r99B4 16r466C 16r7E04 16r466D 16r7577 16r466E 16r5357 16r466F 16r6960 16r4670 16r8EDF 16r4671 16r96E3 16r4672 16r6C5D 16r4673 16r4E8C 16r4674 16r5C3C 16r4675 16r5F10 16r4676 16r8FE9 16r4677 16r5302 16r4678 16r8CD1 16r4679 16r8089 16r467A 16r8679 16r467B 16r5EFF 16r467C 16r65E5 16r467D 16r4E73 16r467E 16r5165 16r4721 16r5982 16r4722 16r5C3F 16r4723 16r97EE 16r4724 16r4EFB 16r4725 16r598A 16r4726 16r5FCD 16r4727 16r8A8D 16r4728 16r6FE1 16r4729 16r79B0 16r472A 16r7962 16r472B 16r5BE7 16r472C 16r8471 16r472D 16r732B 16r472E 16r71B1 16r472F 16r5E74 16r4730 16r5FF5 16r4731 16r637B 16r4732 16r649A 16r4733 16r71C3 16r4734 16r7C98 16r4735 16r4E43 16r4736 16r5EFC 16r4737 16r4E4B 16r4738 16r57DC 16r4739 16r56A2 16r473A 16r60A9 16r473B 16r6FC3 16r473C 16r7D0D 16r473D 16r80FD 16r473E 16r8133 16r473F 16r81BF 16r4740 16r8FB2 16r4741 16r8997 16r4742 16r86A4 16r4743 16r5DF4 16r4744 16r628A 16r4745 16r64AD 16r4746 16r8987 16r4747 16r6777 16r4748 16r6CE2 16r4749 16r6D3E 16r474A 16r7436 16r474B 16r7834 16r474C 16r5A46 16r474D 16r7F75 16r474E 16r82AD 16r474F 16r99AC 16r4750 16r4FF3 16r4751 16r5EC3 16r4752 16r62DD 16r4753 16r6392 16r4754 16r6557 16r4755 16r676F 16r4756 16r76C3 16r4757 16r724C 16r4758 16r80CC 16r4759 16r80BA 16r475A 16r8F29 16r475B 16r914D 16r475C 16r500D 16r475D 16r57F9 16r475E 16r5A92 16r475F 16r6885 16r4760 16r6973 16r4761 16r7164 16r4762 16r72FD 16r4763 16r8CB7 16r4764 16r58F2 16r4765 16r8CE0 16r4766 16r966A 16r4767 16r9019 16r4768 16r877F 16r4769 16r79E4 16r476A 16r77E7 16r476B 16r8429 16r476C 16r4F2F 16r476D 16r5265 16r476E 16r535A 16r476F 16r62CD 16r4770 16r67CF 16r4771 16r6CCA 16r4772 16r767D 16r4773 16r7B94 16r4774 16r7C95 16r4775 16r8236 16r4776 16r8584 16r4777 16r8FEB 16r4778 16r66DD 16r4779 16r6F20 16r477A 16r7206 16r477B 16r7E1B 16r477C 16r83AB 16r477D 16r99C1 16r477E 16r9EA6 16r4821 16r51FD 16r4822 16r7BB1 16r4823 16r7872 16r4824 16r7BB8 16r4825 16r8087 16r4826 16r7B48 16r4827 16r6AE8 16r4828 16r5E61 16r4829 16r808C 16r482A 16r7551 16r482B 16r7560 16r482C 16r516B 16r482D 16r9262 16r482E 16r6E8C 16r482F 16r767A 16r4830 16r9197 16r4831 16r9AEA 16r4832 16r4F10 16r4833 16r7F70 16r4834 16r629C 16r4835 16r7B4F 16r4836 16r95A5 16r4837 16r9CE9 16r4838 16r567A 16r4839 16r5859 16r483A 16r86E4 16r483B 16r96BC 16r483C 16r4F34 16r483D 16r5224 16r483E 16r534A 16r483F 16r53CD 16r4840 16r53DB 16r4841 16r5E06 16r4842 16r642C 16r4843 16r6591 16r4844 16r677F 16r4845 16r6C3E 16r4846 16r6C4E 16r4847 16r7248 16r4848 16r72AF 16r4849 16r73ED 16r484A 16r7554 16r484B 16r7E41 16r484C 16r822C 16r484D 16r85E9 16r484E 16r8CA9 16r484F 16r7BC4 16r4850 16r91C6 16r4851 16r7169 16r4852 16r9812 16r4853 16r98EF 16r4854 16r633D 16r4855 16r6669 16r4856 16r756A 16r4857 16r76E4 16r4858 16r78D0 16r4859 16r8543 16r485A 16r86EE 16r485B 16r532A 16r485C 16r5351 16r485D 16r5426 16r485E 16r5983 16r485F 16r5E87 16r4860 16r5F7C 16r4861 16r60B2 16r4862 16r6249 16r4863 16r6279 16r4864 16r62AB 16r4865 16r6590 16r4866 16r6BD4 16r4867 16r6CCC 16r4868 16r75B2 16r4869 16r76AE 16r486A 16r7891 16r486B 16r79D8 16r486C 16r7DCB 16r486D 16r7F77 16r486E 16r80A5 16r486F 16r88AB 16r4870 16r8AB9 16r4871 16r8CBB 16r4872 16r907F 16r4873 16r975E 16r4874 16r98DB 16r4875 16r6A0B 16r4876 16r7C38 16r4877 16r5099 16r4878 16r5C3E 16r4879 16r5FAE 16r487A 16r6787 16r487B 16r6BD8 16r487C 16r7435 16r487D 16r7709 16r487E 16r7F8E 16r4921 16r9F3B 16r4922 16r67CA 16r4923 16r7A17 16r4924 16r5339 16r4925 16r758B 16r4926 16r9AED 16r4927 16r5F66 16r4928 16r819D 16r4929 16r83F1 16r492A 16r8098 16r492B 16r5F3C 16r492C 16r5FC5 16r492D 16r7562 16r492E 16r7B46 16r492F 16r903C 16r4930 16r6867 16r4931 16r59EB 16r4932 16r5A9B 16r4933 16r7D10 16r4934 16r767E 16r4935 16r8B2C 16r4936 16r4FF5 16r4937 16r5F6A 16r4938 16r6A19 16r4939 16r6C37 16r493A 16r6F02 16r493B 16r74E2 16r493C 16r7968 16r493D 16r8868 16r493E 16r8A55 16r493F 16r8C79 16r4940 16r5EDF 16r4941 16r63CF 16r4942 16r75C5 16r4943 16r79D2 16r4944 16r82D7 16r4945 16r9328 16r4946 16r92F2 16r4947 16r849C 16r4948 16r86ED 16r4949 16r9C2D 16r494A 16r54C1 16r494B 16r5F6C 16r494C 16r658C 16r494D 16r6D5C 16r494E 16r7015 16r494F 16r8CA7 16r4950 16r8CD3 16r4951 16r983B 16r4952 16r654F 16r4953 16r74F6 16r4954 16r4E0D 16r4955 16r4ED8 16r4956 16r57E0 16r4957 16r592B 16r4958 16r5A66 16r4959 16r5BCC 16r495A 16r51A8 16r495B 16r5E03 16r495C 16r5E9C 16r495D 16r6016 16r495E 16r6276 16r495F 16r6577 16r4960 16r65A7 16r4961 16r666E 16r4962 16r6D6E 16r4963 16r7236 16r4964 16r7B26 16r4965 16r8150 16r4966 16r819A 16r4967 16r8299 16r4968 16r8B5C 16r4969 16r8CA0 16r496A 16r8CE6 16r496B 16r8D74 16r496C 16r961C 16r496D 16r9644 16r496E 16r4FAE 16r496F 16r64AB 16r4970 16r6B66 16r4971 16r821E 16r4972 16r8461 16r4973 16r856A 16r4974 16r90E8 16r4975 16r5C01 16r4976 16r6953 16r4977 16r98A8 16r4978 16r847A 16r4979 16r8557 16r497A 16r4F0F 16r497B 16r526F 16r497C 16r5FA9 16r497D 16r5E45 16r497E 16r670D 16r4A21 16r798F 16r4A22 16r8179 16r4A23 16r8907 16r4A24 16r8986 16r4A25 16r6DF5 16r4A26 16r5F17 16r4A27 16r6255 16r4A28 16r6CB8 16r4A29 16r4ECF 16r4A2A 16r7269 16r4A2B 16r9B92 16r4A2C 16r5206 16r4A2D 16r543B 16r4A2E 16r5674 16r4A2F 16r58B3 16r4A30 16r61A4 16r4A31 16r626E 16r4A32 16r711A 16r4A33 16r596E 16r4A34 16r7C89 16r4A35 16r7CDE 16r4A36 16r7D1B 16r4A37 16r96F0 16r4A38 16r6587 16r4A39 16r805E 16r4A3A 16r4E19 16r4A3B 16r4F75 16r4A3C 16r5175 16r4A3D 16r5840 16r4A3E 16r5E63 16r4A3F 16r5E73 16r4A40 16r5F0A 16r4A41 16r67C4 16r4A42 16r4E26 16r4A43 16r853D 16r4A44 16r9589 16r4A45 16r965B 16r4A46 16r7C73 16r4A47 16r9801 16r4A48 16r50FB 16r4A49 16r58C1 16r4A4A 16r7656 16r4A4B 16r78A7 16r4A4C 16r5225 16r4A4D 16r77A5 16r4A4E 16r8511 16r4A4F 16r7B86 16r4A50 16r504F 16r4A51 16r5909 16r4A52 16r7247 16r4A53 16r7BC7 16r4A54 16r7DE8 16r4A55 16r8FBA 16r4A56 16r8FD4 16r4A57 16r904D 16r4A58 16r4FBF 16r4A59 16r52C9 16r4A5A 16r5A29 16r4A5B 16r5F01 16r4A5C 16r97AD 16r4A5D 16r4FDD 16r4A5E 16r8217 16r4A5F 16r92EA 16r4A60 16r5703 16r4A61 16r6355 16r4A62 16r6B69 16r4A63 16r752B 16r4A64 16r88DC 16r4A65 16r8F14 16r4A66 16r7A42 16r4A67 16r52DF 16r4A68 16r5893 16r4A69 16r6155 16r4A6A 16r620A 16r4A6B 16r66AE 16r4A6C 16r6BCD 16r4A6D 16r7C3F 16r4A6E 16r83E9 16r4A6F 16r5023 16r4A70 16r4FF8 16r4A71 16r5305 16r4A72 16r5446 16r4A73 16r5831 16r4A74 16r5949 16r4A75 16r5B9D 16r4A76 16r5CF0 16r4A77 16r5CEF 16r4A78 16r5D29 16r4A79 16r5E96 16r4A7A 16r62B1 16r4A7B 16r6367 16r4A7C 16r653E 16r4A7D 16r65B9 16r4A7E 16r670B 16r4B21 16r6CD5 16r4B22 16r6CE1 16r4B23 16r70F9 16r4B24 16r7832 16r4B25 16r7E2B 16r4B26 16r80DE 16r4B27 16r82B3 16r4B28 16r840C 16r4B29 16r84EC 16r4B2A 16r8702 16r4B2B 16r8912 16r4B2C 16r8A2A 16r4B2D 16r8C4A 16r4B2E 16r90A6 16r4B2F 16r92D2 16r4B30 16r98FD 16r4B31 16r9CF3 16r4B32 16r9D6C 16r4B33 16r4E4F 16r4B34 16r4EA1 16r4B35 16r508D 16r4B36 16r5256 16r4B37 16r574A 16r4B38 16r59A8 16r4B39 16r5E3D 16r4B3A 16r5FD8 16r4B3B 16r5FD9 16r4B3C 16r623F 16r4B3D 16r66B4 16r4B3E 16r671B 16r4B3F 16r67D0 16r4B40 16r68D2 16r4B41 16r5192 16r4B42 16r7D21 16r4B43 16r80AA 16r4B44 16r81A8 16r4B45 16r8B00 16r4B46 16r8C8C 16r4B47 16r8CBF 16r4B48 16r927E 16r4B49 16r9632 16r4B4A 16r5420 16r4B4B 16r982C 16r4B4C 16r5317 16r4B4D 16r50D5 16r4B4E 16r535C 16r4B4F 16r58A8 16r4B50 16r64B2 16r4B51 16r6734 16r4B52 16r7267 16r4B53 16r7766 16r4B54 16r7A46 16r4B55 16r91E6 16r4B56 16r52C3 16r4B57 16r6CA1 16r4B58 16r6B86 16r4B59 16r5800 16r4B5A 16r5E4C 16r4B5B 16r5954 16r4B5C 16r672C 16r4B5D 16r7FFB 16r4B5E 16r51E1 16r4B5F 16r76C6 16r4B60 16r6469 16r4B61 16r78E8 16r4B62 16r9B54 16r4B63 16r9EBB 16r4B64 16r57CB 16r4B65 16r59B9 16r4B66 16r6627 16r4B67 16r679A 16r4B68 16r6BCE 16r4B69 16r54E9 16r4B6A 16r69D9 16r4B6B 16r5E55 16r4B6C 16r819C 16r4B6D 16r6795 16r4B6E 16r9BAA 16r4B6F 16r67FE 16r4B70 16r9C52 16r4B71 16r685D 16r4B72 16r4EA6 16r4B73 16r4FE3 16r4B74 16r53C8 16r4B75 16r62B9 16r4B76 16r672B 16r4B77 16r6CAB 16r4B78 16r8FC4 16r4B79 16r4FAD 16r4B7A 16r7E6D 16r4B7B 16r9EBF 16r4B7C 16r4E07 16r4B7D 16r6162 16r4B7E 16r6E80 16r4C21 16r6F2B 16r4C22 16r8513 16r4C23 16r5473 16r4C24 16r672A 16r4C25 16r9B45 16r4C26 16r5DF3 16r4C27 16r7B95 16r4C28 16r5CAC 16r4C29 16r5BC6 16r4C2A 16r871C 16r4C2B 16r6E4A 16r4C2C 16r84D1 16r4C2D 16r7A14 16r4C2E 16r8108 16r4C2F 16r5999 16r4C30 16r7C8D 16r4C31 16r6C11 16r4C32 16r7720 16r4C33 16r52D9 16r4C34 16r5922 16r4C35 16r7121 16r4C36 16r725F 16r4C37 16r77DB 16r4C38 16r9727 16r4C39 16r9D61 16r4C3A 16r690B 16r4C3B 16r5A7F 16r4C3C 16r5A18 16r4C3D 16r51A5 16r4C3E 16r540D 16r4C3F 16r547D 16r4C40 16r660E 16r4C41 16r76DF 16r4C42 16r8FF7 16r4C43 16r9298 16r4C44 16r9CF4 16r4C45 16r59EA 16r4C46 16r725D 16r4C47 16r6EC5 16r4C48 16r514D 16r4C49 16r68C9 16r4C4A 16r7DBF 16r4C4B 16r7DEC 16r4C4C 16r9762 16r4C4D 16r9EBA 16r4C4E 16r6478 16r4C4F 16r6A21 16r4C50 16r8302 16r4C51 16r5984 16r4C52 16r5B5F 16r4C53 16r6BDB 16r4C54 16r731B 16r4C55 16r76F2 16r4C56 16r7DB2 16r4C57 16r8017 16r4C58 16r8499 16r4C59 16r5132 16r4C5A 16r6728 16r4C5B 16r9ED9 16r4C5C 16r76EE 16r4C5D 16r6762 16r4C5E 16r52FF 16r4C5F 16r9905 16r4C60 16r5C24 16r4C61 16r623B 16r4C62 16r7C7E 16r4C63 16r8CB0 16r4C64 16r554F 16r4C65 16r60B6 16r4C66 16r7D0B 16r4C67 16r9580 16r4C68 16r5301 16r4C69 16r4E5F 16r4C6A 16r51B6 16r4C6B 16r591C 16r4C6C 16r723A 16r4C6D 16r8036 16r4C6E 16r91CE 16r4C6F 16r5F25 16r4C70 16r77E2 16r4C71 16r5384 16r4C72 16r5F79 16r4C73 16r7D04 16r4C74 16r85AC 16r4C75 16r8A33 16r4C76 16r8E8D 16r4C77 16r9756 16r4C78 16r67F3 16r4C79 16r85AE 16r4C7A 16r9453 16r4C7B 16r6109 16r4C7C 16r6108 16r4C7D 16r6CB9 16r4C7E 16r7652 16r4D21 16r8AED 16r4D22 16r8F38 16r4D23 16r552F 16r4D24 16r4F51 16r4D25 16r512A 16r4D26 16r52C7 16r4D27 16r53CB 16r4D28 16r5BA5 16r4D29 16r5E7D 16r4D2A 16r60A0 16r4D2B 16r6182 16r4D2C 16r63D6 16r4D2D 16r6709 16r4D2E 16r67DA 16r4D2F 16r6E67 16r4D30 16r6D8C 16r4D31 16r7336 16r4D32 16r7337 16r4D33 16r7531 16r4D34 16r7950 16r4D35 16r88D5 16r4D36 16r8A98 16r4D37 16r904A 16r4D38 16r9091 16r4D39 16r90F5 16r4D3A 16r96C4 16r4D3B 16r878D 16r4D3C 16r5915 16r4D3D 16r4E88 16r4D3E 16r4F59 16r4D3F 16r4E0E 16r4D40 16r8A89 16r4D41 16r8F3F 16r4D42 16r9810 16r4D43 16r50AD 16r4D44 16r5E7C 16r4D45 16r5996 16r4D46 16r5BB9 16r4D47 16r5EB8 16r4D48 16r63DA 16r4D49 16r63FA 16r4D4A 16r64C1 16r4D4B 16r66DC 16r4D4C 16r694A 16r4D4D 16r69D8 16r4D4E 16r6D0B 16r4D4F 16r6EB6 16r4D50 16r7194 16r4D51 16r7528 16r4D52 16r7AAF 16r4D53 16r7F8A 16r4D54 16r8000 16r4D55 16r8449 16r4D56 16r84C9 16r4D57 16r8981 16r4D58 16r8B21 16r4D59 16r8E0A 16r4D5A 16r9065 16r4D5B 16r967D 16r4D5C 16r990A 16r4D5D 16r617E 16r4D5E 16r6291 16r4D5F 16r6B32 16r4D60 16r6C83 16r4D61 16r6D74 16r4D62 16r7FCC 16r4D63 16r7FFC 16r4D64 16r6DC0 16r4D65 16r7F85 16r4D66 16r87BA 16r4D67 16r88F8 16r4D68 16r6765 16r4D69 16r83B1 16r4D6A 16r983C 16r4D6B 16r96F7 16r4D6C 16r6D1B 16r4D6D 16r7D61 16r4D6E 16r843D 16r4D6F 16r916A 16r4D70 16r4E71 16r4D71 16r5375 16r4D72 16r5D50 16r4D73 16r6B04 16r4D74 16r6FEB 16r4D75 16r85CD 16r4D76 16r862D 16r4D77 16r89A7 16r4D78 16r5229 16r4D79 16r540F 16r4D7A 16r5C65 16r4D7B 16r674E 16r4D7C 16r68A8 16r4D7D 16r7406 16r4D7E 16r7483 16r4E21 16r75E2 16r4E22 16r88CF 16r4E23 16r88E1 16r4E24 16r91CC 16r4E25 16r96E2 16r4E26 16r9678 16r4E27 16r5F8B 16r4E28 16r7387 16r4E29 16r7ACB 16r4E2A 16r844E 16r4E2B 16r63A0 16r4E2C 16r7565 16r4E2D 16r5289 16r4E2E 16r6D41 16r4E2F 16r6E9C 16r4E30 16r7409 16r4E31 16r7559 16r4E32 16r786B 16r4E33 16r7C92 16r4E34 16r9686 16r4E35 16r7ADC 16r4E36 16r9F8D 16r4E37 16r4FB6 16r4E38 16r616E 16r4E39 16r65C5 16r4E3A 16r865C 16r4E3B 16r4E86 16r4E3C 16r4EAE 16r4E3D 16r50DA 16r4E3E 16r4E21 16r4E3F 16r51CC 16r4E40 16r5BEE 16r4E41 16r6599 16r4E42 16r6881 16r4E43 16r6DBC 16r4E44 16r731F 16r4E45 16r7642 16r4E46 16r77AD 16r4E47 16r7A1C 16r4E48 16r7CE7 16r4E49 16r826F 16r4E4A 16r8AD2 16r4E4B 16r907C 16r4E4C 16r91CF 16r4E4D 16r9675 16r4E4E 16r9818 16r4E4F 16r529B 16r4E50 16r7DD1 16r4E51 16r502B 16r4E52 16r5398 16r4E53 16r6797 16r4E54 16r6DCB 16r4E55 16r71D0 16r4E56 16r7433 16r4E57 16r81E8 16r4E58 16r8F2A 16r4E59 16r96A3 16r4E5A 16r9C57 16r4E5B 16r9E9F 16r4E5C 16r7460 16r4E5D 16r5841 16r4E5E 16r6D99 16r4E5F 16r7D2F 16r4E60 16r985E 16r4E61 16r4EE4 16r4E62 16r4F36 16r4E63 16r4F8B 16r4E64 16r51B7 16r4E65 16r52B1 16r4E66 16r5DBA 16r4E67 16r601C 16r4E68 16r73B2 16r4E69 16r793C 16r4E6A 16r82D3 16r4E6B 16r9234 16r4E6C 16r96B7 16r4E6D 16r96F6 16r4E6E 16r970A 16r4E6F 16r9E97 16r4E70 16r9F62 16r4E71 16r66A6 16r4E72 16r6B74 16r4E73 16r5217 16r4E74 16r52A3 16r4E75 16r70C8 16r4E76 16r88C2 16r4E77 16r5EC9 16r4E78 16r604B 16r4E79 16r6190 16r4E7A 16r6F23 16r4E7B 16r7149 16r4E7C 16r7C3E 16r4E7D 16r7DF4 16r4E7E 16r806F 16r4F21 16r84EE 16r4F22 16r9023 16r4F23 16r932C 16r4F24 16r5442 16r4F25 16r9B6F 16r4F26 16r6AD3 16r4F27 16r7089 16r4F28 16r8CC2 16r4F29 16r8DEF 16r4F2A 16r9732 16r4F2B 16r52B4 16r4F2C 16r5A41 16r4F2D 16r5ECA 16r4F2E 16r5F04 16r4F2F 16r6717 16r4F30 16r697C 16r4F31 16r6994 16r4F32 16r6D6A 16r4F33 16r6F0F 16r4F34 16r7262 16r4F35 16r72FC 16r4F36 16r7BED 16r4F37 16r8001 16r4F38 16r807E 16r4F39 16r874B 16r4F3A 16r90CE 16r4F3B 16r516D 16r4F3C 16r9E93 16r4F3D 16r7984 16r4F3E 16r808B 16r4F3F 16r9332 16r4F40 16r8AD6 16r4F41 16r502D 16r4F42 16r548C 16r4F43 16r8A71 16r4F44 16r6B6A 16r4F45 16r8CC4 16r4F46 16r8107 16r4F47 16r60D1 16r4F48 16r67A0 16r4F49 16r9DF2 16r4F4A 16r4E99 16r4F4B 16r4E98 16r4F4C 16r9C10 16r4F4D 16r8A6B 16r4F4E 16r85C1 16r4F4F 16r8568 16r4F50 16r6900 16r4F51 16r6E7E 16r4F52 16r7897 16r4F53 16r8155 16r5021 16r5F0C 16r5022 16r4E10 16r5023 16r4E15 16r5024 16r4E2A 16r5025 16r4E31 16r5026 16r4E36 16r5027 16r4E3C 16r5028 16r4E3F 16r5029 16r4E42 16r502A 16r4E56 16r502B 16r4E58 16r502C 16r4E82 16r502D 16r4E85 16r502E 16r8C6B 16r502F 16r4E8A 16r5030 16r8212 16r5031 16r5F0D 16r5032 16r4E8E 16r5033 16r4E9E 16r5034 16r4E9F 16r5035 16r4EA0 16r5036 16r4EA2 16r5037 16r4EB0 16r5038 16r4EB3 16r5039 16r4EB6 16r503A 16r4ECE 16r503B 16r4ECD 16r503C 16r4EC4 16r503D 16r4EC6 16r503E 16r4EC2 16r503F 16r4ED7 16r5040 16r4EDE 16r5041 16r4EED 16r5042 16r4EDF 16r5043 16r4EF7 16r5044 16r4F09 16r5045 16r4F5A 16r5046 16r4F30 16r5047 16r4F5B 16r5048 16r4F5D 16r5049 16r4F57 16r504A 16r4F47 16r504B 16r4F76 16r504C 16r4F88 16r504D 16r4F8F 16r504E 16r4F98 16r504F 16r4F7B 16r5050 16r4F69 16r5051 16r4F70 16r5052 16r4F91 16r5053 16r4F6F 16r5054 16r4F86 16r5055 16r4F96 16r5056 16r5118 16r5057 16r4FD4 16r5058 16r4FDF 16r5059 16r4FCE 16r505A 16r4FD8 16r505B 16r4FDB 16r505C 16r4FD1 16r505D 16r4FDA 16r505E 16r4FD0 16r505F 16r4FE4 16r5060 16r4FE5 16r5061 16r501A 16r5062 16r5028 16r5063 16r5014 16r5064 16r502A 16r5065 16r5025 16r5066 16r5005 16r5067 16r4F1C 16r5068 16r4FF6 16r5069 16r5021 16r506A 16r5029 16r506B 16r502C 16r506C 16r4FFE 16r506D 16r4FEF 16r506E 16r5011 16r506F 16r5006 16r5070 16r5043 16r5071 16r5047 16r5072 16r6703 16r5073 16r5055 16r5074 16r5050 16r5075 16r5048 16r5076 16r505A 16r5077 16r5056 16r5078 16r506C 16r5079 16r5078 16r507A 16r5080 16r507B 16r509A 16r507C 16r5085 16r507D 16r50B4 16r507E 16r50B2 16r5121 16r50C9 16r5122 16r50CA 16r5123 16r50B3 16r5124 16r50C2 16r5125 16r50D6 16r5126 16r50DE 16r5127 16r50E5 16r5128 16r50ED 16r5129 16r50E3 16r512A 16r50EE 16r512B 16r50F9 16r512C 16r50F5 16r512D 16r5109 16r512E 16r5101 16r512F 16r5102 16r5130 16r5116 16r5131 16r5115 16r5132 16r5114 16r5133 16r511A 16r5134 16r5121 16r5135 16r513A 16r5136 16r5137 16r5137 16r513C 16r5138 16r513B 16r5139 16r513F 16r513A 16r5140 16r513B 16r5152 16r513C 16r514C 16r513D 16r5154 16r513E 16r5162 16r513F 16r7AF8 16r5140 16r5169 16r5141 16r516A 16r5142 16r516E 16r5143 16r5180 16r5144 16r5182 16r5145 16r56D8 16r5146 16r518C 16r5147 16r5189 16r5148 16r518F 16r5149 16r5191 16r514A 16r5193 16r514B 16r5195 16r514C 16r5196 16r514D 16r51A4 16r514E 16r51A6 16r514F 16r51A2 16r5150 16r51A9 16r5151 16r51AA 16r5152 16r51AB 16r5153 16r51B3 16r5154 16r51B1 16r5155 16r51B2 16r5156 16r51B0 16r5157 16r51B5 16r5158 16r51BD 16r5159 16r51C5 16r515A 16r51C9 16r515B 16r51DB 16r515C 16r51E0 16r515D 16r8655 16r515E 16r51E9 16r515F 16r51ED 16r5160 16r51F0 16r5161 16r51F5 16r5162 16r51FE 16r5163 16r5204 16r5164 16r520B 16r5165 16r5214 16r5166 16r520E 16r5167 16r5227 16r5168 16r522A 16r5169 16r522E 16r516A 16r5233 16r516B 16r5239 16r516C 16r524F 16r516D 16r5244 16r516E 16r524B 16r516F 16r524C 16r5170 16r525E 16r5171 16r5254 16r5172 16r526A 16r5173 16r5274 16r5174 16r5269 16r5175 16r5273 16r5176 16r527F 16r5177 16r527D 16r5178 16r528D 16r5179 16r5294 16r517A 16r5292 16r517B 16r5271 16r517C 16r5288 16r517D 16r5291 16r517E 16r8FA8 16r5221 16r8FA7 16r5222 16r52AC 16r5223 16r52AD 16r5224 16r52BC 16r5225 16r52B5 16r5226 16r52C1 16r5227 16r52CD 16r5228 16r52D7 16r5229 16r52DE 16r522A 16r52E3 16r522B 16r52E6 16r522C 16r98ED 16r522D 16r52E0 16r522E 16r52F3 16r522F 16r52F5 16r5230 16r52F8 16r5231 16r52F9 16r5232 16r5306 16r5233 16r5308 16r5234 16r7538 16r5235 16r530D 16r5236 16r5310 16r5237 16r530F 16r5238 16r5315 16r5239 16r531A 16r523A 16r5323 16r523B 16r532F 16r523C 16r5331 16r523D 16r5333 16r523E 16r5338 16r523F 16r5340 16r5240 16r5346 16r5241 16r5345 16r5242 16r4E17 16r5243 16r5349 16r5244 16r534D 16r5245 16r51D6 16r5246 16r535E 16r5247 16r5369 16r5248 16r536E 16r5249 16r5918 16r524A 16r537B 16r524B 16r5377 16r524C 16r5382 16r524D 16r5396 16r524E 16r53A0 16r524F 16r53A6 16r5250 16r53A5 16r5251 16r53AE 16r5252 16r53B0 16r5253 16r53B6 16r5254 16r53C3 16r5255 16r7C12 16r5256 16r96D9 16r5257 16r53DF 16r5258 16r66FC 16r5259 16r71EE 16r525A 16r53EE 16r525B 16r53E8 16r525C 16r53ED 16r525D 16r53FA 16r525E 16r5401 16r525F 16r543D 16r5260 16r5440 16r5261 16r542C 16r5262 16r542D 16r5263 16r543C 16r5264 16r542E 16r5265 16r5436 16r5266 16r5429 16r5267 16r541D 16r5268 16r544E 16r5269 16r548F 16r526A 16r5475 16r526B 16r548E 16r526C 16r545F 16r526D 16r5471 16r526E 16r5477 16r526F 16r5470 16r5270 16r5492 16r5271 16r547B 16r5272 16r5480 16r5273 16r5476 16r5274 16r5484 16r5275 16r5490 16r5276 16r5486 16r5277 16r54C7 16r5278 16r54A2 16r5279 16r54B8 16r527A 16r54A5 16r527B 16r54AC 16r527C 16r54C4 16r527D 16r54C8 16r527E 16r54A8 16r5321 16r54AB 16r5322 16r54C2 16r5323 16r54A4 16r5324 16r54BE 16r5325 16r54BC 16r5326 16r54D8 16r5327 16r54E5 16r5328 16r54E6 16r5329 16r550F 16r532A 16r5514 16r532B 16r54FD 16r532C 16r54EE 16r532D 16r54ED 16r532E 16r54FA 16r532F 16r54E2 16r5330 16r5539 16r5331 16r5540 16r5332 16r5563 16r5333 16r554C 16r5334 16r552E 16r5335 16r555C 16r5336 16r5545 16r5337 16r5556 16r5338 16r5557 16r5339 16r5538 16r533A 16r5533 16r533B 16r555D 16r533C 16r5599 16r533D 16r5580 16r533E 16r54AF 16r533F 16r558A 16r5340 16r559F 16r5341 16r557B 16r5342 16r557E 16r5343 16r5598 16r5344 16r559E 16r5345 16r55AE 16r5346 16r557C 16r5347 16r5583 16r5348 16r55A9 16r5349 16r5587 16r534A 16r55A8 16r534B 16r55DA 16r534C 16r55C5 16r534D 16r55DF 16r534E 16r55C4 16r534F 16r55DC 16r5350 16r55E4 16r5351 16r55D4 16r5352 16r5614 16r5353 16r55F7 16r5354 16r5616 16r5355 16r55FE 16r5356 16r55FD 16r5357 16r561B 16r5358 16r55F9 16r5359 16r564E 16r535A 16r5650 16r535B 16r71DF 16r535C 16r5634 16r535D 16r5636 16r535E 16r5632 16r535F 16r5638 16r5360 16r566B 16r5361 16r5664 16r5362 16r562F 16r5363 16r566C 16r5364 16r566A 16r5365 16r5686 16r5366 16r5680 16r5367 16r568A 16r5368 16r56A0 16r5369 16r5694 16r536A 16r568F 16r536B 16r56A5 16r536C 16r56AE 16r536D 16r56B6 16r536E 16r56B4 16r536F 16r56C2 16r5370 16r56BC 16r5371 16r56C1 16r5372 16r56C3 16r5373 16r56C0 16r5374 16r56C8 16r5375 16r56CE 16r5376 16r56D1 16r5377 16r56D3 16r5378 16r56D7 16r5379 16r56EE 16r537A 16r56F9 16r537B 16r5700 16r537C 16r56FF 16r537D 16r5704 16r537E 16r5709 16r5421 16r5708 16r5422 16r570B 16r5423 16r570D 16r5424 16r5713 16r5425 16r5718 16r5426 16r5716 16r5427 16r55C7 16r5428 16r571C 16r5429 16r5726 16r542A 16r5737 16r542B 16r5738 16r542C 16r574E 16r542D 16r573B 16r542E 16r5740 16r542F 16r574F 16r5430 16r5769 16r5431 16r57C0 16r5432 16r5788 16r5433 16r5761 16r5434 16r577F 16r5435 16r5789 16r5436 16r5793 16r5437 16r57A0 16r5438 16r57B3 16r5439 16r57A4 16r543A 16r57AA 16r543B 16r57B0 16r543C 16r57C3 16r543D 16r57C6 16r543E 16r57D4 16r543F 16r57D2 16r5440 16r57D3 16r5441 16r580A 16r5442 16r57D6 16r5443 16r57E3 16r5444 16r580B 16r5445 16r5819 16r5446 16r581D 16r5447 16r5872 16r5448 16r5821 16r5449 16r5862 16r544A 16r584B 16r544B 16r5870 16r544C 16r6BC0 16r544D 16r5852 16r544E 16r583D 16r544F 16r5879 16r5450 16r5885 16r5451 16r58B9 16r5452 16r589F 16r5453 16r58AB 16r5454 16r58BA 16r5455 16r58DE 16r5456 16r58BB 16r5457 16r58B8 16r5458 16r58AE 16r5459 16r58C5 16r545A 16r58D3 16r545B 16r58D1 16r545C 16r58D7 16r545D 16r58D9 16r545E 16r58D8 16r545F 16r58E5 16r5460 16r58DC 16r5461 16r58E4 16r5462 16r58DF 16r5463 16r58EF 16r5464 16r58FA 16r5465 16r58F9 16r5466 16r58FB 16r5467 16r58FC 16r5468 16r58FD 16r5469 16r5902 16r546A 16r590A 16r546B 16r5910 16r546C 16r591B 16r546D 16r68A6 16r546E 16r5925 16r546F 16r592C 16r5470 16r592D 16r5471 16r5932 16r5472 16r5938 16r5473 16r593E 16r5474 16r7AD2 16r5475 16r5955 16r5476 16r5950 16r5477 16r594E 16r5478 16r595A 16r5479 16r5958 16r547A 16r5962 16r547B 16r5960 16r547C 16r5967 16r547D 16r596C 16r547E 16r5969 16r5521 16r5978 16r5522 16r5981 16r5523 16r599D 16r5524 16r4F5E 16r5525 16r4FAB 16r5526 16r59A3 16r5527 16r59B2 16r5528 16r59C6 16r5529 16r59E8 16r552A 16r59DC 16r552B 16r598D 16r552C 16r59D9 16r552D 16r59DA 16r552E 16r5A25 16r552F 16r5A1F 16r5530 16r5A11 16r5531 16r5A1C 16r5532 16r5A09 16r5533 16r5A1A 16r5534 16r5A40 16r5535 16r5A6C 16r5536 16r5A49 16r5537 16r5A35 16r5538 16r5A36 16r5539 16r5A62 16r553A 16r5A6A 16r553B 16r5A9A 16r553C 16r5ABC 16r553D 16r5ABE 16r553E 16r5ACB 16r553F 16r5AC2 16r5540 16r5ABD 16r5541 16r5AE3 16r5542 16r5AD7 16r5543 16r5AE6 16r5544 16r5AE9 16r5545 16r5AD6 16r5546 16r5AFA 16r5547 16r5AFB 16r5548 16r5B0C 16r5549 16r5B0B 16r554A 16r5B16 16r554B 16r5B32 16r554C 16r5AD0 16r554D 16r5B2A 16r554E 16r5B36 16r554F 16r5B3E 16r5550 16r5B43 16r5551 16r5B45 16r5552 16r5B40 16r5553 16r5B51 16r5554 16r5B55 16r5555 16r5B5A 16r5556 16r5B5B 16r5557 16r5B65 16r5558 16r5B69 16r5559 16r5B70 16r555A 16r5B73 16r555B 16r5B75 16r555C 16r5B78 16r555D 16r6588 16r555E 16r5B7A 16r555F 16r5B80 16r5560 16r5B83 16r5561 16r5BA6 16r5562 16r5BB8 16r5563 16r5BC3 16r5564 16r5BC7 16r5565 16r5BC9 16r5566 16r5BD4 16r5567 16r5BD0 16r5568 16r5BE4 16r5569 16r5BE6 16r556A 16r5BE2 16r556B 16r5BDE 16r556C 16r5BE5 16r556D 16r5BEB 16r556E 16r5BF0 16r556F 16r5BF6 16r5570 16r5BF3 16r5571 16r5C05 16r5572 16r5C07 16r5573 16r5C08 16r5574 16r5C0D 16r5575 16r5C13 16r5576 16r5C20 16r5577 16r5C22 16r5578 16r5C28 16r5579 16r5C38 16r557A 16r5C39 16r557B 16r5C41 16r557C 16r5C46 16r557D 16r5C4E 16r557E 16r5C53 16r5621 16r5C50 16r5622 16r5C4F 16r5623 16r5B71 16r5624 16r5C6C 16r5625 16r5C6E 16r5626 16r4E62 16r5627 16r5C76 16r5628 16r5C79 16r5629 16r5C8C 16r562A 16r5C91 16r562B 16r5C94 16r562C 16r599B 16r562D 16r5CAB 16r562E 16r5CBB 16r562F 16r5CB6 16r5630 16r5CBC 16r5631 16r5CB7 16r5632 16r5CC5 16r5633 16r5CBE 16r5634 16r5CC7 16r5635 16r5CD9 16r5636 16r5CE9 16r5637 16r5CFD 16r5638 16r5CFA 16r5639 16r5CED 16r563A 16r5D8C 16r563B 16r5CEA 16r563C 16r5D0B 16r563D 16r5D15 16r563E 16r5D17 16r563F 16r5D5C 16r5640 16r5D1F 16r5641 16r5D1B 16r5642 16r5D11 16r5643 16r5D14 16r5644 16r5D22 16r5645 16r5D1A 16r5646 16r5D19 16r5647 16r5D18 16r5648 16r5D4C 16r5649 16r5D52 16r564A 16r5D4E 16r564B 16r5D4B 16r564C 16r5D6C 16r564D 16r5D73 16r564E 16r5D76 16r564F 16r5D87 16r5650 16r5D84 16r5651 16r5D82 16r5652 16r5DA2 16r5653 16r5D9D 16r5654 16r5DAC 16r5655 16r5DAE 16r5656 16r5DBD 16r5657 16r5D90 16r5658 16r5DB7 16r5659 16r5DBC 16r565A 16r5DC9 16r565B 16r5DCD 16r565C 16r5DD3 16r565D 16r5DD2 16r565E 16r5DD6 16r565F 16r5DDB 16r5660 16r5DEB 16r5661 16r5DF2 16r5662 16r5DF5 16r5663 16r5E0B 16r5664 16r5E1A 16r5665 16r5E19 16r5666 16r5E11 16r5667 16r5E1B 16r5668 16r5E36 16r5669 16r5E37 16r566A 16r5E44 16r566B 16r5E43 16r566C 16r5E40 16r566D 16r5E4E 16r566E 16r5E57 16r566F 16r5E54 16r5670 16r5E5F 16r5671 16r5E62 16r5672 16r5E64 16r5673 16r5E47 16r5674 16r5E75 16r5675 16r5E76 16r5676 16r5E7A 16r5677 16r9EBC 16r5678 16r5E7F 16r5679 16r5EA0 16r567A 16r5EC1 16r567B 16r5EC2 16r567C 16r5EC8 16r567D 16r5ED0 16r567E 16r5ECF 16r5721 16r5ED6 16r5722 16r5EE3 16r5723 16r5EDD 16r5724 16r5EDA 16r5725 16r5EDB 16r5726 16r5EE2 16r5727 16r5EE1 16r5728 16r5EE8 16r5729 16r5EE9 16r572A 16r5EEC 16r572B 16r5EF1 16r572C 16r5EF3 16r572D 16r5EF0 16r572E 16r5EF4 16r572F 16r5EF8 16r5730 16r5EFE 16r5731 16r5F03 16r5732 16r5F09 16r5733 16r5F5D 16r5734 16r5F5C 16r5735 16r5F0B 16r5736 16r5F11 16r5737 16r5F16 16r5738 16r5F29 16r5739 16r5F2D 16r573A 16r5F38 16r573B 16r5F41 16r573C 16r5F48 16r573D 16r5F4C 16r573E 16r5F4E 16r573F 16r5F2F 16r5740 16r5F51 16r5741 16r5F56 16r5742 16r5F57 16r5743 16r5F59 16r5744 16r5F61 16r5745 16r5F6D 16r5746 16r5F73 16r5747 16r5F77 16r5748 16r5F83 16r5749 16r5F82 16r574A 16r5F7F 16r574B 16r5F8A 16r574C 16r5F88 16r574D 16r5F91 16r574E 16r5F87 16r574F 16r5F9E 16r5750 16r5F99 16r5751 16r5F98 16r5752 16r5FA0 16r5753 16r5FA8 16r5754 16r5FAD 16r5755 16r5FBC 16r5756 16r5FD6 16r5757 16r5FFB 16r5758 16r5FE4 16r5759 16r5FF8 16r575A 16r5FF1 16r575B 16r5FDD 16r575C 16r60B3 16r575D 16r5FFF 16r575E 16r6021 16r575F 16r6060 16r5760 16r6019 16r5761 16r6010 16r5762 16r6029 16r5763 16r600E 16r5764 16r6031 16r5765 16r601B 16r5766 16r6015 16r5767 16r602B 16r5768 16r6026 16r5769 16r600F 16r576A 16r603A 16r576B 16r605A 16r576C 16r6041 16r576D 16r606A 16r576E 16r6077 16r576F 16r605F 16r5770 16r604A 16r5771 16r6046 16r5772 16r604D 16r5773 16r6063 16r5774 16r6043 16r5775 16r6064 16r5776 16r6042 16r5777 16r606C 16r5778 16r606B 16r5779 16r6059 16r577A 16r6081 16r577B 16r608D 16r577C 16r60E7 16r577D 16r6083 16r577E 16r609A 16r5821 16r6084 16r5822 16r609B 16r5823 16r6096 16r5824 16r6097 16r5825 16r6092 16r5826 16r60A7 16r5827 16r608B 16r5828 16r60E1 16r5829 16r60B8 16r582A 16r60E0 16r582B 16r60D3 16r582C 16r60B4 16r582D 16r5FF0 16r582E 16r60BD 16r582F 16r60C6 16r5830 16r60B5 16r5831 16r60D8 16r5832 16r614D 16r5833 16r6115 16r5834 16r6106 16r5835 16r60F6 16r5836 16r60F7 16r5837 16r6100 16r5838 16r60F4 16r5839 16r60FA 16r583A 16r6103 16r583B 16r6121 16r583C 16r60FB 16r583D 16r60F1 16r583E 16r610D 16r583F 16r610E 16r5840 16r6147 16r5841 16r613E 16r5842 16r6128 16r5843 16r6127 16r5844 16r614A 16r5845 16r613F 16r5846 16r613C 16r5847 16r612C 16r5848 16r6134 16r5849 16r613D 16r584A 16r6142 16r584B 16r6144 16r584C 16r6173 16r584D 16r6177 16r584E 16r6158 16r584F 16r6159 16r5850 16r615A 16r5851 16r616B 16r5852 16r6174 16r5853 16r616F 16r5854 16r6165 16r5855 16r6171 16r5856 16r615F 16r5857 16r615D 16r5858 16r6153 16r5859 16r6175 16r585A 16r6199 16r585B 16r6196 16r585C 16r6187 16r585D 16r61AC 16r585E 16r6194 16r585F 16r619A 16r5860 16r618A 16r5861 16r6191 16r5862 16r61AB 16r5863 16r61AE 16r5864 16r61CC 16r5865 16r61CA 16r5866 16r61C9 16r5867 16r61F7 16r5868 16r61C8 16r5869 16r61C3 16r586A 16r61C6 16r586B 16r61BA 16r586C 16r61CB 16r586D 16r7F79 16r586E 16r61CD 16r586F 16r61E6 16r5870 16r61E3 16r5871 16r61F6 16r5872 16r61FA 16r5873 16r61F4 16r5874 16r61FF 16r5875 16r61FD 16r5876 16r61FC 16r5877 16r61FE 16r5878 16r6200 16r5879 16r6208 16r587A 16r6209 16r587B 16r620D 16r587C 16r620C 16r587D 16r6214 16r587E 16r621B 16r5921 16r621E 16r5922 16r6221 16r5923 16r622A 16r5924 16r622E 16r5925 16r6230 16r5926 16r6232 16r5927 16r6233 16r5928 16r6241 16r5929 16r624E 16r592A 16r625E 16r592B 16r6263 16r592C 16r625B 16r592D 16r6260 16r592E 16r6268 16r592F 16r627C 16r5930 16r6282 16r5931 16r6289 16r5932 16r627E 16r5933 16r6292 16r5934 16r6293 16r5935 16r6296 16r5936 16r62D4 16r5937 16r6283 16r5938 16r6294 16r5939 16r62D7 16r593A 16r62D1 16r593B 16r62BB 16r593C 16r62CF 16r593D 16r62FF 16r593E 16r62C6 16r593F 16r64D4 16r5940 16r62C8 16r5941 16r62DC 16r5942 16r62CC 16r5943 16r62CA 16r5944 16r62C2 16r5945 16r62C7 16r5946 16r629B 16r5947 16r62C9 16r5948 16r630C 16r5949 16r62EE 16r594A 16r62F1 16r594B 16r6327 16r594C 16r6302 16r594D 16r6308 16r594E 16r62EF 16r594F 16r62F5 16r5950 16r6350 16r5951 16r633E 16r5952 16r634D 16r5953 16r641C 16r5954 16r634F 16r5955 16r6396 16r5956 16r638E 16r5957 16r6380 16r5958 16r63AB 16r5959 16r6376 16r595A 16r63A3 16r595B 16r638F 16r595C 16r6389 16r595D 16r639F 16r595E 16r63B5 16r595F 16r636B 16r5960 16r6369 16r5961 16r63BE 16r5962 16r63E9 16r5963 16r63C0 16r5964 16r63C6 16r5965 16r63E3 16r5966 16r63C9 16r5967 16r63D2 16r5968 16r63F6 16r5969 16r63C4 16r596A 16r6416 16r596B 16r6434 16r596C 16r6406 16r596D 16r6413 16r596E 16r6426 16r596F 16r6436 16r5970 16r651D 16r5971 16r6417 16r5972 16r6428 16r5973 16r640F 16r5974 16r6467 16r5975 16r646F 16r5976 16r6476 16r5977 16r644E 16r5978 16r652A 16r5979 16r6495 16r597A 16r6493 16r597B 16r64A5 16r597C 16r64A9 16r597D 16r6488 16r597E 16r64BC 16r5A21 16r64DA 16r5A22 16r64D2 16r5A23 16r64C5 16r5A24 16r64C7 16r5A25 16r64BB 16r5A26 16r64D8 16r5A27 16r64C2 16r5A28 16r64F1 16r5A29 16r64E7 16r5A2A 16r8209 16r5A2B 16r64E0 16r5A2C 16r64E1 16r5A2D 16r62AC 16r5A2E 16r64E3 16r5A2F 16r64EF 16r5A30 16r652C 16r5A31 16r64F6 16r5A32 16r64F4 16r5A33 16r64F2 16r5A34 16r64FA 16r5A35 16r6500 16r5A36 16r64FD 16r5A37 16r6518 16r5A38 16r651C 16r5A39 16r6505 16r5A3A 16r6524 16r5A3B 16r6523 16r5A3C 16r652B 16r5A3D 16r6534 16r5A3E 16r6535 16r5A3F 16r6537 16r5A40 16r6536 16r5A41 16r6538 16r5A42 16r754B 16r5A43 16r6548 16r5A44 16r6556 16r5A45 16r6555 16r5A46 16r654D 16r5A47 16r6558 16r5A48 16r655E 16r5A49 16r655D 16r5A4A 16r6572 16r5A4B 16r6578 16r5A4C 16r6582 16r5A4D 16r6583 16r5A4E 16r8B8A 16r5A4F 16r659B 16r5A50 16r659F 16r5A51 16r65AB 16r5A52 16r65B7 16r5A53 16r65C3 16r5A54 16r65C6 16r5A55 16r65C1 16r5A56 16r65C4 16r5A57 16r65CC 16r5A58 16r65D2 16r5A59 16r65DB 16r5A5A 16r65D9 16r5A5B 16r65E0 16r5A5C 16r65E1 16r5A5D 16r65F1 16r5A5E 16r6772 16r5A5F 16r660A 16r5A60 16r6603 16r5A61 16r65FB 16r5A62 16r6773 16r5A63 16r6635 16r5A64 16r6636 16r5A65 16r6634 16r5A66 16r661C 16r5A67 16r664F 16r5A68 16r6644 16r5A69 16r6649 16r5A6A 16r6641 16r5A6B 16r665E 16r5A6C 16r665D 16r5A6D 16r6664 16r5A6E 16r6667 16r5A6F 16r6668 16r5A70 16r665F 16r5A71 16r6662 16r5A72 16r6670 16r5A73 16r6683 16r5A74 16r6688 16r5A75 16r668E 16r5A76 16r6689 16r5A77 16r6684 16r5A78 16r6698 16r5A79 16r669D 16r5A7A 16r66C1 16r5A7B 16r66B9 16r5A7C 16r66C9 16r5A7D 16r66BE 16r5A7E 16r66BC 16r5B21 16r66C4 16r5B22 16r66B8 16r5B23 16r66D6 16r5B24 16r66DA 16r5B25 16r66E0 16r5B26 16r663F 16r5B27 16r66E6 16r5B28 16r66E9 16r5B29 16r66F0 16r5B2A 16r66F5 16r5B2B 16r66F7 16r5B2C 16r670F 16r5B2D 16r6716 16r5B2E 16r671E 16r5B2F 16r6726 16r5B30 16r6727 16r5B31 16r9738 16r5B32 16r672E 16r5B33 16r673F 16r5B34 16r6736 16r5B35 16r6741 16r5B36 16r6738 16r5B37 16r6737 16r5B38 16r6746 16r5B39 16r675E 16r5B3A 16r6760 16r5B3B 16r6759 16r5B3C 16r6763 16r5B3D 16r6764 16r5B3E 16r6789 16r5B3F 16r6770 16r5B40 16r67A9 16r5B41 16r677C 16r5B42 16r676A 16r5B43 16r678C 16r5B44 16r678B 16r5B45 16r67A6 16r5B46 16r67A1 16r5B47 16r6785 16r5B48 16r67B7 16r5B49 16r67EF 16r5B4A 16r67B4 16r5B4B 16r67EC 16r5B4C 16r67B3 16r5B4D 16r67E9 16r5B4E 16r67B8 16r5B4F 16r67E4 16r5B50 16r67DE 16r5B51 16r67DD 16r5B52 16r67E2 16r5B53 16r67EE 16r5B54 16r67B9 16r5B55 16r67CE 16r5B56 16r67C6 16r5B57 16r67E7 16r5B58 16r6A9C 16r5B59 16r681E 16r5B5A 16r6846 16r5B5B 16r6829 16r5B5C 16r6840 16r5B5D 16r684D 16r5B5E 16r6832 16r5B5F 16r684E 16r5B60 16r68B3 16r5B61 16r682B 16r5B62 16r6859 16r5B63 16r6863 16r5B64 16r6877 16r5B65 16r687F 16r5B66 16r689F 16r5B67 16r688F 16r5B68 16r68AD 16r5B69 16r6894 16r5B6A 16r689D 16r5B6B 16r689B 16r5B6C 16r6883 16r5B6D 16r6AAE 16r5B6E 16r68B9 16r5B6F 16r6874 16r5B70 16r68B5 16r5B71 16r68A0 16r5B72 16r68BA 16r5B73 16r690F 16r5B74 16r688D 16r5B75 16r687E 16r5B76 16r6901 16r5B77 16r68CA 16r5B78 16r6908 16r5B79 16r68D8 16r5B7A 16r6922 16r5B7B 16r6926 16r5B7C 16r68E1 16r5B7D 16r690C 16r5B7E 16r68CD 16r5C21 16r68D4 16r5C22 16r68E7 16r5C23 16r68D5 16r5C24 16r6936 16r5C25 16r6912 16r5C26 16r6904 16r5C27 16r68D7 16r5C28 16r68E3 16r5C29 16r6925 16r5C2A 16r68F9 16r5C2B 16r68E0 16r5C2C 16r68EF 16r5C2D 16r6928 16r5C2E 16r692A 16r5C2F 16r691A 16r5C30 16r6923 16r5C31 16r6921 16r5C32 16r68C6 16r5C33 16r6979 16r5C34 16r6977 16r5C35 16r695C 16r5C36 16r6978 16r5C37 16r696B 16r5C38 16r6954 16r5C39 16r697E 16r5C3A 16r696E 16r5C3B 16r6939 16r5C3C 16r6974 16r5C3D 16r693D 16r5C3E 16r6959 16r5C3F 16r6930 16r5C40 16r6961 16r5C41 16r695E 16r5C42 16r695D 16r5C43 16r6981 16r5C44 16r696A 16r5C45 16r69B2 16r5C46 16r69AE 16r5C47 16r69D0 16r5C48 16r69BF 16r5C49 16r69C1 16r5C4A 16r69D3 16r5C4B 16r69BE 16r5C4C 16r69CE 16r5C4D 16r5BE8 16r5C4E 16r69CA 16r5C4F 16r69DD 16r5C50 16r69BB 16r5C51 16r69C3 16r5C52 16r69A7 16r5C53 16r6A2E 16r5C54 16r6991 16r5C55 16r69A0 16r5C56 16r699C 16r5C57 16r6995 16r5C58 16r69B4 16r5C59 16r69DE 16r5C5A 16r69E8 16r5C5B 16r6A02 16r5C5C 16r6A1B 16r5C5D 16r69FF 16r5C5E 16r6B0A 16r5C5F 16r69F9 16r5C60 16r69F2 16r5C61 16r69E7 16r5C62 16r6A05 16r5C63 16r69B1 16r5C64 16r6A1E 16r5C65 16r69ED 16r5C66 16r6A14 16r5C67 16r69EB 16r5C68 16r6A0A 16r5C69 16r6A12 16r5C6A 16r6AC1 16r5C6B 16r6A23 16r5C6C 16r6A13 16r5C6D 16r6A44 16r5C6E 16r6A0C 16r5C6F 16r6A72 16r5C70 16r6A36 16r5C71 16r6A78 16r5C72 16r6A47 16r5C73 16r6A62 16r5C74 16r6A59 16r5C75 16r6A66 16r5C76 16r6A48 16r5C77 16r6A38 16r5C78 16r6A22 16r5C79 16r6A90 16r5C7A 16r6A8D 16r5C7B 16r6AA0 16r5C7C 16r6A84 16r5C7D 16r6AA2 16r5C7E 16r6AA3 16r5D21 16r6A97 16r5D22 16r8617 16r5D23 16r6ABB 16r5D24 16r6AC3 16r5D25 16r6AC2 16r5D26 16r6AB8 16r5D27 16r6AB3 16r5D28 16r6AAC 16r5D29 16r6ADE 16r5D2A 16r6AD1 16r5D2B 16r6ADF 16r5D2C 16r6AAA 16r5D2D 16r6ADA 16r5D2E 16r6AEA 16r5D2F 16r6AFB 16r5D30 16r6B05 16r5D31 16r8616 16r5D32 16r6AFA 16r5D33 16r6B12 16r5D34 16r6B16 16r5D35 16r9B31 16r5D36 16r6B1F 16r5D37 16r6B38 16r5D38 16r6B37 16r5D39 16r76DC 16r5D3A 16r6B39 16r5D3B 16r98EE 16r5D3C 16r6B47 16r5D3D 16r6B43 16r5D3E 16r6B49 16r5D3F 16r6B50 16r5D40 16r6B59 16r5D41 16r6B54 16r5D42 16r6B5B 16r5D43 16r6B5F 16r5D44 16r6B61 16r5D45 16r6B78 16r5D46 16r6B79 16r5D47 16r6B7F 16r5D48 16r6B80 16r5D49 16r6B84 16r5D4A 16r6B83 16r5D4B 16r6B8D 16r5D4C 16r6B98 16r5D4D 16r6B95 16r5D4E 16r6B9E 16r5D4F 16r6BA4 16r5D50 16r6BAA 16r5D51 16r6BAB 16r5D52 16r6BAF 16r5D53 16r6BB2 16r5D54 16r6BB1 16r5D55 16r6BB3 16r5D56 16r6BB7 16r5D57 16r6BBC 16r5D58 16r6BC6 16r5D59 16r6BCB 16r5D5A 16r6BD3 16r5D5B 16r6BDF 16r5D5C 16r6BEC 16r5D5D 16r6BEB 16r5D5E 16r6BF3 16r5D5F 16r6BEF 16r5D60 16r9EBE 16r5D61 16r6C08 16r5D62 16r6C13 16r5D63 16r6C14 16r5D64 16r6C1B 16r5D65 16r6C24 16r5D66 16r6C23 16r5D67 16r6C5E 16r5D68 16r6C55 16r5D69 16r6C62 16r5D6A 16r6C6A 16r5D6B 16r6C82 16r5D6C 16r6C8D 16r5D6D 16r6C9A 16r5D6E 16r6C81 16r5D6F 16r6C9B 16r5D70 16r6C7E 16r5D71 16r6C68 16r5D72 16r6C73 16r5D73 16r6C92 16r5D74 16r6C90 16r5D75 16r6CC4 16r5D76 16r6CF1 16r5D77 16r6CD3 16r5D78 16r6CBD 16r5D79 16r6CD7 16r5D7A 16r6CC5 16r5D7B 16r6CDD 16r5D7C 16r6CAE 16r5D7D 16r6CB1 16r5D7E 16r6CBE 16r5E21 16r6CBA 16r5E22 16r6CDB 16r5E23 16r6CEF 16r5E24 16r6CD9 16r5E25 16r6CEA 16r5E26 16r6D1F 16r5E27 16r884D 16r5E28 16r6D36 16r5E29 16r6D2B 16r5E2A 16r6D3D 16r5E2B 16r6D38 16r5E2C 16r6D19 16r5E2D 16r6D35 16r5E2E 16r6D33 16r5E2F 16r6D12 16r5E30 16r6D0C 16r5E31 16r6D63 16r5E32 16r6D93 16r5E33 16r6D64 16r5E34 16r6D5A 16r5E35 16r6D79 16r5E36 16r6D59 16r5E37 16r6D8E 16r5E38 16r6D95 16r5E39 16r6FE4 16r5E3A 16r6D85 16r5E3B 16r6DF9 16r5E3C 16r6E15 16r5E3D 16r6E0A 16r5E3E 16r6DB5 16r5E3F 16r6DC7 16r5E40 16r6DE6 16r5E41 16r6DB8 16r5E42 16r6DC6 16r5E43 16r6DEC 16r5E44 16r6DDE 16r5E45 16r6DCC 16r5E46 16r6DE8 16r5E47 16r6DD2 16r5E48 16r6DC5 16r5E49 16r6DFA 16r5E4A 16r6DD9 16r5E4B 16r6DE4 16r5E4C 16r6DD5 16r5E4D 16r6DEA 16r5E4E 16r6DEE 16r5E4F 16r6E2D 16r5E50 16r6E6E 16r5E51 16r6E2E 16r5E52 16r6E19 16r5E53 16r6E72 16r5E54 16r6E5F 16r5E55 16r6E3E 16r5E56 16r6E23 16r5E57 16r6E6B 16r5E58 16r6E2B 16r5E59 16r6E76 16r5E5A 16r6E4D 16r5E5B 16r6E1F 16r5E5C 16r6E43 16r5E5D 16r6E3A 16r5E5E 16r6E4E 16r5E5F 16r6E24 16r5E60 16r6EFF 16r5E61 16r6E1D 16r5E62 16r6E38 16r5E63 16r6E82 16r5E64 16r6EAA 16r5E65 16r6E98 16r5E66 16r6EC9 16r5E67 16r6EB7 16r5E68 16r6ED3 16r5E69 16r6EBD 16r5E6A 16r6EAF 16r5E6B 16r6EC4 16r5E6C 16r6EB2 16r5E6D 16r6ED4 16r5E6E 16r6ED5 16r5E6F 16r6E8F 16r5E70 16r6EA5 16r5E71 16r6EC2 16r5E72 16r6E9F 16r5E73 16r6F41 16r5E74 16r6F11 16r5E75 16r704C 16r5E76 16r6EEC 16r5E77 16r6EF8 16r5E78 16r6EFE 16r5E79 16r6F3F 16r5E7A 16r6EF2 16r5E7B 16r6F31 16r5E7C 16r6EEF 16r5E7D 16r6F32 16r5E7E 16r6ECC 16r5F21 16r6F3E 16r5F22 16r6F13 16r5F23 16r6EF7 16r5F24 16r6F86 16r5F25 16r6F7A 16r5F26 16r6F78 16r5F27 16r6F81 16r5F28 16r6F80 16r5F29 16r6F6F 16r5F2A 16r6F5B 16r5F2B 16r6FF3 16r5F2C 16r6F6D 16r5F2D 16r6F82 16r5F2E 16r6F7C 16r5F2F 16r6F58 16r5F30 16r6F8E 16r5F31 16r6F91 16r5F32 16r6FC2 16r5F33 16r6F66 16r5F34 16r6FB3 16r5F35 16r6FA3 16r5F36 16r6FA1 16r5F37 16r6FA4 16r5F38 16r6FB9 16r5F39 16r6FC6 16r5F3A 16r6FAA 16r5F3B 16r6FDF 16r5F3C 16r6FD5 16r5F3D 16r6FEC 16r5F3E 16r6FD4 16r5F3F 16r6FD8 16r5F40 16r6FF1 16r5F41 16r6FEE 16r5F42 16r6FDB 16r5F43 16r7009 16r5F44 16r700B 16r5F45 16r6FFA 16r5F46 16r7011 16r5F47 16r7001 16r5F48 16r700F 16r5F49 16r6FFE 16r5F4A 16r701B 16r5F4B 16r701A 16r5F4C 16r6F74 16r5F4D 16r701D 16r5F4E 16r7018 16r5F4F 16r701F 16r5F50 16r7030 16r5F51 16r703E 16r5F52 16r7032 16r5F53 16r7051 16r5F54 16r7063 16r5F55 16r7099 16r5F56 16r7092 16r5F57 16r70AF 16r5F58 16r70F1 16r5F59 16r70AC 16r5F5A 16r70B8 16r5F5B 16r70B3 16r5F5C 16r70AE 16r5F5D 16r70DF 16r5F5E 16r70CB 16r5F5F 16r70DD 16r5F60 16r70D9 16r5F61 16r7109 16r5F62 16r70FD 16r5F63 16r711C 16r5F64 16r7119 16r5F65 16r7165 16r5F66 16r7155 16r5F67 16r7188 16r5F68 16r7166 16r5F69 16r7162 16r5F6A 16r714C 16r5F6B 16r7156 16r5F6C 16r716C 16r5F6D 16r718F 16r5F6E 16r71FB 16r5F6F 16r7184 16r5F70 16r7195 16r5F71 16r71A8 16r5F72 16r71AC 16r5F73 16r71D7 16r5F74 16r71B9 16r5F75 16r71BE 16r5F76 16r71D2 16r5F77 16r71C9 16r5F78 16r71D4 16r5F79 16r71CE 16r5F7A 16r71E0 16r5F7B 16r71EC 16r5F7C 16r71E7 16r5F7D 16r71F5 16r5F7E 16r71FC 16r6021 16r71F9 16r6022 16r71FF 16r6023 16r720D 16r6024 16r7210 16r6025 16r721B 16r6026 16r7228 16r6027 16r722D 16r6028 16r722C 16r6029 16r7230 16r602A 16r7232 16r602B 16r723B 16r602C 16r723C 16r602D 16r723F 16r602E 16r7240 16r602F 16r7246 16r6030 16r724B 16r6031 16r7258 16r6032 16r7274 16r6033 16r727E 16r6034 16r7282 16r6035 16r7281 16r6036 16r7287 16r6037 16r7292 16r6038 16r7296 16r6039 16r72A2 16r603A 16r72A7 16r603B 16r72B9 16r603C 16r72B2 16r603D 16r72C3 16r603E 16r72C6 16r603F 16r72C4 16r6040 16r72CE 16r6041 16r72D2 16r6042 16r72E2 16r6043 16r72E0 16r6044 16r72E1 16r6045 16r72F9 16r6046 16r72F7 16r6047 16r500F 16r6048 16r7317 16r6049 16r730A 16r604A 16r731C 16r604B 16r7316 16r604C 16r731D 16r604D 16r7334 16r604E 16r732F 16r604F 16r7329 16r6050 16r7325 16r6051 16r733E 16r6052 16r734E 16r6053 16r734F 16r6054 16r9ED8 16r6055 16r7357 16r6056 16r736A 16r6057 16r7368 16r6058 16r7370 16r6059 16r7378 16r605A 16r7375 16r605B 16r737B 16r605C 16r737A 16r605D 16r73C8 16r605E 16r73B3 16r605F 16r73CE 16r6060 16r73BB 16r6061 16r73C0 16r6062 16r73E5 16r6063 16r73EE 16r6064 16r73DE 16r6065 16r74A2 16r6066 16r7405 16r6067 16r746F 16r6068 16r7425 16r6069 16r73F8 16r606A 16r7432 16r606B 16r743A 16r606C 16r7455 16r606D 16r743F 16r606E 16r745F 16r606F 16r7459 16r6070 16r7441 16r6071 16r745C 16r6072 16r7469 16r6073 16r7470 16r6074 16r7463 16r6075 16r746A 16r6076 16r7476 16r6077 16r747E 16r6078 16r748B 16r6079 16r749E 16r607A 16r74A7 16r607B 16r74CA 16r607C 16r74CF 16r607D 16r74D4 16r607E 16r73F1 16r6121 16r74E0 16r6122 16r74E3 16r6123 16r74E7 16r6124 16r74E9 16r6125 16r74EE 16r6126 16r74F2 16r6127 16r74F0 16r6128 16r74F1 16r6129 16r74F8 16r612A 16r74F7 16r612B 16r7504 16r612C 16r7503 16r612D 16r7505 16r612E 16r750C 16r612F 16r750E 16r6130 16r750D 16r6131 16r7515 16r6132 16r7513 16r6133 16r751E 16r6134 16r7526 16r6135 16r752C 16r6136 16r753C 16r6137 16r7544 16r6138 16r754D 16r6139 16r754A 16r613A 16r7549 16r613B 16r755B 16r613C 16r7546 16r613D 16r755A 16r613E 16r7569 16r613F 16r7564 16r6140 16r7567 16r6141 16r756B 16r6142 16r756D 16r6143 16r7578 16r6144 16r7576 16r6145 16r7586 16r6146 16r7587 16r6147 16r7574 16r6148 16r758A 16r6149 16r7589 16r614A 16r7582 16r614B 16r7594 16r614C 16r759A 16r614D 16r759D 16r614E 16r75A5 16r614F 16r75A3 16r6150 16r75C2 16r6151 16r75B3 16r6152 16r75C3 16r6153 16r75B5 16r6154 16r75BD 16r6155 16r75B8 16r6156 16r75BC 16r6157 16r75B1 16r6158 16r75CD 16r6159 16r75CA 16r615A 16r75D2 16r615B 16r75D9 16r615C 16r75E3 16r615D 16r75DE 16r615E 16r75FE 16r615F 16r75FF 16r6160 16r75FC 16r6161 16r7601 16r6162 16r75F0 16r6163 16r75FA 16r6164 16r75F2 16r6165 16r75F3 16r6166 16r760B 16r6167 16r760D 16r6168 16r7609 16r6169 16r761F 16r616A 16r7627 16r616B 16r7620 16r616C 16r7621 16r616D 16r7622 16r616E 16r7624 16r616F 16r7634 16r6170 16r7630 16r6171 16r763B 16r6172 16r7647 16r6173 16r7648 16r6174 16r7646 16r6175 16r765C 16r6176 16r7658 16r6177 16r7661 16r6178 16r7662 16r6179 16r7668 16r617A 16r7669 16r617B 16r766A 16r617C 16r7667 16r617D 16r766C 16r617E 16r7670 16r6221 16r7672 16r6222 16r7676 16r6223 16r7678 16r6224 16r767C 16r6225 16r7680 16r6226 16r7683 16r6227 16r7688 16r6228 16r768B 16r6229 16r768E 16r622A 16r7696 16r622B 16r7693 16r622C 16r7699 16r622D 16r769A 16r622E 16r76B0 16r622F 16r76B4 16r6230 16r76B8 16r6231 16r76B9 16r6232 16r76BA 16r6233 16r76C2 16r6234 16r76CD 16r6235 16r76D6 16r6236 16r76D2 16r6237 16r76DE 16r6238 16r76E1 16r6239 16r76E5 16r623A 16r76E7 16r623B 16r76EA 16r623C 16r862F 16r623D 16r76FB 16r623E 16r7708 16r623F 16r7707 16r6240 16r7704 16r6241 16r7729 16r6242 16r7724 16r6243 16r771E 16r6244 16r7725 16r6245 16r7726 16r6246 16r771B 16r6247 16r7737 16r6248 16r7738 16r6249 16r7747 16r624A 16r775A 16r624B 16r7768 16r624C 16r776B 16r624D 16r775B 16r624E 16r7765 16r624F 16r777F 16r6250 16r777E 16r6251 16r7779 16r6252 16r778E 16r6253 16r778B 16r6254 16r7791 16r6255 16r77A0 16r6256 16r779E 16r6257 16r77B0 16r6258 16r77B6 16r6259 16r77B9 16r625A 16r77BF 16r625B 16r77BC 16r625C 16r77BD 16r625D 16r77BB 16r625E 16r77C7 16r625F 16r77CD 16r6260 16r77D7 16r6261 16r77DA 16r6262 16r77DC 16r6263 16r77E3 16r6264 16r77EE 16r6265 16r77FC 16r6266 16r780C 16r6267 16r7812 16r6268 16r7926 16r6269 16r7820 16r626A 16r792A 16r626B 16r7845 16r626C 16r788E 16r626D 16r7874 16r626E 16r7886 16r626F 16r787C 16r6270 16r789A 16r6271 16r788C 16r6272 16r78A3 16r6273 16r78B5 16r6274 16r78AA 16r6275 16r78AF 16r6276 16r78D1 16r6277 16r78C6 16r6278 16r78CB 16r6279 16r78D4 16r627A 16r78BE 16r627B 16r78BC 16r627C 16r78C5 16r627D 16r78CA 16r627E 16r78EC 16r6321 16r78E7 16r6322 16r78DA 16r6323 16r78FD 16r6324 16r78F4 16r6325 16r7907 16r6326 16r7912 16r6327 16r7911 16r6328 16r7919 16r6329 16r792C 16r632A 16r792B 16r632B 16r7940 16r632C 16r7960 16r632D 16r7957 16r632E 16r795F 16r632F 16r795A 16r6330 16r7955 16r6331 16r7953 16r6332 16r797A 16r6333 16r797F 16r6334 16r798A 16r6335 16r799D 16r6336 16r79A7 16r6337 16r9F4B 16r6338 16r79AA 16r6339 16r79AE 16r633A 16r79B3 16r633B 16r79B9 16r633C 16r79BA 16r633D 16r79C9 16r633E 16r79D5 16r633F 16r79E7 16r6340 16r79EC 16r6341 16r79E1 16r6342 16r79E3 16r6343 16r7A08 16r6344 16r7A0D 16r6345 16r7A18 16r6346 16r7A19 16r6347 16r7A20 16r6348 16r7A1F 16r6349 16r7980 16r634A 16r7A31 16r634B 16r7A3B 16r634C 16r7A3E 16r634D 16r7A37 16r634E 16r7A43 16r634F 16r7A57 16r6350 16r7A49 16r6351 16r7A61 16r6352 16r7A62 16r6353 16r7A69 16r6354 16r9F9D 16r6355 16r7A70 16r6356 16r7A79 16r6357 16r7A7D 16r6358 16r7A88 16r6359 16r7A97 16r635A 16r7A95 16r635B 16r7A98 16r635C 16r7A96 16r635D 16r7AA9 16r635E 16r7AC8 16r635F 16r7AB0 16r6360 16r7AB6 16r6361 16r7AC5 16r6362 16r7AC4 16r6363 16r7ABF 16r6364 16r9083 16r6365 16r7AC7 16r6366 16r7ACA 16r6367 16r7ACD 16r6368 16r7ACF 16r6369 16r7AD5 16r636A 16r7AD3 16r636B 16r7AD9 16r636C 16r7ADA 16r636D 16r7ADD 16r636E 16r7AE1 16r636F 16r7AE2 16r6370 16r7AE6 16r6371 16r7AED 16r6372 16r7AF0 16r6373 16r7B02 16r6374 16r7B0F 16r6375 16r7B0A 16r6376 16r7B06 16r6377 16r7B33 16r6378 16r7B18 16r6379 16r7B19 16r637A 16r7B1E 16r637B 16r7B35 16r637C 16r7B28 16r637D 16r7B36 16r637E 16r7B50 16r6421 16r7B7A 16r6422 16r7B04 16r6423 16r7B4D 16r6424 16r7B0B 16r6425 16r7B4C 16r6426 16r7B45 16r6427 16r7B75 16r6428 16r7B65 16r6429 16r7B74 16r642A 16r7B67 16r642B 16r7B70 16r642C 16r7B71 16r642D 16r7B6C 16r642E 16r7B6E 16r642F 16r7B9D 16r6430 16r7B98 16r6431 16r7B9F 16r6432 16r7B8D 16r6433 16r7B9C 16r6434 16r7B9A 16r6435 16r7B8B 16r6436 16r7B92 16r6437 16r7B8F 16r6438 16r7B5D 16r6439 16r7B99 16r643A 16r7BCB 16r643B 16r7BC1 16r643C 16r7BCC 16r643D 16r7BCF 16r643E 16r7BB4 16r643F 16r7BC6 16r6440 16r7BDD 16r6441 16r7BE9 16r6442 16r7C11 16r6443 16r7C14 16r6444 16r7BE6 16r6445 16r7BE5 16r6446 16r7C60 16r6447 16r7C00 16r6448 16r7C07 16r6449 16r7C13 16r644A 16r7BF3 16r644B 16r7BF7 16r644C 16r7C17 16r644D 16r7C0D 16r644E 16r7BF6 16r644F 16r7C23 16r6450 16r7C27 16r6451 16r7C2A 16r6452 16r7C1F 16r6453 16r7C37 16r6454 16r7C2B 16r6455 16r7C3D 16r6456 16r7C4C 16r6457 16r7C43 16r6458 16r7C54 16r6459 16r7C4F 16r645A 16r7C40 16r645B 16r7C50 16r645C 16r7C58 16r645D 16r7C5F 16r645E 16r7C64 16r645F 16r7C56 16r6460 16r7C65 16r6461 16r7C6C 16r6462 16r7C75 16r6463 16r7C83 16r6464 16r7C90 16r6465 16r7CA4 16r6466 16r7CAD 16r6467 16r7CA2 16r6468 16r7CAB 16r6469 16r7CA1 16r646A 16r7CA8 16r646B 16r7CB3 16r646C 16r7CB2 16r646D 16r7CB1 16r646E 16r7CAE 16r646F 16r7CB9 16r6470 16r7CBD 16r6471 16r7CC0 16r6472 16r7CC5 16r6473 16r7CC2 16r6474 16r7CD8 16r6475 16r7CD2 16r6476 16r7CDC 16r6477 16r7CE2 16r6478 16r9B3B 16r6479 16r7CEF 16r647A 16r7CF2 16r647B 16r7CF4 16r647C 16r7CF6 16r647D 16r7CFA 16r647E 16r7D06 16r6521 16r7D02 16r6522 16r7D1C 16r6523 16r7D15 16r6524 16r7D0A 16r6525 16r7D45 16r6526 16r7D4B 16r6527 16r7D2E 16r6528 16r7D32 16r6529 16r7D3F 16r652A 16r7D35 16r652B 16r7D46 16r652C 16r7D73 16r652D 16r7D56 16r652E 16r7D4E 16r652F 16r7D72 16r6530 16r7D68 16r6531 16r7D6E 16r6532 16r7D4F 16r6533 16r7D63 16r6534 16r7D93 16r6535 16r7D89 16r6536 16r7D5B 16r6537 16r7D8F 16r6538 16r7D7D 16r6539 16r7D9B 16r653A 16r7DBA 16r653B 16r7DAE 16r653C 16r7DA3 16r653D 16r7DB5 16r653E 16r7DC7 16r653F 16r7DBD 16r6540 16r7DAB 16r6541 16r7E3D 16r6542 16r7DA2 16r6543 16r7DAF 16r6544 16r7DDC 16r6545 16r7DB8 16r6546 16r7D9F 16r6547 16r7DB0 16r6548 16r7DD8 16r6549 16r7DDD 16r654A 16r7DE4 16r654B 16r7DDE 16r654C 16r7DFB 16r654D 16r7DF2 16r654E 16r7DE1 16r654F 16r7E05 16r6550 16r7E0A 16r6551 16r7E23 16r6552 16r7E21 16r6553 16r7E12 16r6554 16r7E31 16r6555 16r7E1F 16r6556 16r7E09 16r6557 16r7E0B 16r6558 16r7E22 16r6559 16r7E46 16r655A 16r7E66 16r655B 16r7E3B 16r655C 16r7E35 16r655D 16r7E39 16r655E 16r7E43 16r655F 16r7E37 16r6560 16r7E32 16r6561 16r7E3A 16r6562 16r7E67 16r6563 16r7E5D 16r6564 16r7E56 16r6565 16r7E5E 16r6566 16r7E59 16r6567 16r7E5A 16r6568 16r7E79 16r6569 16r7E6A 16r656A 16r7E69 16r656B 16r7E7C 16r656C 16r7E7B 16r656D 16r7E83 16r656E 16r7DD5 16r656F 16r7E7D 16r6570 16r8FAE 16r6571 16r7E7F 16r6572 16r7E88 16r6573 16r7E89 16r6574 16r7E8C 16r6575 16r7E92 16r6576 16r7E90 16r6577 16r7E93 16r6578 16r7E94 16r6579 16r7E96 16r657A 16r7E8E 16r657B 16r7E9B 16r657C 16r7E9C 16r657D 16r7F38 16r657E 16r7F3A 16r6621 16r7F45 16r6622 16r7F4C 16r6623 16r7F4D 16r6624 16r7F4E 16r6625 16r7F50 16r6626 16r7F51 16r6627 16r7F55 16r6628 16r7F54 16r6629 16r7F58 16r662A 16r7F5F 16r662B 16r7F60 16r662C 16r7F68 16r662D 16r7F69 16r662E 16r7F67 16r662F 16r7F78 16r6630 16r7F82 16r6631 16r7F86 16r6632 16r7F83 16r6633 16r7F88 16r6634 16r7F87 16r6635 16r7F8C 16r6636 16r7F94 16r6637 16r7F9E 16r6638 16r7F9D 16r6639 16r7F9A 16r663A 16r7FA3 16r663B 16r7FAF 16r663C 16r7FB2 16r663D 16r7FB9 16r663E 16r7FAE 16r663F 16r7FB6 16r6640 16r7FB8 16r6641 16r8B71 16r6642 16r7FC5 16r6643 16r7FC6 16r6644 16r7FCA 16r6645 16r7FD5 16r6646 16r7FD4 16r6647 16r7FE1 16r6648 16r7FE6 16r6649 16r7FE9 16r664A 16r7FF3 16r664B 16r7FF9 16r664C 16r98DC 16r664D 16r8006 16r664E 16r8004 16r664F 16r800B 16r6650 16r8012 16r6651 16r8018 16r6652 16r8019 16r6653 16r801C 16r6654 16r8021 16r6655 16r8028 16r6656 16r803F 16r6657 16r803B 16r6658 16r804A 16r6659 16r8046 16r665A 16r8052 16r665B 16r8058 16r665C 16r805A 16r665D 16r805F 16r665E 16r8062 16r665F 16r8068 16r6660 16r8073 16r6661 16r8072 16r6662 16r8070 16r6663 16r8076 16r6664 16r8079 16r6665 16r807D 16r6666 16r807F 16r6667 16r8084 16r6668 16r8086 16r6669 16r8085 16r666A 16r809B 16r666B 16r8093 16r666C 16r809A 16r666D 16r80AD 16r666E 16r5190 16r666F 16r80AC 16r6670 16r80DB 16r6671 16r80E5 16r6672 16r80D9 16r6673 16r80DD 16r6674 16r80C4 16r6675 16r80DA 16r6676 16r80D6 16r6677 16r8109 16r6678 16r80EF 16r6679 16r80F1 16r667A 16r811B 16r667B 16r8129 16r667C 16r8123 16r667D 16r812F 16r667E 16r814B 16r6721 16r968B 16r6722 16r8146 16r6723 16r813E 16r6724 16r8153 16r6725 16r8151 16r6726 16r80FC 16r6727 16r8171 16r6728 16r816E 16r6729 16r8165 16r672A 16r8166 16r672B 16r8174 16r672C 16r8183 16r672D 16r8188 16r672E 16r818A 16r672F 16r8180 16r6730 16r8182 16r6731 16r81A0 16r6732 16r8195 16r6733 16r81A4 16r6734 16r81A3 16r6735 16r815F 16r6736 16r8193 16r6737 16r81A9 16r6738 16r81B0 16r6739 16r81B5 16r673A 16r81BE 16r673B 16r81B8 16r673C 16r81BD 16r673D 16r81C0 16r673E 16r81C2 16r673F 16r81BA 16r6740 16r81C9 16r6741 16r81CD 16r6742 16r81D1 16r6743 16r81D9 16r6744 16r81D8 16r6745 16r81C8 16r6746 16r81DA 16r6747 16r81DF 16r6748 16r81E0 16r6749 16r81E7 16r674A 16r81FA 16r674B 16r81FB 16r674C 16r81FE 16r674D 16r8201 16r674E 16r8202 16r674F 16r8205 16r6750 16r8207 16r6751 16r820A 16r6752 16r820D 16r6753 16r8210 16r6754 16r8216 16r6755 16r8229 16r6756 16r822B 16r6757 16r8238 16r6758 16r8233 16r6759 16r8240 16r675A 16r8259 16r675B 16r8258 16r675C 16r825D 16r675D 16r825A 16r675E 16r825F 16r675F 16r8264 16r6760 16r8262 16r6761 16r8268 16r6762 16r826A 16r6763 16r826B 16r6764 16r822E 16r6765 16r8271 16r6766 16r8277 16r6767 16r8278 16r6768 16r827E 16r6769 16r828D 16r676A 16r8292 16r676B 16r82AB 16r676C 16r829F 16r676D 16r82BB 16r676E 16r82AC 16r676F 16r82E1 16r6770 16r82E3 16r6771 16r82DF 16r6772 16r82D2 16r6773 16r82F4 16r6774 16r82F3 16r6775 16r82FA 16r6776 16r8393 16r6777 16r8303 16r6778 16r82FB 16r6779 16r82F9 16r677A 16r82DE 16r677B 16r8306 16r677C 16r82DC 16r677D 16r8309 16r677E 16r82D9 16r6821 16r8335 16r6822 16r8334 16r6823 16r8316 16r6824 16r8332 16r6825 16r8331 16r6826 16r8340 16r6827 16r8339 16r6828 16r8350 16r6829 16r8345 16r682A 16r832F 16r682B 16r832B 16r682C 16r8317 16r682D 16r8318 16r682E 16r8385 16r682F 16r839A 16r6830 16r83AA 16r6831 16r839F 16r6832 16r83A2 16r6833 16r8396 16r6834 16r8323 16r6835 16r838E 16r6836 16r8387 16r6837 16r838A 16r6838 16r837C 16r6839 16r83B5 16r683A 16r8373 16r683B 16r8375 16r683C 16r83A0 16r683D 16r8389 16r683E 16r83A8 16r683F 16r83F4 16r6840 16r8413 16r6841 16r83EB 16r6842 16r83CE 16r6843 16r83FD 16r6844 16r8403 16r6845 16r83D8 16r6846 16r840B 16r6847 16r83C1 16r6848 16r83F7 16r6849 16r8407 16r684A 16r83E0 16r684B 16r83F2 16r684C 16r840D 16r684D 16r8422 16r684E 16r8420 16r684F 16r83BD 16r6850 16r8438 16r6851 16r8506 16r6852 16r83FB 16r6853 16r846D 16r6854 16r842A 16r6855 16r843C 16r6856 16r855A 16r6857 16r8484 16r6858 16r8477 16r6859 16r846B 16r685A 16r84AD 16r685B 16r846E 16r685C 16r8482 16r685D 16r8469 16r685E 16r8446 16r685F 16r842C 16r6860 16r846F 16r6861 16r8479 16r6862 16r8435 16r6863 16r84CA 16r6864 16r8462 16r6865 16r84B9 16r6866 16r84BF 16r6867 16r849F 16r6868 16r84D9 16r6869 16r84CD 16r686A 16r84BB 16r686B 16r84DA 16r686C 16r84D0 16r686D 16r84C1 16r686E 16r84C6 16r686F 16r84D6 16r6870 16r84A1 16r6871 16r8521 16r6872 16r84FF 16r6873 16r84F4 16r6874 16r8517 16r6875 16r8518 16r6876 16r852C 16r6877 16r851F 16r6878 16r8515 16r6879 16r8514 16r687A 16r84FC 16r687B 16r8540 16r687C 16r8563 16r687D 16r8558 16r687E 16r8548 16r6921 16r8541 16r6922 16r8602 16r6923 16r854B 16r6924 16r8555 16r6925 16r8580 16r6926 16r85A4 16r6927 16r8588 16r6928 16r8591 16r6929 16r858A 16r692A 16r85A8 16r692B 16r856D 16r692C 16r8594 16r692D 16r859B 16r692E 16r85EA 16r692F 16r8587 16r6930 16r859C 16r6931 16r8577 16r6932 16r857E 16r6933 16r8590 16r6934 16r85C9 16r6935 16r85BA 16r6936 16r85CF 16r6937 16r85B9 16r6938 16r85D0 16r6939 16r85D5 16r693A 16r85DD 16r693B 16r85E5 16r693C 16r85DC 16r693D 16r85F9 16r693E 16r860A 16r693F 16r8613 16r6940 16r860B 16r6941 16r85FE 16r6942 16r85FA 16r6943 16r8606 16r6944 16r8622 16r6945 16r861A 16r6946 16r8630 16r6947 16r863F 16r6948 16r864D 16r6949 16r4E55 16r694A 16r8654 16r694B 16r865F 16r694C 16r8667 16r694D 16r8671 16r694E 16r8693 16r694F 16r86A3 16r6950 16r86A9 16r6951 16r86AA 16r6952 16r868B 16r6953 16r868C 16r6954 16r86B6 16r6955 16r86AF 16r6956 16r86C4 16r6957 16r86C6 16r6958 16r86B0 16r6959 16r86C9 16r695A 16r8823 16r695B 16r86AB 16r695C 16r86D4 16r695D 16r86DE 16r695E 16r86E9 16r695F 16r86EC 16r6960 16r86DF 16r6961 16r86DB 16r6962 16r86EF 16r6963 16r8712 16r6964 16r8706 16r6965 16r8708 16r6966 16r8700 16r6967 16r8703 16r6968 16r86FB 16r6969 16r8711 16r696A 16r8709 16r696B 16r870D 16r696C 16r86F9 16r696D 16r870A 16r696E 16r8734 16r696F 16r873F 16r6970 16r8737 16r6971 16r873B 16r6972 16r8725 16r6973 16r8729 16r6974 16r871A 16r6975 16r8760 16r6976 16r875F 16r6977 16r8778 16r6978 16r874C 16r6979 16r874E 16r697A 16r8774 16r697B 16r8757 16r697C 16r8768 16r697D 16r876E 16r697E 16r8759 16r6A21 16r8753 16r6A22 16r8763 16r6A23 16r876A 16r6A24 16r8805 16r6A25 16r87A2 16r6A26 16r879F 16r6A27 16r8782 16r6A28 16r87AF 16r6A29 16r87CB 16r6A2A 16r87BD 16r6A2B 16r87C0 16r6A2C 16r87D0 16r6A2D 16r96D6 16r6A2E 16r87AB 16r6A2F 16r87C4 16r6A30 16r87B3 16r6A31 16r87C7 16r6A32 16r87C6 16r6A33 16r87BB 16r6A34 16r87EF 16r6A35 16r87F2 16r6A36 16r87E0 16r6A37 16r880F 16r6A38 16r880D 16r6A39 16r87FE 16r6A3A 16r87F6 16r6A3B 16r87F7 16r6A3C 16r880E 16r6A3D 16r87D2 16r6A3E 16r8811 16r6A3F 16r8816 16r6A40 16r8815 16r6A41 16r8822 16r6A42 16r8821 16r6A43 16r8831 16r6A44 16r8836 16r6A45 16r8839 16r6A46 16r8827 16r6A47 16r883B 16r6A48 16r8844 16r6A49 16r8842 16r6A4A 16r8852 16r6A4B 16r8859 16r6A4C 16r885E 16r6A4D 16r8862 16r6A4E 16r886B 16r6A4F 16r8881 16r6A50 16r887E 16r6A51 16r889E 16r6A52 16r8875 16r6A53 16r887D 16r6A54 16r88B5 16r6A55 16r8872 16r6A56 16r8882 16r6A57 16r8897 16r6A58 16r8892 16r6A59 16r88AE 16r6A5A 16r8899 16r6A5B 16r88A2 16r6A5C 16r888D 16r6A5D 16r88A4 16r6A5E 16r88B0 16r6A5F 16r88BF 16r6A60 16r88B1 16r6A61 16r88C3 16r6A62 16r88C4 16r6A63 16r88D4 16r6A64 16r88D8 16r6A65 16r88D9 16r6A66 16r88DD 16r6A67 16r88F9 16r6A68 16r8902 16r6A69 16r88FC 16r6A6A 16r88F4 16r6A6B 16r88E8 16r6A6C 16r88F2 16r6A6D 16r8904 16r6A6E 16r890C 16r6A6F 16r890A 16r6A70 16r8913 16r6A71 16r8943 16r6A72 16r891E 16r6A73 16r8925 16r6A74 16r892A 16r6A75 16r892B 16r6A76 16r8941 16r6A77 16r8944 16r6A78 16r893B 16r6A79 16r8936 16r6A7A 16r8938 16r6A7B 16r894C 16r6A7C 16r891D 16r6A7D 16r8960 16r6A7E 16r895E 16r6B21 16r8966 16r6B22 16r8964 16r6B23 16r896D 16r6B24 16r896A 16r6B25 16r896F 16r6B26 16r8974 16r6B27 16r8977 16r6B28 16r897E 16r6B29 16r8983 16r6B2A 16r8988 16r6B2B 16r898A 16r6B2C 16r8993 16r6B2D 16r8998 16r6B2E 16r89A1 16r6B2F 16r89A9 16r6B30 16r89A6 16r6B31 16r89AC 16r6B32 16r89AF 16r6B33 16r89B2 16r6B34 16r89BA 16r6B35 16r89BD 16r6B36 16r89BF 16r6B37 16r89C0 16r6B38 16r89DA 16r6B39 16r89DC 16r6B3A 16r89DD 16r6B3B 16r89E7 16r6B3C 16r89F4 16r6B3D 16r89F8 16r6B3E 16r8A03 16r6B3F 16r8A16 16r6B40 16r8A10 16r6B41 16r8A0C 16r6B42 16r8A1B 16r6B43 16r8A1D 16r6B44 16r8A25 16r6B45 16r8A36 16r6B46 16r8A41 16r6B47 16r8A5B 16r6B48 16r8A52 16r6B49 16r8A46 16r6B4A 16r8A48 16r6B4B 16r8A7C 16r6B4C 16r8A6D 16r6B4D 16r8A6C 16r6B4E 16r8A62 16r6B4F 16r8A85 16r6B50 16r8A82 16r6B51 16r8A84 16r6B52 16r8AA8 16r6B53 16r8AA1 16r6B54 16r8A91 16r6B55 16r8AA5 16r6B56 16r8AA6 16r6B57 16r8A9A 16r6B58 16r8AA3 16r6B59 16r8AC4 16r6B5A 16r8ACD 16r6B5B 16r8AC2 16r6B5C 16r8ADA 16r6B5D 16r8AEB 16r6B5E 16r8AF3 16r6B5F 16r8AE7 16r6B60 16r8AE4 16r6B61 16r8AF1 16r6B62 16r8B14 16r6B63 16r8AE0 16r6B64 16r8AE2 16r6B65 16r8AF7 16r6B66 16r8ADE 16r6B67 16r8ADB 16r6B68 16r8B0C 16r6B69 16r8B07 16r6B6A 16r8B1A 16r6B6B 16r8AE1 16r6B6C 16r8B16 16r6B6D 16r8B10 16r6B6E 16r8B17 16r6B6F 16r8B20 16r6B70 16r8B33 16r6B71 16r97AB 16r6B72 16r8B26 16r6B73 16r8B2B 16r6B74 16r8B3E 16r6B75 16r8B28 16r6B76 16r8B41 16r6B77 16r8B4C 16r6B78 16r8B4F 16r6B79 16r8B4E 16r6B7A 16r8B49 16r6B7B 16r8B56 16r6B7C 16r8B5B 16r6B7D 16r8B5A 16r6B7E 16r8B6B 16r6C21 16r8B5F 16r6C22 16r8B6C 16r6C23 16r8B6F 16r6C24 16r8B74 16r6C25 16r8B7D 16r6C26 16r8B80 16r6C27 16r8B8C 16r6C28 16r8B8E 16r6C29 16r8B92 16r6C2A 16r8B93 16r6C2B 16r8B96 16r6C2C 16r8B99 16r6C2D 16r8B9A 16r6C2E 16r8C3A 16r6C2F 16r8C41 16r6C30 16r8C3F 16r6C31 16r8C48 16r6C32 16r8C4C 16r6C33 16r8C4E 16r6C34 16r8C50 16r6C35 16r8C55 16r6C36 16r8C62 16r6C37 16r8C6C 16r6C38 16r8C78 16r6C39 16r8C7A 16r6C3A 16r8C82 16r6C3B 16r8C89 16r6C3C 16r8C85 16r6C3D 16r8C8A 16r6C3E 16r8C8D 16r6C3F 16r8C8E 16r6C40 16r8C94 16r6C41 16r8C7C 16r6C42 16r8C98 16r6C43 16r621D 16r6C44 16r8CAD 16r6C45 16r8CAA 16r6C46 16r8CBD 16r6C47 16r8CB2 16r6C48 16r8CB3 16r6C49 16r8CAE 16r6C4A 16r8CB6 16r6C4B 16r8CC8 16r6C4C 16r8CC1 16r6C4D 16r8CE4 16r6C4E 16r8CE3 16r6C4F 16r8CDA 16r6C50 16r8CFD 16r6C51 16r8CFA 16r6C52 16r8CFB 16r6C53 16r8D04 16r6C54 16r8D05 16r6C55 16r8D0A 16r6C56 16r8D07 16r6C57 16r8D0F 16r6C58 16r8D0D 16r6C59 16r8D10 16r6C5A 16r9F4E 16r6C5B 16r8D13 16r6C5C 16r8CCD 16r6C5D 16r8D14 16r6C5E 16r8D16 16r6C5F 16r8D67 16r6C60 16r8D6D 16r6C61 16r8D71 16r6C62 16r8D73 16r6C63 16r8D81 16r6C64 16r8D99 16r6C65 16r8DC2 16r6C66 16r8DBE 16r6C67 16r8DBA 16r6C68 16r8DCF 16r6C69 16r8DDA 16r6C6A 16r8DD6 16r6C6B 16r8DCC 16r6C6C 16r8DDB 16r6C6D 16r8DCB 16r6C6E 16r8DEA 16r6C6F 16r8DEB 16r6C70 16r8DDF 16r6C71 16r8DE3 16r6C72 16r8DFC 16r6C73 16r8E08 16r6C74 16r8E09 16r6C75 16r8DFF 16r6C76 16r8E1D 16r6C77 16r8E1E 16r6C78 16r8E10 16r6C79 16r8E1F 16r6C7A 16r8E42 16r6C7B 16r8E35 16r6C7C 16r8E30 16r6C7D 16r8E34 16r6C7E 16r8E4A 16r6D21 16r8E47 16r6D22 16r8E49 16r6D23 16r8E4C 16r6D24 16r8E50 16r6D25 16r8E48 16r6D26 16r8E59 16r6D27 16r8E64 16r6D28 16r8E60 16r6D29 16r8E2A 16r6D2A 16r8E63 16r6D2B 16r8E55 16r6D2C 16r8E76 16r6D2D 16r8E72 16r6D2E 16r8E7C 16r6D2F 16r8E81 16r6D30 16r8E87 16r6D31 16r8E85 16r6D32 16r8E84 16r6D33 16r8E8B 16r6D34 16r8E8A 16r6D35 16r8E93 16r6D36 16r8E91 16r6D37 16r8E94 16r6D38 16r8E99 16r6D39 16r8EAA 16r6D3A 16r8EA1 16r6D3B 16r8EAC 16r6D3C 16r8EB0 16r6D3D 16r8EC6 16r6D3E 16r8EB1 16r6D3F 16r8EBE 16r6D40 16r8EC5 16r6D41 16r8EC8 16r6D42 16r8ECB 16r6D43 16r8EDB 16r6D44 16r8EE3 16r6D45 16r8EFC 16r6D46 16r8EFB 16r6D47 16r8EEB 16r6D48 16r8EFE 16r6D49 16r8F0A 16r6D4A 16r8F05 16r6D4B 16r8F15 16r6D4C 16r8F12 16r6D4D 16r8F19 16r6D4E 16r8F13 16r6D4F 16r8F1C 16r6D50 16r8F1F 16r6D51 16r8F1B 16r6D52 16r8F0C 16r6D53 16r8F26 16r6D54 16r8F33 16r6D55 16r8F3B 16r6D56 16r8F39 16r6D57 16r8F45 16r6D58 16r8F42 16r6D59 16r8F3E 16r6D5A 16r8F4C 16r6D5B 16r8F49 16r6D5C 16r8F46 16r6D5D 16r8F4E 16r6D5E 16r8F57 16r6D5F 16r8F5C 16r6D60 16r8F62 16r6D61 16r8F63 16r6D62 16r8F64 16r6D63 16r8F9C 16r6D64 16r8F9F 16r6D65 16r8FA3 16r6D66 16r8FAD 16r6D67 16r8FAF 16r6D68 16r8FB7 16r6D69 16r8FDA 16r6D6A 16r8FE5 16r6D6B 16r8FE2 16r6D6C 16r8FEA 16r6D6D 16r8FEF 16r6D6E 16r9087 16r6D6F 16r8FF4 16r6D70 16r9005 16r6D71 16r8FF9 16r6D72 16r8FFA 16r6D73 16r9011 16r6D74 16r9015 16r6D75 16r9021 16r6D76 16r900D 16r6D77 16r901E 16r6D78 16r9016 16r6D79 16r900B 16r6D7A 16r9027 16r6D7B 16r9036 16r6D7C 16r9035 16r6D7D 16r9039 16r6D7E 16r8FF8 16r6E21 16r904F 16r6E22 16r9050 16r6E23 16r9051 16r6E24 16r9052 16r6E25 16r900E 16r6E26 16r9049 16r6E27 16r903E 16r6E28 16r9056 16r6E29 16r9058 16r6E2A 16r905E 16r6E2B 16r9068 16r6E2C 16r906F 16r6E2D 16r9076 16r6E2E 16r96A8 16r6E2F 16r9072 16r6E30 16r9082 16r6E31 16r907D 16r6E32 16r9081 16r6E33 16r9080 16r6E34 16r908A 16r6E35 16r9089 16r6E36 16r908F 16r6E37 16r90A8 16r6E38 16r90AF 16r6E39 16r90B1 16r6E3A 16r90B5 16r6E3B 16r90E2 16r6E3C 16r90E4 16r6E3D 16r6248 16r6E3E 16r90DB 16r6E3F 16r9102 16r6E40 16r9112 16r6E41 16r9119 16r6E42 16r9132 16r6E43 16r9130 16r6E44 16r914A 16r6E45 16r9156 16r6E46 16r9158 16r6E47 16r9163 16r6E48 16r9165 16r6E49 16r9169 16r6E4A 16r9173 16r6E4B 16r9172 16r6E4C 16r918B 16r6E4D 16r9189 16r6E4E 16r9182 16r6E4F 16r91A2 16r6E50 16r91AB 16r6E51 16r91AF 16r6E52 16r91AA 16r6E53 16r91B5 16r6E54 16r91B4 16r6E55 16r91BA 16r6E56 16r91C0 16r6E57 16r91C1 16r6E58 16r91C9 16r6E59 16r91CB 16r6E5A 16r91D0 16r6E5B 16r91D6 16r6E5C 16r91DF 16r6E5D 16r91E1 16r6E5E 16r91DB 16r6E5F 16r91FC 16r6E60 16r91F5 16r6E61 16r91F6 16r6E62 16r921E 16r6E63 16r91FF 16r6E64 16r9214 16r6E65 16r922C 16r6E66 16r9215 16r6E67 16r9211 16r6E68 16r925E 16r6E69 16r9257 16r6E6A 16r9245 16r6E6B 16r9249 16r6E6C 16r9264 16r6E6D 16r9248 16r6E6E 16r9295 16r6E6F 16r923F 16r6E70 16r924B 16r6E71 16r9250 16r6E72 16r929C 16r6E73 16r9296 16r6E74 16r9293 16r6E75 16r929B 16r6E76 16r925A 16r6E77 16r92CF 16r6E78 16r92B9 16r6E79 16r92B7 16r6E7A 16r92E9 16r6E7B 16r930F 16r6E7C 16r92FA 16r6E7D 16r9344 16r6E7E 16r932E 16r6F21 16r9319 16r6F22 16r9322 16r6F23 16r931A 16r6F24 16r9323 16r6F25 16r933A 16r6F26 16r9335 16r6F27 16r933B 16r6F28 16r935C 16r6F29 16r9360 16r6F2A 16r937C 16r6F2B 16r936E 16r6F2C 16r9356 16r6F2D 16r93B0 16r6F2E 16r93AC 16r6F2F 16r93AD 16r6F30 16r9394 16r6F31 16r93B9 16r6F32 16r93D6 16r6F33 16r93D7 16r6F34 16r93E8 16r6F35 16r93E5 16r6F36 16r93D8 16r6F37 16r93C3 16r6F38 16r93DD 16r6F39 16r93D0 16r6F3A 16r93C8 16r6F3B 16r93E4 16r6F3C 16r941A 16r6F3D 16r9414 16r6F3E 16r9413 16r6F3F 16r9403 16r6F40 16r9407 16r6F41 16r9410 16r6F42 16r9436 16r6F43 16r942B 16r6F44 16r9435 16r6F45 16r9421 16r6F46 16r943A 16r6F47 16r9441 16r6F48 16r9452 16r6F49 16r9444 16r6F4A 16r945B 16r6F4B 16r9460 16r6F4C 16r9462 16r6F4D 16r945E 16r6F4E 16r946A 16r6F4F 16r9229 16r6F50 16r9470 16r6F51 16r9475 16r6F52 16r9477 16r6F53 16r947D 16r6F54 16r945A 16r6F55 16r947C 16r6F56 16r947E 16r6F57 16r9481 16r6F58 16r947F 16r6F59 16r9582 16r6F5A 16r9587 16r6F5B 16r958A 16r6F5C 16r9594 16r6F5D 16r9596 16r6F5E 16r9598 16r6F5F 16r9599 16r6F60 16r95A0 16r6F61 16r95A8 16r6F62 16r95A7 16r6F63 16r95AD 16r6F64 16r95BC 16r6F65 16r95BB 16r6F66 16r95B9 16r6F67 16r95BE 16r6F68 16r95CA 16r6F69 16r6FF6 16r6F6A 16r95C3 16r6F6B 16r95CD 16r6F6C 16r95CC 16r6F6D 16r95D5 16r6F6E 16r95D4 16r6F6F 16r95D6 16r6F70 16r95DC 16r6F71 16r95E1 16r6F72 16r95E5 16r6F73 16r95E2 16r6F74 16r9621 16r6F75 16r9628 16r6F76 16r962E 16r6F77 16r962F 16r6F78 16r9642 16r6F79 16r964C 16r6F7A 16r964F 16r6F7B 16r964B 16r6F7C 16r9677 16r6F7D 16r965C 16r6F7E 16r965E 16r7021 16r965D 16r7022 16r965F 16r7023 16r9666 16r7024 16r9672 16r7025 16r966C 16r7026 16r968D 16r7027 16r9698 16r7028 16r9695 16r7029 16r9697 16r702A 16r96AA 16r702B 16r96A7 16r702C 16r96B1 16r702D 16r96B2 16r702E 16r96B0 16r702F 16r96B4 16r7030 16r96B6 16r7031 16r96B8 16r7032 16r96B9 16r7033 16r96CE 16r7034 16r96CB 16r7035 16r96C9 16r7036 16r96CD 16r7037 16r894D 16r7038 16r96DC 16r7039 16r970D 16r703A 16r96D5 16r703B 16r96F9 16r703C 16r9704 16r703D 16r9706 16r703E 16r9708 16r703F 16r9713 16r7040 16r970E 16r7041 16r9711 16r7042 16r970F 16r7043 16r9716 16r7044 16r9719 16r7045 16r9724 16r7046 16r972A 16r7047 16r9730 16r7048 16r9739 16r7049 16r973D 16r704A 16r973E 16r704B 16r9744 16r704C 16r9746 16r704D 16r9748 16r704E 16r9742 16r704F 16r9749 16r7050 16r975C 16r7051 16r9760 16r7052 16r9764 16r7053 16r9766 16r7054 16r9768 16r7055 16r52D2 16r7056 16r976B 16r7057 16r9771 16r7058 16r9779 16r7059 16r9785 16r705A 16r977C 16r705B 16r9781 16r705C 16r977A 16r705D 16r9786 16r705E 16r978B 16r705F 16r978F 16r7060 16r9790 16r7061 16r979C 16r7062 16r97A8 16r7063 16r97A6 16r7064 16r97A3 16r7065 16r97B3 16r7066 16r97B4 16r7067 16r97C3 16r7068 16r97C6 16r7069 16r97C8 16r706A 16r97CB 16r706B 16r97DC 16r706C 16r97ED 16r706D 16r9F4F 16r706E 16r97F2 16r706F 16r7ADF 16r7070 16r97F6 16r7071 16r97F5 16r7072 16r980F 16r7073 16r980C 16r7074 16r9838 16r7075 16r9824 16r7076 16r9821 16r7077 16r9837 16r7078 16r983D 16r7079 16r9846 16r707A 16r984F 16r707B 16r984B 16r707C 16r986B 16r707D 16r986F 16r707E 16r9870 16r7121 16r9871 16r7122 16r9874 16r7123 16r9873 16r7124 16r98AA 16r7125 16r98AF 16r7126 16r98B1 16r7127 16r98B6 16r7128 16r98C4 16r7129 16r98C3 16r712A 16r98C6 16r712B 16r98E9 16r712C 16r98EB 16r712D 16r9903 16r712E 16r9909 16r712F 16r9912 16r7130 16r9914 16r7131 16r9918 16r7132 16r9921 16r7133 16r991D 16r7134 16r991E 16r7135 16r9924 16r7136 16r9920 16r7137 16r992C 16r7138 16r992E 16r7139 16r993D 16r713A 16r993E 16r713B 16r9942 16r713C 16r9949 16r713D 16r9945 16r713E 16r9950 16r713F 16r994B 16r7140 16r9951 16r7141 16r9952 16r7142 16r994C 16r7143 16r9955 16r7144 16r9997 16r7145 16r9998 16r7146 16r99A5 16r7147 16r99AD 16r7148 16r99AE 16r7149 16r99BC 16r714A 16r99DF 16r714B 16r99DB 16r714C 16r99DD 16r714D 16r99D8 16r714E 16r99D1 16r714F 16r99ED 16r7150 16r99EE 16r7151 16r99F1 16r7152 16r99F2 16r7153 16r99FB 16r7154 16r99F8 16r7155 16r9A01 16r7156 16r9A0F 16r7157 16r9A05 16r7158 16r99E2 16r7159 16r9A19 16r715A 16r9A2B 16r715B 16r9A37 16r715C 16r9A45 16r715D 16r9A42 16r715E 16r9A40 16r715F 16r9A43 16r7160 16r9A3E 16r7161 16r9A55 16r7162 16r9A4D 16r7163 16r9A5B 16r7164 16r9A57 16r7165 16r9A5F 16r7166 16r9A62 16r7167 16r9A65 16r7168 16r9A64 16r7169 16r9A69 16r716A 16r9A6B 16r716B 16r9A6A 16r716C 16r9AAD 16r716D 16r9AB0 16r716E 16r9ABC 16r716F 16r9AC0 16r7170 16r9ACF 16r7171 16r9AD1 16r7172 16r9AD3 16r7173 16r9AD4 16r7174 16r9ADE 16r7175 16r9ADF 16r7176 16r9AE2 16r7177 16r9AE3 16r7178 16r9AE6 16r7179 16r9AEF 16r717A 16r9AEB 16r717B 16r9AEE 16r717C 16r9AF4 16r717D 16r9AF1 16r717E 16r9AF7 16r7221 16r9AFB 16r7222 16r9B06 16r7223 16r9B18 16r7224 16r9B1A 16r7225 16r9B1F 16r7226 16r9B22 16r7227 16r9B23 16r7228 16r9B25 16r7229 16r9B27 16r722A 16r9B28 16r722B 16r9B29 16r722C 16r9B2A 16r722D 16r9B2E 16r722E 16r9B2F 16r722F 16r9B32 16r7230 16r9B44 16r7231 16r9B43 16r7232 16r9B4F 16r7233 16r9B4D 16r7234 16r9B4E 16r7235 16r9B51 16r7236 16r9B58 16r7237 16r9B74 16r7238 16r9B93 16r7239 16r9B83 16r723A 16r9B91 16r723B 16r9B96 16r723C 16r9B97 16r723D 16r9B9F 16r723E 16r9BA0 16r723F 16r9BA8 16r7240 16r9BB4 16r7241 16r9BC0 16r7242 16r9BCA 16r7243 16r9BB9 16r7244 16r9BC6 16r7245 16r9BCF 16r7246 16r9BD1 16r7247 16r9BD2 16r7248 16r9BE3 16r7249 16r9BE2 16r724A 16r9BE4 16r724B 16r9BD4 16r724C 16r9BE1 16r724D 16r9C3A 16r724E 16r9BF2 16r724F 16r9BF1 16r7250 16r9BF0 16r7251 16r9C15 16r7252 16r9C14 16r7253 16r9C09 16r7254 16r9C13 16r7255 16r9C0C 16r7256 16r9C06 16r7257 16r9C08 16r7258 16r9C12 16r7259 16r9C0A 16r725A 16r9C04 16r725B 16r9C2E 16r725C 16r9C1B 16r725D 16r9C25 16r725E 16r9C24 16r725F 16r9C21 16r7260 16r9C30 16r7261 16r9C47 16r7262 16r9C32 16r7263 16r9C46 16r7264 16r9C3E 16r7265 16r9C5A 16r7266 16r9C60 16r7267 16r9C67 16r7268 16r9C76 16r7269 16r9C78 16r726A 16r9CE7 16r726B 16r9CEC 16r726C 16r9CF0 16r726D 16r9D09 16r726E 16r9D08 16r726F 16r9CEB 16r7270 16r9D03 16r7271 16r9D06 16r7272 16r9D2A 16r7273 16r9D26 16r7274 16r9DAF 16r7275 16r9D23 16r7276 16r9D1F 16r7277 16r9D44 16r7278 16r9D15 16r7279 16r9D12 16r727A 16r9D41 16r727B 16r9D3F 16r727C 16r9D3E 16r727D 16r9D46 16r727E 16r9D48 16r7321 16r9D5D 16r7322 16r9D5E 16r7323 16r9D64 16r7324 16r9D51 16r7325 16r9D50 16r7326 16r9D59 16r7327 16r9D72 16r7328 16r9D89 16r7329 16r9D87 16r732A 16r9DAB 16r732B 16r9D6F 16r732C 16r9D7A 16r732D 16r9D9A 16r732E 16r9DA4 16r732F 16r9DA9 16r7330 16r9DB2 16r7331 16r9DC4 16r7332 16r9DC1 16r7333 16r9DBB 16r7334 16r9DB8 16r7335 16r9DBA 16r7336 16r9DC6 16r7337 16r9DCF 16r7338 16r9DC2 16r7339 16r9DD9 16r733A 16r9DD3 16r733B 16r9DF8 16r733C 16r9DE6 16r733D 16r9DED 16r733E 16r9DEF 16r733F 16r9DFD 16r7340 16r9E1A 16r7341 16r9E1B 16r7342 16r9E1E 16r7343 16r9E75 16r7344 16r9E79 16r7345 16r9E7D 16r7346 16r9E81 16r7347 16r9E88 16r7348 16r9E8B 16r7349 16r9E8C 16r734A 16r9E92 16r734B 16r9E95 16r734C 16r9E91 16r734D 16r9E9D 16r734E 16r9EA5 16r734F 16r9EA9 16r7350 16r9EB8 16r7351 16r9EAA 16r7352 16r9EAD 16r7353 16r9761 16r7354 16r9ECC 16r7355 16r9ECE 16r7356 16r9ECF 16r7357 16r9ED0 16r7358 16r9ED4 16r7359 16r9EDC 16r735A 16r9EDE 16r735B 16r9EDD 16r735C 16r9EE0 16r735D 16r9EE5 16r735E 16r9EE8 16r735F 16r9EEF 16r7360 16r9EF4 16r7361 16r9EF6 16r7362 16r9EF7 16r7363 16r9EF9 16r7364 16r9EFB 16r7365 16r9EFC 16r7366 16r9EFD 16r7367 16r9F07 16r7368 16r9F08 16r7369 16r76B7 16r736A 16r9F15 16r736B 16r9F21 16r736C 16r9F2C 16r736D 16r9F3E 16r736E 16r9F4A 16r736F 16r9F52 16r7370 16r9F54 16r7371 16r9F63 16r7372 16r9F5F 16r7373 16r9F60 16r7374 16r9F61 16r7375 16r9F66 16r7376 16r9F67 16r7377 16r9F6C 16r7378 16r9F6A 16r7379 16r9F77 16r737A 16r9F72 16r737B 16r9F76 16r737C 16r9F95 16r737D 16r9F9C 16r737E 16r9FA0 16r7421 16r582F 16r7422 16r69C7 16r7423 16r9059 16r7424 16r7464 16r7425 16r51DC 16r7426 16r7199).
	encoder encode: 16rFF0F asCharacter as: 16r2140.
	encoder name: #''jisx0208.1983-0''.
	^encoder'</body>

<body package="Jpl" selector="jisx0212EncoderInCharacterEncoderClass">jisx0212EncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-jis character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'jisx0212Encoder
	"CharacterEncoder jisx0212Encoder."

	| encoder |
	encoder := self 
				createLargeCharacterEncoder: #(16r222F 16r2D8 16r2230 16r2C7 16r2231 16rB8 16r2232 16r2D9 16r2233 16r2DD 16r2234 16rAF 16r2235 16r2DB 16r2236 16r2DA 16r2237 16r7E 16r2238 16r384 16r2239 16r385 16r2242 16rA1 16r2243 16rA6 16r2244 16rBF 16r226B 16rBA 16r226C 16rAA 16r226D 16rA9 16r226E 16rAE 16r226F 16r2122 16r2270 16rA4 16r2271 16r2116 16r2661 16r386 16r2662 16r388 16r2663 16r389 16r2664 16r38A 16r2665 16r3AA 16r2667 16r38C 16r2669 16r38E 16r266A 16r3AB 16r266C 16r38F 16r2671 16r3AC 16r2672 16r3AD 16r2673 16r3AE 16r2674 16r3AF 16r2675 16r3CA 16r2676 16r390 16r2677 16r3CC 16r2678 16r3C2 16r2679 16r3CD 16r267A 16r3CB 16r267B 16r3B0 16r267C 16r3CE 16r2742 16r402 16r2743 16r403 16r2744 16r404 16r2745 16r405 16r2746 16r406 16r2747 16r407 16r2748 16r408 16r2749 16r409 16r274A 16r40A 16r274B 16r40B 16r274C 16r40C 16r274D 16r40E 16r274E 16r40F 16r2772 16r452 16r2773 16r453 16r2774 16r454 16r2775 16r455 16r2776 16r456 16r2777 16r457 16r2778 16r458 16r2779 16r459 16r277A 16r45A 16r277B 16r45B 16r277C 16r45C 16r277D 16r45E 16r277E 16r45F 16r2921 16rC6 16r2922 16r110 16r2924 16r126 16r2926 16r132 16r2928 16r141 16r2929 16r13F 16r292B 16r14A 16r292C 16rD8 16r292D 16r152 16r292F 16r166 16r2930 16rDE 16r2941 16rE6 16r2942 16r111 16r2943 16rF0 16r2944 16r127 16r2945 16r131 16r2946 16r133 16r2947 16r138 16r2948 16r142 16r2949 16r140 16r294A 16r149 16r294B 16r14B 16r294C 16rF8 16r294D 16r153 16r294E 16rDF 16r294F 16r167 16r2950 16rFE 16r2A21 16rC1 16r2A22 16rC0 16r2A23 16rC4 16r2A24 16rC2 16r2A25 16r102 16r2A26 16r1CD 16r2A27 16r100 16r2A28 16r104 16r2A29 16rC5 16r2A2A 16rC3 16r2A2B 16r106 16r2A2C 16r108 16r2A2D 16r10C 16r2A2E 16rC7 16r2A2F 16r10A 16r2A30 16r10E 16r2A31 16rC9 16r2A32 16rC8 16r2A33 16rCB 16r2A34 16rCA 16r2A35 16r11A 16r2A36 16r116 16r2A37 16r112 16r2A38 16r118 16r2A3A 16r11C 16r2A3B 16r11E 16r2A3C 16r122 16r2A3D 16r120 16r2A3E 16r124 16r2A3F 16rCD 16r2A40 16rCC 16r2A41 16rCF 16r2A42 16rCE 16r2A43 16r1CF 16r2A44 16r130 16r2A45 16r12A 16r2A46 16r12E 16r2A47 16r128 16r2A48 16r134 16r2A49 16r136 16r2A4A 16r139 16r2A4B 16r13D 16r2A4C 16r13B 16r2A4D 16r143 16r2A4E 16r147 16r2A4F 16r145 16r2A50 16rD1 16r2A51 16rD3 16r2A52 16rD2 16r2A53 16rD6 16r2A54 16rD4 16r2A55 16r1D1 16r2A56 16r150 16r2A57 16r14C 16r2A58 16rD5 16r2A59 16r154 16r2A5A 16r158 16r2A5B 16r156 16r2A5C 16r15A 16r2A5D 16r15C 16r2A5E 16r160 16r2A5F 16r15E 16r2A60 16r164 16r2A61 16r162 16r2A62 16rDA 16r2A63 16rD9 16r2A64 16rDC 16r2A65 16rDB 16r2A66 16r16C 16r2A67 16r1D3 16r2A68 16r170 16r2A69 16r16A 16r2A6A 16r172 16r2A6B 16r16E 16r2A6C 16r168 16r2A6D 16r1D7 16r2A6E 16r1DB 16r2A6F 16r1D9 16r2A70 16r1D5 16r2A71 16r174 16r2A72 16rDD 16r2A73 16r178 16r2A74 16r176 16r2A75 16r179 16r2A76 16r17D 16r2A77 16r17B 16r2B21 16rE1 16r2B22 16rE0 16r2B23 16rE4 16r2B24 16rE2 16r2B25 16r103 16r2B26 16r1CE 16r2B27 16r101 16r2B28 16r105 16r2B29 16rE5 16r2B2A 16rE3 16r2B2B 16r107 16r2B2C 16r109 16r2B2D 16r10D 16r2B2E 16rE7 16r2B2F 16r10B 16r2B30 16r10F 16r2B31 16rE9 16r2B32 16rE8 16r2B33 16rEB 16r2B34 16rEA 16r2B35 16r11B 16r2B36 16r117 16r2B37 16r113 16r2B38 16r119 16r2B39 16r1F5 16r2B3A 16r11D 16r2B3B 16r11F 16r2B3D 16r121 16r2B3E 16r125 16r2B3F 16rED 16r2B40 16rEC 16r2B41 16rEF 16r2B42 16rEE 16r2B43 16r1D0 16r2B45 16r12B 16r2B46 16r12F 16r2B47 16r129 16r2B48 16r135 16r2B49 16r137 16r2B4A 16r13A 16r2B4B 16r13E 16r2B4C 16r13C 16r2B4D 16r144 16r2B4E 16r148 16r2B4F 16r146 16r2B50 16rF1 16r2B51 16rF3 16r2B52 16rF2 16r2B53 16rF6 16r2B54 16rF4 16r2B55 16r1D2 16r2B56 16r151 16r2B57 16r14D 16r2B58 16rF5 16r2B59 16r155 16r2B5A 16r159 16r2B5B 16r157 16r2B5C 16r15B 16r2B5D 16r15D 16r2B5E 16r161 16r2B5F 16r15F 16r2B60 16r165 16r2B61 16r163 16r2B62 16rFA 16r2B63 16rF9 16r2B64 16rFC 16r2B65 16rFB 16r2B66 16r16D 16r2B67 16r1D4 16r2B68 16r171 16r2B69 16r16B 16r2B6A 16r173 16r2B6B 16r16F 16r2B6C 16r169 16r2B6D 16r1D8 16r2B6E 16r1DC 16r2B6F 16r1DA 16r2B70 16r1D6 16r2B71 16r175 16r2B72 16rFD 16r2B73 16rFF 16r2B74 16r177 16r2B75 16r17A 16r2B76 16r17E 16r2B77 16r17C 16r3021 16r4E02 16r3022 16r4E04 16r3023 16r4E05 16r3024 16r4E0C 16r3025 16r4E12 16r3026 16r4E1F 16r3027 16r4E23 16r3028 16r4E24 16r3029 16r4E28 16r302A 16r4E2B 16r302B 16r4E2E 16r302C 16r4E2F 16r302D 16r4E30 16r302E 16r4E35 16r302F 16r4E40 16r3030 16r4E41 16r3031 16r4E44 16r3032 16r4E47 16r3033 16r4E51 16r3034 16r4E5A 16r3035 16r4E5C 16r3036 16r4E63 16r3037 16r4E68 16r3038 16r4E69 16r3039 16r4E74 16r303A 16r4E75 16r303B 16r4E79 16r303C 16r4E7F 16r303D 16r4E8D 16r303E 16r4E96 16r303F 16r4E97 16r3040 16r4E9D 16r3041 16r4EAF 16r3042 16r4EB9 16r3043 16r4EC3 16r3044 16r4ED0 16r3045 16r4EDA 16r3046 16r4EDB 16r3047 16r4EE0 16r3048 16r4EE1 16r3049 16r4EE2 16r304A 16r4EE8 16r304B 16r4EEF 16r304C 16r4EF1 16r304D 16r4EF3 16r304E 16r4EF5 16r304F 16r4EFD 16r3050 16r4EFE 16r3051 16r4EFF 16r3052 16r4F00 16r3053 16r4F02 16r3054 16r4F03 16r3055 16r4F08 16r3056 16r4F0B 16r3057 16r4F0C 16r3058 16r4F12 16r3059 16r4F15 16r305A 16r4F16 16r305B 16r4F17 16r305C 16r4F19 16r305D 16r4F2E 16r305E 16r4F31 16r305F 16r4F60 16r3060 16r4F33 16r3061 16r4F35 16r3062 16r4F37 16r3063 16r4F39 16r3064 16r4F3B 16r3065 16r4F3E 16r3066 16r4F40 16r3067 16r4F42 16r3068 16r4F48 16r3069 16r4F49 16r306A 16r4F4B 16r306B 16r4F4C 16r306C 16r4F52 16r306D 16r4F54 16r306E 16r4F56 16r306F 16r4F58 16r3070 16r4F5F 16r3071 16r4F63 16r3072 16r4F6A 16r3073 16r4F6C 16r3074 16r4F6E 16r3075 16r4F71 16r3076 16r4F77 16r3077 16r4F78 16r3078 16r4F79 16r3079 16r4F7A 16r307A 16r4F7D 16r307B 16r4F7E 16r307C 16r4F81 16r307D 16r4F82 16r307E 16r4F84 16r3121 16r4F85 16r3122 16r4F89 16r3123 16r4F8A 16r3124 16r4F8C 16r3125 16r4F8E 16r3126 16r4F90 16r3127 16r4F92 16r3128 16r4F93 16r3129 16r4F94 16r312A 16r4F97 16r312B 16r4F99 16r312C 16r4F9A 16r312D 16r4F9E 16r312E 16r4F9F 16r312F 16r4FB2 16r3130 16r4FB7 16r3131 16r4FB9 16r3132 16r4FBB 16r3133 16r4FBC 16r3134 16r4FBD 16r3135 16r4FBE 16r3136 16r4FC0 16r3137 16r4FC1 16r3138 16r4FC5 16r3139 16r4FC6 16r313A 16r4FC8 16r313B 16r4FC9 16r313C 16r4FCB 16r313D 16r4FCC 16r313E 16r4FCD 16r313F 16r4FCF 16r3140 16r4FD2 16r3141 16r4FDC 16r3142 16r4FE0 16r3143 16r4FE2 16r3144 16r4FF0 16r3145 16r4FF2 16r3146 16r4FFC 16r3147 16r4FFD 16r3148 16r4FFF 16r3149 16r5000 16r314A 16r5001 16r314B 16r5004 16r314C 16r5007 16r314D 16r500A 16r314E 16r500C 16r314F 16r500E 16r3150 16r5010 16r3151 16r5013 16r3152 16r5017 16r3153 16r5018 16r3154 16r501B 16r3155 16r501C 16r3156 16r501D 16r3157 16r501E 16r3158 16r5022 16r3159 16r5027 16r315A 16r502E 16r315B 16r5030 16r315C 16r5032 16r315D 16r5033 16r315E 16r5035 16r315F 16r5040 16r3160 16r5041 16r3161 16r5042 16r3162 16r5045 16r3163 16r5046 16r3164 16r504A 16r3165 16r504C 16r3166 16r504E 16r3167 16r5051 16r3168 16r5052 16r3169 16r5053 16r316A 16r5057 16r316B 16r5059 16r316C 16r505F 16r316D 16r5060 16r316E 16r5062 16r316F 16r5063 16r3170 16r5066 16r3171 16r5067 16r3172 16r506A 16r3173 16r506D 16r3174 16r5070 16r3175 16r5071 16r3176 16r503B 16r3177 16r5081 16r3178 16r5083 16r3179 16r5084 16r317A 16r5086 16r317B 16r508A 16r317C 16r508E 16r317D 16r508F 16r317E 16r5090 16r3221 16r5092 16r3222 16r5093 16r3223 16r5094 16r3224 16r5096 16r3225 16r509B 16r3226 16r509C 16r3227 16r509E 16r3228 16r509F 16r3229 16r50A0 16r322A 16r50A1 16r322B 16r50A2 16r322C 16r50AA 16r322D 16r50AF 16r322E 16r50B0 16r322F 16r50B9 16r3230 16r50BA 16r3231 16r50BD 16r3232 16r50C0 16r3233 16r50C3 16r3234 16r50C4 16r3235 16r50C7 16r3236 16r50CC 16r3237 16r50CE 16r3238 16r50D0 16r3239 16r50D3 16r323A 16r50D4 16r323B 16r50D8 16r323C 16r50DC 16r323D 16r50DD 16r323E 16r50DF 16r323F 16r50E2 16r3240 16r50E4 16r3241 16r50E6 16r3242 16r50E8 16r3243 16r50E9 16r3244 16r50EF 16r3245 16r50F1 16r3246 16r50F6 16r3247 16r50FA 16r3248 16r50FE 16r3249 16r5103 16r324A 16r5106 16r324B 16r5107 16r324C 16r5108 16r324D 16r510B 16r324E 16r510C 16r324F 16r510D 16r3250 16r510E 16r3251 16r50F2 16r3252 16r5110 16r3253 16r5117 16r3254 16r5119 16r3255 16r511B 16r3256 16r511C 16r3257 16r511D 16r3258 16r511E 16r3259 16r5123 16r325A 16r5127 16r325B 16r5128 16r325C 16r512C 16r325D 16r512D 16r325E 16r512F 16r325F 16r5131 16r3260 16r5133 16r3261 16r5134 16r3262 16r5135 16r3263 16r5138 16r3264 16r5139 16r3265 16r5142 16r3266 16r514A 16r3267 16r514F 16r3268 16r5153 16r3269 16r5155 16r326A 16r5157 16r326B 16r5158 16r326C 16r515F 16r326D 16r5164 16r326E 16r5166 16r326F 16r517E 16r3270 16r5183 16r3271 16r5184 16r3272 16r518B 16r3273 16r518E 16r3274 16r5198 16r3275 16r519D 16r3276 16r51A1 16r3277 16r51A3 16r3278 16r51AD 16r3279 16r51B8 16r327A 16r51BA 16r327B 16r51BC 16r327C 16r51BE 16r327D 16r51BF 16r327E 16r51C2 16r3321 16r51C8 16r3322 16r51CF 16r3323 16r51D1 16r3324 16r51D2 16r3325 16r51D3 16r3326 16r51D5 16r3327 16r51D8 16r3328 16r51DE 16r3329 16r51E2 16r332A 16r51E5 16r332B 16r51EE 16r332C 16r51F2 16r332D 16r51F3 16r332E 16r51F4 16r332F 16r51F7 16r3330 16r5201 16r3331 16r5202 16r3332 16r5205 16r3333 16r5212 16r3334 16r5213 16r3335 16r5215 16r3336 16r5216 16r3337 16r5218 16r3338 16r5222 16r3339 16r5228 16r333A 16r5231 16r333B 16r5232 16r333C 16r5235 16r333D 16r523C 16r333E 16r5245 16r333F 16r5249 16r3340 16r5255 16r3341 16r5257 16r3342 16r5258 16r3343 16r525A 16r3344 16r525C 16r3345 16r525F 16r3346 16r5260 16r3347 16r5261 16r3348 16r5266 16r3349 16r526E 16r334A 16r5277 16r334B 16r5278 16r334C 16r5279 16r334D 16r5280 16r334E 16r5282 16r334F 16r5285 16r3350 16r528A 16r3351 16r528C 16r3352 16r5293 16r3353 16r5295 16r3354 16r5296 16r3355 16r5297 16r3356 16r5298 16r3357 16r529A 16r3358 16r529C 16r3359 16r52A4 16r335A 16r52A5 16r335B 16r52A6 16r335C 16r52A7 16r335D 16r52AF 16r335E 16r52B0 16r335F 16r52B6 16r3360 16r52B7 16r3361 16r52B8 16r3362 16r52BA 16r3363 16r52BB 16r3364 16r52BD 16r3365 16r52C0 16r3366 16r52C4 16r3367 16r52C6 16r3368 16r52C8 16r3369 16r52CC 16r336A 16r52CF 16r336B 16r52D1 16r336C 16r52D4 16r336D 16r52D6 16r336E 16r52DB 16r336F 16r52DC 16r3370 16r52E1 16r3371 16r52E5 16r3372 16r52E8 16r3373 16r52E9 16r3374 16r52EA 16r3375 16r52EC 16r3376 16r52F0 16r3377 16r52F1 16r3378 16r52F4 16r3379 16r52F6 16r337A 16r52F7 16r337B 16r5300 16r337C 16r5303 16r337D 16r530A 16r337E 16r530B 16r3421 16r530C 16r3422 16r5311 16r3423 16r5313 16r3424 16r5318 16r3425 16r531B 16r3426 16r531C 16r3427 16r531E 16r3428 16r531F 16r3429 16r5325 16r342A 16r5327 16r342B 16r5328 16r342C 16r5329 16r342D 16r532B 16r342E 16r532C 16r342F 16r532D 16r3430 16r5330 16r3431 16r5332 16r3432 16r5335 16r3433 16r533C 16r3434 16r533D 16r3435 16r533E 16r3436 16r5342 16r3437 16r534C 16r3438 16r534B 16r3439 16r5359 16r343A 16r535B 16r343B 16r5361 16r343C 16r5363 16r343D 16r5365 16r343E 16r536C 16r343F 16r536D 16r3440 16r5372 16r3441 16r5379 16r3442 16r537E 16r3443 16r5383 16r3444 16r5387 16r3445 16r5388 16r3446 16r538E 16r3447 16r5393 16r3448 16r5394 16r3449 16r5399 16r344A 16r539D 16r344B 16r53A1 16r344C 16r53A4 16r344D 16r53AA 16r344E 16r53AB 16r344F 16r53AF 16r3450 16r53B2 16r3451 16r53B4 16r3452 16r53B5 16r3453 16r53B7 16r3454 16r53B8 16r3455 16r53BA 16r3456 16r53BD 16r3457 16r53C0 16r3458 16r53C5 16r3459 16r53CF 16r345A 16r53D2 16r345B 16r53D3 16r345C 16r53D5 16r345D 16r53DA 16r345E 16r53DD 16r345F 16r53DE 16r3460 16r53E0 16r3461 16r53E6 16r3462 16r53E7 16r3463 16r53F5 16r3464 16r5402 16r3465 16r5413 16r3466 16r541A 16r3467 16r5421 16r3468 16r5427 16r3469 16r5428 16r346A 16r542A 16r346B 16r542F 16r346C 16r5431 16r346D 16r5434 16r346E 16r5435 16r346F 16r5443 16r3470 16r5444 16r3471 16r5447 16r3472 16r544D 16r3473 16r544F 16r3474 16r545E 16r3475 16r5462 16r3476 16r5464 16r3477 16r5466 16r3478 16r5467 16r3479 16r5469 16r347A 16r546B 16r347B 16r546D 16r347C 16r546E 16r347D 16r5474 16r347E 16r547F 16r3521 16r5481 16r3522 16r5483 16r3523 16r5485 16r3524 16r5488 16r3525 16r5489 16r3526 16r548D 16r3527 16r5491 16r3528 16r5495 16r3529 16r5496 16r352A 16r549C 16r352B 16r549F 16r352C 16r54A1 16r352D 16r54A6 16r352E 16r54A7 16r352F 16r54A9 16r3530 16r54AA 16r3531 16r54AD 16r3532 16r54AE 16r3533 16r54B1 16r3534 16r54B7 16r3535 16r54B9 16r3536 16r54BA 16r3537 16r54BB 16r3538 16r54BF 16r3539 16r54C6 16r353A 16r54CA 16r353B 16r54CD 16r353C 16r54CE 16r353D 16r54E0 16r353E 16r54EA 16r353F 16r54EC 16r3540 16r54EF 16r3541 16r54F6 16r3542 16r54FC 16r3543 16r54FE 16r3544 16r54FF 16r3545 16r5500 16r3546 16r5501 16r3547 16r5505 16r3548 16r5508 16r3549 16r5509 16r354A 16r550C 16r354B 16r550D 16r354C 16r550E 16r354D 16r5515 16r354E 16r552A 16r354F 16r552B 16r3550 16r5532 16r3551 16r5535 16r3552 16r5536 16r3553 16r553B 16r3554 16r553C 16r3555 16r553D 16r3556 16r5541 16r3557 16r5547 16r3558 16r5549 16r3559 16r554A 16r355A 16r554D 16r355B 16r5550 16r355C 16r5551 16r355D 16r5558 16r355E 16r555A 16r355F 16r555B 16r3560 16r555E 16r3561 16r5560 16r3562 16r5561 16r3563 16r5564 16r3564 16r5566 16r3565 16r557F 16r3566 16r5581 16r3567 16r5582 16r3568 16r5586 16r3569 16r5588 16r356A 16r558E 16r356B 16r558F 16r356C 16r5591 16r356D 16r5592 16r356E 16r5593 16r356F 16r5594 16r3570 16r5597 16r3571 16r55A3 16r3572 16r55A4 16r3573 16r55AD 16r3574 16r55B2 16r3575 16r55BF 16r3576 16r55C1 16r3577 16r55C3 16r3578 16r55C6 16r3579 16r55C9 16r357A 16r55CB 16r357B 16r55CC 16r357C 16r55CE 16r357D 16r55D1 16r357E 16r55D2 16r3621 16r55D3 16r3622 16r55D7 16r3623 16r55D8 16r3624 16r55DB 16r3625 16r55DE 16r3626 16r55E2 16r3627 16r55E9 16r3628 16r55F6 16r3629 16r55FF 16r362A 16r5605 16r362B 16r5608 16r362C 16r560A 16r362D 16r560D 16r362E 16r560E 16r362F 16r560F 16r3630 16r5610 16r3631 16r5611 16r3632 16r5612 16r3633 16r5619 16r3634 16r562C 16r3635 16r5630 16r3636 16r5633 16r3637 16r5635 16r3638 16r5637 16r3639 16r5639 16r363A 16r563B 16r363B 16r563C 16r363C 16r563D 16r363D 16r563F 16r363E 16r5640 16r363F 16r5641 16r3640 16r5643 16r3641 16r5644 16r3642 16r5646 16r3643 16r5649 16r3644 16r564B 16r3645 16r564D 16r3646 16r564F 16r3647 16r5654 16r3648 16r565E 16r3649 16r5660 16r364A 16r5661 16r364B 16r5662 16r364C 16r5663 16r364D 16r5666 16r364E 16r5669 16r364F 16r566D 16r3650 16r566F 16r3651 16r5671 16r3652 16r5672 16r3653 16r5675 16r3654 16r5684 16r3655 16r5685 16r3656 16r5688 16r3657 16r568B 16r3658 16r568C 16r3659 16r5695 16r365A 16r5699 16r365B 16r569A 16r365C 16r569D 16r365D 16r569E 16r365E 16r569F 16r365F 16r56A6 16r3660 16r56A7 16r3661 16r56A8 16r3662 16r56A9 16r3663 16r56AB 16r3664 16r56AC 16r3665 16r56AD 16r3666 16r56B1 16r3667 16r56B3 16r3668 16r56B7 16r3669 16r56BE 16r366A 16r56C5 16r366B 16r56C9 16r366C 16r56CA 16r366D 16r56CB 16r366E 16r56CF 16r366F 16r56D0 16r3670 16r56CC 16r3671 16r56CD 16r3672 16r56D9 16r3673 16r56DC 16r3674 16r56DD 16r3675 16r56DF 16r3676 16r56E1 16r3677 16r56E4 16r3678 16r56E5 16r3679 16r56E6 16r367A 16r56E7 16r367B 16r56E8 16r367C 16r56F1 16r367D 16r56EB 16r367E 16r56ED 16r3721 16r56F6 16r3722 16r56F7 16r3723 16r5701 16r3724 16r5702 16r3725 16r5707 16r3726 16r570A 16r3727 16r570C 16r3728 16r5711 16r3729 16r5715 16r372A 16r571A 16r372B 16r571B 16r372C 16r571D 16r372D 16r5720 16r372E 16r5722 16r372F 16r5723 16r3730 16r5724 16r3731 16r5725 16r3732 16r5729 16r3733 16r572A 16r3734 16r572C 16r3735 16r572E 16r3736 16r572F 16r3737 16r5733 16r3738 16r5734 16r3739 16r573D 16r373A 16r573E 16r373B 16r573F 16r373C 16r5745 16r373D 16r5746 16r373E 16r574C 16r373F 16r574D 16r3740 16r5752 16r3741 16r5762 16r3742 16r5765 16r3743 16r5767 16r3744 16r5768 16r3745 16r576B 16r3746 16r576D 16r3747 16r576E 16r3748 16r576F 16r3749 16r5770 16r374A 16r5771 16r374B 16r5773 16r374C 16r5774 16r374D 16r5775 16r374E 16r5777 16r374F 16r5779 16r3750 16r577A 16r3751 16r577B 16r3752 16r577C 16r3753 16r577E 16r3754 16r5781 16r3755 16r5783 16r3756 16r578C 16r3757 16r5794 16r3758 16r5797 16r3759 16r5799 16r375A 16r579A 16r375B 16r579C 16r375C 16r579D 16r375D 16r579E 16r375E 16r579F 16r375F 16r57A1 16r3760 16r5795 16r3761 16r57A7 16r3762 16r57A8 16r3763 16r57A9 16r3764 16r57AC 16r3765 16r57B8 16r3766 16r57BD 16r3767 16r57C7 16r3768 16r57C8 16r3769 16r57CC 16r376A 16r57CF 16r376B 16r57D5 16r376C 16r57DD 16r376D 16r57DE 16r376E 16r57E4 16r376F 16r57E6 16r3770 16r57E7 16r3771 16r57E9 16r3772 16r57ED 16r3773 16r57F0 16r3774 16r57F5 16r3775 16r57F6 16r3776 16r57F8 16r3777 16r57FD 16r3778 16r57FE 16r3779 16r57FF 16r377A 16r5803 16r377B 16r5804 16r377C 16r5808 16r377D 16r5809 16r377E 16r57E1 16r3821 16r580C 16r3822 16r580D 16r3823 16r581B 16r3824 16r581E 16r3825 16r581F 16r3826 16r5820 16r3827 16r5826 16r3828 16r5827 16r3829 16r582D 16r382A 16r5832 16r382B 16r5839 16r382C 16r583F 16r382D 16r5849 16r382E 16r584C 16r382F 16r584D 16r3830 16r584F 16r3831 16r5850 16r3832 16r5855 16r3833 16r585F 16r3834 16r5861 16r3835 16r5864 16r3836 16r5867 16r3837 16r5868 16r3838 16r5878 16r3839 16r587C 16r383A 16r587F 16r383B 16r5880 16r383C 16r5881 16r383D 16r5887 16r383E 16r5888 16r383F 16r5889 16r3840 16r588A 16r3841 16r588C 16r3842 16r588D 16r3843 16r588F 16r3844 16r5890 16r3845 16r5894 16r3846 16r5896 16r3847 16r589D 16r3848 16r58A0 16r3849 16r58A1 16r384A 16r58A2 16r384B 16r58A6 16r384C 16r58A9 16r384D 16r58B1 16r384E 16r58B2 16r384F 16r58C4 16r3850 16r58BC 16r3851 16r58C2 16r3852 16r58C8 16r3853 16r58CD 16r3854 16r58CE 16r3855 16r58D0 16r3856 16r58D2 16r3857 16r58D4 16r3858 16r58D6 16r3859 16r58DA 16r385A 16r58DD 16r385B 16r58E1 16r385C 16r58E2 16r385D 16r58E9 16r385E 16r58F3 16r385F 16r5905 16r3860 16r5906 16r3861 16r590B 16r3862 16r590C 16r3863 16r5912 16r3864 16r5913 16r3865 16r5914 16r3866 16r8641 16r3867 16r591D 16r3868 16r5921 16r3869 16r5923 16r386A 16r5924 16r386B 16r5928 16r386C 16r592F 16r386D 16r5930 16r386E 16r5933 16r386F 16r5935 16r3870 16r5936 16r3871 16r593F 16r3872 16r5943 16r3873 16r5946 16r3874 16r5952 16r3875 16r5953 16r3876 16r5959 16r3877 16r595B 16r3878 16r595D 16r3879 16r595E 16r387A 16r595F 16r387B 16r5961 16r387C 16r5963 16r387D 16r596B 16r387E 16r596D 16r3921 16r596F 16r3922 16r5972 16r3923 16r5975 16r3924 16r5976 16r3925 16r5979 16r3926 16r597B 16r3927 16r597C 16r3928 16r598B 16r3929 16r598C 16r392A 16r598E 16r392B 16r5992 16r392C 16r5995 16r392D 16r5997 16r392E 16r599F 16r392F 16r59A4 16r3930 16r59A7 16r3931 16r59AD 16r3932 16r59AE 16r3933 16r59AF 16r3934 16r59B0 16r3935 16r59B3 16r3936 16r59B7 16r3937 16r59BA 16r3938 16r59BC 16r3939 16r59C1 16r393A 16r59C3 16r393B 16r59C4 16r393C 16r59C8 16r393D 16r59CA 16r393E 16r59CD 16r393F 16r59D2 16r3940 16r59DD 16r3941 16r59DE 16r3942 16r59DF 16r3943 16r59E3 16r3944 16r59E4 16r3945 16r59E7 16r3946 16r59EE 16r3947 16r59EF 16r3948 16r59F1 16r3949 16r59F2 16r394A 16r59F4 16r394B 16r59F7 16r394C 16r5A00 16r394D 16r5A04 16r394E 16r5A0C 16r394F 16r5A0D 16r3950 16r5A0E 16r3951 16r5A12 16r3952 16r5A13 16r3953 16r5A1E 16r3954 16r5A23 16r3955 16r5A24 16r3956 16r5A27 16r3957 16r5A28 16r3958 16r5A2A 16r3959 16r5A2D 16r395A 16r5A30 16r395B 16r5A44 16r395C 16r5A45 16r395D 16r5A47 16r395E 16r5A48 16r395F 16r5A4C 16r3960 16r5A50 16r3961 16r5A55 16r3962 16r5A5E 16r3963 16r5A63 16r3964 16r5A65 16r3965 16r5A67 16r3966 16r5A6D 16r3967 16r5A77 16r3968 16r5A7A 16r3969 16r5A7B 16r396A 16r5A7E 16r396B 16r5A8B 16r396C 16r5A90 16r396D 16r5A93 16r396E 16r5A96 16r396F 16r5A99 16r3970 16r5A9C 16r3971 16r5A9E 16r3972 16r5A9F 16r3973 16r5AA0 16r3974 16r5AA2 16r3975 16r5AA7 16r3976 16r5AAC 16r3977 16r5AB1 16r3978 16r5AB2 16r3979 16r5AB3 16r397A 16r5AB5 16r397B 16r5AB8 16r397C 16r5ABA 16r397D 16r5ABB 16r397E 16r5ABF 16r3A21 16r5AC4 16r3A22 16r5AC6 16r3A23 16r5AC8 16r3A24 16r5ACF 16r3A25 16r5ADA 16r3A26 16r5ADC 16r3A27 16r5AE0 16r3A28 16r5AE5 16r3A29 16r5AEA 16r3A2A 16r5AEE 16r3A2B 16r5AF5 16r3A2C 16r5AF6 16r3A2D 16r5AFD 16r3A2E 16r5B00 16r3A2F 16r5B01 16r3A30 16r5B08 16r3A31 16r5B17 16r3A32 16r5B34 16r3A33 16r5B19 16r3A34 16r5B1B 16r3A35 16r5B1D 16r3A36 16r5B21 16r3A37 16r5B25 16r3A38 16r5B2D 16r3A39 16r5B38 16r3A3A 16r5B41 16r3A3B 16r5B4B 16r3A3C 16r5B4C 16r3A3D 16r5B52 16r3A3E 16r5B56 16r3A3F 16r5B5E 16r3A40 16r5B68 16r3A41 16r5B6E 16r3A42 16r5B6F 16r3A43 16r5B7C 16r3A44 16r5B7D 16r3A45 16r5B7E 16r3A46 16r5B7F 16r3A47 16r5B81 16r3A48 16r5B84 16r3A49 16r5B86 16r3A4A 16r5B8A 16r3A4B 16r5B8E 16r3A4C 16r5B90 16r3A4D 16r5B91 16r3A4E 16r5B93 16r3A4F 16r5B94 16r3A50 16r5B96 16r3A51 16r5BA8 16r3A52 16r5BA9 16r3A53 16r5BAC 16r3A54 16r5BAD 16r3A55 16r5BAF 16r3A56 16r5BB1 16r3A57 16r5BB2 16r3A58 16r5BB7 16r3A59 16r5BBA 16r3A5A 16r5BBC 16r3A5B 16r5BC0 16r3A5C 16r5BC1 16r3A5D 16r5BCD 16r3A5E 16r5BCF 16r3A5F 16r5BD6 16r3A60 16r5BD7 16r3A61 16r5BD8 16r3A62 16r5BD9 16r3A63 16r5BDA 16r3A64 16r5BE0 16r3A65 16r5BEF 16r3A66 16r5BF1 16r3A67 16r5BF4 16r3A68 16r5BFD 16r3A69 16r5C0C 16r3A6A 16r5C17 16r3A6B 16r5C1E 16r3A6C 16r5C1F 16r3A6D 16r5C23 16r3A6E 16r5C26 16r3A6F 16r5C29 16r3A70 16r5C2B 16r3A71 16r5C2C 16r3A72 16r5C2E 16r3A73 16r5C30 16r3A74 16r5C32 16r3A75 16r5C35 16r3A76 16r5C36 16r3A77 16r5C59 16r3A78 16r5C5A 16r3A79 16r5C5C 16r3A7A 16r5C62 16r3A7B 16r5C63 16r3A7C 16r5C67 16r3A7D 16r5C68 16r3A7E 16r5C69 16r3B21 16r5C6D 16r3B22 16r5C70 16r3B23 16r5C74 16r3B24 16r5C75 16r3B25 16r5C7A 16r3B26 16r5C7B 16r3B27 16r5C7C 16r3B28 16r5C7D 16r3B29 16r5C87 16r3B2A 16r5C88 16r3B2B 16r5C8A 16r3B2C 16r5C8F 16r3B2D 16r5C92 16r3B2E 16r5C9D 16r3B2F 16r5C9F 16r3B30 16r5CA0 16r3B31 16r5CA2 16r3B32 16r5CA3 16r3B33 16r5CA6 16r3B34 16r5CAA 16r3B35 16r5CB2 16r3B36 16r5CB4 16r3B37 16r5CB5 16r3B38 16r5CBA 16r3B39 16r5CC9 16r3B3A 16r5CCB 16r3B3B 16r5CD2 16r3B3C 16r5CDD 16r3B3D 16r5CD7 16r3B3E 16r5CEE 16r3B3F 16r5CF1 16r3B40 16r5CF2 16r3B41 16r5CF4 16r3B42 16r5D01 16r3B43 16r5D06 16r3B44 16r5D0D 16r3B45 16r5D12 16r3B46 16r5D2B 16r3B47 16r5D23 16r3B48 16r5D24 16r3B49 16r5D26 16r3B4A 16r5D27 16r3B4B 16r5D31 16r3B4C 16r5D34 16r3B4D 16r5D39 16r3B4E 16r5D3D 16r3B4F 16r5D3F 16r3B50 16r5D42 16r3B51 16r5D43 16r3B52 16r5D46 16r3B53 16r5D48 16r3B54 16r5D55 16r3B55 16r5D51 16r3B56 16r5D59 16r3B57 16r5D4A 16r3B58 16r5D5F 16r3B59 16r5D60 16r3B5A 16r5D61 16r3B5B 16r5D62 16r3B5C 16r5D64 16r3B5D 16r5D6A 16r3B5E 16r5D6D 16r3B5F 16r5D70 16r3B60 16r5D79 16r3B61 16r5D7A 16r3B62 16r5D7E 16r3B63 16r5D7F 16r3B64 16r5D81 16r3B65 16r5D83 16r3B66 16r5D88 16r3B67 16r5D8A 16r3B68 16r5D92 16r3B69 16r5D93 16r3B6A 16r5D94 16r3B6B 16r5D95 16r3B6C 16r5D99 16r3B6D 16r5D9B 16r3B6E 16r5D9F 16r3B6F 16r5DA0 16r3B70 16r5DA7 16r3B71 16r5DAB 16r3B72 16r5DB0 16r3B73 16r5DB4 16r3B74 16r5DB8 16r3B75 16r5DB9 16r3B76 16r5DC3 16r3B77 16r5DC7 16r3B78 16r5DCB 16r3B79 16r5DD0 16r3B7A 16r5DCE 16r3B7B 16r5DD8 16r3B7C 16r5DD9 16r3B7D 16r5DE0 16r3B7E 16r5DE4 16r3C21 16r5DE9 16r3C22 16r5DF8 16r3C23 16r5DF9 16r3C24 16r5E00 16r3C25 16r5E07 16r3C26 16r5E0D 16r3C27 16r5E12 16r3C28 16r5E14 16r3C29 16r5E15 16r3C2A 16r5E18 16r3C2B 16r5E1F 16r3C2C 16r5E20 16r3C2D 16r5E2E 16r3C2E 16r5E28 16r3C2F 16r5E32 16r3C30 16r5E35 16r3C31 16r5E3E 16r3C32 16r5E4B 16r3C33 16r5E50 16r3C34 16r5E49 16r3C35 16r5E51 16r3C36 16r5E56 16r3C37 16r5E58 16r3C38 16r5E5B 16r3C39 16r5E5C 16r3C3A 16r5E5E 16r3C3B 16r5E68 16r3C3C 16r5E6A 16r3C3D 16r5E6B 16r3C3E 16r5E6C 16r3C3F 16r5E6D 16r3C40 16r5E6E 16r3C41 16r5E70 16r3C42 16r5E80 16r3C43 16r5E8B 16r3C44 16r5E8E 16r3C45 16r5EA2 16r3C46 16r5EA4 16r3C47 16r5EA5 16r3C48 16r5EA8 16r3C49 16r5EAA 16r3C4A 16r5EAC 16r3C4B 16r5EB1 16r3C4C 16r5EB3 16r3C4D 16r5EBD 16r3C4E 16r5EBE 16r3C4F 16r5EBF 16r3C50 16r5EC6 16r3C51 16r5ECC 16r3C52 16r5ECB 16r3C53 16r5ECE 16r3C54 16r5ED1 16r3C55 16r5ED2 16r3C56 16r5ED4 16r3C57 16r5ED5 16r3C58 16r5EDC 16r3C59 16r5EDE 16r3C5A 16r5EE5 16r3C5B 16r5EEB 16r3C5C 16r5F02 16r3C5D 16r5F06 16r3C5E 16r5F07 16r3C5F 16r5F08 16r3C60 16r5F0E 16r3C61 16r5F19 16r3C62 16r5F1C 16r3C63 16r5F1D 16r3C64 16r5F21 16r3C65 16r5F22 16r3C66 16r5F23 16r3C67 16r5F24 16r3C68 16r5F28 16r3C69 16r5F2B 16r3C6A 16r5F2C 16r3C6B 16r5F2E 16r3C6C 16r5F30 16r3C6D 16r5F34 16r3C6E 16r5F36 16r3C6F 16r5F3B 16r3C70 16r5F3D 16r3C71 16r5F3F 16r3C72 16r5F40 16r3C73 16r5F44 16r3C74 16r5F45 16r3C75 16r5F47 16r3C76 16r5F4D 16r3C77 16r5F50 16r3C78 16r5F54 16r3C79 16r5F58 16r3C7A 16r5F5B 16r3C7B 16r5F60 16r3C7C 16r5F63 16r3C7D 16r5F64 16r3C7E 16r5F67 16r3D21 16r5F6F 16r3D22 16r5F72 16r3D23 16r5F74 16r3D24 16r5F75 16r3D25 16r5F78 16r3D26 16r5F7A 16r3D27 16r5F7D 16r3D28 16r5F7E 16r3D29 16r5F89 16r3D2A 16r5F8D 16r3D2B 16r5F8F 16r3D2C 16r5F96 16r3D2D 16r5F9C 16r3D2E 16r5F9D 16r3D2F 16r5FA2 16r3D30 16r5FA7 16r3D31 16r5FAB 16r3D32 16r5FA4 16r3D33 16r5FAC 16r3D34 16r5FAF 16r3D35 16r5FB0 16r3D36 16r5FB1 16r3D37 16r5FB8 16r3D38 16r5FC4 16r3D39 16r5FC7 16r3D3A 16r5FC8 16r3D3B 16r5FC9 16r3D3C 16r5FCB 16r3D3D 16r5FD0 16r3D3E 16r5FD1 16r3D3F 16r5FD2 16r3D40 16r5FD3 16r3D41 16r5FD4 16r3D42 16r5FDE 16r3D43 16r5FE1 16r3D44 16r5FE2 16r3D45 16r5FE8 16r3D46 16r5FE9 16r3D47 16r5FEA 16r3D48 16r5FEC 16r3D49 16r5FED 16r3D4A 16r5FEE 16r3D4B 16r5FEF 16r3D4C 16r5FF2 16r3D4D 16r5FF3 16r3D4E 16r5FF6 16r3D4F 16r5FFA 16r3D50 16r5FFC 16r3D51 16r6007 16r3D52 16r600A 16r3D53 16r600D 16r3D54 16r6013 16r3D55 16r6014 16r3D56 16r6017 16r3D57 16r6018 16r3D58 16r601A 16r3D59 16r601F 16r3D5A 16r6024 16r3D5B 16r602D 16r3D5C 16r6033 16r3D5D 16r6035 16r3D5E 16r6040 16r3D5F 16r6047 16r3D60 16r6048 16r3D61 16r6049 16r3D62 16r604C 16r3D63 16r6051 16r3D64 16r6054 16r3D65 16r6056 16r3D66 16r6057 16r3D67 16r605D 16r3D68 16r6061 16r3D69 16r6067 16r3D6A 16r6071 16r3D6B 16r607E 16r3D6C 16r607F 16r3D6D 16r6082 16r3D6E 16r6086 16r3D6F 16r6088 16r3D70 16r608A 16r3D71 16r608E 16r3D72 16r6091 16r3D73 16r6093 16r3D74 16r6095 16r3D75 16r6098 16r3D76 16r609D 16r3D77 16r609E 16r3D78 16r60A2 16r3D79 16r60A4 16r3D7A 16r60A5 16r3D7B 16r60A8 16r3D7C 16r60B0 16r3D7D 16r60B1 16r3D7E 16r60B7 16r3E21 16r60BB 16r3E22 16r60BE 16r3E23 16r60C2 16r3E24 16r60C4 16r3E25 16r60C8 16r3E26 16r60C9 16r3E27 16r60CA 16r3E28 16r60CB 16r3E29 16r60CE 16r3E2A 16r60CF 16r3E2B 16r60D4 16r3E2C 16r60D5 16r3E2D 16r60D9 16r3E2E 16r60DB 16r3E2F 16r60DD 16r3E30 16r60DE 16r3E31 16r60E2 16r3E32 16r60E5 16r3E33 16r60F2 16r3E34 16r60F5 16r3E35 16r60F8 16r3E36 16r60FC 16r3E37 16r60FD 16r3E38 16r6102 16r3E39 16r6107 16r3E3A 16r610A 16r3E3B 16r610C 16r3E3C 16r6110 16r3E3D 16r6111 16r3E3E 16r6112 16r3E3F 16r6113 16r3E40 16r6114 16r3E41 16r6116 16r3E42 16r6117 16r3E43 16r6119 16r3E44 16r611C 16r3E45 16r611E 16r3E46 16r6122 16r3E47 16r612A 16r3E48 16r612B 16r3E49 16r6130 16r3E4A 16r6131 16r3E4B 16r6135 16r3E4C 16r6136 16r3E4D 16r6137 16r3E4E 16r6139 16r3E4F 16r6141 16r3E50 16r6145 16r3E51 16r6146 16r3E52 16r6149 16r3E53 16r615E 16r3E54 16r6160 16r3E55 16r616C 16r3E56 16r6172 16r3E57 16r6178 16r3E58 16r617B 16r3E59 16r617C 16r3E5A 16r617F 16r3E5B 16r6180 16r3E5C 16r6181 16r3E5D 16r6183 16r3E5E 16r6184 16r3E5F 16r618B 16r3E60 16r618D 16r3E61 16r6192 16r3E62 16r6193 16r3E63 16r6197 16r3E64 16r6198 16r3E65 16r619C 16r3E66 16r619D 16r3E67 16r619F 16r3E68 16r61A0 16r3E69 16r61A5 16r3E6A 16r61A8 16r3E6B 16r61AA 16r3E6C 16r61AD 16r3E6D 16r61B8 16r3E6E 16r61B9 16r3E6F 16r61BC 16r3E70 16r61C0 16r3E71 16r61C1 16r3E72 16r61C2 16r3E73 16r61CE 16r3E74 16r61CF 16r3E75 16r61D5 16r3E76 16r61DC 16r3E77 16r61DD 16r3E78 16r61DE 16r3E79 16r61DF 16r3E7A 16r61E1 16r3E7B 16r61E2 16r3E7C 16r61E7 16r3E7D 16r61E9 16r3E7E 16r61E5 16r3F21 16r61EC 16r3F22 16r61ED 16r3F23 16r61EF 16r3F24 16r6201 16r3F25 16r6203 16r3F26 16r6204 16r3F27 16r6207 16r3F28 16r6213 16r3F29 16r6215 16r3F2A 16r621C 16r3F2B 16r6220 16r3F2C 16r6222 16r3F2D 16r6223 16r3F2E 16r6227 16r3F2F 16r6229 16r3F30 16r622B 16r3F31 16r6239 16r3F32 16r623D 16r3F33 16r6242 16r3F34 16r6243 16r3F35 16r6244 16r3F36 16r6246 16r3F37 16r624C 16r3F38 16r6250 16r3F39 16r6251 16r3F3A 16r6252 16r3F3B 16r6254 16r3F3C 16r6256 16r3F3D 16r625A 16r3F3E 16r625C 16r3F3F 16r6264 16r3F40 16r626D 16r3F41 16r626F 16r3F42 16r6273 16r3F43 16r627A 16r3F44 16r627D 16r3F45 16r628D 16r3F46 16r628E 16r3F47 16r628F 16r3F48 16r6290 16r3F49 16r62A6 16r3F4A 16r62A8 16r3F4B 16r62B3 16r3F4C 16r62B6 16r3F4D 16r62B7 16r3F4E 16r62BA 16r3F4F 16r62BE 16r3F50 16r62BF 16r3F51 16r62C4 16r3F52 16r62CE 16r3F53 16r62D5 16r3F54 16r62D6 16r3F55 16r62DA 16r3F56 16r62EA 16r3F57 16r62F2 16r3F58 16r62F4 16r3F59 16r62FC 16r3F5A 16r62FD 16r3F5B 16r6303 16r3F5C 16r6304 16r3F5D 16r630A 16r3F5E 16r630B 16r3F5F 16r630D 16r3F60 16r6310 16r3F61 16r6313 16r3F62 16r6316 16r3F63 16r6318 16r3F64 16r6329 16r3F65 16r632A 16r3F66 16r632D 16r3F67 16r6335 16r3F68 16r6336 16r3F69 16r6339 16r3F6A 16r633C 16r3F6B 16r6341 16r3F6C 16r6342 16r3F6D 16r6343 16r3F6E 16r6344 16r3F6F 16r6346 16r3F70 16r634A 16r3F71 16r634B 16r3F72 16r634E 16r3F73 16r6352 16r3F74 16r6353 16r3F75 16r6354 16r3F76 16r6358 16r3F77 16r635B 16r3F78 16r6365 16r3F79 16r6366 16r3F7A 16r636C 16r3F7B 16r636D 16r3F7C 16r6371 16r3F7D 16r6374 16r3F7E 16r6375 16r4021 16r6378 16r4022 16r637C 16r4023 16r637D 16r4024 16r637F 16r4025 16r6382 16r4026 16r6384 16r4027 16r6387 16r4028 16r638A 16r4029 16r6390 16r402A 16r6394 16r402B 16r6395 16r402C 16r6399 16r402D 16r639A 16r402E 16r639E 16r402F 16r63A4 16r4030 16r63A6 16r4031 16r63AD 16r4032 16r63AE 16r4033 16r63AF 16r4034 16r63BD 16r4035 16r63C1 16r4036 16r63C5 16r4037 16r63C8 16r4038 16r63CE 16r4039 16r63D1 16r403A 16r63D3 16r403B 16r63D4 16r403C 16r63D5 16r403D 16r63DC 16r403E 16r63E0 16r403F 16r63E5 16r4040 16r63EA 16r4041 16r63EC 16r4042 16r63F2 16r4043 16r63F3 16r4044 16r63F5 16r4045 16r63F8 16r4046 16r63F9 16r4047 16r6409 16r4048 16r640A 16r4049 16r6410 16r404A 16r6412 16r404B 16r6414 16r404C 16r6418 16r404D 16r641E 16r404E 16r6420 16r404F 16r6422 16r4050 16r6424 16r4051 16r6425 16r4052 16r6429 16r4053 16r642A 16r4054 16r642F 16r4055 16r6430 16r4056 16r6435 16r4057 16r643D 16r4058 16r643F 16r4059 16r644B 16r405A 16r644F 16r405B 16r6451 16r405C 16r6452 16r405D 16r6453 16r405E 16r6454 16r405F 16r645A 16r4060 16r645B 16r4061 16r645C 16r4062 16r645D 16r4063 16r645F 16r4064 16r6460 16r4065 16r6461 16r4066 16r6463 16r4067 16r646D 16r4068 16r6473 16r4069 16r6474 16r406A 16r647B 16r406B 16r647D 16r406C 16r6485 16r406D 16r6487 16r406E 16r648F 16r406F 16r6490 16r4070 16r6491 16r4071 16r6498 16r4072 16r6499 16r4073 16r649B 16r4074 16r649D 16r4075 16r649F 16r4076 16r64A1 16r4077 16r64A3 16r4078 16r64A6 16r4079 16r64A8 16r407A 16r64AC 16r407B 16r64B3 16r407C 16r64BD 16r407D 16r64BE 16r407E 16r64BF 16r4121 16r64C4 16r4122 16r64C9 16r4123 16r64CA 16r4124 16r64CB 16r4125 16r64CC 16r4126 16r64CE 16r4127 16r64D0 16r4128 16r64D1 16r4129 16r64D5 16r412A 16r64D7 16r412B 16r64E4 16r412C 16r64E5 16r412D 16r64E9 16r412E 16r64EA 16r412F 16r64ED 16r4130 16r64F0 16r4131 16r64F5 16r4132 16r64F7 16r4133 16r64FB 16r4134 16r64FF 16r4135 16r6501 16r4136 16r6504 16r4137 16r6508 16r4138 16r6509 16r4139 16r650A 16r413A 16r650F 16r413B 16r6513 16r413C 16r6514 16r413D 16r6516 16r413E 16r6519 16r413F 16r651B 16r4140 16r651E 16r4141 16r651F 16r4142 16r6522 16r4143 16r6526 16r4144 16r6529 16r4145 16r652E 16r4146 16r6531 16r4147 16r653A 16r4148 16r653C 16r4149 16r653D 16r414A 16r6543 16r414B 16r6547 16r414C 16r6549 16r414D 16r6550 16r414E 16r6552 16r414F 16r6554 16r4150 16r655F 16r4151 16r6560 16r4152 16r6567 16r4153 16r656B 16r4154 16r657A 16r4155 16r657D 16r4156 16r6581 16r4157 16r6585 16r4158 16r658A 16r4159 16r6592 16r415A 16r6595 16r415B 16r6598 16r415C 16r659D 16r415D 16r65A0 16r415E 16r65A3 16r415F 16r65A6 16r4160 16r65AE 16r4161 16r65B2 16r4162 16r65B3 16r4163 16r65B4 16r4164 16r65BF 16r4165 16r65C2 16r4166 16r65C8 16r4167 16r65C9 16r4168 16r65CE 16r4169 16r65D0 16r416A 16r65D4 16r416B 16r65D6 16r416C 16r65D8 16r416D 16r65DF 16r416E 16r65F0 16r416F 16r65F2 16r4170 16r65F4 16r4171 16r65F5 16r4172 16r65F9 16r4173 16r65FE 16r4174 16r65FF 16r4175 16r6600 16r4176 16r6604 16r4177 16r6608 16r4178 16r6609 16r4179 16r660D 16r417A 16r6611 16r417B 16r6612 16r417C 16r6615 16r417D 16r6616 16r417E 16r661D 16r4221 16r661E 16r4222 16r6621 16r4223 16r6622 16r4224 16r6623 16r4225 16r6624 16r4226 16r6626 16r4227 16r6629 16r4228 16r662A 16r4229 16r662B 16r422A 16r662C 16r422B 16r662E 16r422C 16r6630 16r422D 16r6631 16r422E 16r6633 16r422F 16r6639 16r4230 16r6637 16r4231 16r6640 16r4232 16r6645 16r4233 16r6646 16r4234 16r664A 16r4235 16r664C 16r4236 16r6651 16r4237 16r664E 16r4238 16r6657 16r4239 16r6658 16r423A 16r6659 16r423B 16r665B 16r423C 16r665C 16r423D 16r6660 16r423E 16r6661 16r423F 16r66FB 16r4240 16r666A 16r4241 16r666B 16r4242 16r666C 16r4243 16r667E 16r4244 16r6673 16r4245 16r6675 16r4246 16r667F 16r4247 16r6677 16r4248 16r6678 16r4249 16r6679 16r424A 16r667B 16r424B 16r6680 16r424C 16r667C 16r424D 16r668B 16r424E 16r668C 16r424F 16r668D 16r4250 16r6690 16r4251 16r6692 16r4252 16r6699 16r4253 16r669A 16r4254 16r669B 16r4255 16r669C 16r4256 16r669F 16r4257 16r66A0 16r4258 16r66A4 16r4259 16r66AD 16r425A 16r66B1 16r425B 16r66B2 16r425C 16r66B5 16r425D 16r66BB 16r425E 16r66BF 16r425F 16r66C0 16r4260 16r66C2 16r4261 16r66C3 16r4262 16r66C8 16r4263 16r66CC 16r4264 16r66CE 16r4265 16r66CF 16r4266 16r66D4 16r4267 16r66DB 16r4268 16r66DF 16r4269 16r66E8 16r426A 16r66EB 16r426B 16r66EC 16r426C 16r66EE 16r426D 16r66FA 16r426E 16r6705 16r426F 16r6707 16r4270 16r670E 16r4271 16r6713 16r4272 16r6719 16r4273 16r671C 16r4274 16r6720 16r4275 16r6722 16r4276 16r6733 16r4277 16r673E 16r4278 16r6745 16r4279 16r6747 16r427A 16r6748 16r427B 16r674C 16r427C 16r6754 16r427D 16r6755 16r427E 16r675D 16r4321 16r6766 16r4322 16r676C 16r4323 16r676E 16r4324 16r6774 16r4325 16r6776 16r4326 16r677B 16r4327 16r6781 16r4328 16r6784 16r4329 16r678E 16r432A 16r678F 16r432B 16r6791 16r432C 16r6793 16r432D 16r6796 16r432E 16r6798 16r432F 16r6799 16r4330 16r679B 16r4331 16r67B0 16r4332 16r67B1 16r4333 16r67B2 16r4334 16r67B5 16r4335 16r67BB 16r4336 16r67BC 16r4337 16r67BD 16r4338 16r67F9 16r4339 16r67C0 16r433A 16r67C2 16r433B 16r67C3 16r433C 16r67C5 16r433D 16r67C8 16r433E 16r67C9 16r433F 16r67D2 16r4340 16r67D7 16r4341 16r67D9 16r4342 16r67DC 16r4343 16r67E1 16r4344 16r67E6 16r4345 16r67F0 16r4346 16r67F2 16r4347 16r67F6 16r4348 16r67F7 16r4349 16r6852 16r434A 16r6814 16r434B 16r6819 16r434C 16r681D 16r434D 16r681F 16r434E 16r6828 16r434F 16r6827 16r4350 16r682C 16r4351 16r682D 16r4352 16r682F 16r4353 16r6830 16r4354 16r6831 16r4355 16r6833 16r4356 16r683B 16r4357 16r683F 16r4358 16r6844 16r4359 16r6845 16r435A 16r684A 16r435B 16r684C 16r435C 16r6855 16r435D 16r6857 16r435E 16r6858 16r435F 16r685B 16r4360 16r686B 16r4361 16r686E 16r4362 16r686F 16r4363 16r6870 16r4364 16r6871 16r4365 16r6872 16r4366 16r6875 16r4367 16r6879 16r4368 16r687A 16r4369 16r687B 16r436A 16r687C 16r436B 16r6882 16r436C 16r6884 16r436D 16r6886 16r436E 16r6888 16r436F 16r6896 16r4370 16r6898 16r4371 16r689A 16r4372 16r689C 16r4373 16r68A1 16r4374 16r68A3 16r4375 16r68A5 16r4376 16r68A9 16r4377 16r68AA 16r4378 16r68AE 16r4379 16r68B2 16r437A 16r68BB 16r437B 16r68C5 16r437C 16r68C8 16r437D 16r68CC 16r437E 16r68CF 16r4421 16r68D0 16r4422 16r68D1 16r4423 16r68D3 16r4424 16r68D6 16r4425 16r68D9 16r4426 16r68DC 16r4427 16r68DD 16r4428 16r68E5 16r4429 16r68E8 16r442A 16r68EA 16r442B 16r68EB 16r442C 16r68EC 16r442D 16r68ED 16r442E 16r68F0 16r442F 16r68F1 16r4430 16r68F5 16r4431 16r68F6 16r4432 16r68FB 16r4433 16r68FC 16r4434 16r68FD 16r4435 16r6906 16r4436 16r6909 16r4437 16r690A 16r4438 16r6910 16r4439 16r6911 16r443A 16r6913 16r443B 16r6916 16r443C 16r6917 16r443D 16r6931 16r443E 16r6933 16r443F 16r6935 16r4440 16r6938 16r4441 16r693B 16r4442 16r6942 16r4443 16r6945 16r4444 16r6949 16r4445 16r694E 16r4446 16r6957 16r4447 16r695B 16r4448 16r6963 16r4449 16r6964 16r444A 16r6965 16r444B 16r6966 16r444C 16r6968 16r444D 16r6969 16r444E 16r696C 16r444F 16r6970 16r4450 16r6971 16r4451 16r6972 16r4452 16r697A 16r4453 16r697B 16r4454 16r697F 16r4455 16r6980 16r4456 16r698D 16r4457 16r6992 16r4458 16r6996 16r4459 16r6998 16r445A 16r69A1 16r445B 16r69A5 16r445C 16r69A6 16r445D 16r69A8 16r445E 16r69AB 16r445F 16r69AD 16r4460 16r69AF 16r4461 16r69B7 16r4462 16r69B8 16r4463 16r69BA 16r4464 16r69BC 16r4465 16r69C5 16r4466 16r69C8 16r4467 16r69D1 16r4468 16r69D6 16r4469 16r69D7 16r446A 16r69E2 16r446B 16r69E5 16r446C 16r69EE 16r446D 16r69EF 16r446E 16r69F1 16r446F 16r69F3 16r4470 16r69F5 16r4471 16r69FE 16r4472 16r6A00 16r4473 16r6A01 16r4474 16r6A03 16r4475 16r6A0F 16r4476 16r6A11 16r4477 16r6A15 16r4478 16r6A1A 16r4479 16r6A1D 16r447A 16r6A20 16r447B 16r6A24 16r447C 16r6A28 16r447D 16r6A30 16r447E 16r6A32 16r4521 16r6A34 16r4522 16r6A37 16r4523 16r6A3B 16r4524 16r6A3E 16r4525 16r6A3F 16r4526 16r6A45 16r4527 16r6A46 16r4528 16r6A49 16r4529 16r6A4A 16r452A 16r6A4E 16r452B 16r6A50 16r452C 16r6A51 16r452D 16r6A52 16r452E 16r6A55 16r452F 16r6A56 16r4530 16r6A5B 16r4531 16r6A64 16r4532 16r6A67 16r4533 16r6A6A 16r4534 16r6A71 16r4535 16r6A73 16r4536 16r6A7E 16r4537 16r6A81 16r4538 16r6A83 16r4539 16r6A86 16r453A 16r6A87 16r453B 16r6A89 16r453C 16r6A8B 16r453D 16r6A91 16r453E 16r6A9B 16r453F 16r6A9D 16r4540 16r6A9E 16r4541 16r6A9F 16r4542 16r6AA5 16r4543 16r6AAB 16r4544 16r6AAF 16r4545 16r6AB0 16r4546 16r6AB1 16r4547 16r6AB4 16r4548 16r6ABD 16r4549 16r6ABE 16r454A 16r6ABF 16r454B 16r6AC6 16r454C 16r6AC9 16r454D 16r6AC8 16r454E 16r6ACC 16r454F 16r6AD0 16r4550 16r6AD4 16r4551 16r6AD5 16r4552 16r6AD6 16r4553 16r6ADC 16r4554 16r6ADD 16r4555 16r6AE4 16r4556 16r6AE7 16r4557 16r6AEC 16r4558 16r6AF0 16r4559 16r6AF1 16r455A 16r6AF2 16r455B 16r6AFC 16r455C 16r6AFD 16r455D 16r6B02 16r455E 16r6B03 16r455F 16r6B06 16r4560 16r6B07 16r4561 16r6B09 16r4562 16r6B0F 16r4563 16r6B10 16r4564 16r6B11 16r4565 16r6B17 16r4566 16r6B1B 16r4567 16r6B1E 16r4568 16r6B24 16r4569 16r6B28 16r456A 16r6B2B 16r456B 16r6B2C 16r456C 16r6B2F 16r456D 16r6B35 16r456E 16r6B36 16r456F 16r6B3B 16r4570 16r6B3F 16r4571 16r6B46 16r4572 16r6B4A 16r4573 16r6B4D 16r4574 16r6B52 16r4575 16r6B56 16r4576 16r6B58 16r4577 16r6B5D 16r4578 16r6B60 16r4579 16r6B67 16r457A 16r6B6B 16r457B 16r6B6E 16r457C 16r6B70 16r457D 16r6B75 16r457E 16r6B7D 16r4621 16r6B7E 16r4622 16r6B82 16r4623 16r6B85 16r4624 16r6B97 16r4625 16r6B9B 16r4626 16r6B9F 16r4627 16r6BA0 16r4628 16r6BA2 16r4629 16r6BA3 16r462A 16r6BA8 16r462B 16r6BA9 16r462C 16r6BAC 16r462D 16r6BAD 16r462E 16r6BAE 16r462F 16r6BB0 16r4630 16r6BB8 16r4631 16r6BB9 16r4632 16r6BBD 16r4633 16r6BBE 16r4634 16r6BC3 16r4635 16r6BC4 16r4636 16r6BC9 16r4637 16r6BCC 16r4638 16r6BD6 16r4639 16r6BDA 16r463A 16r6BE1 16r463B 16r6BE3 16r463C 16r6BE6 16r463D 16r6BE7 16r463E 16r6BEE 16r463F 16r6BF1 16r4640 16r6BF7 16r4641 16r6BF9 16r4642 16r6BFF 16r4643 16r6C02 16r4644 16r6C04 16r4645 16r6C05 16r4646 16r6C09 16r4647 16r6C0D 16r4648 16r6C0E 16r4649 16r6C10 16r464A 16r6C12 16r464B 16r6C19 16r464C 16r6C1F 16r464D 16r6C26 16r464E 16r6C27 16r464F 16r6C28 16r4650 16r6C2C 16r4651 16r6C2E 16r4652 16r6C33 16r4653 16r6C35 16r4654 16r6C36 16r4655 16r6C3A 16r4656 16r6C3B 16r4657 16r6C3F 16r4658 16r6C4A 16r4659 16r6C4B 16r465A 16r6C4D 16r465B 16r6C4F 16r465C 16r6C52 16r465D 16r6C54 16r465E 16r6C59 16r465F 16r6C5B 16r4660 16r6C5C 16r4661 16r6C6B 16r4662 16r6C6D 16r4663 16r6C6F 16r4664 16r6C74 16r4665 16r6C76 16r4666 16r6C78 16r4667 16r6C79 16r4668 16r6C7B 16r4669 16r6C85 16r466A 16r6C86 16r466B 16r6C87 16r466C 16r6C89 16r466D 16r6C94 16r466E 16r6C95 16r466F 16r6C97 16r4670 16r6C98 16r4671 16r6C9C 16r4672 16r6C9F 16r4673 16r6CB0 16r4674 16r6CB2 16r4675 16r6CB4 16r4676 16r6CC2 16r4677 16r6CC6 16r4678 16r6CCD 16r4679 16r6CCF 16r467A 16r6CD0 16r467B 16r6CD1 16r467C 16r6CD2 16r467D 16r6CD4 16r467E 16r6CD6 16r4721 16r6CDA 16r4722 16r6CDC 16r4723 16r6CE0 16r4724 16r6CE7 16r4725 16r6CE9 16r4726 16r6CEB 16r4727 16r6CEC 16r4728 16r6CEE 16r4729 16r6CF2 16r472A 16r6CF4 16r472B 16r6D04 16r472C 16r6D07 16r472D 16r6D0A 16r472E 16r6D0E 16r472F 16r6D0F 16r4730 16r6D11 16r4731 16r6D13 16r4732 16r6D1A 16r4733 16r6D26 16r4734 16r6D27 16r4735 16r6D28 16r4736 16r6C67 16r4737 16r6D2E 16r4738 16r6D2F 16r4739 16r6D31 16r473A 16r6D39 16r473B 16r6D3C 16r473C 16r6D3F 16r473D 16r6D57 16r473E 16r6D5E 16r473F 16r6D5F 16r4740 16r6D61 16r4741 16r6D65 16r4742 16r6D67 16r4743 16r6D6F 16r4744 16r6D70 16r4745 16r6D7C 16r4746 16r6D82 16r4747 16r6D87 16r4748 16r6D91 16r4749 16r6D92 16r474A 16r6D94 16r474B 16r6D96 16r474C 16r6D97 16r474D 16r6D98 16r474E 16r6DAA 16r474F 16r6DAC 16r4750 16r6DB4 16r4751 16r6DB7 16r4752 16r6DB9 16r4753 16r6DBD 16r4754 16r6DBF 16r4755 16r6DC4 16r4756 16r6DC8 16r4757 16r6DCA 16r4758 16r6DCE 16r4759 16r6DCF 16r475A 16r6DD6 16r475B 16r6DDB 16r475C 16r6DDD 16r475D 16r6DDF 16r475E 16r6DE0 16r475F 16r6DE2 16r4760 16r6DE5 16r4761 16r6DE9 16r4762 16r6DEF 16r4763 16r6DF0 16r4764 16r6DF4 16r4765 16r6DF6 16r4766 16r6DFC 16r4767 16r6E00 16r4768 16r6E04 16r4769 16r6E1E 16r476A 16r6E22 16r476B 16r6E27 16r476C 16r6E32 16r476D 16r6E36 16r476E 16r6E39 16r476F 16r6E3B 16r4770 16r6E3C 16r4771 16r6E44 16r4772 16r6E45 16r4773 16r6E48 16r4774 16r6E49 16r4775 16r6E4B 16r4776 16r6E4F 16r4777 16r6E51 16r4778 16r6E52 16r4779 16r6E53 16r477A 16r6E54 16r477B 16r6E57 16r477C 16r6E5C 16r477D 16r6E5D 16r477E 16r6E5E 16r4821 16r6E62 16r4822 16r6E63 16r4823 16r6E68 16r4824 16r6E73 16r4825 16r6E7B 16r4826 16r6E7D 16r4827 16r6E8D 16r4828 16r6E93 16r4829 16r6E99 16r482A 16r6EA0 16r482B 16r6EA7 16r482C 16r6EAD 16r482D 16r6EAE 16r482E 16r6EB1 16r482F 16r6EB3 16r4830 16r6EBB 16r4831 16r6EBF 16r4832 16r6EC0 16r4833 16r6EC1 16r4834 16r6EC3 16r4835 16r6EC7 16r4836 16r6EC8 16r4837 16r6ECA 16r4838 16r6ECD 16r4839 16r6ECE 16r483A 16r6ECF 16r483B 16r6EEB 16r483C 16r6EED 16r483D 16r6EEE 16r483E 16r6EF9 16r483F 16r6EFB 16r4840 16r6EFD 16r4841 16r6F04 16r4842 16r6F08 16r4843 16r6F0A 16r4844 16r6F0C 16r4845 16r6F0D 16r4846 16r6F16 16r4847 16r6F18 16r4848 16r6F1A 16r4849 16r6F1B 16r484A 16r6F26 16r484B 16r6F29 16r484C 16r6F2A 16r484D 16r6F2F 16r484E 16r6F30 16r484F 16r6F33 16r4850 16r6F36 16r4851 16r6F3B 16r4852 16r6F3C 16r4853 16r6F2D 16r4854 16r6F4F 16r4855 16r6F51 16r4856 16r6F52 16r4857 16r6F53 16r4858 16r6F57 16r4859 16r6F59 16r485A 16r6F5A 16r485B 16r6F5D 16r485C 16r6F5E 16r485D 16r6F61 16r485E 16r6F62 16r485F 16r6F68 16r4860 16r6F6C 16r4861 16r6F7D 16r4862 16r6F7E 16r4863 16r6F83 16r4864 16r6F87 16r4865 16r6F88 16r4866 16r6F8B 16r4867 16r6F8C 16r4868 16r6F8D 16r4869 16r6F90 16r486A 16r6F92 16r486B 16r6F93 16r486C 16r6F94 16r486D 16r6F96 16r486E 16r6F9A 16r486F 16r6F9F 16r4870 16r6FA0 16r4871 16r6FA5 16r4872 16r6FA6 16r4873 16r6FA7 16r4874 16r6FA8 16r4875 16r6FAE 16r4876 16r6FAF 16r4877 16r6FB0 16r4878 16r6FB5 16r4879 16r6FB6 16r487A 16r6FBC 16r487B 16r6FC5 16r487C 16r6FC7 16r487D 16r6FC8 16r487E 16r6FCA 16r4921 16r6FDA 16r4922 16r6FDE 16r4923 16r6FE8 16r4924 16r6FE9 16r4925 16r6FF0 16r4926 16r6FF5 16r4927 16r6FF9 16r4928 16r6FFC 16r4929 16r6FFD 16r492A 16r7000 16r492B 16r7005 16r492C 16r7006 16r492D 16r7007 16r492E 16r700D 16r492F 16r7017 16r4930 16r7020 16r4931 16r7023 16r4932 16r702F 16r4933 16r7034 16r4934 16r7037 16r4935 16r7039 16r4936 16r703C 16r4937 16r7043 16r4938 16r7044 16r4939 16r7048 16r493A 16r7049 16r493B 16r704A 16r493C 16r704B 16r493D 16r7054 16r493E 16r7055 16r493F 16r705D 16r4940 16r705E 16r4941 16r704E 16r4942 16r7064 16r4943 16r7065 16r4944 16r706C 16r4945 16r706E 16r4946 16r7075 16r4947 16r7076 16r4948 16r707E 16r4949 16r7081 16r494A 16r7085 16r494B 16r7086 16r494C 16r7094 16r494D 16r7095 16r494E 16r7096 16r494F 16r7097 16r4950 16r7098 16r4951 16r709B 16r4952 16r70A4 16r4953 16r70AB 16r4954 16r70B0 16r4955 16r70B1 16r4956 16r70B4 16r4957 16r70B7 16r4958 16r70CA 16r4959 16r70D1 16r495A 16r70D3 16r495B 16r70D4 16r495C 16r70D5 16r495D 16r70D6 16r495E 16r70D8 16r495F 16r70DC 16r4960 16r70E4 16r4961 16r70FA 16r4962 16r7103 16r4963 16r7104 16r4964 16r7105 16r4965 16r7106 16r4966 16r7107 16r4967 16r710B 16r4968 16r710C 16r4969 16r710F 16r496A 16r711E 16r496B 16r7120 16r496C 16r712B 16r496D 16r712D 16r496E 16r712F 16r496F 16r7130 16r4970 16r7131 16r4971 16r7138 16r4972 16r7141 16r4973 16r7145 16r4974 16r7146 16r4975 16r7147 16r4976 16r714A 16r4977 16r714B 16r4978 16r7150 16r4979 16r7152 16r497A 16r7157 16r497B 16r715A 16r497C 16r715C 16r497D 16r715E 16r497E 16r7160 16r4A21 16r7168 16r4A22 16r7179 16r4A23 16r7180 16r4A24 16r7185 16r4A25 16r7187 16r4A26 16r718C 16r4A27 16r7192 16r4A28 16r719A 16r4A29 16r719B 16r4A2A 16r71A0 16r4A2B 16r71A2 16r4A2C 16r71AF 16r4A2D 16r71B0 16r4A2E 16r71B2 16r4A2F 16r71B3 16r4A30 16r71BA 16r4A31 16r71BF 16r4A32 16r71C0 16r4A33 16r71C1 16r4A34 16r71C4 16r4A35 16r71CB 16r4A36 16r71CC 16r4A37 16r71D3 16r4A38 16r71D6 16r4A39 16r71D9 16r4A3A 16r71DA 16r4A3B 16r71DC 16r4A3C 16r71F8 16r4A3D 16r71FE 16r4A3E 16r7200 16r4A3F 16r7207 16r4A40 16r7208 16r4A41 16r7209 16r4A42 16r7213 16r4A43 16r7217 16r4A44 16r721A 16r4A45 16r721D 16r4A46 16r721F 16r4A47 16r7224 16r4A48 16r722B 16r4A49 16r722F 16r4A4A 16r7234 16r4A4B 16r7238 16r4A4C 16r7239 16r4A4D 16r7241 16r4A4E 16r7242 16r4A4F 16r7243 16r4A50 16r7245 16r4A51 16r724E 16r4A52 16r724F 16r4A53 16r7250 16r4A54 16r7253 16r4A55 16r7255 16r4A56 16r7256 16r4A57 16r725A 16r4A58 16r725C 16r4A59 16r725E 16r4A5A 16r7260 16r4A5B 16r7263 16r4A5C 16r7268 16r4A5D 16r726B 16r4A5E 16r726E 16r4A5F 16r726F 16r4A60 16r7271 16r4A61 16r7277 16r4A62 16r7278 16r4A63 16r727B 16r4A64 16r727C 16r4A65 16r727F 16r4A66 16r7284 16r4A67 16r7289 16r4A68 16r728D 16r4A69 16r728E 16r4A6A 16r7293 16r4A6B 16r729B 16r4A6C 16r72A8 16r4A6D 16r72AD 16r4A6E 16r72AE 16r4A6F 16r72B1 16r4A70 16r72B4 16r4A71 16r72BE 16r4A72 16r72C1 16r4A73 16r72C7 16r4A74 16r72C9 16r4A75 16r72CC 16r4A76 16r72D5 16r4A77 16r72D6 16r4A78 16r72D8 16r4A79 16r72DF 16r4A7A 16r72E5 16r4A7B 16r72F3 16r4A7C 16r72F4 16r4A7D 16r72FA 16r4A7E 16r72FB 16r4B21 16r72FE 16r4B22 16r7302 16r4B23 16r7304 16r4B24 16r7305 16r4B25 16r7307 16r4B26 16r730B 16r4B27 16r730D 16r4B28 16r7312 16r4B29 16r7313 16r4B2A 16r7318 16r4B2B 16r7319 16r4B2C 16r731E 16r4B2D 16r7322 16r4B2E 16r7324 16r4B2F 16r7327 16r4B30 16r7328 16r4B31 16r732C 16r4B32 16r7331 16r4B33 16r7332 16r4B34 16r7335 16r4B35 16r733A 16r4B36 16r733B 16r4B37 16r733D 16r4B38 16r7343 16r4B39 16r734D 16r4B3A 16r7350 16r4B3B 16r7352 16r4B3C 16r7356 16r4B3D 16r7358 16r4B3E 16r735D 16r4B3F 16r735E 16r4B40 16r735F 16r4B41 16r7360 16r4B42 16r7366 16r4B43 16r7367 16r4B44 16r7369 16r4B45 16r736B 16r4B46 16r736C 16r4B47 16r736E 16r4B48 16r736F 16r4B49 16r7371 16r4B4A 16r7377 16r4B4B 16r7379 16r4B4C 16r737C 16r4B4D 16r7380 16r4B4E 16r7381 16r4B4F 16r7383 16r4B50 16r7385 16r4B51 16r7386 16r4B52 16r738E 16r4B53 16r7390 16r4B54 16r7393 16r4B55 16r7395 16r4B56 16r7397 16r4B57 16r7398 16r4B58 16r739C 16r4B59 16r739E 16r4B5A 16r739F 16r4B5B 16r73A0 16r4B5C 16r73A2 16r4B5D 16r73A5 16r4B5E 16r73A6 16r4B5F 16r73AA 16r4B60 16r73AB 16r4B61 16r73AD 16r4B62 16r73B5 16r4B63 16r73B7 16r4B64 16r73B9 16r4B65 16r73BC 16r4B66 16r73BD 16r4B67 16r73BF 16r4B68 16r73C5 16r4B69 16r73C6 16r4B6A 16r73C9 16r4B6B 16r73CB 16r4B6C 16r73CC 16r4B6D 16r73CF 16r4B6E 16r73D2 16r4B6F 16r73D3 16r4B70 16r73D6 16r4B71 16r73D9 16r4B72 16r73DD 16r4B73 16r73E1 16r4B74 16r73E3 16r4B75 16r73E6 16r4B76 16r73E7 16r4B77 16r73E9 16r4B78 16r73F4 16r4B79 16r73F5 16r4B7A 16r73F7 16r4B7B 16r73F9 16r4B7C 16r73FA 16r4B7D 16r73FB 16r4B7E 16r73FD 16r4C21 16r73FF 16r4C22 16r7400 16r4C23 16r7401 16r4C24 16r7404 16r4C25 16r7407 16r4C26 16r740A 16r4C27 16r7411 16r4C28 16r741A 16r4C29 16r741B 16r4C2A 16r7424 16r4C2B 16r7426 16r4C2C 16r7428 16r4C2D 16r7429 16r4C2E 16r742A 16r4C2F 16r742B 16r4C30 16r742C 16r4C31 16r742D 16r4C32 16r742E 16r4C33 16r742F 16r4C34 16r7430 16r4C35 16r7431 16r4C36 16r7439 16r4C37 16r7440 16r4C38 16r7443 16r4C39 16r7444 16r4C3A 16r7446 16r4C3B 16r7447 16r4C3C 16r744B 16r4C3D 16r744D 16r4C3E 16r7451 16r4C3F 16r7452 16r4C40 16r7457 16r4C41 16r745D 16r4C42 16r7462 16r4C43 16r7466 16r4C44 16r7467 16r4C45 16r7468 16r4C46 16r746B 16r4C47 16r746D 16r4C48 16r746E 16r4C49 16r7471 16r4C4A 16r7472 16r4C4B 16r7480 16r4C4C 16r7481 16r4C4D 16r7485 16r4C4E 16r7486 16r4C4F 16r7487 16r4C50 16r7489 16r4C51 16r748F 16r4C52 16r7490 16r4C53 16r7491 16r4C54 16r7492 16r4C55 16r7498 16r4C56 16r7499 16r4C57 16r749A 16r4C58 16r749C 16r4C59 16r749F 16r4C5A 16r74A0 16r4C5B 16r74A1 16r4C5C 16r74A3 16r4C5D 16r74A6 16r4C5E 16r74A8 16r4C5F 16r74A9 16r4C60 16r74AA 16r4C61 16r74AB 16r4C62 16r74AE 16r4C63 16r74AF 16r4C64 16r74B1 16r4C65 16r74B2 16r4C66 16r74B5 16r4C67 16r74B9 16r4C68 16r74BB 16r4C69 16r74BF 16r4C6A 16r74C8 16r4C6B 16r74C9 16r4C6C 16r74CC 16r4C6D 16r74D0 16r4C6E 16r74D3 16r4C6F 16r74D8 16r4C70 16r74DA 16r4C71 16r74DB 16r4C72 16r74DE 16r4C73 16r74DF 16r4C74 16r74E4 16r4C75 16r74E8 16r4C76 16r74EA 16r4C77 16r74EB 16r4C78 16r74EF 16r4C79 16r74F4 16r4C7A 16r74FA 16r4C7B 16r74FB 16r4C7C 16r74FC 16r4C7D 16r74FF 16r4C7E 16r7506 16r4D21 16r7512 16r4D22 16r7516 16r4D23 16r7517 16r4D24 16r7520 16r4D25 16r7521 16r4D26 16r7524 16r4D27 16r7527 16r4D28 16r7529 16r4D29 16r752A 16r4D2A 16r752F 16r4D2B 16r7536 16r4D2C 16r7539 16r4D2D 16r753D 16r4D2E 16r753E 16r4D2F 16r753F 16r4D30 16r7540 16r4D31 16r7543 16r4D32 16r7547 16r4D33 16r7548 16r4D34 16r754E 16r4D35 16r7550 16r4D36 16r7552 16r4D37 16r7557 16r4D38 16r755E 16r4D39 16r755F 16r4D3A 16r7561 16r4D3B 16r756F 16r4D3C 16r7571 16r4D3D 16r7579 16r4D3E 16r757A 16r4D3F 16r757B 16r4D40 16r757C 16r4D41 16r757D 16r4D42 16r757E 16r4D43 16r7581 16r4D44 16r7585 16r4D45 16r7590 16r4D46 16r7592 16r4D47 16r7593 16r4D48 16r7595 16r4D49 16r7599 16r4D4A 16r759C 16r4D4B 16r75A2 16r4D4C 16r75A4 16r4D4D 16r75B4 16r4D4E 16r75BA 16r4D4F 16r75BF 16r4D50 16r75C0 16r4D51 16r75C1 16r4D52 16r75C4 16r4D53 16r75C6 16r4D54 16r75CC 16r4D55 16r75CE 16r4D56 16r75CF 16r4D57 16r75D7 16r4D58 16r75DC 16r4D59 16r75DF 16r4D5A 16r75E0 16r4D5B 16r75E1 16r4D5C 16r75E4 16r4D5D 16r75E7 16r4D5E 16r75EC 16r4D5F 16r75EE 16r4D60 16r75EF 16r4D61 16r75F1 16r4D62 16r75F9 16r4D63 16r7600 16r4D64 16r7602 16r4D65 16r7603 16r4D66 16r7604 16r4D67 16r7607 16r4D68 16r7608 16r4D69 16r760A 16r4D6A 16r760C 16r4D6B 16r760F 16r4D6C 16r7612 16r4D6D 16r7613 16r4D6E 16r7615 16r4D6F 16r7616 16r4D70 16r7619 16r4D71 16r761B 16r4D72 16r761C 16r4D73 16r761D 16r4D74 16r761E 16r4D75 16r7623 16r4D76 16r7625 16r4D77 16r7626 16r4D78 16r7629 16r4D79 16r762D 16r4D7A 16r7632 16r4D7B 16r7633 16r4D7C 16r7635 16r4D7D 16r7638 16r4D7E 16r7639 16r4E21 16r763A 16r4E22 16r763C 16r4E23 16r764A 16r4E24 16r7640 16r4E25 16r7641 16r4E26 16r7643 16r4E27 16r7644 16r4E28 16r7645 16r4E29 16r7649 16r4E2A 16r764B 16r4E2B 16r7655 16r4E2C 16r7659 16r4E2D 16r765F 16r4E2E 16r7664 16r4E2F 16r7665 16r4E30 16r766D 16r4E31 16r766E 16r4E32 16r766F 16r4E33 16r7671 16r4E34 16r7674 16r4E35 16r7681 16r4E36 16r7685 16r4E37 16r768C 16r4E38 16r768D 16r4E39 16r7695 16r4E3A 16r769B 16r4E3B 16r769C 16r4E3C 16r769D 16r4E3D 16r769F 16r4E3E 16r76A0 16r4E3F 16r76A2 16r4E40 16r76A3 16r4E41 16r76A4 16r4E42 16r76A5 16r4E43 16r76A6 16r4E44 16r76A7 16r4E45 16r76A8 16r4E46 16r76AA 16r4E47 16r76AD 16r4E48 16r76BD 16r4E49 16r76C1 16r4E4A 16r76C5 16r4E4B 16r76C9 16r4E4C 16r76CB 16r4E4D 16r76CC 16r4E4E 16r76CE 16r4E4F 16r76D4 16r4E50 16r76D9 16r4E51 16r76E0 16r4E52 16r76E6 16r4E53 16r76E8 16r4E54 16r76EC 16r4E55 16r76F0 16r4E56 16r76F1 16r4E57 16r76F6 16r4E58 16r76F9 16r4E59 16r76FC 16r4E5A 16r7700 16r4E5B 16r7706 16r4E5C 16r770A 16r4E5D 16r770E 16r4E5E 16r7712 16r4E5F 16r7714 16r4E60 16r7715 16r4E61 16r7717 16r4E62 16r7719 16r4E63 16r771A 16r4E64 16r771C 16r4E65 16r7722 16r4E66 16r7728 16r4E67 16r772D 16r4E68 16r772E 16r4E69 16r772F 16r4E6A 16r7734 16r4E6B 16r7735 16r4E6C 16r7736 16r4E6D 16r7739 16r4E6E 16r773D 16r4E6F 16r773E 16r4E70 16r7742 16r4E71 16r7745 16r4E72 16r7746 16r4E73 16r774A 16r4E74 16r774D 16r4E75 16r774E 16r4E76 16r774F 16r4E77 16r7752 16r4E78 16r7756 16r4E79 16r7757 16r4E7A 16r775C 16r4E7B 16r775E 16r4E7C 16r775F 16r4E7D 16r7760 16r4E7E 16r7762 16r4F21 16r7764 16r4F22 16r7767 16r4F23 16r776A 16r4F24 16r776C 16r4F25 16r7770 16r4F26 16r7772 16r4F27 16r7773 16r4F28 16r7774 16r4F29 16r777A 16r4F2A 16r777D 16r4F2B 16r7780 16r4F2C 16r7784 16r4F2D 16r778C 16r4F2E 16r778D 16r4F2F 16r7794 16r4F30 16r7795 16r4F31 16r7796 16r4F32 16r779A 16r4F33 16r779F 16r4F34 16r77A2 16r4F35 16r77A7 16r4F36 16r77AA 16r4F37 16r77AE 16r4F38 16r77AF 16r4F39 16r77B1 16r4F3A 16r77B5 16r4F3B 16r77BE 16r4F3C 16r77C3 16r4F3D 16r77C9 16r4F3E 16r77D1 16r4F3F 16r77D2 16r4F40 16r77D5 16r4F41 16r77D9 16r4F42 16r77DE 16r4F43 16r77DF 16r4F44 16r77E0 16r4F45 16r77E4 16r4F46 16r77E6 16r4F47 16r77EA 16r4F48 16r77EC 16r4F49 16r77F0 16r4F4A 16r77F1 16r4F4B 16r77F4 16r4F4C 16r77F8 16r4F4D 16r77FB 16r4F4E 16r7805 16r4F4F 16r7806 16r4F50 16r7809 16r4F51 16r780D 16r4F52 16r780E 16r4F53 16r7811 16r4F54 16r781D 16r4F55 16r7821 16r4F56 16r7822 16r4F57 16r7823 16r4F58 16r782D 16r4F59 16r782E 16r4F5A 16r7830 16r4F5B 16r7835 16r4F5C 16r7837 16r4F5D 16r7843 16r4F5E 16r7844 16r4F5F 16r7847 16r4F60 16r7848 16r4F61 16r784C 16r4F62 16r784E 16r4F63 16r7852 16r4F64 16r785C 16r4F65 16r785E 16r4F66 16r7860 16r4F67 16r7861 16r4F68 16r7863 16r4F69 16r7864 16r4F6A 16r7868 16r4F6B 16r786A 16r4F6C 16r786E 16r4F6D 16r787A 16r4F6E 16r787E 16r4F6F 16r788A 16r4F70 16r788F 16r4F71 16r7894 16r4F72 16r7898 16r4F73 16r78A1 16r4F74 16r789D 16r4F75 16r789E 16r4F76 16r789F 16r4F77 16r78A4 16r4F78 16r78A8 16r4F79 16r78AC 16r4F7A 16r78AD 16r4F7B 16r78B0 16r4F7C 16r78B1 16r4F7D 16r78B2 16r4F7E 16r78B3 16r5021 16r78BB 16r5022 16r78BD 16r5023 16r78BF 16r5024 16r78C7 16r5025 16r78C8 16r5026 16r78C9 16r5027 16r78CC 16r5028 16r78CE 16r5029 16r78D2 16r502A 16r78D3 16r502B 16r78D5 16r502C 16r78D6 16r502D 16r78E4 16r502E 16r78DB 16r502F 16r78DF 16r5030 16r78E0 16r5031 16r78E1 16r5032 16r78E6 16r5033 16r78EA 16r5034 16r78F2 16r5035 16r78F3 16r5036 16r7900 16r5037 16r78F6 16r5038 16r78F7 16r5039 16r78FA 16r503A 16r78FB 16r503B 16r78FF 16r503C 16r7906 16r503D 16r790C 16r503E 16r7910 16r503F 16r791A 16r5040 16r791C 16r5041 16r791E 16r5042 16r791F 16r5043 16r7920 16r5044 16r7925 16r5045 16r7927 16r5046 16r7929 16r5047 16r792D 16r5048 16r7931 16r5049 16r7934 16r504A 16r7935 16r504B 16r793B 16r504C 16r793D 16r504D 16r793F 16r504E 16r7944 16r504F 16r7945 16r5050 16r7946 16r5051 16r794A 16r5052 16r794B 16r5053 16r794F 16r5054 16r7951 16r5055 16r7954 16r5056 16r7958 16r5057 16r795B 16r5058 16r795C 16r5059 16r7967 16r505A 16r7969 16r505B 16r796B 16r505C 16r7972 16r505D 16r7979 16r505E 16r797B 16r505F 16r797C 16r5060 16r797E 16r5061 16r798B 16r5062 16r798C 16r5063 16r7991 16r5064 16r7993 16r5065 16r7994 16r5066 16r7995 16r5067 16r7996 16r5068 16r7998 16r5069 16r799B 16r506A 16r799C 16r506B 16r79A1 16r506C 16r79A8 16r506D 16r79A9 16r506E 16r79AB 16r506F 16r79AF 16r5070 16r79B1 16r5071 16r79B4 16r5072 16r79B8 16r5073 16r79BB 16r5074 16r79C2 16r5075 16r79C4 16r5076 16r79C7 16r5077 16r79C8 16r5078 16r79CA 16r5079 16r79CF 16r507A 16r79D4 16r507B 16r79D6 16r507C 16r79DA 16r507D 16r79DD 16r507E 16r79DE 16r5121 16r79E0 16r5122 16r79E2 16r5123 16r79E5 16r5124 16r79EA 16r5125 16r79EB 16r5126 16r79ED 16r5127 16r79F1 16r5128 16r79F8 16r5129 16r79FC 16r512A 16r7A02 16r512B 16r7A03 16r512C 16r7A07 16r512D 16r7A09 16r512E 16r7A0A 16r512F 16r7A0C 16r5130 16r7A11 16r5131 16r7A15 16r5132 16r7A1B 16r5133 16r7A1E 16r5134 16r7A21 16r5135 16r7A27 16r5136 16r7A2B 16r5137 16r7A2D 16r5138 16r7A2F 16r5139 16r7A30 16r513A 16r7A34 16r513B 16r7A35 16r513C 16r7A38 16r513D 16r7A39 16r513E 16r7A3A 16r513F 16r7A44 16r5140 16r7A45 16r5141 16r7A47 16r5142 16r7A48 16r5143 16r7A4C 16r5144 16r7A55 16r5145 16r7A56 16r5146 16r7A59 16r5147 16r7A5C 16r5148 16r7A5D 16r5149 16r7A5F 16r514A 16r7A60 16r514B 16r7A65 16r514C 16r7A67 16r514D 16r7A6A 16r514E 16r7A6D 16r514F 16r7A75 16r5150 16r7A78 16r5151 16r7A7E 16r5152 16r7A80 16r5153 16r7A82 16r5154 16r7A85 16r5155 16r7A86 16r5156 16r7A8A 16r5157 16r7A8B 16r5158 16r7A90 16r5159 16r7A91 16r515A 16r7A94 16r515B 16r7A9E 16r515C 16r7AA0 16r515D 16r7AA3 16r515E 16r7AAC 16r515F 16r7AB3 16r5160 16r7AB5 16r5161 16r7AB9 16r5162 16r7ABB 16r5163 16r7ABC 16r5164 16r7AC6 16r5165 16r7AC9 16r5166 16r7ACC 16r5167 16r7ACE 16r5168 16r7AD1 16r5169 16r7ADB 16r516A 16r7AE8 16r516B 16r7AE9 16r516C 16r7AEB 16r516D 16r7AEC 16r516E 16r7AF1 16r516F 16r7AF4 16r5170 16r7AFB 16r5171 16r7AFD 16r5172 16r7AFE 16r5173 16r7B07 16r5174 16r7B14 16r5175 16r7B1F 16r5176 16r7B23 16r5177 16r7B27 16r5178 16r7B29 16r5179 16r7B2A 16r517A 16r7B2B 16r517B 16r7B2D 16r517C 16r7B2E 16r517D 16r7B2F 16r517E 16r7B30 16r5221 16r7B31 16r5222 16r7B34 16r5223 16r7B3D 16r5224 16r7B3F 16r5225 16r7B40 16r5226 16r7B41 16r5227 16r7B47 16r5228 16r7B4E 16r5229 16r7B55 16r522A 16r7B60 16r522B 16r7B64 16r522C 16r7B66 16r522D 16r7B69 16r522E 16r7B6A 16r522F 16r7B6D 16r5230 16r7B6F 16r5231 16r7B72 16r5232 16r7B73 16r5233 16r7B77 16r5234 16r7B84 16r5235 16r7B89 16r5236 16r7B8E 16r5237 16r7B90 16r5238 16r7B91 16r5239 16r7B96 16r523A 16r7B9B 16r523B 16r7B9E 16r523C 16r7BA0 16r523D 16r7BA5 16r523E 16r7BAC 16r523F 16r7BAF 16r5240 16r7BB0 16r5241 16r7BB2 16r5242 16r7BB5 16r5243 16r7BB6 16r5244 16r7BBA 16r5245 16r7BBB 16r5246 16r7BBC 16r5247 16r7BBD 16r5248 16r7BC2 16r5249 16r7BC5 16r524A 16r7BC8 16r524B 16r7BCA 16r524C 16r7BD4 16r524D 16r7BD6 16r524E 16r7BD7 16r524F 16r7BD9 16r5250 16r7BDA 16r5251 16r7BDB 16r5252 16r7BE8 16r5253 16r7BEA 16r5254 16r7BF2 16r5255 16r7BF4 16r5256 16r7BF5 16r5257 16r7BF8 16r5258 16r7BF9 16r5259 16r7BFA 16r525A 16r7BFC 16r525B 16r7BFE 16r525C 16r7C01 16r525D 16r7C02 16r525E 16r7C03 16r525F 16r7C04 16r5260 16r7C06 16r5261 16r7C09 16r5262 16r7C0B 16r5263 16r7C0C 16r5264 16r7C0E 16r5265 16r7C0F 16r5266 16r7C19 16r5267 16r7C1B 16r5268 16r7C20 16r5269 16r7C25 16r526A 16r7C26 16r526B 16r7C28 16r526C 16r7C2C 16r526D 16r7C31 16r526E 16r7C33 16r526F 16r7C34 16r5270 16r7C36 16r5271 16r7C39 16r5272 16r7C3A 16r5273 16r7C46 16r5274 16r7C4A 16r5275 16r7C55 16r5276 16r7C51 16r5277 16r7C52 16r5278 16r7C53 16r5279 16r7C59 16r527A 16r7C5A 16r527B 16r7C5B 16r527C 16r7C5C 16r527D 16r7C5D 16r527E 16r7C5E 16r5321 16r7C61 16r5322 16r7C63 16r5323 16r7C67 16r5324 16r7C69 16r5325 16r7C6D 16r5326 16r7C6E 16r5327 16r7C70 16r5328 16r7C72 16r5329 16r7C79 16r532A 16r7C7C 16r532B 16r7C7D 16r532C 16r7C86 16r532D 16r7C87 16r532E 16r7C8F 16r532F 16r7C94 16r5330 16r7C9E 16r5331 16r7CA0 16r5332 16r7CA6 16r5333 16r7CB0 16r5334 16r7CB6 16r5335 16r7CB7 16r5336 16r7CBA 16r5337 16r7CBB 16r5338 16r7CBC 16r5339 16r7CBF 16r533A 16r7CC4 16r533B 16r7CC7 16r533C 16r7CC8 16r533D 16r7CC9 16r533E 16r7CCD 16r533F 16r7CCF 16r5340 16r7CD3 16r5341 16r7CD4 16r5342 16r7CD5 16r5343 16r7CD7 16r5344 16r7CD9 16r5345 16r7CDA 16r5346 16r7CDD 16r5347 16r7CE6 16r5348 16r7CE9 16r5349 16r7CEB 16r534A 16r7CF5 16r534B 16r7D03 16r534C 16r7D07 16r534D 16r7D08 16r534E 16r7D09 16r534F 16r7D0F 16r5350 16r7D11 16r5351 16r7D12 16r5352 16r7D13 16r5353 16r7D16 16r5354 16r7D1D 16r5355 16r7D1E 16r5356 16r7D23 16r5357 16r7D26 16r5358 16r7D2A 16r5359 16r7D2D 16r535A 16r7D31 16r535B 16r7D3C 16r535C 16r7D3D 16r535D 16r7D3E 16r535E 16r7D40 16r535F 16r7D41 16r5360 16r7D47 16r5361 16r7D48 16r5362 16r7D4D 16r5363 16r7D51 16r5364 16r7D53 16r5365 16r7D57 16r5366 16r7D59 16r5367 16r7D5A 16r5368 16r7D5C 16r5369 16r7D5D 16r536A 16r7D65 16r536B 16r7D67 16r536C 16r7D6A 16r536D 16r7D70 16r536E 16r7D78 16r536F 16r7D7A 16r5370 16r7D7B 16r5371 16r7D7F 16r5372 16r7D81 16r5373 16r7D82 16r5374 16r7D83 16r5375 16r7D85 16r5376 16r7D86 16r5377 16r7D88 16r5378 16r7D8B 16r5379 16r7D8C 16r537A 16r7D8D 16r537B 16r7D91 16r537C 16r7D96 16r537D 16r7D97 16r537E 16r7D9D 16r5421 16r7D9E 16r5422 16r7DA6 16r5423 16r7DA7 16r5424 16r7DAA 16r5425 16r7DB3 16r5426 16r7DB6 16r5427 16r7DB7 16r5428 16r7DB9 16r5429 16r7DC2 16r542A 16r7DC3 16r542B 16r7DC4 16r542C 16r7DC5 16r542D 16r7DC6 16r542E 16r7DCC 16r542F 16r7DCD 16r5430 16r7DCE 16r5431 16r7DD7 16r5432 16r7DD9 16r5433 16r7E00 16r5434 16r7DE2 16r5435 16r7DE5 16r5436 16r7DE6 16r5437 16r7DEA 16r5438 16r7DEB 16r5439 16r7DED 16r543A 16r7DF1 16r543B 16r7DF5 16r543C 16r7DF6 16r543D 16r7DF9 16r543E 16r7DFA 16r543F 16r7E08 16r5440 16r7E10 16r5441 16r7E11 16r5442 16r7E15 16r5443 16r7E17 16r5444 16r7E1C 16r5445 16r7E1D 16r5446 16r7E20 16r5447 16r7E27 16r5448 16r7E28 16r5449 16r7E2C 16r544A 16r7E2D 16r544B 16r7E2F 16r544C 16r7E33 16r544D 16r7E36 16r544E 16r7E3F 16r544F 16r7E44 16r5450 16r7E45 16r5451 16r7E47 16r5452 16r7E4E 16r5453 16r7E50 16r5454 16r7E52 16r5455 16r7E58 16r5456 16r7E5F 16r5457 16r7E61 16r5458 16r7E62 16r5459 16r7E65 16r545A 16r7E6B 16r545B 16r7E6E 16r545C 16r7E6F 16r545D 16r7E73 16r545E 16r7E78 16r545F 16r7E7E 16r5460 16r7E81 16r5461 16r7E86 16r5462 16r7E87 16r5463 16r7E8A 16r5464 16r7E8D 16r5465 16r7E91 16r5466 16r7E95 16r5467 16r7E98 16r5468 16r7E9A 16r5469 16r7E9D 16r546A 16r7E9E 16r546B 16r7F3C 16r546C 16r7F3B 16r546D 16r7F3D 16r546E 16r7F3E 16r546F 16r7F3F 16r5470 16r7F43 16r5471 16r7F44 16r5472 16r7F47 16r5473 16r7F4F 16r5474 16r7F52 16r5475 16r7F53 16r5476 16r7F5B 16r5477 16r7F5C 16r5478 16r7F5D 16r5479 16r7F61 16r547A 16r7F63 16r547B 16r7F64 16r547C 16r7F65 16r547D 16r7F66 16r547E 16r7F6D 16r5521 16r7F71 16r5522 16r7F7D 16r5523 16r7F7E 16r5524 16r7F7F 16r5525 16r7F80 16r5526 16r7F8B 16r5527 16r7F8D 16r5528 16r7F8F 16r5529 16r7F90 16r552A 16r7F91 16r552B 16r7F96 16r552C 16r7F97 16r552D 16r7F9C 16r552E 16r7FA1 16r552F 16r7FA2 16r5530 16r7FA6 16r5531 16r7FAA 16r5532 16r7FAD 16r5533 16r7FB4 16r5534 16r7FBC 16r5535 16r7FBF 16r5536 16r7FC0 16r5537 16r7FC3 16r5538 16r7FC8 16r5539 16r7FCE 16r553A 16r7FCF 16r553B 16r7FDB 16r553C 16r7FDF 16r553D 16r7FE3 16r553E 16r7FE5 16r553F 16r7FE8 16r5540 16r7FEC 16r5541 16r7FEE 16r5542 16r7FEF 16r5543 16r7FF2 16r5544 16r7FFA 16r5545 16r7FFD 16r5546 16r7FFE 16r5547 16r7FFF 16r5548 16r8007 16r5549 16r8008 16r554A 16r800A 16r554B 16r800D 16r554C 16r800E 16r554D 16r800F 16r554E 16r8011 16r554F 16r8013 16r5550 16r8014 16r5551 16r8016 16r5552 16r801D 16r5553 16r801E 16r5554 16r801F 16r5555 16r8020 16r5556 16r8024 16r5557 16r8026 16r5558 16r802C 16r5559 16r802E 16r555A 16r8030 16r555B 16r8034 16r555C 16r8035 16r555D 16r8037 16r555E 16r8039 16r555F 16r803A 16r5560 16r803C 16r5561 16r803E 16r5562 16r8040 16r5563 16r8044 16r5564 16r8060 16r5565 16r8064 16r5566 16r8066 16r5567 16r806D 16r5568 16r8071 16r5569 16r8075 16r556A 16r8081 16r556B 16r8088 16r556C 16r808E 16r556D 16r809C 16r556E 16r809E 16r556F 16r80A6 16r5570 16r80A7 16r5571 16r80AB 16r5572 16r80B8 16r5573 16r80B9 16r5574 16r80C8 16r5575 16r80CD 16r5576 16r80CF 16r5577 16r80D2 16r5578 16r80D4 16r5579 16r80D5 16r557A 16r80D7 16r557B 16r80D8 16r557C 16r80E0 16r557D 16r80ED 16r557E 16r80EE 16r5621 16r80F0 16r5622 16r80F2 16r5623 16r80F3 16r5624 16r80F6 16r5625 16r80F9 16r5626 16r80FA 16r5627 16r80FE 16r5628 16r8103 16r5629 16r810B 16r562A 16r8116 16r562B 16r8117 16r562C 16r8118 16r562D 16r811C 16r562E 16r811E 16r562F 16r8120 16r5630 16r8124 16r5631 16r8127 16r5632 16r812C 16r5633 16r8130 16r5634 16r8135 16r5635 16r813A 16r5636 16r813C 16r5637 16r8145 16r5638 16r8147 16r5639 16r814A 16r563A 16r814C 16r563B 16r8152 16r563C 16r8157 16r563D 16r8160 16r563E 16r8161 16r563F 16r8167 16r5640 16r8168 16r5641 16r8169 16r5642 16r816D 16r5643 16r816F 16r5644 16r8177 16r5645 16r8181 16r5646 16r8190 16r5647 16r8184 16r5648 16r8185 16r5649 16r8186 16r564A 16r818B 16r564B 16r818E 16r564C 16r8196 16r564D 16r8198 16r564E 16r819B 16r564F 16r819E 16r5650 16r81A2 16r5651 16r81AE 16r5652 16r81B2 16r5653 16r81B4 16r5654 16r81BB 16r5655 16r81CB 16r5656 16r81C3 16r5657 16r81C5 16r5658 16r81CA 16r5659 16r81CE 16r565A 16r81CF 16r565B 16r81D5 16r565C 16r81D7 16r565D 16r81DB 16r565E 16r81DD 16r565F 16r81DE 16r5660 16r81E1 16r5661 16r81E4 16r5662 16r81EB 16r5663 16r81EC 16r5664 16r81F0 16r5665 16r81F1 16r5666 16r81F2 16r5667 16r81F5 16r5668 16r81F6 16r5669 16r81F8 16r566A 16r81F9 16r566B 16r81FD 16r566C 16r81FF 16r566D 16r8200 16r566E 16r8203 16r566F 16r820F 16r5670 16r8213 16r5671 16r8214 16r5672 16r8219 16r5673 16r821A 16r5674 16r821D 16r5675 16r8221 16r5676 16r8222 16r5677 16r8228 16r5678 16r8232 16r5679 16r8234 16r567A 16r823A 16r567B 16r8243 16r567C 16r8244 16r567D 16r8245 16r567E 16r8246 16r5721 16r824B 16r5722 16r824E 16r5723 16r824F 16r5724 16r8251 16r5725 16r8256 16r5726 16r825C 16r5727 16r8260 16r5728 16r8263 16r5729 16r8267 16r572A 16r826D 16r572B 16r8274 16r572C 16r827B 16r572D 16r827D 16r572E 16r827F 16r572F 16r8280 16r5730 16r8281 16r5731 16r8283 16r5732 16r8284 16r5733 16r8287 16r5734 16r8289 16r5735 16r828A 16r5736 16r828E 16r5737 16r8291 16r5738 16r8294 16r5739 16r8296 16r573A 16r8298 16r573B 16r829A 16r573C 16r829B 16r573D 16r82A0 16r573E 16r82A1 16r573F 16r82A3 16r5740 16r82A4 16r5741 16r82A7 16r5742 16r82A8 16r5743 16r82A9 16r5744 16r82AA 16r5745 16r82AE 16r5746 16r82B0 16r5747 16r82B2 16r5748 16r82B4 16r5749 16r82B7 16r574A 16r82BA 16r574B 16r82BC 16r574C 16r82BE 16r574D 16r82BF 16r574E 16r82C6 16r574F 16r82D0 16r5750 16r82D5 16r5751 16r82DA 16r5752 16r82E0 16r5753 16r82E2 16r5754 16r82E4 16r5755 16r82E8 16r5756 16r82EA 16r5757 16r82ED 16r5758 16r82EF 16r5759 16r82F6 16r575A 16r82F7 16r575B 16r82FD 16r575C 16r82FE 16r575D 16r8300 16r575E 16r8301 16r575F 16r8307 16r5760 16r8308 16r5761 16r830A 16r5762 16r830B 16r5763 16r8354 16r5764 16r831B 16r5765 16r831D 16r5766 16r831E 16r5767 16r831F 16r5768 16r8321 16r5769 16r8322 16r576A 16r832C 16r576B 16r832D 16r576C 16r832E 16r576D 16r8330 16r576E 16r8333 16r576F 16r8337 16r5770 16r833A 16r5771 16r833C 16r5772 16r833D 16r5773 16r8342 16r5774 16r8343 16r5775 16r8344 16r5776 16r8347 16r5777 16r834D 16r5778 16r834E 16r5779 16r8351 16r577A 16r8355 16r577B 16r8356 16r577C 16r8357 16r577D 16r8370 16r577E 16r8378 16r5821 16r837D 16r5822 16r837F 16r5823 16r8380 16r5824 16r8382 16r5825 16r8384 16r5826 16r8386 16r5827 16r838D 16r5828 16r8392 16r5829 16r8394 16r582A 16r8395 16r582B 16r8398 16r582C 16r8399 16r582D 16r839B 16r582E 16r839C 16r582F 16r839D 16r5830 16r83A6 16r5831 16r83A7 16r5832 16r83A9 16r5833 16r83AC 16r5834 16r83BE 16r5835 16r83BF 16r5836 16r83C0 16r5837 16r83C7 16r5838 16r83C9 16r5839 16r83CF 16r583A 16r83D0 16r583B 16r83D1 16r583C 16r83D4 16r583D 16r83DD 16r583E 16r8353 16r583F 16r83E8 16r5840 16r83EA 16r5841 16r83F6 16r5842 16r83F8 16r5843 16r83F9 16r5844 16r83FC 16r5845 16r8401 16r5846 16r8406 16r5847 16r840A 16r5848 16r840F 16r5849 16r8411 16r584A 16r8415 16r584B 16r8419 16r584C 16r83AD 16r584D 16r842F 16r584E 16r8439 16r584F 16r8445 16r5850 16r8447 16r5851 16r8448 16r5852 16r844A 16r5853 16r844D 16r5854 16r844F 16r5855 16r8451 16r5856 16r8452 16r5857 16r8456 16r5858 16r8458 16r5859 16r8459 16r585A 16r845A 16r585B 16r845C 16r585C 16r8460 16r585D 16r8464 16r585E 16r8465 16r585F 16r8467 16r5860 16r846A 16r5861 16r8470 16r5862 16r8473 16r5863 16r8474 16r5864 16r8476 16r5865 16r8478 16r5866 16r847C 16r5867 16r847D 16r5868 16r8481 16r5869 16r8485 16r586A 16r8492 16r586B 16r8493 16r586C 16r8495 16r586D 16r849E 16r586E 16r84A6 16r586F 16r84A8 16r5870 16r84A9 16r5871 16r84AA 16r5872 16r84AF 16r5873 16r84B1 16r5874 16r84B4 16r5875 16r84BA 16r5876 16r84BD 16r5877 16r84BE 16r5878 16r84C0 16r5879 16r84C2 16r587A 16r84C7 16r587B 16r84C8 16r587C 16r84CC 16r587D 16r84CF 16r587E 16r84D3 16r5921 16r84DC 16r5922 16r84E7 16r5923 16r84EA 16r5924 16r84EF 16r5925 16r84F0 16r5926 16r84F1 16r5927 16r84F2 16r5928 16r84F7 16r5929 16r8532 16r592A 16r84FA 16r592B 16r84FB 16r592C 16r84FD 16r592D 16r8502 16r592E 16r8503 16r592F 16r8507 16r5930 16r850C 16r5931 16r850E 16r5932 16r8510 16r5933 16r851C 16r5934 16r851E 16r5935 16r8522 16r5936 16r8523 16r5937 16r8524 16r5938 16r8525 16r5939 16r8527 16r593A 16r852A 16r593B 16r852B 16r593C 16r852F 16r593D 16r8533 16r593E 16r8534 16r593F 16r8536 16r5940 16r853F 16r5941 16r8546 16r5942 16r854F 16r5943 16r8550 16r5944 16r8551 16r5945 16r8552 16r5946 16r8553 16r5947 16r8556 16r5948 16r8559 16r5949 16r855C 16r594A 16r855D 16r594B 16r855E 16r594C 16r855F 16r594D 16r8560 16r594E 16r8561 16r594F 16r8562 16r5950 16r8564 16r5951 16r856B 16r5952 16r856F 16r5953 16r8579 16r5954 16r857A 16r5955 16r857B 16r5956 16r857D 16r5957 16r857F 16r5958 16r8581 16r5959 16r8585 16r595A 16r8586 16r595B 16r8589 16r595C 16r858B 16r595D 16r858C 16r595E 16r858F 16r595F 16r8593 16r5960 16r8598 16r5961 16r859D 16r5962 16r859F 16r5963 16r85A0 16r5964 16r85A2 16r5965 16r85A5 16r5966 16r85A7 16r5967 16r85B4 16r5968 16r85B6 16r5969 16r85B7 16r596A 16r85B8 16r596B 16r85BC 16r596C 16r85BD 16r596D 16r85BE 16r596E 16r85BF 16r596F 16r85C2 16r5970 16r85C7 16r5971 16r85CA 16r5972 16r85CB 16r5973 16r85CE 16r5974 16r85AD 16r5975 16r85D8 16r5976 16r85DA 16r5977 16r85DF 16r5978 16r85E0 16r5979 16r85E6 16r597A 16r85E8 16r597B 16r85ED 16r597C 16r85F3 16r597D 16r85F6 16r597E 16r85FC 16r5A21 16r85FF 16r5A22 16r8600 16r5A23 16r8604 16r5A24 16r8605 16r5A25 16r860D 16r5A26 16r860E 16r5A27 16r8610 16r5A28 16r8611 16r5A29 16r8612 16r5A2A 16r8618 16r5A2B 16r8619 16r5A2C 16r861B 16r5A2D 16r861E 16r5A2E 16r8621 16r5A2F 16r8627 16r5A30 16r8629 16r5A31 16r8636 16r5A32 16r8638 16r5A33 16r863A 16r5A34 16r863C 16r5A35 16r863D 16r5A36 16r8640 16r5A37 16r8642 16r5A38 16r8646 16r5A39 16r8652 16r5A3A 16r8653 16r5A3B 16r8656 16r5A3C 16r8657 16r5A3D 16r8658 16r5A3E 16r8659 16r5A3F 16r865D 16r5A40 16r8660 16r5A41 16r8661 16r5A42 16r8662 16r5A43 16r8663 16r5A44 16r8664 16r5A45 16r8669 16r5A46 16r866C 16r5A47 16r866F 16r5A48 16r8675 16r5A49 16r8676 16r5A4A 16r8677 16r5A4B 16r867A 16r5A4C 16r868D 16r5A4D 16r8691 16r5A4E 16r8696 16r5A4F 16r8698 16r5A50 16r869A 16r5A51 16r869C 16r5A52 16r86A1 16r5A53 16r86A6 16r5A54 16r86A7 16r5A55 16r86A8 16r5A56 16r86AD 16r5A57 16r86B1 16r5A58 16r86B3 16r5A59 16r86B4 16r5A5A 16r86B5 16r5A5B 16r86B7 16r5A5C 16r86B8 16r5A5D 16r86B9 16r5A5E 16r86BF 16r5A5F 16r86C0 16r5A60 16r86C1 16r5A61 16r86C3 16r5A62 16r86C5 16r5A63 16r86D1 16r5A64 16r86D2 16r5A65 16r86D5 16r5A66 16r86D7 16r5A67 16r86DA 16r5A68 16r86DC 16r5A69 16r86E0 16r5A6A 16r86E3 16r5A6B 16r86E5 16r5A6C 16r86E7 16r5A6D 16r8688 16r5A6E 16r86FA 16r5A6F 16r86FC 16r5A70 16r86FD 16r5A71 16r8704 16r5A72 16r8705 16r5A73 16r8707 16r5A74 16r870B 16r5A75 16r870E 16r5A76 16r870F 16r5A77 16r8710 16r5A78 16r8713 16r5A79 16r8714 16r5A7A 16r8719 16r5A7B 16r871E 16r5A7C 16r871F 16r5A7D 16r8721 16r5A7E 16r8723 16r5B21 16r8728 16r5B22 16r872E 16r5B23 16r872F 16r5B24 16r8731 16r5B25 16r8732 16r5B26 16r8739 16r5B27 16r873A 16r5B28 16r873C 16r5B29 16r873D 16r5B2A 16r873E 16r5B2B 16r8740 16r5B2C 16r8743 16r5B2D 16r8745 16r5B2E 16r874D 16r5B2F 16r8758 16r5B30 16r875D 16r5B31 16r8761 16r5B32 16r8764 16r5B33 16r8765 16r5B34 16r876F 16r5B35 16r8771 16r5B36 16r8772 16r5B37 16r877B 16r5B38 16r8783 16r5B39 16r8784 16r5B3A 16r8785 16r5B3B 16r8786 16r5B3C 16r8787 16r5B3D 16r8788 16r5B3E 16r8789 16r5B3F 16r878B 16r5B40 16r878C 16r5B41 16r8790 16r5B42 16r8793 16r5B43 16r8795 16r5B44 16r8797 16r5B45 16r8798 16r5B46 16r8799 16r5B47 16r879E 16r5B48 16r87A0 16r5B49 16r87A3 16r5B4A 16r87A7 16r5B4B 16r87AC 16r5B4C 16r87AD 16r5B4D 16r87AE 16r5B4E 16r87B1 16r5B4F 16r87B5 16r5B50 16r87BE 16r5B51 16r87BF 16r5B52 16r87C1 16r5B53 16r87C8 16r5B54 16r87C9 16r5B55 16r87CA 16r5B56 16r87CE 16r5B57 16r87D5 16r5B58 16r87D6 16r5B59 16r87D9 16r5B5A 16r87DA 16r5B5B 16r87DC 16r5B5C 16r87DF 16r5B5D 16r87E2 16r5B5E 16r87E3 16r5B5F 16r87E4 16r5B60 16r87EA 16r5B61 16r87EB 16r5B62 16r87ED 16r5B63 16r87F1 16r5B64 16r87F3 16r5B65 16r87F8 16r5B66 16r87FA 16r5B67 16r87FF 16r5B68 16r8801 16r5B69 16r8803 16r5B6A 16r8806 16r5B6B 16r8809 16r5B6C 16r880A 16r5B6D 16r880B 16r5B6E 16r8810 16r5B6F 16r8819 16r5B70 16r8812 16r5B71 16r8813 16r5B72 16r8814 16r5B73 16r8818 16r5B74 16r881A 16r5B75 16r881B 16r5B76 16r881C 16r5B77 16r881E 16r5B78 16r881F 16r5B79 16r8828 16r5B7A 16r882D 16r5B7B 16r882E 16r5B7C 16r8830 16r5B7D 16r8832 16r5B7E 16r8835 16r5C21 16r883A 16r5C22 16r883C 16r5C23 16r8841 16r5C24 16r8843 16r5C25 16r8845 16r5C26 16r8848 16r5C27 16r8849 16r5C28 16r884A 16r5C29 16r884B 16r5C2A 16r884E 16r5C2B 16r8851 16r5C2C 16r8855 16r5C2D 16r8856 16r5C2E 16r8858 16r5C2F 16r885A 16r5C30 16r885C 16r5C31 16r885F 16r5C32 16r8860 16r5C33 16r8864 16r5C34 16r8869 16r5C35 16r8871 16r5C36 16r8879 16r5C37 16r887B 16r5C38 16r8880 16r5C39 16r8898 16r5C3A 16r889A 16r5C3B 16r889B 16r5C3C 16r889C 16r5C3D 16r889F 16r5C3E 16r88A0 16r5C3F 16r88A8 16r5C40 16r88AA 16r5C41 16r88BA 16r5C42 16r88BD 16r5C43 16r88BE 16r5C44 16r88C0 16r5C45 16r88CA 16r5C46 16r88CB 16r5C47 16r88CC 16r5C48 16r88CD 16r5C49 16r88CE 16r5C4A 16r88D1 16r5C4B 16r88D2 16r5C4C 16r88D3 16r5C4D 16r88DB 16r5C4E 16r88DE 16r5C4F 16r88E7 16r5C50 16r88EF 16r5C51 16r88F0 16r5C52 16r88F1 16r5C53 16r88F5 16r5C54 16r88F7 16r5C55 16r8901 16r5C56 16r8906 16r5C57 16r890D 16r5C58 16r890E 16r5C59 16r890F 16r5C5A 16r8915 16r5C5B 16r8916 16r5C5C 16r8918 16r5C5D 16r8919 16r5C5E 16r891A 16r5C5F 16r891C 16r5C60 16r8920 16r5C61 16r8926 16r5C62 16r8927 16r5C63 16r8928 16r5C64 16r8930 16r5C65 16r8931 16r5C66 16r8932 16r5C67 16r8935 16r5C68 16r8939 16r5C69 16r893A 16r5C6A 16r893E 16r5C6B 16r8940 16r5C6C 16r8942 16r5C6D 16r8945 16r5C6E 16r8946 16r5C6F 16r8949 16r5C70 16r894F 16r5C71 16r8952 16r5C72 16r8957 16r5C73 16r895A 16r5C74 16r895B 16r5C75 16r895C 16r5C76 16r8961 16r5C77 16r8962 16r5C78 16r8963 16r5C79 16r896B 16r5C7A 16r896E 16r5C7B 16r8970 16r5C7C 16r8973 16r5C7D 16r8975 16r5C7E 16r897A 16r5D21 16r897B 16r5D22 16r897C 16r5D23 16r897D 16r5D24 16r8989 16r5D25 16r898D 16r5D26 16r8990 16r5D27 16r8994 16r5D28 16r8995 16r5D29 16r899B 16r5D2A 16r899C 16r5D2B 16r899F 16r5D2C 16r89A0 16r5D2D 16r89A5 16r5D2E 16r89B0 16r5D2F 16r89B4 16r5D30 16r89B5 16r5D31 16r89B6 16r5D32 16r89B7 16r5D33 16r89BC 16r5D34 16r89D4 16r5D35 16r89D5 16r5D36 16r89D6 16r5D37 16r89D7 16r5D38 16r89D8 16r5D39 16r89E5 16r5D3A 16r89E9 16r5D3B 16r89EB 16r5D3C 16r89ED 16r5D3D 16r89F1 16r5D3E 16r89F3 16r5D3F 16r89F6 16r5D40 16r89F9 16r5D41 16r89FD 16r5D42 16r89FF 16r5D43 16r8A04 16r5D44 16r8A05 16r5D45 16r8A07 16r5D46 16r8A0F 16r5D47 16r8A11 16r5D48 16r8A12 16r5D49 16r8A14 16r5D4A 16r8A15 16r5D4B 16r8A1E 16r5D4C 16r8A20 16r5D4D 16r8A22 16r5D4E 16r8A24 16r5D4F 16r8A26 16r5D50 16r8A2B 16r5D51 16r8A2C 16r5D52 16r8A2F 16r5D53 16r8A35 16r5D54 16r8A37 16r5D55 16r8A3D 16r5D56 16r8A3E 16r5D57 16r8A40 16r5D58 16r8A43 16r5D59 16r8A45 16r5D5A 16r8A47 16r5D5B 16r8A49 16r5D5C 16r8A4D 16r5D5D 16r8A4E 16r5D5E 16r8A53 16r5D5F 16r8A56 16r5D60 16r8A57 16r5D61 16r8A58 16r5D62 16r8A5C 16r5D63 16r8A5D 16r5D64 16r8A61 16r5D65 16r8A65 16r5D66 16r8A67 16r5D67 16r8A75 16r5D68 16r8A76 16r5D69 16r8A77 16r5D6A 16r8A79 16r5D6B 16r8A7A 16r5D6C 16r8A7B 16r5D6D 16r8A7E 16r5D6E 16r8A7F 16r5D6F 16r8A80 16r5D70 16r8A83 16r5D71 16r8A86 16r5D72 16r8A8B 16r5D73 16r8A8F 16r5D74 16r8A90 16r5D75 16r8A92 16r5D76 16r8A96 16r5D77 16r8A97 16r5D78 16r8A99 16r5D79 16r8A9F 16r5D7A 16r8AA7 16r5D7B 16r8AA9 16r5D7C 16r8AAE 16r5D7D 16r8AAF 16r5D7E 16r8AB3 16r5E21 16r8AB6 16r5E22 16r8AB7 16r5E23 16r8ABB 16r5E24 16r8ABE 16r5E25 16r8AC3 16r5E26 16r8AC6 16r5E27 16r8AC8 16r5E28 16r8AC9 16r5E29 16r8ACA 16r5E2A 16r8AD1 16r5E2B 16r8AD3 16r5E2C 16r8AD4 16r5E2D 16r8AD5 16r5E2E 16r8AD7 16r5E2F 16r8ADD 16r5E30 16r8ADF 16r5E31 16r8AEC 16r5E32 16r8AF0 16r5E33 16r8AF4 16r5E34 16r8AF5 16r5E35 16r8AF6 16r5E36 16r8AFC 16r5E37 16r8AFF 16r5E38 16r8B05 16r5E39 16r8B06 16r5E3A 16r8B0B 16r5E3B 16r8B11 16r5E3C 16r8B1C 16r5E3D 16r8B1E 16r5E3E 16r8B1F 16r5E3F 16r8B0A 16r5E40 16r8B2D 16r5E41 16r8B30 16r5E42 16r8B37 16r5E43 16r8B3C 16r5E44 16r8B42 16r5E45 16r8B43 16r5E46 16r8B44 16r5E47 16r8B45 16r5E48 16r8B46 16r5E49 16r8B48 16r5E4A 16r8B52 16r5E4B 16r8B53 16r5E4C 16r8B54 16r5E4D 16r8B59 16r5E4E 16r8B4D 16r5E4F 16r8B5E 16r5E50 16r8B63 16r5E51 16r8B6D 16r5E52 16r8B76 16r5E53 16r8B78 16r5E54 16r8B79 16r5E55 16r8B7C 16r5E56 16r8B7E 16r5E57 16r8B81 16r5E58 16r8B84 16r5E59 16r8B85 16r5E5A 16r8B8B 16r5E5B 16r8B8D 16r5E5C 16r8B8F 16r5E5D 16r8B94 16r5E5E 16r8B95 16r5E5F 16r8B9C 16r5E60 16r8B9E 16r5E61 16r8B9F 16r5E62 16r8C38 16r5E63 16r8C39 16r5E64 16r8C3D 16r5E65 16r8C3E 16r5E66 16r8C45 16r5E67 16r8C47 16r5E68 16r8C49 16r5E69 16r8C4B 16r5E6A 16r8C4F 16r5E6B 16r8C51 16r5E6C 16r8C53 16r5E6D 16r8C54 16r5E6E 16r8C57 16r5E6F 16r8C58 16r5E70 16r8C5B 16r5E71 16r8C5D 16r5E72 16r8C59 16r5E73 16r8C63 16r5E74 16r8C64 16r5E75 16r8C66 16r5E76 16r8C68 16r5E77 16r8C69 16r5E78 16r8C6D 16r5E79 16r8C73 16r5E7A 16r8C75 16r5E7B 16r8C76 16r5E7C 16r8C7B 16r5E7D 16r8C7E 16r5E7E 16r8C86 16r5F21 16r8C87 16r5F22 16r8C8B 16r5F23 16r8C90 16r5F24 16r8C92 16r5F25 16r8C93 16r5F26 16r8C99 16r5F27 16r8C9B 16r5F28 16r8C9C 16r5F29 16r8CA4 16r5F2A 16r8CB9 16r5F2B 16r8CBA 16r5F2C 16r8CC5 16r5F2D 16r8CC6 16r5F2E 16r8CC9 16r5F2F 16r8CCB 16r5F30 16r8CCF 16r5F31 16r8CD6 16r5F32 16r8CD5 16r5F33 16r8CD9 16r5F34 16r8CDD 16r5F35 16r8CE1 16r5F36 16r8CE8 16r5F37 16r8CEC 16r5F38 16r8CEF 16r5F39 16r8CF0 16r5F3A 16r8CF2 16r5F3B 16r8CF5 16r5F3C 16r8CF7 16r5F3D 16r8CF8 16r5F3E 16r8CFE 16r5F3F 16r8CFF 16r5F40 16r8D01 16r5F41 16r8D03 16r5F42 16r8D09 16r5F43 16r8D12 16r5F44 16r8D17 16r5F45 16r8D1B 16r5F46 16r8D65 16r5F47 16r8D69 16r5F48 16r8D6C 16r5F49 16r8D6E 16r5F4A 16r8D7F 16r5F4B 16r8D82 16r5F4C 16r8D84 16r5F4D 16r8D88 16r5F4E 16r8D8D 16r5F4F 16r8D90 16r5F50 16r8D91 16r5F51 16r8D95 16r5F52 16r8D9E 16r5F53 16r8D9F 16r5F54 16r8DA0 16r5F55 16r8DA6 16r5F56 16r8DAB 16r5F57 16r8DAC 16r5F58 16r8DAF 16r5F59 16r8DB2 16r5F5A 16r8DB5 16r5F5B 16r8DB7 16r5F5C 16r8DB9 16r5F5D 16r8DBB 16r5F5E 16r8DC0 16r5F5F 16r8DC5 16r5F60 16r8DC6 16r5F61 16r8DC7 16r5F62 16r8DC8 16r5F63 16r8DCA 16r5F64 16r8DCE 16r5F65 16r8DD1 16r5F66 16r8DD4 16r5F67 16r8DD5 16r5F68 16r8DD7 16r5F69 16r8DD9 16r5F6A 16r8DE4 16r5F6B 16r8DE5 16r5F6C 16r8DE7 16r5F6D 16r8DEC 16r5F6E 16r8DF0 16r5F6F 16r8DBC 16r5F70 16r8DF1 16r5F71 16r8DF2 16r5F72 16r8DF4 16r5F73 16r8DFD 16r5F74 16r8E01 16r5F75 16r8E04 16r5F76 16r8E05 16r5F77 16r8E06 16r5F78 16r8E0B 16r5F79 16r8E11 16r5F7A 16r8E14 16r5F7B 16r8E16 16r5F7C 16r8E20 16r5F7D 16r8E21 16r5F7E 16r8E22 16r6021 16r8E23 16r6022 16r8E26 16r6023 16r8E27 16r6024 16r8E31 16r6025 16r8E33 16r6026 16r8E36 16r6027 16r8E37 16r6028 16r8E38 16r6029 16r8E39 16r602A 16r8E3D 16r602B 16r8E40 16r602C 16r8E41 16r602D 16r8E4B 16r602E 16r8E4D 16r602F 16r8E4E 16r6030 16r8E4F 16r6031 16r8E54 16r6032 16r8E5B 16r6033 16r8E5C 16r6034 16r8E5D 16r6035 16r8E5E 16r6036 16r8E61 16r6037 16r8E62 16r6038 16r8E69 16r6039 16r8E6C 16r603A 16r8E6D 16r603B 16r8E6F 16r603C 16r8E70 16r603D 16r8E71 16r603E 16r8E79 16r603F 16r8E7A 16r6040 16r8E7B 16r6041 16r8E82 16r6042 16r8E83 16r6043 16r8E89 16r6044 16r8E90 16r6045 16r8E92 16r6046 16r8E95 16r6047 16r8E9A 16r6048 16r8E9B 16r6049 16r8E9D 16r604A 16r8E9E 16r604B 16r8EA2 16r604C 16r8EA7 16r604D 16r8EA9 16r604E 16r8EAD 16r604F 16r8EAE 16r6050 16r8EB3 16r6051 16r8EB5 16r6052 16r8EBA 16r6053 16r8EBB 16r6054 16r8EC0 16r6055 16r8EC1 16r6056 16r8EC3 16r6057 16r8EC4 16r6058 16r8EC7 16r6059 16r8ECF 16r605A 16r8ED1 16r605B 16r8ED4 16r605C 16r8EDC 16r605D 16r8EE8 16r605E 16r8EEE 16r605F 16r8EF0 16r6060 16r8EF1 16r6061 16r8EF7 16r6062 16r8EF9 16r6063 16r8EFA 16r6064 16r8EED 16r6065 16r8F00 16r6066 16r8F02 16r6067 16r8F07 16r6068 16r8F08 16r6069 16r8F0F 16r606A 16r8F10 16r606B 16r8F16 16r606C 16r8F17 16r606D 16r8F18 16r606E 16r8F1E 16r606F 16r8F20 16r6070 16r8F21 16r6071 16r8F23 16r6072 16r8F25 16r6073 16r8F27 16r6074 16r8F28 16r6075 16r8F2C 16r6076 16r8F2D 16r6077 16r8F2E 16r6078 16r8F34 16r6079 16r8F35 16r607A 16r8F36 16r607B 16r8F37 16r607C 16r8F3A 16r607D 16r8F40 16r607E 16r8F41 16r6121 16r8F43 16r6122 16r8F47 16r6123 16r8F4F 16r6124 16r8F51 16r6125 16r8F52 16r6126 16r8F53 16r6127 16r8F54 16r6128 16r8F55 16r6129 16r8F58 16r612A 16r8F5D 16r612B 16r8F5E 16r612C 16r8F65 16r612D 16r8F9D 16r612E 16r8FA0 16r612F 16r8FA1 16r6130 16r8FA4 16r6131 16r8FA5 16r6132 16r8FA6 16r6133 16r8FB5 16r6134 16r8FB6 16r6135 16r8FB8 16r6136 16r8FBE 16r6137 16r8FC0 16r6138 16r8FC1 16r6139 16r8FC6 16r613A 16r8FCA 16r613B 16r8FCB 16r613C 16r8FCD 16r613D 16r8FD0 16r613E 16r8FD2 16r613F 16r8FD3 16r6140 16r8FD5 16r6141 16r8FE0 16r6142 16r8FE3 16r6143 16r8FE4 16r6144 16r8FE8 16r6145 16r8FEE 16r6146 16r8FF1 16r6147 16r8FF5 16r6148 16r8FF6 16r6149 16r8FFB 16r614A 16r8FFE 16r614B 16r9002 16r614C 16r9004 16r614D 16r9008 16r614E 16r900C 16r614F 16r9018 16r6150 16r901B 16r6151 16r9028 16r6152 16r9029 16r6153 16r902F 16r6154 16r902A 16r6155 16r902C 16r6156 16r902D 16r6157 16r9033 16r6158 16r9034 16r6159 16r9037 16r615A 16r903F 16r615B 16r9043 16r615C 16r9044 16r615D 16r904C 16r615E 16r905B 16r615F 16r905D 16r6160 16r9062 16r6161 16r9066 16r6162 16r9067 16r6163 16r906C 16r6164 16r9070 16r6165 16r9074 16r6166 16r9079 16r6167 16r9085 16r6168 16r9088 16r6169 16r908B 16r616A 16r908C 16r616B 16r908E 16r616C 16r9090 16r616D 16r9095 16r616E 16r9097 16r616F 16r9098 16r6170 16r9099 16r6171 16r909B 16r6172 16r90A0 16r6173 16r90A1 16r6174 16r90A2 16r6175 16r90A5 16r6176 16r90B0 16r6177 16r90B2 16r6178 16r90B3 16r6179 16r90B4 16r617A 16r90B6 16r617B 16r90BD 16r617C 16r90CC 16r617D 16r90BE 16r617E 16r90C3 16r6221 16r90C4 16r6222 16r90C5 16r6223 16r90C7 16r6224 16r90C8 16r6225 16r90D5 16r6226 16r90D7 16r6227 16r90D8 16r6228 16r90D9 16r6229 16r90DC 16r622A 16r90DD 16r622B 16r90DF 16r622C 16r90E5 16r622D 16r90D2 16r622E 16r90F6 16r622F 16r90EB 16r6230 16r90EF 16r6231 16r90F0 16r6232 16r90F4 16r6233 16r90FE 16r6234 16r90FF 16r6235 16r9100 16r6236 16r9104 16r6237 16r9105 16r6238 16r9106 16r6239 16r9108 16r623A 16r910D 16r623B 16r9110 16r623C 16r9114 16r623D 16r9116 16r623E 16r9117 16r623F 16r9118 16r6240 16r911A 16r6241 16r911C 16r6242 16r911E 16r6243 16r9120 16r6244 16r9125 16r6245 16r9122 16r6246 16r9123 16r6247 16r9127 16r6248 16r9129 16r6249 16r912E 16r624A 16r912F 16r624B 16r9131 16r624C 16r9134 16r624D 16r9136 16r624E 16r9137 16r624F 16r9139 16r6250 16r913A 16r6251 16r913C 16r6252 16r913D 16r6253 16r9143 16r6254 16r9147 16r6255 16r9148 16r6256 16r914F 16r6257 16r9153 16r6258 16r9157 16r6259 16r9159 16r625A 16r915A 16r625B 16r915B 16r625C 16r9161 16r625D 16r9164 16r625E 16r9167 16r625F 16r916D 16r6260 16r9174 16r6261 16r9179 16r6262 16r917A 16r6263 16r917B 16r6264 16r9181 16r6265 16r9183 16r6266 16r9185 16r6267 16r9186 16r6268 16r918A 16r6269 16r918E 16r626A 16r9191 16r626B 16r9193 16r626C 16r9194 16r626D 16r9195 16r626E 16r9198 16r626F 16r919E 16r6270 16r91A1 16r6271 16r91A6 16r6272 16r91A8 16r6273 16r91AC 16r6274 16r91AD 16r6275 16r91AE 16r6276 16r91B0 16r6277 16r91B1 16r6278 16r91B2 16r6279 16r91B3 16r627A 16r91B6 16r627B 16r91BB 16r627C 16r91BC 16r627D 16r91BD 16r627E 16r91BF 16r6321 16r91C2 16r6322 16r91C3 16r6323 16r91C5 16r6324 16r91D3 16r6325 16r91D4 16r6326 16r91D7 16r6327 16r91D9 16r6328 16r91DA 16r6329 16r91DE 16r632A 16r91E4 16r632B 16r91E5 16r632C 16r91E9 16r632D 16r91EA 16r632E 16r91EC 16r632F 16r91ED 16r6330 16r91EE 16r6331 16r91EF 16r6332 16r91F0 16r6333 16r91F1 16r6334 16r91F7 16r6335 16r91F9 16r6336 16r91FB 16r6337 16r91FD 16r6338 16r9200 16r6339 16r9201 16r633A 16r9204 16r633B 16r9205 16r633C 16r9206 16r633D 16r9207 16r633E 16r9209 16r633F 16r920A 16r6340 16r920C 16r6341 16r9210 16r6342 16r9212 16r6343 16r9213 16r6344 16r9216 16r6345 16r9218 16r6346 16r921C 16r6347 16r921D 16r6348 16r9223 16r6349 16r9224 16r634A 16r9225 16r634B 16r9226 16r634C 16r9228 16r634D 16r922E 16r634E 16r922F 16r634F 16r9230 16r6350 16r9233 16r6351 16r9235 16r6352 16r9236 16r6353 16r9238 16r6354 16r9239 16r6355 16r923A 16r6356 16r923C 16r6357 16r923E 16r6358 16r9240 16r6359 16r9242 16r635A 16r9243 16r635B 16r9246 16r635C 16r9247 16r635D 16r924A 16r635E 16r924D 16r635F 16r924E 16r6360 16r924F 16r6361 16r9251 16r6362 16r9258 16r6363 16r9259 16r6364 16r925C 16r6365 16r925D 16r6366 16r9260 16r6367 16r9261 16r6368 16r9265 16r6369 16r9267 16r636A 16r9268 16r636B 16r9269 16r636C 16r926E 16r636D 16r926F 16r636E 16r9270 16r636F 16r9275 16r6370 16r9276 16r6371 16r9277 16r6372 16r9278 16r6373 16r9279 16r6374 16r927B 16r6375 16r927C 16r6376 16r927D 16r6377 16r927F 16r6378 16r9288 16r6379 16r9289 16r637A 16r928A 16r637B 16r928D 16r637C 16r928E 16r637D 16r9292 16r637E 16r9297 16r6421 16r9299 16r6422 16r929F 16r6423 16r92A0 16r6424 16r92A4 16r6425 16r92A5 16r6426 16r92A7 16r6427 16r92A8 16r6428 16r92AB 16r6429 16r92AF 16r642A 16r92B2 16r642B 16r92B6 16r642C 16r92B8 16r642D 16r92BA 16r642E 16r92BB 16r642F 16r92BC 16r6430 16r92BD 16r6431 16r92BF 16r6432 16r92C0 16r6433 16r92C1 16r6434 16r92C2 16r6435 16r92C3 16r6436 16r92C5 16r6437 16r92C6 16r6438 16r92C7 16r6439 16r92C8 16r643A 16r92CB 16r643B 16r92CC 16r643C 16r92CD 16r643D 16r92CE 16r643E 16r92D0 16r643F 16r92D3 16r6440 16r92D5 16r6441 16r92D7 16r6442 16r92D8 16r6443 16r92D9 16r6444 16r92DC 16r6445 16r92DD 16r6446 16r92DF 16r6447 16r92E0 16r6448 16r92E1 16r6449 16r92E3 16r644A 16r92E5 16r644B 16r92E7 16r644C 16r92E8 16r644D 16r92EC 16r644E 16r92EE 16r644F 16r92F0 16r6450 16r92F9 16r6451 16r92FB 16r6452 16r92FF 16r6453 16r9300 16r6454 16r9302 16r6455 16r9308 16r6456 16r930D 16r6457 16r9311 16r6458 16r9314 16r6459 16r9315 16r645A 16r931C 16r645B 16r931D 16r645C 16r931E 16r645D 16r931F 16r645E 16r9321 16r645F 16r9324 16r6460 16r9325 16r6461 16r9327 16r6462 16r9329 16r6463 16r932A 16r6464 16r9333 16r6465 16r9334 16r6466 16r9336 16r6467 16r9337 16r6468 16r9347 16r6469 16r9348 16r646A 16r9349 16r646B 16r9350 16r646C 16r9351 16r646D 16r9352 16r646E 16r9355 16r646F 16r9357 16r6470 16r9358 16r6471 16r935A 16r6472 16r935E 16r6473 16r9364 16r6474 16r9365 16r6475 16r9367 16r6476 16r9369 16r6477 16r936A 16r6478 16r936D 16r6479 16r936F 16r647A 16r9370 16r647B 16r9371 16r647C 16r9373 16r647D 16r9374 16r647E 16r9376 16r6521 16r937A 16r6522 16r937D 16r6523 16r937F 16r6524 16r9380 16r6525 16r9381 16r6526 16r9382 16r6527 16r9388 16r6528 16r938A 16r6529 16r938B 16r652A 16r938D 16r652B 16r938F 16r652C 16r9392 16r652D 16r9395 16r652E 16r9398 16r652F 16r939B 16r6530 16r939E 16r6531 16r93A1 16r6532 16r93A3 16r6533 16r93A4 16r6534 16r93A6 16r6535 16r93A8 16r6536 16r93AB 16r6537 16r93B4 16r6538 16r93B5 16r6539 16r93B6 16r653A 16r93BA 16r653B 16r93A9 16r653C 16r93C1 16r653D 16r93C4 16r653E 16r93C5 16r653F 16r93C6 16r6540 16r93C7 16r6541 16r93C9 16r6542 16r93CA 16r6543 16r93CB 16r6544 16r93CC 16r6545 16r93CD 16r6546 16r93D3 16r6547 16r93D9 16r6548 16r93DC 16r6549 16r93DE 16r654A 16r93DF 16r654B 16r93E2 16r654C 16r93E6 16r654D 16r93E7 16r654E 16r93F9 16r654F 16r93F7 16r6550 16r93F8 16r6551 16r93FA 16r6552 16r93FB 16r6553 16r93FD 16r6554 16r9401 16r6555 16r9402 16r6556 16r9404 16r6557 16r9408 16r6558 16r9409 16r6559 16r940D 16r655A 16r940E 16r655B 16r940F 16r655C 16r9415 16r655D 16r9416 16r655E 16r9417 16r655F 16r941F 16r6560 16r942E 16r6561 16r942F 16r6562 16r9431 16r6563 16r9432 16r6564 16r9433 16r6565 16r9434 16r6566 16r943B 16r6567 16r943F 16r6568 16r943D 16r6569 16r9443 16r656A 16r9445 16r656B 16r9448 16r656C 16r944A 16r656D 16r944C 16r656E 16r9455 16r656F 16r9459 16r6570 16r945C 16r6571 16r945F 16r6572 16r9461 16r6573 16r9463 16r6574 16r9468 16r6575 16r946B 16r6576 16r946D 16r6577 16r946E 16r6578 16r946F 16r6579 16r9471 16r657A 16r9472 16r657B 16r9484 16r657C 16r9483 16r657D 16r9578 16r657E 16r9579 16r6621 16r957E 16r6622 16r9584 16r6623 16r9588 16r6624 16r958C 16r6625 16r958D 16r6626 16r958E 16r6627 16r959D 16r6628 16r959E 16r6629 16r959F 16r662A 16r95A1 16r662B 16r95A6 16r662C 16r95A9 16r662D 16r95AB 16r662E 16r95AC 16r662F 16r95B4 16r6630 16r95B6 16r6631 16r95BA 16r6632 16r95BD 16r6633 16r95BF 16r6634 16r95C6 16r6635 16r95C8 16r6636 16r95C9 16r6637 16r95CB 16r6638 16r95D0 16r6639 16r95D1 16r663A 16r95D2 16r663B 16r95D3 16r663C 16r95D9 16r663D 16r95DA 16r663E 16r95DD 16r663F 16r95DE 16r6640 16r95DF 16r6641 16r95E0 16r6642 16r95E4 16r6643 16r95E6 16r6644 16r961D 16r6645 16r961E 16r6646 16r9622 16r6647 16r9624 16r6648 16r9625 16r6649 16r9626 16r664A 16r962C 16r664B 16r9631 16r664C 16r9633 16r664D 16r9637 16r664E 16r9638 16r664F 16r9639 16r6650 16r963A 16r6651 16r963C 16r6652 16r963D 16r6653 16r9641 16r6654 16r9652 16r6655 16r9654 16r6656 16r9656 16r6657 16r9657 16r6658 16r9658 16r6659 16r9661 16r665A 16r966E 16r665B 16r9674 16r665C 16r967B 16r665D 16r967C 16r665E 16r967E 16r665F 16r967F 16r6660 16r9681 16r6661 16r9682 16r6662 16r9683 16r6663 16r9684 16r6664 16r9689 16r6665 16r9691 16r6666 16r9696 16r6667 16r969A 16r6668 16r969D 16r6669 16r969F 16r666A 16r96A4 16r666B 16r96A5 16r666C 16r96A6 16r666D 16r96A9 16r666E 16r96AE 16r666F 16r96AF 16r6670 16r96B3 16r6671 16r96BA 16r6672 16r96CA 16r6673 16r96D2 16r6674 16r5DB2 16r6675 16r96D8 16r6676 16r96DA 16r6677 16r96DD 16r6678 16r96DE 16r6679 16r96DF 16r667A 16r96E9 16r667B 16r96EF 16r667C 16r96F1 16r667D 16r96FA 16r667E 16r9702 16r6721 16r9703 16r6722 16r9705 16r6723 16r9709 16r6724 16r971A 16r6725 16r971B 16r6726 16r971D 16r6727 16r9721 16r6728 16r9722 16r6729 16r9723 16r672A 16r9728 16r672B 16r9731 16r672C 16r9733 16r672D 16r9741 16r672E 16r9743 16r672F 16r974A 16r6730 16r974E 16r6731 16r974F 16r6732 16r9755 16r6733 16r9757 16r6734 16r9758 16r6735 16r975A 16r6736 16r975B 16r6737 16r9763 16r6738 16r9767 16r6739 16r976A 16r673A 16r976E 16r673B 16r9773 16r673C 16r9776 16r673D 16r9777 16r673E 16r9778 16r673F 16r977B 16r6740 16r977D 16r6741 16r977F 16r6742 16r9780 16r6743 16r9789 16r6744 16r9795 16r6745 16r9796 16r6746 16r9797 16r6747 16r9799 16r6748 16r979A 16r6749 16r979E 16r674A 16r979F 16r674B 16r97A2 16r674C 16r97AC 16r674D 16r97AE 16r674E 16r97B1 16r674F 16r97B2 16r6750 16r97B5 16r6751 16r97B6 16r6752 16r97B8 16r6753 16r97B9 16r6754 16r97BA 16r6755 16r97BC 16r6756 16r97BE 16r6757 16r97BF 16r6758 16r97C1 16r6759 16r97C4 16r675A 16r97C5 16r675B 16r97C7 16r675C 16r97C9 16r675D 16r97CA 16r675E 16r97CC 16r675F 16r97CD 16r6760 16r97CE 16r6761 16r97D0 16r6762 16r97D1 16r6763 16r97D4 16r6764 16r97D7 16r6765 16r97D8 16r6766 16r97D9 16r6767 16r97DD 16r6768 16r97DE 16r6769 16r97E0 16r676A 16r97DB 16r676B 16r97E1 16r676C 16r97E4 16r676D 16r97EF 16r676E 16r97F1 16r676F 16r97F4 16r6770 16r97F7 16r6771 16r97F8 16r6772 16r97FA 16r6773 16r9807 16r6774 16r980A 16r6775 16r9819 16r6776 16r980D 16r6777 16r980E 16r6778 16r9814 16r6779 16r9816 16r677A 16r981C 16r677B 16r981E 16r677C 16r9820 16r677D 16r9823 16r677E 16r9826 16r6821 16r982B 16r6822 16r982E 16r6823 16r982F 16r6824 16r9830 16r6825 16r9832 16r6826 16r9833 16r6827 16r9835 16r6828 16r9825 16r6829 16r983E 16r682A 16r9844 16r682B 16r9847 16r682C 16r984A 16r682D 16r9851 16r682E 16r9852 16r682F 16r9853 16r6830 16r9856 16r6831 16r9857 16r6832 16r9859 16r6833 16r985A 16r6834 16r9862 16r6835 16r9863 16r6836 16r9865 16r6837 16r9866 16r6838 16r986A 16r6839 16r986C 16r683A 16r98AB 16r683B 16r98AD 16r683C 16r98AE 16r683D 16r98B0 16r683E 16r98B4 16r683F 16r98B7 16r6840 16r98B8 16r6841 16r98BA 16r6842 16r98BB 16r6843 16r98BF 16r6844 16r98C2 16r6845 16r98C5 16r6846 16r98C8 16r6847 16r98CC 16r6848 16r98E1 16r6849 16r98E3 16r684A 16r98E5 16r684B 16r98E6 16r684C 16r98E7 16r684D 16r98EA 16r684E 16r98F3 16r684F 16r98F6 16r6850 16r9902 16r6851 16r9907 16r6852 16r9908 16r6853 16r9911 16r6854 16r9915 16r6855 16r9916 16r6856 16r9917 16r6857 16r991A 16r6858 16r991B 16r6859 16r991C 16r685A 16r991F 16r685B 16r9922 16r685C 16r9926 16r685D 16r9927 16r685E 16r992B 16r685F 16r9931 16r6860 16r9932 16r6861 16r9933 16r6862 16r9934 16r6863 16r9935 16r6864 16r9939 16r6865 16r993A 16r6866 16r993B 16r6867 16r993C 16r6868 16r9940 16r6869 16r9941 16r686A 16r9946 16r686B 16r9947 16r686C 16r9948 16r686D 16r994D 16r686E 16r994E 16r686F 16r9954 16r6870 16r9958 16r6871 16r9959 16r6872 16r995B 16r6873 16r995C 16r6874 16r995E 16r6875 16r995F 16r6876 16r9960 16r6877 16r999B 16r6878 16r999D 16r6879 16r999F 16r687A 16r99A6 16r687B 16r99B0 16r687C 16r99B1 16r687D 16r99B2 16r687E 16r99B5 16r6921 16r99B9 16r6922 16r99BA 16r6923 16r99BD 16r6924 16r99BF 16r6925 16r99C3 16r6926 16r99C9 16r6927 16r99D3 16r6928 16r99D4 16r6929 16r99D9 16r692A 16r99DA 16r692B 16r99DC 16r692C 16r99DE 16r692D 16r99E7 16r692E 16r99EA 16r692F 16r99EB 16r6930 16r99EC 16r6931 16r99F0 16r6932 16r99F4 16r6933 16r99F5 16r6934 16r99F9 16r6935 16r99FD 16r6936 16r99FE 16r6937 16r9A02 16r6938 16r9A03 16r6939 16r9A04 16r693A 16r9A0B 16r693B 16r9A0C 16r693C 16r9A10 16r693D 16r9A11 16r693E 16r9A16 16r693F 16r9A1E 16r6940 16r9A20 16r6941 16r9A22 16r6942 16r9A23 16r6943 16r9A24 16r6944 16r9A27 16r6945 16r9A2D 16r6946 16r9A2E 16r6947 16r9A33 16r6948 16r9A35 16r6949 16r9A36 16r694A 16r9A38 16r694B 16r9A47 16r694C 16r9A41 16r694D 16r9A44 16r694E 16r9A4A 16r694F 16r9A4B 16r6950 16r9A4C 16r6951 16r9A4E 16r6952 16r9A51 16r6953 16r9A54 16r6954 16r9A56 16r6955 16r9A5D 16r6956 16r9AAA 16r6957 16r9AAC 16r6958 16r9AAE 16r6959 16r9AAF 16r695A 16r9AB2 16r695B 16r9AB4 16r695C 16r9AB5 16r695D 16r9AB6 16r695E 16r9AB9 16r695F 16r9ABB 16r6960 16r9ABE 16r6961 16r9ABF 16r6962 16r9AC1 16r6963 16r9AC3 16r6964 16r9AC6 16r6965 16r9AC8 16r6966 16r9ACE 16r6967 16r9AD0 16r6968 16r9AD2 16r6969 16r9AD5 16r696A 16r9AD6 16r696B 16r9AD7 16r696C 16r9ADB 16r696D 16r9ADC 16r696E 16r9AE0 16r696F 16r9AE4 16r6970 16r9AE5 16r6971 16r9AE7 16r6972 16r9AE9 16r6973 16r9AEC 16r6974 16r9AF2 16r6975 16r9AF3 16r6976 16r9AF5 16r6977 16r9AF9 16r6978 16r9AFA 16r6979 16r9AFD 16r697A 16r9AFF 16r697B 16r9B00 16r697C 16r9B01 16r697D 16r9B02 16r697E 16r9B03 16r6A21 16r9B04 16r6A22 16r9B05 16r6A23 16r9B08 16r6A24 16r9B09 16r6A25 16r9B0B 16r6A26 16r9B0C 16r6A27 16r9B0D 16r6A28 16r9B0E 16r6A29 16r9B10 16r6A2A 16r9B12 16r6A2B 16r9B16 16r6A2C 16r9B19 16r6A2D 16r9B1B 16r6A2E 16r9B1C 16r6A2F 16r9B20 16r6A30 16r9B26 16r6A31 16r9B2B 16r6A32 16r9B2D 16r6A33 16r9B33 16r6A34 16r9B34 16r6A35 16r9B35 16r6A36 16r9B37 16r6A37 16r9B39 16r6A38 16r9B3A 16r6A39 16r9B3D 16r6A3A 16r9B48 16r6A3B 16r9B4B 16r6A3C 16r9B4C 16r6A3D 16r9B55 16r6A3E 16r9B56 16r6A3F 16r9B57 16r6A40 16r9B5B 16r6A41 16r9B5E 16r6A42 16r9B61 16r6A43 16r9B63 16r6A44 16r9B65 16r6A45 16r9B66 16r6A46 16r9B68 16r6A47 16r9B6A 16r6A48 16r9B6B 16r6A49 16r9B6C 16r6A4A 16r9B6D 16r6A4B 16r9B6E 16r6A4C 16r9B73 16r6A4D 16r9B75 16r6A4E 16r9B77 16r6A4F 16r9B78 16r6A50 16r9B79 16r6A51 16r9B7F 16r6A52 16r9B80 16r6A53 16r9B84 16r6A54 16r9B85 16r6A55 16r9B86 16r6A56 16r9B87 16r6A57 16r9B89 16r6A58 16r9B8A 16r6A59 16r9B8B 16r6A5A 16r9B8D 16r6A5B 16r9B8F 16r6A5C 16r9B90 16r6A5D 16r9B94 16r6A5E 16r9B9A 16r6A5F 16r9B9D 16r6A60 16r9B9E 16r6A61 16r9BA6 16r6A62 16r9BA7 16r6A63 16r9BA9 16r6A64 16r9BAC 16r6A65 16r9BB0 16r6A66 16r9BB1 16r6A67 16r9BB2 16r6A68 16r9BB7 16r6A69 16r9BB8 16r6A6A 16r9BBB 16r6A6B 16r9BBC 16r6A6C 16r9BBE 16r6A6D 16r9BBF 16r6A6E 16r9BC1 16r6A6F 16r9BC7 16r6A70 16r9BC8 16r6A71 16r9BCE 16r6A72 16r9BD0 16r6A73 16r9BD7 16r6A74 16r9BD8 16r6A75 16r9BDD 16r6A76 16r9BDF 16r6A77 16r9BE5 16r6A78 16r9BE7 16r6A79 16r9BEA 16r6A7A 16r9BEB 16r6A7B 16r9BEF 16r6A7C 16r9BF3 16r6A7D 16r9BF7 16r6A7E 16r9BF8 16r6B21 16r9BF9 16r6B22 16r9BFA 16r6B23 16r9BFD 16r6B24 16r9BFF 16r6B25 16r9C00 16r6B26 16r9C02 16r6B27 16r9C0B 16r6B28 16r9C0F 16r6B29 16r9C11 16r6B2A 16r9C16 16r6B2B 16r9C18 16r6B2C 16r9C19 16r6B2D 16r9C1A 16r6B2E 16r9C1C 16r6B2F 16r9C1E 16r6B30 16r9C22 16r6B31 16r9C23 16r6B32 16r9C26 16r6B33 16r9C27 16r6B34 16r9C28 16r6B35 16r9C29 16r6B36 16r9C2A 16r6B37 16r9C31 16r6B38 16r9C35 16r6B39 16r9C36 16r6B3A 16r9C37 16r6B3B 16r9C3D 16r6B3C 16r9C41 16r6B3D 16r9C43 16r6B3E 16r9C44 16r6B3F 16r9C45 16r6B40 16r9C49 16r6B41 16r9C4A 16r6B42 16r9C4E 16r6B43 16r9C4F 16r6B44 16r9C50 16r6B45 16r9C53 16r6B46 16r9C54 16r6B47 16r9C56 16r6B48 16r9C58 16r6B49 16r9C5B 16r6B4A 16r9C5D 16r6B4B 16r9C5E 16r6B4C 16r9C5F 16r6B4D 16r9C63 16r6B4E 16r9C69 16r6B4F 16r9C6A 16r6B50 16r9C5C 16r6B51 16r9C6B 16r6B52 16r9C68 16r6B53 16r9C6E 16r6B54 16r9C70 16r6B55 16r9C72 16r6B56 16r9C75 16r6B57 16r9C77 16r6B58 16r9C7B 16r6B59 16r9CE6 16r6B5A 16r9CF2 16r6B5B 16r9CF7 16r6B5C 16r9CF9 16r6B5D 16r9D0B 16r6B5E 16r9D02 16r6B5F 16r9D11 16r6B60 16r9D17 16r6B61 16r9D18 16r6B62 16r9D1C 16r6B63 16r9D1D 16r6B64 16r9D1E 16r6B65 16r9D2F 16r6B66 16r9D30 16r6B67 16r9D32 16r6B68 16r9D33 16r6B69 16r9D34 16r6B6A 16r9D3A 16r6B6B 16r9D3C 16r6B6C 16r9D45 16r6B6D 16r9D3D 16r6B6E 16r9D42 16r6B6F 16r9D43 16r6B70 16r9D47 16r6B71 16r9D4A 16r6B72 16r9D53 16r6B73 16r9D54 16r6B74 16r9D5F 16r6B75 16r9D63 16r6B76 16r9D62 16r6B77 16r9D65 16r6B78 16r9D69 16r6B79 16r9D6A 16r6B7A 16r9D6B 16r6B7B 16r9D70 16r6B7C 16r9D76 16r6B7D 16r9D77 16r6B7E 16r9D7B 16r6C21 16r9D7C 16r6C22 16r9D7E 16r6C23 16r9D83 16r6C24 16r9D84 16r6C25 16r9D86 16r6C26 16r9D8A 16r6C27 16r9D8D 16r6C28 16r9D8E 16r6C29 16r9D92 16r6C2A 16r9D93 16r6C2B 16r9D95 16r6C2C 16r9D96 16r6C2D 16r9D97 16r6C2E 16r9D98 16r6C2F 16r9DA1 16r6C30 16r9DAA 16r6C31 16r9DAC 16r6C32 16r9DAE 16r6C33 16r9DB1 16r6C34 16r9DB5 16r6C35 16r9DB9 16r6C36 16r9DBC 16r6C37 16r9DBF 16r6C38 16r9DC3 16r6C39 16r9DC7 16r6C3A 16r9DC9 16r6C3B 16r9DCA 16r6C3C 16r9DD4 16r6C3D 16r9DD5 16r6C3E 16r9DD6 16r6C3F 16r9DD7 16r6C40 16r9DDA 16r6C41 16r9DDE 16r6C42 16r9DDF 16r6C43 16r9DE0 16r6C44 16r9DE5 16r6C45 16r9DE7 16r6C46 16r9DE9 16r6C47 16r9DEB 16r6C48 16r9DEE 16r6C49 16r9DF0 16r6C4A 16r9DF3 16r6C4B 16r9DF4 16r6C4C 16r9DFE 16r6C4D 16r9E0A 16r6C4E 16r9E02 16r6C4F 16r9E07 16r6C50 16r9E0E 16r6C51 16r9E10 16r6C52 16r9E11 16r6C53 16r9E12 16r6C54 16r9E15 16r6C55 16r9E16 16r6C56 16r9E19 16r6C57 16r9E1C 16r6C58 16r9E1D 16r6C59 16r9E7A 16r6C5A 16r9E7B 16r6C5B 16r9E7C 16r6C5C 16r9E80 16r6C5D 16r9E82 16r6C5E 16r9E83 16r6C5F 16r9E84 16r6C60 16r9E85 16r6C61 16r9E87 16r6C62 16r9E8E 16r6C63 16r9E8F 16r6C64 16r9E96 16r6C65 16r9E98 16r6C66 16r9E9B 16r6C67 16r9E9E 16r6C68 16r9EA4 16r6C69 16r9EA8 16r6C6A 16r9EAC 16r6C6B 16r9EAE 16r6C6C 16r9EAF 16r6C6D 16r9EB0 16r6C6E 16r9EB3 16r6C6F 16r9EB4 16r6C70 16r9EB5 16r6C71 16r9EC6 16r6C72 16r9EC8 16r6C73 16r9ECB 16r6C74 16r9ED5 16r6C75 16r9EDF 16r6C76 16r9EE4 16r6C77 16r9EE7 16r6C78 16r9EEC 16r6C79 16r9EED 16r6C7A 16r9EEE 16r6C7B 16r9EF0 16r6C7C 16r9EF1 16r6C7D 16r9EF2 16r6C7E 16r9EF5 16r6D21 16r9EF8 16r6D22 16r9EFF 16r6D23 16r9F02 16r6D24 16r9F03 16r6D25 16r9F09 16r6D26 16r9F0F 16r6D27 16r9F10 16r6D28 16r9F11 16r6D29 16r9F12 16r6D2A 16r9F14 16r6D2B 16r9F16 16r6D2C 16r9F17 16r6D2D 16r9F19 16r6D2E 16r9F1A 16r6D2F 16r9F1B 16r6D30 16r9F1F 16r6D31 16r9F22 16r6D32 16r9F26 16r6D33 16r9F2A 16r6D34 16r9F2B 16r6D35 16r9F2F 16r6D36 16r9F31 16r6D37 16r9F32 16r6D38 16r9F34 16r6D39 16r9F37 16r6D3A 16r9F39 16r6D3B 16r9F3A 16r6D3C 16r9F3C 16r6D3D 16r9F3D 16r6D3E 16r9F3F 16r6D3F 16r9F41 16r6D40 16r9F43 16r6D41 16r9F44 16r6D42 16r9F45 16r6D43 16r9F46 16r6D44 16r9F47 16r6D45 16r9F53 16r6D46 16r9F55 16r6D47 16r9F56 16r6D48 16r9F57 16r6D49 16r9F58 16r6D4A 16r9F5A 16r6D4B 16r9F5D 16r6D4C 16r9F5E 16r6D4D 16r9F68 16r6D4E 16r9F69 16r6D4F 16r9F6D 16r6D50 16r9F6E 16r6D51 16r9F6F 16r6D52 16r9F70 16r6D53 16r9F71 16r6D54 16r9F73 16r6D55 16r9F75 16r6D56 16r9F7A 16r6D57 16r9F7D 16r6D58 16r9F8F 16r6D59 16r9F90 16r6D5A 16r9F91 16r6D5B 16r9F92 16r6D5C 16r9F94 16r6D5D 16r9F96 16r6D5E 16r9F97 16r6D5F 16r9F9E 16r6D60 16r9FA1 16r6D61 16r9FA2 16r6D62 16r9FA3 16r6D63 16r9FA5).
	encoder name: #''jisx0212.1990-0''.
	^encoder'</body>

<body package="Jpl" selector="shiftJISEncoderInCharacterEncoderClass">shiftJISEncoderInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-jis character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'shiftJISEncoder
	"CharacterEncoder shiftJISEncoder."

	| encoder |
	encoder := self 
				createLargeCharacterEncoder: #(16r20 16r20 16r21 16r21 16r22 16r22 16r23 16r23 16r24 16r24 16r25 16r25 16r26 16r26 16r27 16r27 16r28 16r28 16r29 16r29 16r2A 16r2A 16r2B 16r2B 16r2C 16r2C 16r2D 16r2D 16r2E 16r2E 16r2F 16r2F 16r30 16r30 16r31 16r31 16r32 16r32 16r33 16r33 16r34 16r34 16r35 16r35 16r36 16r36 16r37 16r37 16r38 16r38 16r39 16r39 16r3A 16r3A 16r3B 16r3B 16r3C 16r3C 16r3D 16r3D 16r3E 16r3E 16r3F 16r3F 16r40 16r40 16r41 16r41 16r42 16r42 16r43 16r43 16r44 16r44 16r45 16r45 16r46 16r46 16r47 16r47 16r48 16r48 16r49 16r49 16r4A 16r4A 16r4B 16r4B 16r4C 16r4C 16r4D 16r4D 16r4E 16r4E 16r4F 16r4F 16r50 16r50 16r51 16r51 16r52 16r52 16r53 16r53 16r54 16r54 16r55 16r55 16r56 16r56 16r57 16r57 16r58 16r58 16r59 16r59 16r5A 16r5A 16r5B 16r5B 16r5C 16rA5 16r5D 16r5D 16r5E 16r5E 16r5F 16r5F 16r60 16r60 16r61 16r61 16r62 16r62 16r63 16r63 16r64 16r64 16r65 16r65 16r66 16r66 16r67 16r67 16r68 16r68 16r69 16r69 16r6A 16r6A 16r6B 16r6B 16r6C 16r6C 16r6D 16r6D 16r6E 16r6E 16r6F 16r6F 16r70 16r70 16r71 16r71 16r72 16r72 16r73 16r73 16r74 16r74 16r75 16r75 16r76 16r76 16r77 16r77 16r78 16r78 16r79 16r79 16r7A 16r7A 16r7B 16r7B 16r7C 16r7C 16r7D 16r7D 16r7E 16r203E 16r8140 16r3000 16r8141 16r3001 16r8142 16r3002 16r8143 16rFF0C 16r8144 16rFF0E 16r8145 16r30FB 16r8146 16rFF1A 16r8147 16rFF1B 16r8148 16rFF1F 16r8149 16rFF01 16r814A 16r309B 16r814B 16r309C 16r814C 16rB4 16r814D 16rFF40 16r814E 16rA8 16r814F 16rFF3E 16r8150 16rFFE3 16r8151 16rFF3F 16r8152 16r30FD 16r8153 16r30FE 16r8154 16r309D 16r8155 16r309E 16r8156 16r3003 16r8157 16r4EDD 16r8158 16r3005 16r8159 16r3006 16r815A 16r3007 16r815B 16r30FC 16r815C 16r2015 16r815D 16r2010 16r815E 16rFF0F 16r815F 16rFF3C 16r8160 16r301C 16r8161 16r2016 16r8162 16rFF5C 16r8163 16r2026 16r8164 16r2025 16r8165 16r2018 16r8166 16r2019 16r8167 16r201C 16r8168 16r201D 16r8169 16rFF08 16r816A 16rFF09 16r816B 16r3014 16r816C 16r3015 16r816D 16rFF3B 16r816E 16rFF3D 16r816F 16rFF5B 16r8170 16rFF5D 16r8171 16r3008 16r8172 16r3009 16r8173 16r300A 16r8174 16r300B 16r8175 16r300C 16r8176 16r300D 16r8177 16r300E 16r8178 16r300F 16r8179 16r3010 16r817A 16r3011 16r817B 16rFF0B 16r817C 16r2212 16r817D 16rB1 16r817E 16rD7 16r8180 16rF7 16r8181 16rFF1D 16r8182 16r2260 16r8183 16rFF1C 16r8184 16rFF1E 16r8185 16r2266 16r8186 16r2267 16r8187 16r221E 16r8188 16r2234 16r8189 16r2642 16r818A 16r2640 16r818B 16rB0 16r818C 16r2032 16r818D 16r2033 16r818E 16r2103 16r818F 16rFFE5 16r8190 16rFF04 16r8191 16rA2 16r8192 16rA3 16r8193 16rFF05 16r8194 16rFF03 16r8195 16rFF06 16r8196 16rFF0A 16r8197 16rFF20 16r8198 16rA7 16r8199 16r2606 16r819A 16r2605 16r819B 16r25CB 16r819C 16r25CF 16r819D 16r25CE 16r819E 16r25C7 16r819F 16r25C6 16r81A0 16r25A1 16r81A1 16r25A0 16r81A2 16r25B3 16r81A3 16r25B2 16r81A4 16r25BD 16r81A5 16r25BC 16r81A6 16r203B 16r81A7 16r3012 16r81A8 16r2192 16r81A9 16r2190 16r81AA 16r2191 16r81AB 16r2193 16r81AC 16r3013 16r81B8 16r2208 16r81B9 16r220B 16r81BA 16r2286 16r81BB 16r2287 16r81BC 16r2282 16r81BD 16r2283 16r81BE 16r222A 16r81BF 16r2229 16r81C8 16r2227 16r81C9 16r2228 16r81CA 16rAC 16r81CB 16r21D2 16r81CC 16r21D4 16r81CD 16r2200 16r81CE 16r2203 16r81DA 16r2220 16r81DB 16r22A5 16r81DC 16r2312 16r81DD 16r2202 16r81DE 16r2207 16r81DF 16r2261 16r81E0 16r2252 16r81E1 16r226A 16r81E2 16r226B 16r81E3 16r221A 16r81E4 16r223D 16r81E5 16r221D 16r81E6 16r2235 16r81E7 16r222B 16r81E8 16r222C 16r81F0 16r212B 16r81F1 16r2030 16r81F2 16r266F 16r81F3 16r266D 16r81F4 16r266A 16r81F5 16r2020 16r81F6 16r2021 16r81F7 16rB6 16r81FC 16r25EF 16r824F 16rFF10 16r8250 16rFF11 16r8251 16rFF12 16r8252 16rFF13 16r8253 16rFF14 16r8254 16rFF15 16r8255 16rFF16 16r8256 16rFF17 16r8257 16rFF18 16r8258 16rFF19 16r8260 16rFF21 16r8261 16rFF22 16r8262 16rFF23 16r8263 16rFF24 16r8264 16rFF25 16r8265 16rFF26 16r8266 16rFF27 16r8267 16rFF28 16r8268 16rFF29 16r8269 16rFF2A 16r826A 16rFF2B 16r826B 16rFF2C 16r826C 16rFF2D 16r826D 16rFF2E 16r826E 16rFF2F 16r826F 16rFF30 16r8270 16rFF31 16r8271 16rFF32 16r8272 16rFF33 16r8273 16rFF34 16r8274 16rFF35 16r8275 16rFF36 16r8276 16rFF37 16r8277 16rFF38 16r8278 16rFF39 16r8279 16rFF3A 16r8281 16rFF41 16r8282 16rFF42 16r8283 16rFF43 16r8284 16rFF44 16r8285 16rFF45 16r8286 16rFF46 16r8287 16rFF47 16r8288 16rFF48 16r8289 16rFF49 16r828A 16rFF4A 16r828B 16rFF4B 16r828C 16rFF4C 16r828D 16rFF4D 16r828E 16rFF4E 16r828F 16rFF4F 16r8290 16rFF50 16r8291 16rFF51 16r8292 16rFF52 16r8293 16rFF53 16r8294 16rFF54 16r8295 16rFF55 16r8296 16rFF56 16r8297 16rFF57 16r8298 16rFF58 16r8299 16rFF59 16r829A 16rFF5A 16r829F 16r3041 16r82A0 16r3042 16r82A1 16r3043 16r82A2 16r3044 16r82A3 16r3045 16r82A4 16r3046 16r82A5 16r3047 16r82A6 16r3048 16r82A7 16r3049 16r82A8 16r304A 16r82A9 16r304B 16r82AA 16r304C 16r82AB 16r304D 16r82AC 16r304E 16r82AD 16r304F 16r82AE 16r3050 16r82AF 16r3051 16r82B0 16r3052 16r82B1 16r3053 16r82B2 16r3054 16r82B3 16r3055 16r82B4 16r3056 16r82B5 16r3057 16r82B6 16r3058 16r82B7 16r3059 16r82B8 16r305A 16r82B9 16r305B 16r82BA 16r305C 16r82BB 16r305D 16r82BC 16r305E 16r82BD 16r305F 16r82BE 16r3060 16r82BF 16r3061 16r82C0 16r3062 16r82C1 16r3063 16r82C2 16r3064 16r82C3 16r3065 16r82C4 16r3066 16r82C5 16r3067 16r82C6 16r3068 16r82C7 16r3069 16r82C8 16r306A 16r82C9 16r306B 16r82CA 16r306C 16r82CB 16r306D 16r82CC 16r306E 16r82CD 16r306F 16r82CE 16r3070 16r82CF 16r3071 16r82D0 16r3072 16r82D1 16r3073 16r82D2 16r3074 16r82D3 16r3075 16r82D4 16r3076 16r82D5 16r3077 16r82D6 16r3078 16r82D7 16r3079 16r82D8 16r307A 16r82D9 16r307B 16r82DA 16r307C 16r82DB 16r307D 16r82DC 16r307E 16r82DD 16r307F 16r82DE 16r3080 16r82DF 16r3081 16r82E0 16r3082 16r82E1 16r3083 16r82E2 16r3084 16r82E3 16r3085 16r82E4 16r3086 16r82E5 16r3087 16r82E6 16r3088 16r82E7 16r3089 16r82E8 16r308A 16r82E9 16r308B 16r82EA 16r308C 16r82EB 16r308D 16r82EC 16r308E 16r82ED 16r308F 16r82EE 16r3090 16r82EF 16r3091 16r82F0 16r3092 16r82F1 16r3093 16r8340 16r30A1 16r8341 16r30A2 16r8342 16r30A3 16r8343 16r30A4 16r8344 16r30A5 16r8345 16r30A6 16r8346 16r30A7 16r8347 16r30A8 16r8348 16r30A9 16r8349 16r30AA 16r834A 16r30AB 16r834B 16r30AC 16r834C 16r30AD 16r834D 16r30AE 16r834E 16r30AF 16r834F 16r30B0 16r8350 16r30B1 16r8351 16r30B2 16r8352 16r30B3 16r8353 16r30B4 16r8354 16r30B5 16r8355 16r30B6 16r8356 16r30B7 16r8357 16r30B8 16r8358 16r30B9 16r8359 16r30BA 16r835A 16r30BB 16r835B 16r30BC 16r835C 16r30BD 16r835D 16r30BE 16r835E 16r30BF 16r835F 16r30C0 16r8360 16r30C1 16r8361 16r30C2 16r8362 16r30C3 16r8363 16r30C4 16r8364 16r30C5 16r8365 16r30C6 16r8366 16r30C7 16r8367 16r30C8 16r8368 16r30C9 16r8369 16r30CA 16r836A 16r30CB 16r836B 16r30CC 16r836C 16r30CD 16r836D 16r30CE 16r836E 16r30CF 16r836F 16r30D0 16r8370 16r30D1 16r8371 16r30D2 16r8372 16r30D3 16r8373 16r30D4 16r8374 16r30D5 16r8375 16r30D6 16r8376 16r30D7 16r8377 16r30D8 16r8378 16r30D9 16r8379 16r30DA 16r837A 16r30DB 16r837B 16r30DC 16r837C 16r30DD 16r837D 16r30DE 16r837E 16r30DF 16r8380 16r30E0 16r8381 16r30E1 16r8382 16r30E2 16r8383 16r30E3 16r8384 16r30E4 16r8385 16r30E5 16r8386 16r30E6 16r8387 16r30E7 16r8388 16r30E8 16r8389 16r30E9 16r838A 16r30EA 16r838B 16r30EB 16r838C 16r30EC 16r838D 16r30ED 16r838E 16r30EE 16r838F 16r30EF 16r8390 16r30F0 16r8391 16r30F1 16r8392 16r30F2 16r8393 16r30F3 16r8394 16r30F4 16r8395 16r30F5 16r8396 16r30F6 16r839F 16r391 16r83A0 16r392 16r83A1 16r393 16r83A2 16r394 16r83A3 16r395 16r83A4 16r396 16r83A5 16r397 16r83A6 16r398 16r83A7 16r399 16r83A8 16r39A 16r83A9 16r39B 16r83AA 16r39C 16r83AB 16r39D 16r83AC 16r39E 16r83AD 16r39F 16r83AE 16r3A0 16r83AF 16r3A1 16r83B0 16r3A3 16r83B1 16r3A4 16r83B2 16r3A5 16r83B3 16r3A6 16r83B4 16r3A7 16r83B5 16r3A8 16r83B6 16r3A9 16r83BF 16r3B1 16r83C0 16r3B2 16r83C1 16r3B3 16r83C2 16r3B4 16r83C3 16r3B5 16r83C4 16r3B6 16r83C5 16r3B7 16r83C6 16r3B8 16r83C7 16r3B9 16r83C8 16r3BA 16r83C9 16r3BB 16r83CA 16r3BC 16r83CB 16r3BD 16r83CC 16r3BE 16r83CD 16r3BF 16r83CE 16r3C0 16r83CF 16r3C1 16r83D0 16r3C3 16r83D1 16r3C4 16r83D2 16r3C5 16r83D3 16r3C6 16r83D4 16r3C7 16r83D5 16r3C8 16r83D6 16r3C9 16r8440 16r410 16r8441 16r411 16r8442 16r412 16r8443 16r413 16r8444 16r414 16r8445 16r415 16r8446 16r401 16r8447 16r416 16r8448 16r417 16r8449 16r418 16r844A 16r419 16r844B 16r41A 16r844C 16r41B 16r844D 16r41C 16r844E 16r41D 16r844F 16r41E 16r8450 16r41F 16r8451 16r420 16r8452 16r421 16r8453 16r422 16r8454 16r423 16r8455 16r424 16r8456 16r425 16r8457 16r426 16r8458 16r427 16r8459 16r428 16r845A 16r429 16r845B 16r42A 16r845C 16r42B 16r845D 16r42C 16r845E 16r42D 16r845F 16r42E 16r8460 16r42F 16r8470 16r430 16r8471 16r431 16r8472 16r432 16r8473 16r433 16r8474 16r434 16r8475 16r435 16r8476 16r451 16r8477 16r436 16r8478 16r437 16r8479 16r438 16r847A 16r439 16r847B 16r43A 16r847C 16r43B 16r847D 16r43C 16r847E 16r43D 16r8480 16r43E 16r8481 16r43F 16r8482 16r440 16r8483 16r441 16r8484 16r442 16r8485 16r443 16r8486 16r444 16r8487 16r445 16r8488 16r446 16r8489 16r447 16r848A 16r448 16r848B 16r449 16r848C 16r44A 16r848D 16r44B 16r848E 16r44C 16r848F 16r44D 16r8490 16r44E 16r8491 16r44F 16r849F 16r2500 16r84A0 16r2502 16r84A1 16r250C 16r84A2 16r2510 16r84A3 16r2518 16r84A4 16r2514 16r84A5 16r251C 16r84A6 16r252C 16r84A7 16r2524 16r84A8 16r2534 16r84A9 16r253C 16r84AA 16r2501 16r84AB 16r2503 16r84AC 16r250F 16r84AD 16r2513 16r84AE 16r251B 16r84AF 16r2517 16r84B0 16r2523 16r84B1 16r2533 16r84B2 16r252B 16r84B3 16r253B 16r84B4 16r254B 16r84B5 16r2520 16r84B6 16r252F 16r84B7 16r2528 16r84B8 16r2537 16r84B9 16r253F 16r84BA 16r251D 16r84BB 16r2530 16r84BC 16r2525 16r84BD 16r2538 16r84BE 16r2542 16r889F 16r4E9C 16r88A0 16r5516 16r88A1 16r5A03 16r88A2 16r963F 16r88A3 16r54C0 16r88A4 16r611B 16r88A5 16r6328 16r88A6 16r59F6 16r88A7 16r9022 16r88A8 16r8475 16r88A9 16r831C 16r88AA 16r7A50 16r88AB 16r60AA 16r88AC 16r63E1 16r88AD 16r6E25 16r88AE 16r65ED 16r88AF 16r8466 16r88B0 16r82A6 16r88B1 16r9BF5 16r88B2 16r6893 16r88B3 16r5727 16r88B4 16r65A1 16r88B5 16r6271 16r88B6 16r5B9B 16r88B7 16r59D0 16r88B8 16r867B 16r88B9 16r98F4 16r88BA 16r7D62 16r88BB 16r7DBE 16r88BC 16r9B8E 16r88BD 16r6216 16r88BE 16r7C9F 16r88BF 16r88B7 16r88C0 16r5B89 16r88C1 16r5EB5 16r88C2 16r6309 16r88C3 16r6697 16r88C4 16r6848 16r88C5 16r95C7 16r88C6 16r978D 16r88C7 16r674F 16r88C8 16r4EE5 16r88C9 16r4F0A 16r88CA 16r4F4D 16r88CB 16r4F9D 16r88CC 16r5049 16r88CD 16r56F2 16r88CE 16r5937 16r88CF 16r59D4 16r88D0 16r5A01 16r88D1 16r5C09 16r88D2 16r60DF 16r88D3 16r610F 16r88D4 16r6170 16r88D5 16r6613 16r88D6 16r6905 16r88D7 16r70BA 16r88D8 16r754F 16r88D9 16r7570 16r88DA 16r79FB 16r88DB 16r7DAD 16r88DC 16r7DEF 16r88DD 16r80C3 16r88DE 16r840E 16r88DF 16r8863 16r88E0 16r8B02 16r88E1 16r9055 16r88E2 16r907A 16r88E3 16r533B 16r88E4 16r4E95 16r88E5 16r4EA5 16r88E6 16r57DF 16r88E7 16r80B2 16r88E8 16r90C1 16r88E9 16r78EF 16r88EA 16r4E00 16r88EB 16r58F1 16r88EC 16r6EA2 16r88ED 16r9038 16r88EE 16r7A32 16r88EF 16r8328 16r88F0 16r828B 16r88F1 16r9C2F 16r88F2 16r5141 16r88F3 16r5370 16r88F4 16r54BD 16r88F5 16r54E1 16r88F6 16r56E0 16r88F7 16r59FB 16r88F8 16r5F15 16r88F9 16r98F2 16r88FA 16r6DEB 16r88FB 16r80E4 16r88FC 16r852D 16r8940 16r9662 16r8941 16r9670 16r8942 16r96A0 16r8943 16r97FB 16r8944 16r540B 16r8945 16r53F3 16r8946 16r5B87 16r8947 16r70CF 16r8948 16r7FBD 16r8949 16r8FC2 16r894A 16r96E8 16r894B 16r536F 16r894C 16r9D5C 16r894D 16r7ABA 16r894E 16r4E11 16r894F 16r7893 16r8950 16r81FC 16r8951 16r6E26 16r8952 16r5618 16r8953 16r5504 16r8954 16r6B1D 16r8955 16r851A 16r8956 16r9C3B 16r8957 16r59E5 16r8958 16r53A9 16r8959 16r6D66 16r895A 16r74DC 16r895B 16r958F 16r895C 16r5642 16r895D 16r4E91 16r895E 16r904B 16r895F 16r96F2 16r8960 16r834F 16r8961 16r990C 16r8962 16r53E1 16r8963 16r55B6 16r8964 16r5B30 16r8965 16r5F71 16r8966 16r6620 16r8967 16r66F3 16r8968 16r6804 16r8969 16r6C38 16r896A 16r6CF3 16r896B 16r6D29 16r896C 16r745B 16r896D 16r76C8 16r896E 16r7A4E 16r896F 16r9834 16r8970 16r82F1 16r8971 16r885B 16r8972 16r8A60 16r8973 16r92ED 16r8974 16r6DB2 16r8975 16r75AB 16r8976 16r76CA 16r8977 16r99C5 16r8978 16r60A6 16r8979 16r8B01 16r897A 16r8D8A 16r897B 16r95B2 16r897C 16r698E 16r897D 16r53AD 16r897E 16r5186 16r8980 16r5712 16r8981 16r5830 16r8982 16r5944 16r8983 16r5BB4 16r8984 16r5EF6 16r8985 16r6028 16r8986 16r63A9 16r8987 16r63F4 16r8988 16r6CBF 16r8989 16r6F14 16r898A 16r708E 16r898B 16r7114 16r898C 16r7159 16r898D 16r71D5 16r898E 16r733F 16r898F 16r7E01 16r8990 16r8276 16r8991 16r82D1 16r8992 16r8597 16r8993 16r9060 16r8994 16r925B 16r8995 16r9D1B 16r8996 16r5869 16r8997 16r65BC 16r8998 16r6C5A 16r8999 16r7525 16r899A 16r51F9 16r899B 16r592E 16r899C 16r5965 16r899D 16r5F80 16r899E 16r5FDC 16r899F 16r62BC 16r89A0 16r65FA 16r89A1 16r6A2A 16r89A2 16r6B27 16r89A3 16r6BB4 16r89A4 16r738B 16r89A5 16r7FC1 16r89A6 16r8956 16r89A7 16r9D2C 16r89A8 16r9D0E 16r89A9 16r9EC4 16r89AA 16r5CA1 16r89AB 16r6C96 16r89AC 16r837B 16r89AD 16r5104 16r89AE 16r5C4B 16r89AF 16r61B6 16r89B0 16r81C6 16r89B1 16r6876 16r89B2 16r7261 16r89B3 16r4E59 16r89B4 16r4FFA 16r89B5 16r5378 16r89B6 16r6069 16r89B7 16r6E29 16r89B8 16r7A4F 16r89B9 16r97F3 16r89BA 16r4E0B 16r89BB 16r5316 16r89BC 16r4EEE 16r89BD 16r4F55 16r89BE 16r4F3D 16r89BF 16r4FA1 16r89C0 16r4F73 16r89C1 16r52A0 16r89C2 16r53EF 16r89C3 16r5609 16r89C4 16r590F 16r89C5 16r5AC1 16r89C6 16r5BB6 16r89C7 16r5BE1 16r89C8 16r79D1 16r89C9 16r6687 16r89CA 16r679C 16r89CB 16r67B6 16r89CC 16r6B4C 16r89CD 16r6CB3 16r89CE 16r706B 16r89CF 16r73C2 16r89D0 16r798D 16r89D1 16r79BE 16r89D2 16r7A3C 16r89D3 16r7B87 16r89D4 16r82B1 16r89D5 16r82DB 16r89D6 16r8304 16r89D7 16r8377 16r89D8 16r83EF 16r89D9 16r83D3 16r89DA 16r8766 16r89DB 16r8AB2 16r89DC 16r5629 16r89DD 16r8CA8 16r89DE 16r8FE6 16r89DF 16r904E 16r89E0 16r971E 16r89E1 16r868A 16r89E2 16r4FC4 16r89E3 16r5CE8 16r89E4 16r6211 16r89E5 16r7259 16r89E6 16r753B 16r89E7 16r81E5 16r89E8 16r82BD 16r89E9 16r86FE 16r89EA 16r8CC0 16r89EB 16r96C5 16r89EC 16r9913 16r89ED 16r99D5 16r89EE 16r4ECB 16r89EF 16r4F1A 16r89F0 16r89E3 16r89F1 16r56DE 16r89F2 16r584A 16r89F3 16r58CA 16r89F4 16r5EFB 16r89F5 16r5FEB 16r89F6 16r602A 16r89F7 16r6094 16r89F8 16r6062 16r89F9 16r61D0 16r89FA 16r6212 16r89FB 16r62D0 16r89FC 16r6539 16r8A40 16r9B41 16r8A41 16r6666 16r8A42 16r68B0 16r8A43 16r6D77 16r8A44 16r7070 16r8A45 16r754C 16r8A46 16r7686 16r8A47 16r7D75 16r8A48 16r82A5 16r8A49 16r87F9 16r8A4A 16r958B 16r8A4B 16r968E 16r8A4C 16r8C9D 16r8A4D 16r51F1 16r8A4E 16r52BE 16r8A4F 16r5916 16r8A50 16r54B3 16r8A51 16r5BB3 16r8A52 16r5D16 16r8A53 16r6168 16r8A54 16r6982 16r8A55 16r6DAF 16r8A56 16r788D 16r8A57 16r84CB 16r8A58 16r8857 16r8A59 16r8A72 16r8A5A 16r93A7 16r8A5B 16r9AB8 16r8A5C 16r6D6C 16r8A5D 16r99A8 16r8A5E 16r86D9 16r8A5F 16r57A3 16r8A60 16r67FF 16r8A61 16r86CE 16r8A62 16r920E 16r8A63 16r5283 16r8A64 16r5687 16r8A65 16r5404 16r8A66 16r5ED3 16r8A67 16r62E1 16r8A68 16r64B9 16r8A69 16r683C 16r8A6A 16r6838 16r8A6B 16r6BBB 16r8A6C 16r7372 16r8A6D 16r78BA 16r8A6E 16r7A6B 16r8A6F 16r899A 16r8A70 16r89D2 16r8A71 16r8D6B 16r8A72 16r8F03 16r8A73 16r90ED 16r8A74 16r95A3 16r8A75 16r9694 16r8A76 16r9769 16r8A77 16r5B66 16r8A78 16r5CB3 16r8A79 16r697D 16r8A7A 16r984D 16r8A7B 16r984E 16r8A7C 16r639B 16r8A7D 16r7B20 16r8A7E 16r6A2B 16r8A80 16r6A7F 16r8A81 16r68B6 16r8A82 16r9C0D 16r8A83 16r6F5F 16r8A84 16r5272 16r8A85 16r559D 16r8A86 16r6070 16r8A87 16r62EC 16r8A88 16r6D3B 16r8A89 16r6E07 16r8A8A 16r6ED1 16r8A8B 16r845B 16r8A8C 16r8910 16r8A8D 16r8F44 16r8A8E 16r4E14 16r8A8F 16r9C39 16r8A90 16r53F6 16r8A91 16r691B 16r8A92 16r6A3A 16r8A93 16r9784 16r8A94 16r682A 16r8A95 16r515C 16r8A96 16r7AC3 16r8A97 16r84B2 16r8A98 16r91DC 16r8A99 16r938C 16r8A9A 16r565B 16r8A9B 16r9D28 16r8A9C 16r6822 16r8A9D 16r8305 16r8A9E 16r8431 16r8A9F 16r7CA5 16r8AA0 16r5208 16r8AA1 16r82C5 16r8AA2 16r74E6 16r8AA3 16r4E7E 16r8AA4 16r4F83 16r8AA5 16r51A0 16r8AA6 16r5BD2 16r8AA7 16r520A 16r8AA8 16r52D8 16r8AA9 16r52E7 16r8AAA 16r5DFB 16r8AAB 16r559A 16r8AAC 16r582A 16r8AAD 16r59E6 16r8AAE 16r5B8C 16r8AAF 16r5B98 16r8AB0 16r5BDB 16r8AB1 16r5E72 16r8AB2 16r5E79 16r8AB3 16r60A3 16r8AB4 16r611F 16r8AB5 16r6163 16r8AB6 16r61BE 16r8AB7 16r63DB 16r8AB8 16r6562 16r8AB9 16r67D1 16r8ABA 16r6853 16r8ABB 16r68FA 16r8ABC 16r6B3E 16r8ABD 16r6B53 16r8ABE 16r6C57 16r8ABF 16r6F22 16r8AC0 16r6F97 16r8AC1 16r6F45 16r8AC2 16r74B0 16r8AC3 16r7518 16r8AC4 16r76E3 16r8AC5 16r770B 16r8AC6 16r7AFF 16r8AC7 16r7BA1 16r8AC8 16r7C21 16r8AC9 16r7DE9 16r8ACA 16r7F36 16r8ACB 16r7FF0 16r8ACC 16r809D 16r8ACD 16r8266 16r8ACE 16r839E 16r8ACF 16r89B3 16r8AD0 16r8ACC 16r8AD1 16r8CAB 16r8AD2 16r9084 16r8AD3 16r9451 16r8AD4 16r9593 16r8AD5 16r9591 16r8AD6 16r95A2 16r8AD7 16r9665 16r8AD8 16r97D3 16r8AD9 16r9928 16r8ADA 16r8218 16r8ADB 16r4E38 16r8ADC 16r542B 16r8ADD 16r5CB8 16r8ADE 16r5DCC 16r8ADF 16r73A9 16r8AE0 16r764C 16r8AE1 16r773C 16r8AE2 16r5CA9 16r8AE3 16r7FEB 16r8AE4 16r8D0B 16r8AE5 16r96C1 16r8AE6 16r9811 16r8AE7 16r9854 16r8AE8 16r9858 16r8AE9 16r4F01 16r8AEA 16r4F0E 16r8AEB 16r5371 16r8AEC 16r559C 16r8AED 16r5668 16r8AEE 16r57FA 16r8AEF 16r5947 16r8AF0 16r5B09 16r8AF1 16r5BC4 16r8AF2 16r5C90 16r8AF3 16r5E0C 16r8AF4 16r5E7E 16r8AF5 16r5FCC 16r8AF6 16r63EE 16r8AF7 16r673A 16r8AF8 16r65D7 16r8AF9 16r65E2 16r8AFA 16r671F 16r8AFB 16r68CB 16r8AFC 16r68C4 16r8B40 16r6A5F 16r8B41 16r5E30 16r8B42 16r6BC5 16r8B43 16r6C17 16r8B44 16r6C7D 16r8B45 16r757F 16r8B46 16r7948 16r8B47 16r5B63 16r8B48 16r7A00 16r8B49 16r7D00 16r8B4A 16r5FBD 16r8B4B 16r898F 16r8B4C 16r8A18 16r8B4D 16r8CB4 16r8B4E 16r8D77 16r8B4F 16r8ECC 16r8B50 16r8F1D 16r8B51 16r98E2 16r8B52 16r9A0E 16r8B53 16r9B3C 16r8B54 16r4E80 16r8B55 16r507D 16r8B56 16r5100 16r8B57 16r5993 16r8B58 16r5B9C 16r8B59 16r622F 16r8B5A 16r6280 16r8B5B 16r64EC 16r8B5C 16r6B3A 16r8B5D 16r72A0 16r8B5E 16r7591 16r8B5F 16r7947 16r8B60 16r7FA9 16r8B61 16r87FB 16r8B62 16r8ABC 16r8B63 16r8B70 16r8B64 16r63AC 16r8B65 16r83CA 16r8B66 16r97A0 16r8B67 16r5409 16r8B68 16r5403 16r8B69 16r55AB 16r8B6A 16r6854 16r8B6B 16r6A58 16r8B6C 16r8A70 16r8B6D 16r7827 16r8B6E 16r6775 16r8B6F 16r9ECD 16r8B70 16r5374 16r8B71 16r5BA2 16r8B72 16r811A 16r8B73 16r8650 16r8B74 16r9006 16r8B75 16r4E18 16r8B76 16r4E45 16r8B77 16r4EC7 16r8B78 16r4F11 16r8B79 16r53CA 16r8B7A 16r5438 16r8B7B 16r5BAE 16r8B7C 16r5F13 16r8B7D 16r6025 16r8B7E 16r6551 16r8B80 16r673D 16r8B81 16r6C42 16r8B82 16r6C72 16r8B83 16r6CE3 16r8B84 16r7078 16r8B85 16r7403 16r8B86 16r7A76 16r8B87 16r7AAE 16r8B88 16r7B08 16r8B89 16r7D1A 16r8B8A 16r7CFE 16r8B8B 16r7D66 16r8B8C 16r65E7 16r8B8D 16r725B 16r8B8E 16r53BB 16r8B8F 16r5C45 16r8B90 16r5DE8 16r8B91 16r62D2 16r8B92 16r62E0 16r8B93 16r6319 16r8B94 16r6E20 16r8B95 16r865A 16r8B96 16r8A31 16r8B97 16r8DDD 16r8B98 16r92F8 16r8B99 16r6F01 16r8B9A 16r79A6 16r8B9B 16r9B5A 16r8B9C 16r4EA8 16r8B9D 16r4EAB 16r8B9E 16r4EAC 16r8B9F 16r4F9B 16r8BA0 16r4FA0 16r8BA1 16r50D1 16r8BA2 16r5147 16r8BA3 16r7AF6 16r8BA4 16r5171 16r8BA5 16r51F6 16r8BA6 16r5354 16r8BA7 16r5321 16r8BA8 16r537F 16r8BA9 16r53EB 16r8BAA 16r55AC 16r8BAB 16r5883 16r8BAC 16r5CE1 16r8BAD 16r5F37 16r8BAE 16r5F4A 16r8BAF 16r602F 16r8BB0 16r6050 16r8BB1 16r606D 16r8BB2 16r631F 16r8BB3 16r6559 16r8BB4 16r6A4B 16r8BB5 16r6CC1 16r8BB6 16r72C2 16r8BB7 16r72ED 16r8BB8 16r77EF 16r8BB9 16r80F8 16r8BBA 16r8105 16r8BBB 16r8208 16r8BBC 16r854E 16r8BBD 16r90F7 16r8BBE 16r93E1 16r8BBF 16r97FF 16r8BC0 16r9957 16r8BC1 16r9A5A 16r8BC2 16r4EF0 16r8BC3 16r51DD 16r8BC4 16r5C2D 16r8BC5 16r6681 16r8BC6 16r696D 16r8BC7 16r5C40 16r8BC8 16r66F2 16r8BC9 16r6975 16r8BCA 16r7389 16r8BCB 16r6850 16r8BCC 16r7C81 16r8BCD 16r50C5 16r8BCE 16r52E4 16r8BCF 16r5747 16r8BD0 16r5DFE 16r8BD1 16r9326 16r8BD2 16r65A4 16r8BD3 16r6B23 16r8BD4 16r6B3D 16r8BD5 16r7434 16r8BD6 16r7981 16r8BD7 16r79BD 16r8BD8 16r7B4B 16r8BD9 16r7DCA 16r8BDA 16r82B9 16r8BDB 16r83CC 16r8BDC 16r887F 16r8BDD 16r895F 16r8BDE 16r8B39 16r8BDF 16r8FD1 16r8BE0 16r91D1 16r8BE1 16r541F 16r8BE2 16r9280 16r8BE3 16r4E5D 16r8BE4 16r5036 16r8BE5 16r53E5 16r8BE6 16r533A 16r8BE7 16r72D7 16r8BE8 16r7396 16r8BE9 16r77E9 16r8BEA 16r82E6 16r8BEB 16r8EAF 16r8BEC 16r99C6 16r8BED 16r99C8 16r8BEE 16r99D2 16r8BEF 16r5177 16r8BF0 16r611A 16r8BF1 16r865E 16r8BF2 16r55B0 16r8BF3 16r7A7A 16r8BF4 16r5076 16r8BF5 16r5BD3 16r8BF6 16r9047 16r8BF7 16r9685 16r8BF8 16r4E32 16r8BF9 16r6ADB 16r8BFA 16r91E7 16r8BFB 16r5C51 16r8BFC 16r5C48 16r8C40 16r6398 16r8C41 16r7A9F 16r8C42 16r6C93 16r8C43 16r9774 16r8C44 16r8F61 16r8C45 16r7AAA 16r8C46 16r718A 16r8C47 16r9688 16r8C48 16r7C82 16r8C49 16r6817 16r8C4A 16r7E70 16r8C4B 16r6851 16r8C4C 16r936C 16r8C4D 16r52F2 16r8C4E 16r541B 16r8C4F 16r85AB 16r8C50 16r8A13 16r8C51 16r7FA4 16r8C52 16r8ECD 16r8C53 16r90E1 16r8C54 16r5366 16r8C55 16r8888 16r8C56 16r7941 16r8C57 16r4FC2 16r8C58 16r50BE 16r8C59 16r5211 16r8C5A 16r5144 16r8C5B 16r5553 16r8C5C 16r572D 16r8C5D 16r73EA 16r8C5E 16r578B 16r8C5F 16r5951 16r8C60 16r5F62 16r8C61 16r5F84 16r8C62 16r6075 16r8C63 16r6176 16r8C64 16r6167 16r8C65 16r61A9 16r8C66 16r63B2 16r8C67 16r643A 16r8C68 16r656C 16r8C69 16r666F 16r8C6A 16r6842 16r8C6B 16r6E13 16r8C6C 16r7566 16r8C6D 16r7A3D 16r8C6E 16r7CFB 16r8C6F 16r7D4C 16r8C70 16r7D99 16r8C71 16r7E4B 16r8C72 16r7F6B 16r8C73 16r830E 16r8C74 16r834A 16r8C75 16r86CD 16r8C76 16r8A08 16r8C77 16r8A63 16r8C78 16r8B66 16r8C79 16r8EFD 16r8C7A 16r981A 16r8C7B 16r9D8F 16r8C7C 16r82B8 16r8C7D 16r8FCE 16r8C7E 16r9BE8 16r8C80 16r5287 16r8C81 16r621F 16r8C82 16r6483 16r8C83 16r6FC0 16r8C84 16r9699 16r8C85 16r6841 16r8C86 16r5091 16r8C87 16r6B20 16r8C88 16r6C7A 16r8C89 16r6F54 16r8C8A 16r7A74 16r8C8B 16r7D50 16r8C8C 16r8840 16r8C8D 16r8A23 16r8C8E 16r6708 16r8C8F 16r4EF6 16r8C90 16r5039 16r8C91 16r5026 16r8C92 16r5065 16r8C93 16r517C 16r8C94 16r5238 16r8C95 16r5263 16r8C96 16r55A7 16r8C97 16r570F 16r8C98 16r5805 16r8C99 16r5ACC 16r8C9A 16r5EFA 16r8C9B 16r61B2 16r8C9C 16r61F8 16r8C9D 16r62F3 16r8C9E 16r6372 16r8C9F 16r691C 16r8CA0 16r6A29 16r8CA1 16r727D 16r8CA2 16r72AC 16r8CA3 16r732E 16r8CA4 16r7814 16r8CA5 16r786F 16r8CA6 16r7D79 16r8CA7 16r770C 16r8CA8 16r80A9 16r8CA9 16r898B 16r8CAA 16r8B19 16r8CAB 16r8CE2 16r8CAC 16r8ED2 16r8CAD 16r9063 16r8CAE 16r9375 16r8CAF 16r967A 16r8CB0 16r9855 16r8CB1 16r9A13 16r8CB2 16r9E78 16r8CB3 16r5143 16r8CB4 16r539F 16r8CB5 16r53B3 16r8CB6 16r5E7B 16r8CB7 16r5F26 16r8CB8 16r6E1B 16r8CB9 16r6E90 16r8CBA 16r7384 16r8CBB 16r73FE 16r8CBC 16r7D43 16r8CBD 16r8237 16r8CBE 16r8A00 16r8CBF 16r8AFA 16r8CC0 16r9650 16r8CC1 16r4E4E 16r8CC2 16r500B 16r8CC3 16r53E4 16r8CC4 16r547C 16r8CC5 16r56FA 16r8CC6 16r59D1 16r8CC7 16r5B64 16r8CC8 16r5DF1 16r8CC9 16r5EAB 16r8CCA 16r5F27 16r8CCB 16r6238 16r8CCC 16r6545 16r8CCD 16r67AF 16r8CCE 16r6E56 16r8CCF 16r72D0 16r8CD0 16r7CCA 16r8CD1 16r88B4 16r8CD2 16r80A1 16r8CD3 16r80E1 16r8CD4 16r83F0 16r8CD5 16r864E 16r8CD6 16r8A87 16r8CD7 16r8DE8 16r8CD8 16r9237 16r8CD9 16r96C7 16r8CDA 16r9867 16r8CDB 16r9F13 16r8CDC 16r4E94 16r8CDD 16r4E92 16r8CDE 16r4F0D 16r8CDF 16r5348 16r8CE0 16r5449 16r8CE1 16r543E 16r8CE2 16r5A2F 16r8CE3 16r5F8C 16r8CE4 16r5FA1 16r8CE5 16r609F 16r8CE6 16r68A7 16r8CE7 16r6A8E 16r8CE8 16r745A 16r8CE9 16r7881 16r8CEA 16r8A9E 16r8CEB 16r8AA4 16r8CEC 16r8B77 16r8CED 16r9190 16r8CEE 16r4E5E 16r8CEF 16r9BC9 16r8CF0 16r4EA4 16r8CF1 16r4F7C 16r8CF2 16r4FAF 16r8CF3 16r5019 16r8CF4 16r5016 16r8CF5 16r5149 16r8CF6 16r516C 16r8CF7 16r529F 16r8CF8 16r52B9 16r8CF9 16r52FE 16r8CFA 16r539A 16r8CFB 16r53E3 16r8CFC 16r5411 16r8D40 16r540E 16r8D41 16r5589 16r8D42 16r5751 16r8D43 16r57A2 16r8D44 16r597D 16r8D45 16r5B54 16r8D46 16r5B5D 16r8D47 16r5B8F 16r8D48 16r5DE5 16r8D49 16r5DE7 16r8D4A 16r5DF7 16r8D4B 16r5E78 16r8D4C 16r5E83 16r8D4D 16r5E9A 16r8D4E 16r5EB7 16r8D4F 16r5F18 16r8D50 16r6052 16r8D51 16r614C 16r8D52 16r6297 16r8D53 16r62D8 16r8D54 16r63A7 16r8D55 16r653B 16r8D56 16r6602 16r8D57 16r6643 16r8D58 16r66F4 16r8D59 16r676D 16r8D5A 16r6821 16r8D5B 16r6897 16r8D5C 16r69CB 16r8D5D 16r6C5F 16r8D5E 16r6D2A 16r8D5F 16r6D69 16r8D60 16r6E2F 16r8D61 16r6E9D 16r8D62 16r7532 16r8D63 16r7687 16r8D64 16r786C 16r8D65 16r7A3F 16r8D66 16r7CE0 16r8D67 16r7D05 16r8D68 16r7D18 16r8D69 16r7D5E 16r8D6A 16r7DB1 16r8D6B 16r8015 16r8D6C 16r8003 16r8D6D 16r80AF 16r8D6E 16r80B1 16r8D6F 16r8154 16r8D70 16r818F 16r8D71 16r822A 16r8D72 16r8352 16r8D73 16r884C 16r8D74 16r8861 16r8D75 16r8B1B 16r8D76 16r8CA2 16r8D77 16r8CFC 16r8D78 16r90CA 16r8D79 16r9175 16r8D7A 16r9271 16r8D7B 16r783F 16r8D7C 16r92FC 16r8D7D 16r95A4 16r8D7E 16r964D 16r8D80 16r9805 16r8D81 16r9999 16r8D82 16r9AD8 16r8D83 16r9D3B 16r8D84 16r525B 16r8D85 16r52AB 16r8D86 16r53F7 16r8D87 16r5408 16r8D88 16r58D5 16r8D89 16r62F7 16r8D8A 16r6FE0 16r8D8B 16r8C6A 16r8D8C 16r8F5F 16r8D8D 16r9EB9 16r8D8E 16r514B 16r8D8F 16r523B 16r8D90 16r544A 16r8D91 16r56FD 16r8D92 16r7A40 16r8D93 16r9177 16r8D94 16r9D60 16r8D95 16r9ED2 16r8D96 16r7344 16r8D97 16r6F09 16r8D98 16r8170 16r8D99 16r7511 16r8D9A 16r5FFD 16r8D9B 16r60DA 16r8D9C 16r9AA8 16r8D9D 16r72DB 16r8D9E 16r8FBC 16r8D9F 16r6B64 16r8DA0 16r9803 16r8DA1 16r4ECA 16r8DA2 16r56F0 16r8DA3 16r5764 16r8DA4 16r58BE 16r8DA5 16r5A5A 16r8DA6 16r6068 16r8DA7 16r61C7 16r8DA8 16r660F 16r8DA9 16r6606 16r8DAA 16r6839 16r8DAB 16r68B1 16r8DAC 16r6DF7 16r8DAD 16r75D5 16r8DAE 16r7D3A 16r8DAF 16r826E 16r8DB0 16r9B42 16r8DB1 16r4E9B 16r8DB2 16r4F50 16r8DB3 16r53C9 16r8DB4 16r5506 16r8DB5 16r5D6F 16r8DB6 16r5DE6 16r8DB7 16r5DEE 16r8DB8 16r67FB 16r8DB9 16r6C99 16r8DBA 16r7473 16r8DBB 16r7802 16r8DBC 16r8A50 16r8DBD 16r9396 16r8DBE 16r88DF 16r8DBF 16r5750 16r8DC0 16r5EA7 16r8DC1 16r632B 16r8DC2 16r50B5 16r8DC3 16r50AC 16r8DC4 16r518D 16r8DC5 16r6700 16r8DC6 16r54C9 16r8DC7 16r585E 16r8DC8 16r59BB 16r8DC9 16r5BB0 16r8DCA 16r5F69 16r8DCB 16r624D 16r8DCC 16r63A1 16r8DCD 16r683D 16r8DCE 16r6B73 16r8DCF 16r6E08 16r8DD0 16r707D 16r8DD1 16r91C7 16r8DD2 16r7280 16r8DD3 16r7815 16r8DD4 16r7826 16r8DD5 16r796D 16r8DD6 16r658E 16r8DD7 16r7D30 16r8DD8 16r83DC 16r8DD9 16r88C1 16r8DDA 16r8F09 16r8DDB 16r969B 16r8DDC 16r5264 16r8DDD 16r5728 16r8DDE 16r6750 16r8DDF 16r7F6A 16r8DE0 16r8CA1 16r8DE1 16r51B4 16r8DE2 16r5742 16r8DE3 16r962A 16r8DE4 16r583A 16r8DE5 16r698A 16r8DE6 16r80B4 16r8DE7 16r54B2 16r8DE8 16r5D0E 16r8DE9 16r57FC 16r8DEA 16r7895 16r8DEB 16r9DFA 16r8DEC 16r4F5C 16r8DED 16r524A 16r8DEE 16r548B 16r8DEF 16r643E 16r8DF0 16r6628 16r8DF1 16r6714 16r8DF2 16r67F5 16r8DF3 16r7A84 16r8DF4 16r7B56 16r8DF5 16r7D22 16r8DF6 16r932F 16r8DF7 16r685C 16r8DF8 16r9BAD 16r8DF9 16r7B39 16r8DFA 16r5319 16r8DFB 16r518A 16r8DFC 16r5237 16r8E40 16r5BDF 16r8E41 16r62F6 16r8E42 16r64AE 16r8E43 16r64E6 16r8E44 16r672D 16r8E45 16r6BBA 16r8E46 16r85A9 16r8E47 16r96D1 16r8E48 16r7690 16r8E49 16r9BD6 16r8E4A 16r634C 16r8E4B 16r9306 16r8E4C 16r9BAB 16r8E4D 16r76BF 16r8E4E 16r6652 16r8E4F 16r4E09 16r8E50 16r5098 16r8E51 16r53C2 16r8E52 16r5C71 16r8E53 16r60E8 16r8E54 16r6492 16r8E55 16r6563 16r8E56 16r685F 16r8E57 16r71E6 16r8E58 16r73CA 16r8E59 16r7523 16r8E5A 16r7B97 16r8E5B 16r7E82 16r8E5C 16r8695 16r8E5D 16r8B83 16r8E5E 16r8CDB 16r8E5F 16r9178 16r8E60 16r9910 16r8E61 16r65AC 16r8E62 16r66AB 16r8E63 16r6B8B 16r8E64 16r4ED5 16r8E65 16r4ED4 16r8E66 16r4F3A 16r8E67 16r4F7F 16r8E68 16r523A 16r8E69 16r53F8 16r8E6A 16r53F2 16r8E6B 16r55E3 16r8E6C 16r56DB 16r8E6D 16r58EB 16r8E6E 16r59CB 16r8E6F 16r59C9 16r8E70 16r59FF 16r8E71 16r5B50 16r8E72 16r5C4D 16r8E73 16r5E02 16r8E74 16r5E2B 16r8E75 16r5FD7 16r8E76 16r601D 16r8E77 16r6307 16r8E78 16r652F 16r8E79 16r5B5C 16r8E7A 16r65AF 16r8E7B 16r65BD 16r8E7C 16r65E8 16r8E7D 16r679D 16r8E7E 16r6B62 16r8E80 16r6B7B 16r8E81 16r6C0F 16r8E82 16r7345 16r8E83 16r7949 16r8E84 16r79C1 16r8E85 16r7CF8 16r8E86 16r7D19 16r8E87 16r7D2B 16r8E88 16r80A2 16r8E89 16r8102 16r8E8A 16r81F3 16r8E8B 16r8996 16r8E8C 16r8A5E 16r8E8D 16r8A69 16r8E8E 16r8A66 16r8E8F 16r8A8C 16r8E90 16r8AEE 16r8E91 16r8CC7 16r8E92 16r8CDC 16r8E93 16r96CC 16r8E94 16r98FC 16r8E95 16r6B6F 16r8E96 16r4E8B 16r8E97 16r4F3C 16r8E98 16r4F8D 16r8E99 16r5150 16r8E9A 16r5B57 16r8E9B 16r5BFA 16r8E9C 16r6148 16r8E9D 16r6301 16r8E9E 16r6642 16r8E9F 16r6B21 16r8EA0 16r6ECB 16r8EA1 16r6CBB 16r8EA2 16r723E 16r8EA3 16r74BD 16r8EA4 16r75D4 16r8EA5 16r78C1 16r8EA6 16r793A 16r8EA7 16r800C 16r8EA8 16r8033 16r8EA9 16r81EA 16r8EAA 16r8494 16r8EAB 16r8F9E 16r8EAC 16r6C50 16r8EAD 16r9E7F 16r8EAE 16r5F0F 16r8EAF 16r8B58 16r8EB0 16r9D2B 16r8EB1 16r7AFA 16r8EB2 16r8EF8 16r8EB3 16r5B8D 16r8EB4 16r96EB 16r8EB5 16r4E03 16r8EB6 16r53F1 16r8EB7 16r57F7 16r8EB8 16r5931 16r8EB9 16r5AC9 16r8EBA 16r5BA4 16r8EBB 16r6089 16r8EBC 16r6E7F 16r8EBD 16r6F06 16r8EBE 16r75BE 16r8EBF 16r8CEA 16r8EC0 16r5B9F 16r8EC1 16r8500 16r8EC2 16r7BE0 16r8EC3 16r5072 16r8EC4 16r67F4 16r8EC5 16r829D 16r8EC6 16r5C61 16r8EC7 16r854A 16r8EC8 16r7E1E 16r8EC9 16r820E 16r8ECA 16r5199 16r8ECB 16r5C04 16r8ECC 16r6368 16r8ECD 16r8D66 16r8ECE 16r659C 16r8ECF 16r716E 16r8ED0 16r793E 16r8ED1 16r7D17 16r8ED2 16r8005 16r8ED3 16r8B1D 16r8ED4 16r8ECA 16r8ED5 16r906E 16r8ED6 16r86C7 16r8ED7 16r90AA 16r8ED8 16r501F 16r8ED9 16r52FA 16r8EDA 16r5C3A 16r8EDB 16r6753 16r8EDC 16r707C 16r8EDD 16r7235 16r8EDE 16r914C 16r8EDF 16r91C8 16r8EE0 16r932B 16r8EE1 16r82E5 16r8EE2 16r5BC2 16r8EE3 16r5F31 16r8EE4 16r60F9 16r8EE5 16r4E3B 16r8EE6 16r53D6 16r8EE7 16r5B88 16r8EE8 16r624B 16r8EE9 16r6731 16r8EEA 16r6B8A 16r8EEB 16r72E9 16r8EEC 16r73E0 16r8EED 16r7A2E 16r8EEE 16r816B 16r8EEF 16r8DA3 16r8EF0 16r9152 16r8EF1 16r9996 16r8EF2 16r5112 16r8EF3 16r53D7 16r8EF4 16r546A 16r8EF5 16r5BFF 16r8EF6 16r6388 16r8EF7 16r6A39 16r8EF8 16r7DAC 16r8EF9 16r9700 16r8EFA 16r56DA 16r8EFB 16r53CE 16r8EFC 16r5468 16r8F40 16r5B97 16r8F41 16r5C31 16r8F42 16r5DDE 16r8F43 16r4FEE 16r8F44 16r6101 16r8F45 16r62FE 16r8F46 16r6D32 16r8F47 16r79C0 16r8F48 16r79CB 16r8F49 16r7D42 16r8F4A 16r7E4D 16r8F4B 16r7FD2 16r8F4C 16r81ED 16r8F4D 16r821F 16r8F4E 16r8490 16r8F4F 16r8846 16r8F50 16r8972 16r8F51 16r8B90 16r8F52 16r8E74 16r8F53 16r8F2F 16r8F54 16r9031 16r8F55 16r914B 16r8F56 16r916C 16r8F57 16r96C6 16r8F58 16r919C 16r8F59 16r4EC0 16r8F5A 16r4F4F 16r8F5B 16r5145 16r8F5C 16r5341 16r8F5D 16r5F93 16r8F5E 16r620E 16r8F5F 16r67D4 16r8F60 16r6C41 16r8F61 16r6E0B 16r8F62 16r7363 16r8F63 16r7E26 16r8F64 16r91CD 16r8F65 16r9283 16r8F66 16r53D4 16r8F67 16r5919 16r8F68 16r5BBF 16r8F69 16r6DD1 16r8F6A 16r795D 16r8F6B 16r7E2E 16r8F6C 16r7C9B 16r8F6D 16r587E 16r8F6E 16r719F 16r8F6F 16r51FA 16r8F70 16r8853 16r8F71 16r8FF0 16r8F72 16r4FCA 16r8F73 16r5CFB 16r8F74 16r6625 16r8F75 16r77AC 16r8F76 16r7AE3 16r8F77 16r821C 16r8F78 16r99FF 16r8F79 16r51C6 16r8F7A 16r5FAA 16r8F7B 16r65EC 16r8F7C 16r696F 16r8F7D 16r6B89 16r8F7E 16r6DF3 16r8F80 16r6E96 16r8F81 16r6F64 16r8F82 16r76FE 16r8F83 16r7D14 16r8F84 16r5DE1 16r8F85 16r9075 16r8F86 16r9187 16r8F87 16r9806 16r8F88 16r51E6 16r8F89 16r521D 16r8F8A 16r6240 16r8F8B 16r6691 16r8F8C 16r66D9 16r8F8D 16r6E1A 16r8F8E 16r5EB6 16r8F8F 16r7DD2 16r8F90 16r7F72 16r8F91 16r66F8 16r8F92 16r85AF 16r8F93 16r85F7 16r8F94 16r8AF8 16r8F95 16r52A9 16r8F96 16r53D9 16r8F97 16r5973 16r8F98 16r5E8F 16r8F99 16r5F90 16r8F9A 16r6055 16r8F9B 16r92E4 16r8F9C 16r9664 16r8F9D 16r50B7 16r8F9E 16r511F 16r8F9F 16r52DD 16r8FA0 16r5320 16r8FA1 16r5347 16r8FA2 16r53EC 16r8FA3 16r54E8 16r8FA4 16r5546 16r8FA5 16r5531 16r8FA6 16r5617 16r8FA7 16r5968 16r8FA8 16r59BE 16r8FA9 16r5A3C 16r8FAA 16r5BB5 16r8FAB 16r5C06 16r8FAC 16r5C0F 16r8FAD 16r5C11 16r8FAE 16r5C1A 16r8FAF 16r5E84 16r8FB0 16r5E8A 16r8FB1 16r5EE0 16r8FB2 16r5F70 16r8FB3 16r627F 16r8FB4 16r6284 16r8FB5 16r62DB 16r8FB6 16r638C 16r8FB7 16r6377 16r8FB8 16r6607 16r8FB9 16r660C 16r8FBA 16r662D 16r8FBB 16r6676 16r8FBC 16r677E 16r8FBD 16r68A2 16r8FBE 16r6A1F 16r8FBF 16r6A35 16r8FC0 16r6CBC 16r8FC1 16r6D88 16r8FC2 16r6E09 16r8FC3 16r6E58 16r8FC4 16r713C 16r8FC5 16r7126 16r8FC6 16r7167 16r8FC7 16r75C7 16r8FC8 16r7701 16r8FC9 16r785D 16r8FCA 16r7901 16r8FCB 16r7965 16r8FCC 16r79F0 16r8FCD 16r7AE0 16r8FCE 16r7B11 16r8FCF 16r7CA7 16r8FD0 16r7D39 16r8FD1 16r8096 16r8FD2 16r83D6 16r8FD3 16r848B 16r8FD4 16r8549 16r8FD5 16r885D 16r8FD6 16r88F3 16r8FD7 16r8A1F 16r8FD8 16r8A3C 16r8FD9 16r8A54 16r8FDA 16r8A73 16r8FDB 16r8C61 16r8FDC 16r8CDE 16r8FDD 16r91A4 16r8FDE 16r9266 16r8FDF 16r937E 16r8FE0 16r9418 16r8FE1 16r969C 16r8FE2 16r9798 16r8FE3 16r4E0A 16r8FE4 16r4E08 16r8FE5 16r4E1E 16r8FE6 16r4E57 16r8FE7 16r5197 16r8FE8 16r5270 16r8FE9 16r57CE 16r8FEA 16r5834 16r8FEB 16r58CC 16r8FEC 16r5B22 16r8FED 16r5E38 16r8FEE 16r60C5 16r8FEF 16r64FE 16r8FF0 16r6761 16r8FF1 16r6756 16r8FF2 16r6D44 16r8FF3 16r72B6 16r8FF4 16r7573 16r8FF5 16r7A63 16r8FF6 16r84B8 16r8FF7 16r8B72 16r8FF8 16r91B8 16r8FF9 16r9320 16r8FFA 16r5631 16r8FFB 16r57F4 16r8FFC 16r98FE 16r9040 16r62ED 16r9041 16r690D 16r9042 16r6B96 16r9043 16r71ED 16r9044 16r7E54 16r9045 16r8077 16r9046 16r8272 16r9047 16r89E6 16r9048 16r98DF 16r9049 16r8755 16r904A 16r8FB1 16r904B 16r5C3B 16r904C 16r4F38 16r904D 16r4FE1 16r904E 16r4FB5 16r904F 16r5507 16r9050 16r5A20 16r9051 16r5BDD 16r9052 16r5BE9 16r9053 16r5FC3 16r9054 16r614E 16r9055 16r632F 16r9056 16r65B0 16r9057 16r664B 16r9058 16r68EE 16r9059 16r699B 16r905A 16r6D78 16r905B 16r6DF1 16r905C 16r7533 16r905D 16r75B9 16r905E 16r771F 16r905F 16r795E 16r9060 16r79E6 16r9061 16r7D33 16r9062 16r81E3 16r9063 16r82AF 16r9064 16r85AA 16r9065 16r89AA 16r9066 16r8A3A 16r9067 16r8EAB 16r9068 16r8F9B 16r9069 16r9032 16r906A 16r91DD 16r906B 16r9707 16r906C 16r4EBA 16r906D 16r4EC1 16r906E 16r5203 16r906F 16r5875 16r9070 16r58EC 16r9071 16r5C0B 16r9072 16r751A 16r9073 16r5C3D 16r9074 16r814E 16r9075 16r8A0A 16r9076 16r8FC5 16r9077 16r9663 16r9078 16r976D 16r9079 16r7B25 16r907A 16r8ACF 16r907B 16r9808 16r907C 16r9162 16r907D 16r56F3 16r907E 16r53A8 16r9080 16r9017 16r9081 16r5439 16r9082 16r5782 16r9083 16r5E25 16r9084 16r63A8 16r9085 16r6C34 16r9086 16r708A 16r9087 16r7761 16r9088 16r7C8B 16r9089 16r7FE0 16r908A 16r8870 16r908B 16r9042 16r908C 16r9154 16r908D 16r9310 16r908E 16r9318 16r908F 16r968F 16r9090 16r745E 16r9091 16r9AC4 16r9092 16r5D07 16r9093 16r5D69 16r9094 16r6570 16r9095 16r67A2 16r9096 16r8DA8 16r9097 16r96DB 16r9098 16r636E 16r9099 16r6749 16r909A 16r6919 16r909B 16r83C5 16r909C 16r9817 16r909D 16r96C0 16r909E 16r88FE 16r909F 16r6F84 16r90A0 16r647A 16r90A1 16r5BF8 16r90A2 16r4E16 16r90A3 16r702C 16r90A4 16r755D 16r90A5 16r662F 16r90A6 16r51C4 16r90A7 16r5236 16r90A8 16r52E2 16r90A9 16r59D3 16r90AA 16r5F81 16r90AB 16r6027 16r90AC 16r6210 16r90AD 16r653F 16r90AE 16r6574 16r90AF 16r661F 16r90B0 16r6674 16r90B1 16r68F2 16r90B2 16r6816 16r90B3 16r6B63 16r90B4 16r6E05 16r90B5 16r7272 16r90B6 16r751F 16r90B7 16r76DB 16r90B8 16r7CBE 16r90B9 16r8056 16r90BA 16r58F0 16r90BB 16r88FD 16r90BC 16r897F 16r90BD 16r8AA0 16r90BE 16r8A93 16r90BF 16r8ACB 16r90C0 16r901D 16r90C1 16r9192 16r90C2 16r9752 16r90C3 16r9759 16r90C4 16r6589 16r90C5 16r7A0E 16r90C6 16r8106 16r90C7 16r96BB 16r90C8 16r5E2D 16r90C9 16r60DC 16r90CA 16r621A 16r90CB 16r65A5 16r90CC 16r6614 16r90CD 16r6790 16r90CE 16r77F3 16r90CF 16r7A4D 16r90D0 16r7C4D 16r90D1 16r7E3E 16r90D2 16r810A 16r90D3 16r8CAC 16r90D4 16r8D64 16r90D5 16r8DE1 16r90D6 16r8E5F 16r90D7 16r78A9 16r90D8 16r5207 16r90D9 16r62D9 16r90DA 16r63A5 16r90DB 16r6442 16r90DC 16r6298 16r90DD 16r8A2D 16r90DE 16r7A83 16r90DF 16r7BC0 16r90E0 16r8AAC 16r90E1 16r96EA 16r90E2 16r7D76 16r90E3 16r820C 16r90E4 16r8749 16r90E5 16r4ED9 16r90E6 16r5148 16r90E7 16r5343 16r90E8 16r5360 16r90E9 16r5BA3 16r90EA 16r5C02 16r90EB 16r5C16 16r90EC 16r5DDD 16r90ED 16r6226 16r90EE 16r6247 16r90EF 16r64B0 16r90F0 16r6813 16r90F1 16r6834 16r90F2 16r6CC9 16r90F3 16r6D45 16r90F4 16r6D17 16r90F5 16r67D3 16r90F6 16r6F5C 16r90F7 16r714E 16r90F8 16r717D 16r90F9 16r65CB 16r90FA 16r7A7F 16r90FB 16r7BAD 16r90FC 16r7DDA 16r9140 16r7E4A 16r9141 16r7FA8 16r9142 16r817A 16r9143 16r821B 16r9144 16r8239 16r9145 16r85A6 16r9146 16r8A6E 16r9147 16r8CCE 16r9148 16r8DF5 16r9149 16r9078 16r914A 16r9077 16r914B 16r92AD 16r914C 16r9291 16r914D 16r9583 16r914E 16r9BAE 16r914F 16r524D 16r9150 16r5584 16r9151 16r6F38 16r9152 16r7136 16r9153 16r5168 16r9154 16r7985 16r9155 16r7E55 16r9156 16r81B3 16r9157 16r7CCE 16r9158 16r564C 16r9159 16r5851 16r915A 16r5CA8 16r915B 16r63AA 16r915C 16r66FE 16r915D 16r66FD 16r915E 16r695A 16r915F 16r72D9 16r9160 16r758F 16r9161 16r758E 16r9162 16r790E 16r9163 16r7956 16r9164 16r79DF 16r9165 16r7C97 16r9166 16r7D20 16r9167 16r7D44 16r9168 16r8607 16r9169 16r8A34 16r916A 16r963B 16r916B 16r9061 16r916C 16r9F20 16r916D 16r50E7 16r916E 16r5275 16r916F 16r53CC 16r9170 16r53E2 16r9171 16r5009 16r9172 16r55AA 16r9173 16r58EE 16r9174 16r594F 16r9175 16r723D 16r9176 16r5B8B 16r9177 16r5C64 16r9178 16r531D 16r9179 16r60E3 16r917A 16r60F3 16r917B 16r635C 16r917C 16r6383 16r917D 16r633F 16r917E 16r63BB 16r9180 16r64CD 16r9181 16r65E9 16r9182 16r66F9 16r9183 16r5DE3 16r9184 16r69CD 16r9185 16r69FD 16r9186 16r6F15 16r9187 16r71E5 16r9188 16r4E89 16r9189 16r75E9 16r918A 16r76F8 16r918B 16r7A93 16r918C 16r7CDF 16r918D 16r7DCF 16r918E 16r7D9C 16r918F 16r8061 16r9190 16r8349 16r9191 16r8358 16r9192 16r846C 16r9193 16r84BC 16r9194 16r85FB 16r9195 16r88C5 16r9196 16r8D70 16r9197 16r9001 16r9198 16r906D 16r9199 16r9397 16r919A 16r971C 16r919B 16r9A12 16r919C 16r50CF 16r919D 16r5897 16r919E 16r618E 16r919F 16r81D3 16r91A0 16r8535 16r91A1 16r8D08 16r91A2 16r9020 16r91A3 16r4FC3 16r91A4 16r5074 16r91A5 16r5247 16r91A6 16r5373 16r91A7 16r606F 16r91A8 16r6349 16r91A9 16r675F 16r91AA 16r6E2C 16r91AB 16r8DB3 16r91AC 16r901F 16r91AD 16r4FD7 16r91AE 16r5C5E 16r91AF 16r8CCA 16r91B0 16r65CF 16r91B1 16r7D9A 16r91B2 16r5352 16r91B3 16r8896 16r91B4 16r5176 16r91B5 16r63C3 16r91B6 16r5B58 16r91B7 16r5B6B 16r91B8 16r5C0A 16r91B9 16r640D 16r91BA 16r6751 16r91BB 16r905C 16r91BC 16r4ED6 16r91BD 16r591A 16r91BE 16r592A 16r91BF 16r6C70 16r91C0 16r8A51 16r91C1 16r553E 16r91C2 16r5815 16r91C3 16r59A5 16r91C4 16r60F0 16r91C5 16r6253 16r91C6 16r67C1 16r91C7 16r8235 16r91C8 16r6955 16r91C9 16r9640 16r91CA 16r99C4 16r91CB 16r9A28 16r91CC 16r4F53 16r91CD 16r5806 16r91CE 16r5BFE 16r91CF 16r8010 16r91D0 16r5CB1 16r91D1 16r5E2F 16r91D2 16r5F85 16r91D3 16r6020 16r91D4 16r614B 16r91D5 16r6234 16r91D6 16r66FF 16r91D7 16r6CF0 16r91D8 16r6EDE 16r91D9 16r80CE 16r91DA 16r817F 16r91DB 16r82D4 16r91DC 16r888B 16r91DD 16r8CB8 16r91DE 16r9000 16r91DF 16r902E 16r91E0 16r968A 16r91E1 16r9EDB 16r91E2 16r9BDB 16r91E3 16r4EE3 16r91E4 16r53F0 16r91E5 16r5927 16r91E6 16r7B2C 16r91E7 16r918D 16r91E8 16r984C 16r91E9 16r9DF9 16r91EA 16r6EDD 16r91EB 16r7027 16r91EC 16r5353 16r91ED 16r5544 16r91EE 16r5B85 16r91EF 16r6258 16r91F0 16r629E 16r91F1 16r62D3 16r91F2 16r6CA2 16r91F3 16r6FEF 16r91F4 16r7422 16r91F5 16r8A17 16r91F6 16r9438 16r91F7 16r6FC1 16r91F8 16r8AFE 16r91F9 16r8338 16r91FA 16r51E7 16r91FB 16r86F8 16r91FC 16r53EA 16r9240 16r53E9 16r9241 16r4F46 16r9242 16r9054 16r9243 16r8FB0 16r9244 16r596A 16r9245 16r8131 16r9246 16r5DFD 16r9247 16r7AEA 16r9248 16r8FBF 16r9249 16r68DA 16r924A 16r8C37 16r924B 16r72F8 16r924C 16r9C48 16r924D 16r6A3D 16r924E 16r8AB0 16r924F 16r4E39 16r9250 16r5358 16r9251 16r5606 16r9252 16r5766 16r9253 16r62C5 16r9254 16r63A2 16r9255 16r65E6 16r9256 16r6B4E 16r9257 16r6DE1 16r9258 16r6E5B 16r9259 16r70AD 16r925A 16r77ED 16r925B 16r7AEF 16r925C 16r7BAA 16r925D 16r7DBB 16r925E 16r803D 16r925F 16r80C6 16r9260 16r86CB 16r9261 16r8A95 16r9262 16r935B 16r9263 16r56E3 16r9264 16r58C7 16r9265 16r5F3E 16r9266 16r65AD 16r9267 16r6696 16r9268 16r6A80 16r9269 16r6BB5 16r926A 16r7537 16r926B 16r8AC7 16r926C 16r5024 16r926D 16r77E5 16r926E 16r5730 16r926F 16r5F1B 16r9270 16r6065 16r9271 16r667A 16r9272 16r6C60 16r9273 16r75F4 16r9274 16r7A1A 16r9275 16r7F6E 16r9276 16r81F4 16r9277 16r8718 16r9278 16r9045 16r9279 16r99B3 16r927A 16r7BC9 16r927B 16r755C 16r927C 16r7AF9 16r927D 16r7B51 16r927E 16r84C4 16r9280 16r9010 16r9281 16r79E9 16r9282 16r7A92 16r9283 16r8336 16r9284 16r5AE1 16r9285 16r7740 16r9286 16r4E2D 16r9287 16r4EF2 16r9288 16r5B99 16r9289 16r5FE0 16r928A 16r62BD 16r928B 16r663C 16r928C 16r67F1 16r928D 16r6CE8 16r928E 16r866B 16r928F 16r8877 16r9290 16r8A3B 16r9291 16r914E 16r9292 16r92F3 16r9293 16r99D0 16r9294 16r6A17 16r9295 16r7026 16r9296 16r732A 16r9297 16r82E7 16r9298 16r8457 16r9299 16r8CAF 16r929A 16r4E01 16r929B 16r5146 16r929C 16r51CB 16r929D 16r558B 16r929E 16r5BF5 16r929F 16r5E16 16r92A0 16r5E33 16r92A1 16r5E81 16r92A2 16r5F14 16r92A3 16r5F35 16r92A4 16r5F6B 16r92A5 16r5FB4 16r92A6 16r61F2 16r92A7 16r6311 16r92A8 16r66A2 16r92A9 16r671D 16r92AA 16r6F6E 16r92AB 16r7252 16r92AC 16r753A 16r92AD 16r773A 16r92AE 16r8074 16r92AF 16r8139 16r92B0 16r8178 16r92B1 16r8776 16r92B2 16r8ABF 16r92B3 16r8ADC 16r92B4 16r8D85 16r92B5 16r8DF3 16r92B6 16r929A 16r92B7 16r9577 16r92B8 16r9802 16r92B9 16r9CE5 16r92BA 16r52C5 16r92BB 16r6357 16r92BC 16r76F4 16r92BD 16r6715 16r92BE 16r6C88 16r92BF 16r73CD 16r92C0 16r8CC3 16r92C1 16r93AE 16r92C2 16r9673 16r92C3 16r6D25 16r92C4 16r589C 16r92C5 16r690E 16r92C6 16r69CC 16r92C7 16r8FFD 16r92C8 16r939A 16r92C9 16r75DB 16r92CA 16r901A 16r92CB 16r585A 16r92CC 16r6802 16r92CD 16r63B4 16r92CE 16r69FB 16r92CF 16r4F43 16r92D0 16r6F2C 16r92D1 16r67D8 16r92D2 16r8FBB 16r92D3 16r8526 16r92D4 16r7DB4 16r92D5 16r9354 16r92D6 16r693F 16r92D7 16r6F70 16r92D8 16r576A 16r92D9 16r58F7 16r92DA 16r5B2C 16r92DB 16r7D2C 16r92DC 16r722A 16r92DD 16r540A 16r92DE 16r91E3 16r92DF 16r9DB4 16r92E0 16r4EAD 16r92E1 16r4F4E 16r92E2 16r505C 16r92E3 16r5075 16r92E4 16r5243 16r92E5 16r8C9E 16r92E6 16r5448 16r92E7 16r5824 16r92E8 16r5B9A 16r92E9 16r5E1D 16r92EA 16r5E95 16r92EB 16r5EAD 16r92EC 16r5EF7 16r92ED 16r5F1F 16r92EE 16r608C 16r92EF 16r62B5 16r92F0 16r633A 16r92F1 16r63D0 16r92F2 16r68AF 16r92F3 16r6C40 16r92F4 16r7887 16r92F5 16r798E 16r92F6 16r7A0B 16r92F7 16r7DE0 16r92F8 16r8247 16r92F9 16r8A02 16r92FA 16r8AE6 16r92FB 16r8E44 16r92FC 16r9013 16r9340 16r90B8 16r9341 16r912D 16r9342 16r91D8 16r9343 16r9F0E 16r9344 16r6CE5 16r9345 16r6458 16r9346 16r64E2 16r9347 16r6575 16r9348 16r6EF4 16r9349 16r7684 16r934A 16r7B1B 16r934B 16r9069 16r934C 16r93D1 16r934D 16r6EBA 16r934E 16r54F2 16r934F 16r5FB9 16r9350 16r64A4 16r9351 16r8F4D 16r9352 16r8FED 16r9353 16r9244 16r9354 16r5178 16r9355 16r586B 16r9356 16r5929 16r9357 16r5C55 16r9358 16r5E97 16r9359 16r6DFB 16r935A 16r7E8F 16r935B 16r751C 16r935C 16r8CBC 16r935D 16r8EE2 16r935E 16r985B 16r935F 16r70B9 16r9360 16r4F1D 16r9361 16r6BBF 16r9362 16r6FB1 16r9363 16r7530 16r9364 16r96FB 16r9365 16r514E 16r9366 16r5410 16r9367 16r5835 16r9368 16r5857 16r9369 16r59AC 16r936A 16r5C60 16r936B 16r5F92 16r936C 16r6597 16r936D 16r675C 16r936E 16r6E21 16r936F 16r767B 16r9370 16r83DF 16r9371 16r8CED 16r9372 16r9014 16r9373 16r90FD 16r9374 16r934D 16r9375 16r7825 16r9376 16r783A 16r9377 16r52AA 16r9378 16r5EA6 16r9379 16r571F 16r937A 16r5974 16r937B 16r6012 16r937C 16r5012 16r937D 16r515A 16r937E 16r51AC 16r9380 16r51CD 16r9381 16r5200 16r9382 16r5510 16r9383 16r5854 16r9384 16r5858 16r9385 16r5957 16r9386 16r5B95 16r9387 16r5CF6 16r9388 16r5D8B 16r9389 16r60BC 16r938A 16r6295 16r938B 16r642D 16r938C 16r6771 16r938D 16r6843 16r938E 16r68BC 16r938F 16r68DF 16r9390 16r76D7 16r9391 16r6DD8 16r9392 16r6E6F 16r9393 16r6D9B 16r9394 16r706F 16r9395 16r71C8 16r9396 16r5F53 16r9397 16r75D8 16r9398 16r7977 16r9399 16r7B49 16r939A 16r7B54 16r939B 16r7B52 16r939C 16r7CD6 16r939D 16r7D71 16r939E 16r5230 16r939F 16r8463 16r93A0 16r8569 16r93A1 16r85E4 16r93A2 16r8A0E 16r93A3 16r8B04 16r93A4 16r8C46 16r93A5 16r8E0F 16r93A6 16r9003 16r93A7 16r900F 16r93A8 16r9419 16r93A9 16r9676 16r93AA 16r982D 16r93AB 16r9A30 16r93AC 16r95D8 16r93AD 16r50CD 16r93AE 16r52D5 16r93AF 16r540C 16r93B0 16r5802 16r93B1 16r5C0E 16r93B2 16r61A7 16r93B3 16r649E 16r93B4 16r6D1E 16r93B5 16r77B3 16r93B6 16r7AE5 16r93B7 16r80F4 16r93B8 16r8404 16r93B9 16r9053 16r93BA 16r9285 16r93BB 16r5CE0 16r93BC 16r9D07 16r93BD 16r533F 16r93BE 16r5F97 16r93BF 16r5FB3 16r93C0 16r6D9C 16r93C1 16r7279 16r93C2 16r7763 16r93C3 16r79BF 16r93C4 16r7BE4 16r93C5 16r6BD2 16r93C6 16r72EC 16r93C7 16r8AAD 16r93C8 16r6803 16r93C9 16r6A61 16r93CA 16r51F8 16r93CB 16r7A81 16r93CC 16r6934 16r93CD 16r5C4A 16r93CE 16r9CF6 16r93CF 16r82EB 16r93D0 16r5BC5 16r93D1 16r9149 16r93D2 16r701E 16r93D3 16r5678 16r93D4 16r5C6F 16r93D5 16r60C7 16r93D6 16r6566 16r93D7 16r6C8C 16r93D8 16r8C5A 16r93D9 16r9041 16r93DA 16r9813 16r93DB 16r5451 16r93DC 16r66C7 16r93DD 16r920D 16r93DE 16r5948 16r93DF 16r90A3 16r93E0 16r5185 16r93E1 16r4E4D 16r93E2 16r51EA 16r93E3 16r8599 16r93E4 16r8B0E 16r93E5 16r7058 16r93E6 16r637A 16r93E7 16r934B 16r93E8 16r6962 16r93E9 16r99B4 16r93EA 16r7E04 16r93EB 16r7577 16r93EC 16r5357 16r93ED 16r6960 16r93EE 16r8EDF 16r93EF 16r96E3 16r93F0 16r6C5D 16r93F1 16r4E8C 16r93F2 16r5C3C 16r93F3 16r5F10 16r93F4 16r8FE9 16r93F5 16r5302 16r93F6 16r8CD1 16r93F7 16r8089 16r93F8 16r8679 16r93F9 16r5EFF 16r93FA 16r65E5 16r93FB 16r4E73 16r93FC 16r5165 16r9440 16r5982 16r9441 16r5C3F 16r9442 16r97EE 16r9443 16r4EFB 16r9444 16r598A 16r9445 16r5FCD 16r9446 16r8A8D 16r9447 16r6FE1 16r9448 16r79B0 16r9449 16r7962 16r944A 16r5BE7 16r944B 16r8471 16r944C 16r732B 16r944D 16r71B1 16r944E 16r5E74 16r944F 16r5FF5 16r9450 16r637B 16r9451 16r649A 16r9452 16r71C3 16r9453 16r7C98 16r9454 16r4E43 16r9455 16r5EFC 16r9456 16r4E4B 16r9457 16r57DC 16r9458 16r56A2 16r9459 16r60A9 16r945A 16r6FC3 16r945B 16r7D0D 16r945C 16r80FD 16r945D 16r8133 16r945E 16r81BF 16r945F 16r8FB2 16r9460 16r8997 16r9461 16r86A4 16r9462 16r5DF4 16r9463 16r628A 16r9464 16r64AD 16r9465 16r8987 16r9466 16r6777 16r9467 16r6CE2 16r9468 16r6D3E 16r9469 16r7436 16r946A 16r7834 16r946B 16r5A46 16r946C 16r7F75 16r946D 16r82AD 16r946E 16r99AC 16r946F 16r4FF3 16r9470 16r5EC3 16r9471 16r62DD 16r9472 16r6392 16r9473 16r6557 16r9474 16r676F 16r9475 16r76C3 16r9476 16r724C 16r9477 16r80CC 16r9478 16r80BA 16r9479 16r8F29 16r947A 16r914D 16r947B 16r500D 16r947C 16r57F9 16r947D 16r5A92 16r947E 16r6885 16r9480 16r6973 16r9481 16r7164 16r9482 16r72FD 16r9483 16r8CB7 16r9484 16r58F2 16r9485 16r8CE0 16r9486 16r966A 16r9487 16r9019 16r9488 16r877F 16r9489 16r79E4 16r948A 16r77E7 16r948B 16r8429 16r948C 16r4F2F 16r948D 16r5265 16r948E 16r535A 16r948F 16r62CD 16r9490 16r67CF 16r9491 16r6CCA 16r9492 16r767D 16r9493 16r7B94 16r9494 16r7C95 16r9495 16r8236 16r9496 16r8584 16r9497 16r8FEB 16r9498 16r66DD 16r9499 16r6F20 16r949A 16r7206 16r949B 16r7E1B 16r949C 16r83AB 16r949D 16r99C1 16r949E 16r9EA6 16r949F 16r51FD 16r94A0 16r7BB1 16r94A1 16r7872 16r94A2 16r7BB8 16r94A3 16r8087 16r94A4 16r7B48 16r94A5 16r6AE8 16r94A6 16r5E61 16r94A7 16r808C 16r94A8 16r7551 16r94A9 16r7560 16r94AA 16r516B 16r94AB 16r9262 16r94AC 16r6E8C 16r94AD 16r767A 16r94AE 16r9197 16r94AF 16r9AEA 16r94B0 16r4F10 16r94B1 16r7F70 16r94B2 16r629C 16r94B3 16r7B4F 16r94B4 16r95A5 16r94B5 16r9CE9 16r94B6 16r567A 16r94B7 16r5859 16r94B8 16r86E4 16r94B9 16r96BC 16r94BA 16r4F34 16r94BB 16r5224 16r94BC 16r534A 16r94BD 16r53CD 16r94BE 16r53DB 16r94BF 16r5E06 16r94C0 16r642C 16r94C1 16r6591 16r94C2 16r677F 16r94C3 16r6C3E 16r94C4 16r6C4E 16r94C5 16r7248 16r94C6 16r72AF 16r94C7 16r73ED 16r94C8 16r7554 16r94C9 16r7E41 16r94CA 16r822C 16r94CB 16r85E9 16r94CC 16r8CA9 16r94CD 16r7BC4 16r94CE 16r91C6 16r94CF 16r7169 16r94D0 16r9812 16r94D1 16r98EF 16r94D2 16r633D 16r94D3 16r6669 16r94D4 16r756A 16r94D5 16r76E4 16r94D6 16r78D0 16r94D7 16r8543 16r94D8 16r86EE 16r94D9 16r532A 16r94DA 16r5351 16r94DB 16r5426 16r94DC 16r5983 16r94DD 16r5E87 16r94DE 16r5F7C 16r94DF 16r60B2 16r94E0 16r6249 16r94E1 16r6279 16r94E2 16r62AB 16r94E3 16r6590 16r94E4 16r6BD4 16r94E5 16r6CCC 16r94E6 16r75B2 16r94E7 16r76AE 16r94E8 16r7891 16r94E9 16r79D8 16r94EA 16r7DCB 16r94EB 16r7F77 16r94EC 16r80A5 16r94ED 16r88AB 16r94EE 16r8AB9 16r94EF 16r8CBB 16r94F0 16r907F 16r94F1 16r975E 16r94F2 16r98DB 16r94F3 16r6A0B 16r94F4 16r7C38 16r94F5 16r5099 16r94F6 16r5C3E 16r94F7 16r5FAE 16r94F8 16r6787 16r94F9 16r6BD8 16r94FA 16r7435 16r94FB 16r7709 16r94FC 16r7F8E 16r9540 16r9F3B 16r9541 16r67CA 16r9542 16r7A17 16r9543 16r5339 16r9544 16r758B 16r9545 16r9AED 16r9546 16r5F66 16r9547 16r819D 16r9548 16r83F1 16r9549 16r8098 16r954A 16r5F3C 16r954B 16r5FC5 16r954C 16r7562 16r954D 16r7B46 16r954E 16r903C 16r954F 16r6867 16r9550 16r59EB 16r9551 16r5A9B 16r9552 16r7D10 16r9553 16r767E 16r9554 16r8B2C 16r9555 16r4FF5 16r9556 16r5F6A 16r9557 16r6A19 16r9558 16r6C37 16r9559 16r6F02 16r955A 16r74E2 16r955B 16r7968 16r955C 16r8868 16r955D 16r8A55 16r955E 16r8C79 16r955F 16r5EDF 16r9560 16r63CF 16r9561 16r75C5 16r9562 16r79D2 16r9563 16r82D7 16r9564 16r9328 16r9565 16r92F2 16r9566 16r849C 16r9567 16r86ED 16r9568 16r9C2D 16r9569 16r54C1 16r956A 16r5F6C 16r956B 16r658C 16r956C 16r6D5C 16r956D 16r7015 16r956E 16r8CA7 16r956F 16r8CD3 16r9570 16r983B 16r9571 16r654F 16r9572 16r74F6 16r9573 16r4E0D 16r9574 16r4ED8 16r9575 16r57E0 16r9576 16r592B 16r9577 16r5A66 16r9578 16r5BCC 16r9579 16r51A8 16r957A 16r5E03 16r957B 16r5E9C 16r957C 16r6016 16r957D 16r6276 16r957E 16r6577 16r9580 16r65A7 16r9581 16r666E 16r9582 16r6D6E 16r9583 16r7236 16r9584 16r7B26 16r9585 16r8150 16r9586 16r819A 16r9587 16r8299 16r9588 16r8B5C 16r9589 16r8CA0 16r958A 16r8CE6 16r958B 16r8D74 16r958C 16r961C 16r958D 16r9644 16r958E 16r4FAE 16r958F 16r64AB 16r9590 16r6B66 16r9591 16r821E 16r9592 16r8461 16r9593 16r856A 16r9594 16r90E8 16r9595 16r5C01 16r9596 16r6953 16r9597 16r98A8 16r9598 16r847A 16r9599 16r8557 16r959A 16r4F0F 16r959B 16r526F 16r959C 16r5FA9 16r959D 16r5E45 16r959E 16r670D 16r959F 16r798F 16r95A0 16r8179 16r95A1 16r8907 16r95A2 16r8986 16r95A3 16r6DF5 16r95A4 16r5F17 16r95A5 16r6255 16r95A6 16r6CB8 16r95A7 16r4ECF 16r95A8 16r7269 16r95A9 16r9B92 16r95AA 16r5206 16r95AB 16r543B 16r95AC 16r5674 16r95AD 16r58B3 16r95AE 16r61A4 16r95AF 16r626E 16r95B0 16r711A 16r95B1 16r596E 16r95B2 16r7C89 16r95B3 16r7CDE 16r95B4 16r7D1B 16r95B5 16r96F0 16r95B6 16r6587 16r95B7 16r805E 16r95B8 16r4E19 16r95B9 16r4F75 16r95BA 16r5175 16r95BB 16r5840 16r95BC 16r5E63 16r95BD 16r5E73 16r95BE 16r5F0A 16r95BF 16r67C4 16r95C0 16r4E26 16r95C1 16r853D 16r95C2 16r9589 16r95C3 16r965B 16r95C4 16r7C73 16r95C5 16r9801 16r95C6 16r50FB 16r95C7 16r58C1 16r95C8 16r7656 16r95C9 16r78A7 16r95CA 16r5225 16r95CB 16r77A5 16r95CC 16r8511 16r95CD 16r7B86 16r95CE 16r504F 16r95CF 16r5909 16r95D0 16r7247 16r95D1 16r7BC7 16r95D2 16r7DE8 16r95D3 16r8FBA 16r95D4 16r8FD4 16r95D5 16r904D 16r95D6 16r4FBF 16r95D7 16r52C9 16r95D8 16r5A29 16r95D9 16r5F01 16r95DA 16r97AD 16r95DB 16r4FDD 16r95DC 16r8217 16r95DD 16r92EA 16r95DE 16r5703 16r95DF 16r6355 16r95E0 16r6B69 16r95E1 16r752B 16r95E2 16r88DC 16r95E3 16r8F14 16r95E4 16r7A42 16r95E5 16r52DF 16r95E6 16r5893 16r95E7 16r6155 16r95E8 16r620A 16r95E9 16r66AE 16r95EA 16r6BCD 16r95EB 16r7C3F 16r95EC 16r83E9 16r95ED 16r5023 16r95EE 16r4FF8 16r95EF 16r5305 16r95F0 16r5446 16r95F1 16r5831 16r95F2 16r5949 16r95F3 16r5B9D 16r95F4 16r5CF0 16r95F5 16r5CEF 16r95F6 16r5D29 16r95F7 16r5E96 16r95F8 16r62B1 16r95F9 16r6367 16r95FA 16r653E 16r95FB 16r65B9 16r95FC 16r670B 16r9640 16r6CD5 16r9641 16r6CE1 16r9642 16r70F9 16r9643 16r7832 16r9644 16r7E2B 16r9645 16r80DE 16r9646 16r82B3 16r9647 16r840C 16r9648 16r84EC 16r9649 16r8702 16r964A 16r8912 16r964B 16r8A2A 16r964C 16r8C4A 16r964D 16r90A6 16r964E 16r92D2 16r964F 16r98FD 16r9650 16r9CF3 16r9651 16r9D6C 16r9652 16r4E4F 16r9653 16r4EA1 16r9654 16r508D 16r9655 16r5256 16r9656 16r574A 16r9657 16r59A8 16r9658 16r5E3D 16r9659 16r5FD8 16r965A 16r5FD9 16r965B 16r623F 16r965C 16r66B4 16r965D 16r671B 16r965E 16r67D0 16r965F 16r68D2 16r9660 16r5192 16r9661 16r7D21 16r9662 16r80AA 16r9663 16r81A8 16r9664 16r8B00 16r9665 16r8C8C 16r9666 16r8CBF 16r9667 16r927E 16r9668 16r9632 16r9669 16r5420 16r966A 16r982C 16r966B 16r5317 16r966C 16r50D5 16r966D 16r535C 16r966E 16r58A8 16r966F 16r64B2 16r9670 16r6734 16r9671 16r7267 16r9672 16r7766 16r9673 16r7A46 16r9674 16r91E6 16r9675 16r52C3 16r9676 16r6CA1 16r9677 16r6B86 16r9678 16r5800 16r9679 16r5E4C 16r967A 16r5954 16r967B 16r672C 16r967C 16r7FFB 16r967D 16r51E1 16r967E 16r76C6 16r9680 16r6469 16r9681 16r78E8 16r9682 16r9B54 16r9683 16r9EBB 16r9684 16r57CB 16r9685 16r59B9 16r9686 16r6627 16r9687 16r679A 16r9688 16r6BCE 16r9689 16r54E9 16r968A 16r69D9 16r968B 16r5E55 16r968C 16r819C 16r968D 16r6795 16r968E 16r9BAA 16r968F 16r67FE 16r9690 16r9C52 16r9691 16r685D 16r9692 16r4EA6 16r9693 16r4FE3 16r9694 16r53C8 16r9695 16r62B9 16r9696 16r672B 16r9697 16r6CAB 16r9698 16r8FC4 16r9699 16r4FAD 16r969A 16r7E6D 16r969B 16r9EBF 16r969C 16r4E07 16r969D 16r6162 16r969E 16r6E80 16r969F 16r6F2B 16r96A0 16r8513 16r96A1 16r5473 16r96A2 16r672A 16r96A3 16r9B45 16r96A4 16r5DF3 16r96A5 16r7B95 16r96A6 16r5CAC 16r96A7 16r5BC6 16r96A8 16r871C 16r96A9 16r6E4A 16r96AA 16r84D1 16r96AB 16r7A14 16r96AC 16r8108 16r96AD 16r5999 16r96AE 16r7C8D 16r96AF 16r6C11 16r96B0 16r7720 16r96B1 16r52D9 16r96B2 16r5922 16r96B3 16r7121 16r96B4 16r725F 16r96B5 16r77DB 16r96B6 16r9727 16r96B7 16r9D61 16r96B8 16r690B 16r96B9 16r5A7F 16r96BA 16r5A18 16r96BB 16r51A5 16r96BC 16r540D 16r96BD 16r547D 16r96BE 16r660E 16r96BF 16r76DF 16r96C0 16r8FF7 16r96C1 16r9298 16r96C2 16r9CF4 16r96C3 16r59EA 16r96C4 16r725D 16r96C5 16r6EC5 16r96C6 16r514D 16r96C7 16r68C9 16r96C8 16r7DBF 16r96C9 16r7DEC 16r96CA 16r9762 16r96CB 16r9EBA 16r96CC 16r6478 16r96CD 16r6A21 16r96CE 16r8302 16r96CF 16r5984 16r96D0 16r5B5F 16r96D1 16r6BDB 16r96D2 16r731B 16r96D3 16r76F2 16r96D4 16r7DB2 16r96D5 16r8017 16r96D6 16r8499 16r96D7 16r5132 16r96D8 16r6728 16r96D9 16r9ED9 16r96DA 16r76EE 16r96DB 16r6762 16r96DC 16r52FF 16r96DD 16r9905 16r96DE 16r5C24 16r96DF 16r623B 16r96E0 16r7C7E 16r96E1 16r8CB0 16r96E2 16r554F 16r96E3 16r60B6 16r96E4 16r7D0B 16r96E5 16r9580 16r96E6 16r5301 16r96E7 16r4E5F 16r96E8 16r51B6 16r96E9 16r591C 16r96EA 16r723A 16r96EB 16r8036 16r96EC 16r91CE 16r96ED 16r5F25 16r96EE 16r77E2 16r96EF 16r5384 16r96F0 16r5F79 16r96F1 16r7D04 16r96F2 16r85AC 16r96F3 16r8A33 16r96F4 16r8E8D 16r96F5 16r9756 16r96F6 16r67F3 16r96F7 16r85AE 16r96F8 16r9453 16r96F9 16r6109 16r96FA 16r6108 16r96FB 16r6CB9 16r96FC 16r7652 16r9740 16r8AED 16r9741 16r8F38 16r9742 16r552F 16r9743 16r4F51 16r9744 16r512A 16r9745 16r52C7 16r9746 16r53CB 16r9747 16r5BA5 16r9748 16r5E7D 16r9749 16r60A0 16r974A 16r6182 16r974B 16r63D6 16r974C 16r6709 16r974D 16r67DA 16r974E 16r6E67 16r974F 16r6D8C 16r9750 16r7336 16r9751 16r7337 16r9752 16r7531 16r9753 16r7950 16r9754 16r88D5 16r9755 16r8A98 16r9756 16r904A 16r9757 16r9091 16r9758 16r90F5 16r9759 16r96C4 16r975A 16r878D 16r975B 16r5915 16r975C 16r4E88 16r975D 16r4F59 16r975E 16r4E0E 16r975F 16r8A89 16r9760 16r8F3F 16r9761 16r9810 16r9762 16r50AD 16r9763 16r5E7C 16r9764 16r5996 16r9765 16r5BB9 16r9766 16r5EB8 16r9767 16r63DA 16r9768 16r63FA 16r9769 16r64C1 16r976A 16r66DC 16r976B 16r694A 16r976C 16r69D8 16r976D 16r6D0B 16r976E 16r6EB6 16r976F 16r7194 16r9770 16r7528 16r9771 16r7AAF 16r9772 16r7F8A 16r9773 16r8000 16r9774 16r8449 16r9775 16r84C9 16r9776 16r8981 16r9777 16r8B21 16r9778 16r8E0A 16r9779 16r9065 16r977A 16r967D 16r977B 16r990A 16r977C 16r617E 16r977D 16r6291 16r977E 16r6B32 16r9780 16r6C83 16r9781 16r6D74 16r9782 16r7FCC 16r9783 16r7FFC 16r9784 16r6DC0 16r9785 16r7F85 16r9786 16r87BA 16r9787 16r88F8 16r9788 16r6765 16r9789 16r83B1 16r978A 16r983C 16r978B 16r96F7 16r978C 16r6D1B 16r978D 16r7D61 16r978E 16r843D 16r978F 16r916A 16r9790 16r4E71 16r9791 16r5375 16r9792 16r5D50 16r9793 16r6B04 16r9794 16r6FEB 16r9795 16r85CD 16r9796 16r862D 16r9797 16r89A7 16r9798 16r5229 16r9799 16r540F 16r979A 16r5C65 16r979B 16r674E 16r979C 16r68A8 16r979D 16r7406 16r979E 16r7483 16r979F 16r75E2 16r97A0 16r88CF 16r97A1 16r88E1 16r97A2 16r91CC 16r97A3 16r96E2 16r97A4 16r9678 16r97A5 16r5F8B 16r97A6 16r7387 16r97A7 16r7ACB 16r97A8 16r844E 16r97A9 16r63A0 16r97AA 16r7565 16r97AB 16r5289 16r97AC 16r6D41 16r97AD 16r6E9C 16r97AE 16r7409 16r97AF 16r7559 16r97B0 16r786B 16r97B1 16r7C92 16r97B2 16r9686 16r97B3 16r7ADC 16r97B4 16r9F8D 16r97B5 16r4FB6 16r97B6 16r616E 16r97B7 16r65C5 16r97B8 16r865C 16r97B9 16r4E86 16r97BA 16r4EAE 16r97BB 16r50DA 16r97BC 16r4E21 16r97BD 16r51CC 16r97BE 16r5BEE 16r97BF 16r6599 16r97C0 16r6881 16r97C1 16r6DBC 16r97C2 16r731F 16r97C3 16r7642 16r97C4 16r77AD 16r97C5 16r7A1C 16r97C6 16r7CE7 16r97C7 16r826F 16r97C8 16r8AD2 16r97C9 16r907C 16r97CA 16r91CF 16r97CB 16r9675 16r97CC 16r9818 16r97CD 16r529B 16r97CE 16r7DD1 16r97CF 16r502B 16r97D0 16r5398 16r97D1 16r6797 16r97D2 16r6DCB 16r97D3 16r71D0 16r97D4 16r7433 16r97D5 16r81E8 16r97D6 16r8F2A 16r97D7 16r96A3 16r97D8 16r9C57 16r97D9 16r9E9F 16r97DA 16r7460 16r97DB 16r5841 16r97DC 16r6D99 16r97DD 16r7D2F 16r97DE 16r985E 16r97DF 16r4EE4 16r97E0 16r4F36 16r97E1 16r4F8B 16r97E2 16r51B7 16r97E3 16r52B1 16r97E4 16r5DBA 16r97E5 16r601C 16r97E6 16r73B2 16r97E7 16r793C 16r97E8 16r82D3 16r97E9 16r9234 16r97EA 16r96B7 16r97EB 16r96F6 16r97EC 16r970A 16r97ED 16r9E97 16r97EE 16r9F62 16r97EF 16r66A6 16r97F0 16r6B74 16r97F1 16r5217 16r97F2 16r52A3 16r97F3 16r70C8 16r97F4 16r88C2 16r97F5 16r5EC9 16r97F6 16r604B 16r97F7 16r6190 16r97F8 16r6F23 16r97F9 16r7149 16r97FA 16r7C3E 16r97FB 16r7DF4 16r97FC 16r806F 16r9840 16r84EE 16r9841 16r9023 16r9842 16r932C 16r9843 16r5442 16r9844 16r9B6F 16r9845 16r6AD3 16r9846 16r7089 16r9847 16r8CC2 16r9848 16r8DEF 16r9849 16r9732 16r984A 16r52B4 16r984B 16r5A41 16r984C 16r5ECA 16r984D 16r5F04 16r984E 16r6717 16r984F 16r697C 16r9850 16r6994 16r9851 16r6D6A 16r9852 16r6F0F 16r9853 16r7262 16r9854 16r72FC 16r9855 16r7BED 16r9856 16r8001 16r9857 16r807E 16r9858 16r874B 16r9859 16r90CE 16r985A 16r516D 16r985B 16r9E93 16r985C 16r7984 16r985D 16r808B 16r985E 16r9332 16r985F 16r8AD6 16r9860 16r502D 16r9861 16r548C 16r9862 16r8A71 16r9863 16r6B6A 16r9864 16r8CC4 16r9865 16r8107 16r9866 16r60D1 16r9867 16r67A0 16r9868 16r9DF2 16r9869 16r4E99 16r986A 16r4E98 16r986B 16r9C10 16r986C 16r8A6B 16r986D 16r85C1 16r986E 16r8568 16r986F 16r6900 16r9870 16r6E7E 16r9871 16r7897 16r9872 16r8155 16r989F 16r5F0C 16r98A0 16r4E10 16r98A1 16r4E15 16r98A2 16r4E2A 16r98A3 16r4E31 16r98A4 16r4E36 16r98A5 16r4E3C 16r98A6 16r4E3F 16r98A7 16r4E42 16r98A8 16r4E56 16r98A9 16r4E58 16r98AA 16r4E82 16r98AB 16r4E85 16r98AC 16r8C6B 16r98AD 16r4E8A 16r98AE 16r8212 16r98AF 16r5F0D 16r98B0 16r4E8E 16r98B1 16r4E9E 16r98B2 16r4E9F 16r98B3 16r4EA0 16r98B4 16r4EA2 16r98B5 16r4EB0 16r98B6 16r4EB3 16r98B7 16r4EB6 16r98B8 16r4ECE 16r98B9 16r4ECD 16r98BA 16r4EC4 16r98BB 16r4EC6 16r98BC 16r4EC2 16r98BD 16r4ED7 16r98BE 16r4EDE 16r98BF 16r4EED 16r98C0 16r4EDF 16r98C1 16r4EF7 16r98C2 16r4F09 16r98C3 16r4F5A 16r98C4 16r4F30 16r98C5 16r4F5B 16r98C6 16r4F5D 16r98C7 16r4F57 16r98C8 16r4F47 16r98C9 16r4F76 16r98CA 16r4F88 16r98CB 16r4F8F 16r98CC 16r4F98 16r98CD 16r4F7B 16r98CE 16r4F69 16r98CF 16r4F70 16r98D0 16r4F91 16r98D1 16r4F6F 16r98D2 16r4F86 16r98D3 16r4F96 16r98D4 16r5118 16r98D5 16r4FD4 16r98D6 16r4FDF 16r98D7 16r4FCE 16r98D8 16r4FD8 16r98D9 16r4FDB 16r98DA 16r4FD1 16r98DB 16r4FDA 16r98DC 16r4FD0 16r98DD 16r4FE4 16r98DE 16r4FE5 16r98DF 16r501A 16r98E0 16r5028 16r98E1 16r5014 16r98E2 16r502A 16r98E3 16r5025 16r98E4 16r5005 16r98E5 16r4F1C 16r98E6 16r4FF6 16r98E7 16r5021 16r98E8 16r5029 16r98E9 16r502C 16r98EA 16r4FFE 16r98EB 16r4FEF 16r98EC 16r5011 16r98ED 16r5006 16r98EE 16r5043 16r98EF 16r5047 16r98F0 16r6703 16r98F1 16r5055 16r98F2 16r5050 16r98F3 16r5048 16r98F4 16r505A 16r98F5 16r5056 16r98F6 16r506C 16r98F7 16r5078 16r98F8 16r5080 16r98F9 16r509A 16r98FA 16r5085 16r98FB 16r50B4 16r98FC 16r50B2 16r9940 16r50C9 16r9941 16r50CA 16r9942 16r50B3 16r9943 16r50C2 16r9944 16r50D6 16r9945 16r50DE 16r9946 16r50E5 16r9947 16r50ED 16r9948 16r50E3 16r9949 16r50EE 16r994A 16r50F9 16r994B 16r50F5 16r994C 16r5109 16r994D 16r5101 16r994E 16r5102 16r994F 16r5116 16r9950 16r5115 16r9951 16r5114 16r9952 16r511A 16r9953 16r5121 16r9954 16r513A 16r9955 16r5137 16r9956 16r513C 16r9957 16r513B 16r9958 16r513F 16r9959 16r5140 16r995A 16r5152 16r995B 16r514C 16r995C 16r5154 16r995D 16r5162 16r995E 16r7AF8 16r995F 16r5169 16r9960 16r516A 16r9961 16r516E 16r9962 16r5180 16r9963 16r5182 16r9964 16r56D8 16r9965 16r518C 16r9966 16r5189 16r9967 16r518F 16r9968 16r5191 16r9969 16r5193 16r996A 16r5195 16r996B 16r5196 16r996C 16r51A4 16r996D 16r51A6 16r996E 16r51A2 16r996F 16r51A9 16r9970 16r51AA 16r9971 16r51AB 16r9972 16r51B3 16r9973 16r51B1 16r9974 16r51B2 16r9975 16r51B0 16r9976 16r51B5 16r9977 16r51BD 16r9978 16r51C5 16r9979 16r51C9 16r997A 16r51DB 16r997B 16r51E0 16r997C 16r8655 16r997D 16r51E9 16r997E 16r51ED 16r9980 16r51F0 16r9981 16r51F5 16r9982 16r51FE 16r9983 16r5204 16r9984 16r520B 16r9985 16r5214 16r9986 16r520E 16r9987 16r5227 16r9988 16r522A 16r9989 16r522E 16r998A 16r5233 16r998B 16r5239 16r998C 16r524F 16r998D 16r5244 16r998E 16r524B 16r998F 16r524C 16r9990 16r525E 16r9991 16r5254 16r9992 16r526A 16r9993 16r5274 16r9994 16r5269 16r9995 16r5273 16r9996 16r527F 16r9997 16r527D 16r9998 16r528D 16r9999 16r5294 16r999A 16r5292 16r999B 16r5271 16r999C 16r5288 16r999D 16r5291 16r999E 16r8FA8 16r999F 16r8FA7 16r99A0 16r52AC 16r99A1 16r52AD 16r99A2 16r52BC 16r99A3 16r52B5 16r99A4 16r52C1 16r99A5 16r52CD 16r99A6 16r52D7 16r99A7 16r52DE 16r99A8 16r52E3 16r99A9 16r52E6 16r99AA 16r98ED 16r99AB 16r52E0 16r99AC 16r52F3 16r99AD 16r52F5 16r99AE 16r52F8 16r99AF 16r52F9 16r99B0 16r5306 16r99B1 16r5308 16r99B2 16r7538 16r99B3 16r530D 16r99B4 16r5310 16r99B5 16r530F 16r99B6 16r5315 16r99B7 16r531A 16r99B8 16r5323 16r99B9 16r532F 16r99BA 16r5331 16r99BB 16r5333 16r99BC 16r5338 16r99BD 16r5340 16r99BE 16r5346 16r99BF 16r5345 16r99C0 16r4E17 16r99C1 16r5349 16r99C2 16r534D 16r99C3 16r51D6 16r99C4 16r535E 16r99C5 16r5369 16r99C6 16r536E 16r99C7 16r5918 16r99C8 16r537B 16r99C9 16r5377 16r99CA 16r5382 16r99CB 16r5396 16r99CC 16r53A0 16r99CD 16r53A6 16r99CE 16r53A5 16r99CF 16r53AE 16r99D0 16r53B0 16r99D1 16r53B6 16r99D2 16r53C3 16r99D3 16r7C12 16r99D4 16r96D9 16r99D5 16r53DF 16r99D6 16r66FC 16r99D7 16r71EE 16r99D8 16r53EE 16r99D9 16r53E8 16r99DA 16r53ED 16r99DB 16r53FA 16r99DC 16r5401 16r99DD 16r543D 16r99DE 16r5440 16r99DF 16r542C 16r99E0 16r542D 16r99E1 16r543C 16r99E2 16r542E 16r99E3 16r5436 16r99E4 16r5429 16r99E5 16r541D 16r99E6 16r544E 16r99E7 16r548F 16r99E8 16r5475 16r99E9 16r548E 16r99EA 16r545F 16r99EB 16r5471 16r99EC 16r5477 16r99ED 16r5470 16r99EE 16r5492 16r99EF 16r547B 16r99F0 16r5480 16r99F1 16r5476 16r99F2 16r5484 16r99F3 16r5490 16r99F4 16r5486 16r99F5 16r54C7 16r99F6 16r54A2 16r99F7 16r54B8 16r99F8 16r54A5 16r99F9 16r54AC 16r99FA 16r54C4 16r99FB 16r54C8 16r99FC 16r54A8 16r9A40 16r54AB 16r9A41 16r54C2 16r9A42 16r54A4 16r9A43 16r54BE 16r9A44 16r54BC 16r9A45 16r54D8 16r9A46 16r54E5 16r9A47 16r54E6 16r9A48 16r550F 16r9A49 16r5514 16r9A4A 16r54FD 16r9A4B 16r54EE 16r9A4C 16r54ED 16r9A4D 16r54FA 16r9A4E 16r54E2 16r9A4F 16r5539 16r9A50 16r5540 16r9A51 16r5563 16r9A52 16r554C 16r9A53 16r552E 16r9A54 16r555C 16r9A55 16r5545 16r9A56 16r5556 16r9A57 16r5557 16r9A58 16r5538 16r9A59 16r5533 16r9A5A 16r555D 16r9A5B 16r5599 16r9A5C 16r5580 16r9A5D 16r54AF 16r9A5E 16r558A 16r9A5F 16r559F 16r9A60 16r557B 16r9A61 16r557E 16r9A62 16r5598 16r9A63 16r559E 16r9A64 16r55AE 16r9A65 16r557C 16r9A66 16r5583 16r9A67 16r55A9 16r9A68 16r5587 16r9A69 16r55A8 16r9A6A 16r55DA 16r9A6B 16r55C5 16r9A6C 16r55DF 16r9A6D 16r55C4 16r9A6E 16r55DC 16r9A6F 16r55E4 16r9A70 16r55D4 16r9A71 16r5614 16r9A72 16r55F7 16r9A73 16r5616 16r9A74 16r55FE 16r9A75 16r55FD 16r9A76 16r561B 16r9A77 16r55F9 16r9A78 16r564E 16r9A79 16r5650 16r9A7A 16r71DF 16r9A7B 16r5634 16r9A7C 16r5636 16r9A7D 16r5632 16r9A7E 16r5638 16r9A80 16r566B 16r9A81 16r5664 16r9A82 16r562F 16r9A83 16r566C 16r9A84 16r566A 16r9A85 16r5686 16r9A86 16r5680 16r9A87 16r568A 16r9A88 16r56A0 16r9A89 16r5694 16r9A8A 16r568F 16r9A8B 16r56A5 16r9A8C 16r56AE 16r9A8D 16r56B6 16r9A8E 16r56B4 16r9A8F 16r56C2 16r9A90 16r56BC 16r9A91 16r56C1 16r9A92 16r56C3 16r9A93 16r56C0 16r9A94 16r56C8 16r9A95 16r56CE 16r9A96 16r56D1 16r9A97 16r56D3 16r9A98 16r56D7 16r9A99 16r56EE 16r9A9A 16r56F9 16r9A9B 16r5700 16r9A9C 16r56FF 16r9A9D 16r5704 16r9A9E 16r5709 16r9A9F 16r5708 16r9AA0 16r570B 16r9AA1 16r570D 16r9AA2 16r5713 16r9AA3 16r5718 16r9AA4 16r5716 16r9AA5 16r55C7 16r9AA6 16r571C 16r9AA7 16r5726 16r9AA8 16r5737 16r9AA9 16r5738 16r9AAA 16r574E 16r9AAB 16r573B 16r9AAC 16r5740 16r9AAD 16r574F 16r9AAE 16r5769 16r9AAF 16r57C0 16r9AB0 16r5788 16r9AB1 16r5761 16r9AB2 16r577F 16r9AB3 16r5789 16r9AB4 16r5793 16r9AB5 16r57A0 16r9AB6 16r57B3 16r9AB7 16r57A4 16r9AB8 16r57AA 16r9AB9 16r57B0 16r9ABA 16r57C3 16r9ABB 16r57C6 16r9ABC 16r57D4 16r9ABD 16r57D2 16r9ABE 16r57D3 16r9ABF 16r580A 16r9AC0 16r57D6 16r9AC1 16r57E3 16r9AC2 16r580B 16r9AC3 16r5819 16r9AC4 16r581D 16r9AC5 16r5872 16r9AC6 16r5821 16r9AC7 16r5862 16r9AC8 16r584B 16r9AC9 16r5870 16r9ACA 16r6BC0 16r9ACB 16r5852 16r9ACC 16r583D 16r9ACD 16r5879 16r9ACE 16r5885 16r9ACF 16r58B9 16r9AD0 16r589F 16r9AD1 16r58AB 16r9AD2 16r58BA 16r9AD3 16r58DE 16r9AD4 16r58BB 16r9AD5 16r58B8 16r9AD6 16r58AE 16r9AD7 16r58C5 16r9AD8 16r58D3 16r9AD9 16r58D1 16r9ADA 16r58D7 16r9ADB 16r58D9 16r9ADC 16r58D8 16r9ADD 16r58E5 16r9ADE 16r58DC 16r9ADF 16r58E4 16r9AE0 16r58DF 16r9AE1 16r58EF 16r9AE2 16r58FA 16r9AE3 16r58F9 16r9AE4 16r58FB 16r9AE5 16r58FC 16r9AE6 16r58FD 16r9AE7 16r5902 16r9AE8 16r590A 16r9AE9 16r5910 16r9AEA 16r591B 16r9AEB 16r68A6 16r9AEC 16r5925 16r9AED 16r592C 16r9AEE 16r592D 16r9AEF 16r5932 16r9AF0 16r5938 16r9AF1 16r593E 16r9AF2 16r7AD2 16r9AF3 16r5955 16r9AF4 16r5950 16r9AF5 16r594E 16r9AF6 16r595A 16r9AF7 16r5958 16r9AF8 16r5962 16r9AF9 16r5960 16r9AFA 16r5967 16r9AFB 16r596C 16r9AFC 16r5969 16r9B40 16r5978 16r9B41 16r5981 16r9B42 16r599D 16r9B43 16r4F5E 16r9B44 16r4FAB 16r9B45 16r59A3 16r9B46 16r59B2 16r9B47 16r59C6 16r9B48 16r59E8 16r9B49 16r59DC 16r9B4A 16r598D 16r9B4B 16r59D9 16r9B4C 16r59DA 16r9B4D 16r5A25 16r9B4E 16r5A1F 16r9B4F 16r5A11 16r9B50 16r5A1C 16r9B51 16r5A09 16r9B52 16r5A1A 16r9B53 16r5A40 16r9B54 16r5A6C 16r9B55 16r5A49 16r9B56 16r5A35 16r9B57 16r5A36 16r9B58 16r5A62 16r9B59 16r5A6A 16r9B5A 16r5A9A 16r9B5B 16r5ABC 16r9B5C 16r5ABE 16r9B5D 16r5ACB 16r9B5E 16r5AC2 16r9B5F 16r5ABD 16r9B60 16r5AE3 16r9B61 16r5AD7 16r9B62 16r5AE6 16r9B63 16r5AE9 16r9B64 16r5AD6 16r9B65 16r5AFA 16r9B66 16r5AFB 16r9B67 16r5B0C 16r9B68 16r5B0B 16r9B69 16r5B16 16r9B6A 16r5B32 16r9B6B 16r5AD0 16r9B6C 16r5B2A 16r9B6D 16r5B36 16r9B6E 16r5B3E 16r9B6F 16r5B43 16r9B70 16r5B45 16r9B71 16r5B40 16r9B72 16r5B51 16r9B73 16r5B55 16r9B74 16r5B5A 16r9B75 16r5B5B 16r9B76 16r5B65 16r9B77 16r5B69 16r9B78 16r5B70 16r9B79 16r5B73 16r9B7A 16r5B75 16r9B7B 16r5B78 16r9B7C 16r6588 16r9B7D 16r5B7A 16r9B7E 16r5B80 16r9B80 16r5B83 16r9B81 16r5BA6 16r9B82 16r5BB8 16r9B83 16r5BC3 16r9B84 16r5BC7 16r9B85 16r5BC9 16r9B86 16r5BD4 16r9B87 16r5BD0 16r9B88 16r5BE4 16r9B89 16r5BE6 16r9B8A 16r5BE2 16r9B8B 16r5BDE 16r9B8C 16r5BE5 16r9B8D 16r5BEB 16r9B8E 16r5BF0 16r9B8F 16r5BF6 16r9B90 16r5BF3 16r9B91 16r5C05 16r9B92 16r5C07 16r9B93 16r5C08 16r9B94 16r5C0D 16r9B95 16r5C13 16r9B96 16r5C20 16r9B97 16r5C22 16r9B98 16r5C28 16r9B99 16r5C38 16r9B9A 16r5C39 16r9B9B 16r5C41 16r9B9C 16r5C46 16r9B9D 16r5C4E 16r9B9E 16r5C53 16r9B9F 16r5C50 16r9BA0 16r5C4F 16r9BA1 16r5B71 16r9BA2 16r5C6C 16r9BA3 16r5C6E 16r9BA4 16r4E62 16r9BA5 16r5C76 16r9BA6 16r5C79 16r9BA7 16r5C8C 16r9BA8 16r5C91 16r9BA9 16r5C94 16r9BAA 16r599B 16r9BAB 16r5CAB 16r9BAC 16r5CBB 16r9BAD 16r5CB6 16r9BAE 16r5CBC 16r9BAF 16r5CB7 16r9BB0 16r5CC5 16r9BB1 16r5CBE 16r9BB2 16r5CC7 16r9BB3 16r5CD9 16r9BB4 16r5CE9 16r9BB5 16r5CFD 16r9BB6 16r5CFA 16r9BB7 16r5CED 16r9BB8 16r5D8C 16r9BB9 16r5CEA 16r9BBA 16r5D0B 16r9BBB 16r5D15 16r9BBC 16r5D17 16r9BBD 16r5D5C 16r9BBE 16r5D1F 16r9BBF 16r5D1B 16r9BC0 16r5D11 16r9BC1 16r5D14 16r9BC2 16r5D22 16r9BC3 16r5D1A 16r9BC4 16r5D19 16r9BC5 16r5D18 16r9BC6 16r5D4C 16r9BC7 16r5D52 16r9BC8 16r5D4E 16r9BC9 16r5D4B 16r9BCA 16r5D6C 16r9BCB 16r5D73 16r9BCC 16r5D76 16r9BCD 16r5D87 16r9BCE 16r5D84 16r9BCF 16r5D82 16r9BD0 16r5DA2 16r9BD1 16r5D9D 16r9BD2 16r5DAC 16r9BD3 16r5DAE 16r9BD4 16r5DBD 16r9BD5 16r5D90 16r9BD6 16r5DB7 16r9BD7 16r5DBC 16r9BD8 16r5DC9 16r9BD9 16r5DCD 16r9BDA 16r5DD3 16r9BDB 16r5DD2 16r9BDC 16r5DD6 16r9BDD 16r5DDB 16r9BDE 16r5DEB 16r9BDF 16r5DF2 16r9BE0 16r5DF5 16r9BE1 16r5E0B 16r9BE2 16r5E1A 16r9BE3 16r5E19 16r9BE4 16r5E11 16r9BE5 16r5E1B 16r9BE6 16r5E36 16r9BE7 16r5E37 16r9BE8 16r5E44 16r9BE9 16r5E43 16r9BEA 16r5E40 16r9BEB 16r5E4E 16r9BEC 16r5E57 16r9BED 16r5E54 16r9BEE 16r5E5F 16r9BEF 16r5E62 16r9BF0 16r5E64 16r9BF1 16r5E47 16r9BF2 16r5E75 16r9BF3 16r5E76 16r9BF4 16r5E7A 16r9BF5 16r9EBC 16r9BF6 16r5E7F 16r9BF7 16r5EA0 16r9BF8 16r5EC1 16r9BF9 16r5EC2 16r9BFA 16r5EC8 16r9BFB 16r5ED0 16r9BFC 16r5ECF 16r9C40 16r5ED6 16r9C41 16r5EE3 16r9C42 16r5EDD 16r9C43 16r5EDA 16r9C44 16r5EDB 16r9C45 16r5EE2 16r9C46 16r5EE1 16r9C47 16r5EE8 16r9C48 16r5EE9 16r9C49 16r5EEC 16r9C4A 16r5EF1 16r9C4B 16r5EF3 16r9C4C 16r5EF0 16r9C4D 16r5EF4 16r9C4E 16r5EF8 16r9C4F 16r5EFE 16r9C50 16r5F03 16r9C51 16r5F09 16r9C52 16r5F5D 16r9C53 16r5F5C 16r9C54 16r5F0B 16r9C55 16r5F11 16r9C56 16r5F16 16r9C57 16r5F29 16r9C58 16r5F2D 16r9C59 16r5F38 16r9C5A 16r5F41 16r9C5B 16r5F48 16r9C5C 16r5F4C 16r9C5D 16r5F4E 16r9C5E 16r5F2F 16r9C5F 16r5F51 16r9C60 16r5F56 16r9C61 16r5F57 16r9C62 16r5F59 16r9C63 16r5F61 16r9C64 16r5F6D 16r9C65 16r5F73 16r9C66 16r5F77 16r9C67 16r5F83 16r9C68 16r5F82 16r9C69 16r5F7F 16r9C6A 16r5F8A 16r9C6B 16r5F88 16r9C6C 16r5F91 16r9C6D 16r5F87 16r9C6E 16r5F9E 16r9C6F 16r5F99 16r9C70 16r5F98 16r9C71 16r5FA0 16r9C72 16r5FA8 16r9C73 16r5FAD 16r9C74 16r5FBC 16r9C75 16r5FD6 16r9C76 16r5FFB 16r9C77 16r5FE4 16r9C78 16r5FF8 16r9C79 16r5FF1 16r9C7A 16r5FDD 16r9C7B 16r60B3 16r9C7C 16r5FFF 16r9C7D 16r6021 16r9C7E 16r6060 16r9C80 16r6019 16r9C81 16r6010 16r9C82 16r6029 16r9C83 16r600E 16r9C84 16r6031 16r9C85 16r601B 16r9C86 16r6015 16r9C87 16r602B 16r9C88 16r6026 16r9C89 16r600F 16r9C8A 16r603A 16r9C8B 16r605A 16r9C8C 16r6041 16r9C8D 16r606A 16r9C8E 16r6077 16r9C8F 16r605F 16r9C90 16r604A 16r9C91 16r6046 16r9C92 16r604D 16r9C93 16r6063 16r9C94 16r6043 16r9C95 16r6064 16r9C96 16r6042 16r9C97 16r606C 16r9C98 16r606B 16r9C99 16r6059 16r9C9A 16r6081 16r9C9B 16r608D 16r9C9C 16r60E7 16r9C9D 16r6083 16r9C9E 16r609A 16r9C9F 16r6084 16r9CA0 16r609B 16r9CA1 16r6096 16r9CA2 16r6097 16r9CA3 16r6092 16r9CA4 16r60A7 16r9CA5 16r608B 16r9CA6 16r60E1 16r9CA7 16r60B8 16r9CA8 16r60E0 16r9CA9 16r60D3 16r9CAA 16r60B4 16r9CAB 16r5FF0 16r9CAC 16r60BD 16r9CAD 16r60C6 16r9CAE 16r60B5 16r9CAF 16r60D8 16r9CB0 16r614D 16r9CB1 16r6115 16r9CB2 16r6106 16r9CB3 16r60F6 16r9CB4 16r60F7 16r9CB5 16r6100 16r9CB6 16r60F4 16r9CB7 16r60FA 16r9CB8 16r6103 16r9CB9 16r6121 16r9CBA 16r60FB 16r9CBB 16r60F1 16r9CBC 16r610D 16r9CBD 16r610E 16r9CBE 16r6147 16r9CBF 16r613E 16r9CC0 16r6128 16r9CC1 16r6127 16r9CC2 16r614A 16r9CC3 16r613F 16r9CC4 16r613C 16r9CC5 16r612C 16r9CC6 16r6134 16r9CC7 16r613D 16r9CC8 16r6142 16r9CC9 16r6144 16r9CCA 16r6173 16r9CCB 16r6177 16r9CCC 16r6158 16r9CCD 16r6159 16r9CCE 16r615A 16r9CCF 16r616B 16r9CD0 16r6174 16r9CD1 16r616F 16r9CD2 16r6165 16r9CD3 16r6171 16r9CD4 16r615F 16r9CD5 16r615D 16r9CD6 16r6153 16r9CD7 16r6175 16r9CD8 16r6199 16r9CD9 16r6196 16r9CDA 16r6187 16r9CDB 16r61AC 16r9CDC 16r6194 16r9CDD 16r619A 16r9CDE 16r618A 16r9CDF 16r6191 16r9CE0 16r61AB 16r9CE1 16r61AE 16r9CE2 16r61CC 16r9CE3 16r61CA 16r9CE4 16r61C9 16r9CE5 16r61F7 16r9CE6 16r61C8 16r9CE7 16r61C3 16r9CE8 16r61C6 16r9CE9 16r61BA 16r9CEA 16r61CB 16r9CEB 16r7F79 16r9CEC 16r61CD 16r9CED 16r61E6 16r9CEE 16r61E3 16r9CEF 16r61F6 16r9CF0 16r61FA 16r9CF1 16r61F4 16r9CF2 16r61FF 16r9CF3 16r61FD 16r9CF4 16r61FC 16r9CF5 16r61FE 16r9CF6 16r6200 16r9CF7 16r6208 16r9CF8 16r6209 16r9CF9 16r620D 16r9CFA 16r620C 16r9CFB 16r6214 16r9CFC 16r621B 16r9D40 16r621E 16r9D41 16r6221 16r9D42 16r622A 16r9D43 16r622E 16r9D44 16r6230 16r9D45 16r6232 16r9D46 16r6233 16r9D47 16r6241 16r9D48 16r624E 16r9D49 16r625E 16r9D4A 16r6263 16r9D4B 16r625B 16r9D4C 16r6260 16r9D4D 16r6268 16r9D4E 16r627C 16r9D4F 16r6282 16r9D50 16r6289 16r9D51 16r627E 16r9D52 16r6292 16r9D53 16r6293 16r9D54 16r6296 16r9D55 16r62D4 16r9D56 16r6283 16r9D57 16r6294 16r9D58 16r62D7 16r9D59 16r62D1 16r9D5A 16r62BB 16r9D5B 16r62CF 16r9D5C 16r62FF 16r9D5D 16r62C6 16r9D5E 16r64D4 16r9D5F 16r62C8 16r9D60 16r62DC 16r9D61 16r62CC 16r9D62 16r62CA 16r9D63 16r62C2 16r9D64 16r62C7 16r9D65 16r629B 16r9D66 16r62C9 16r9D67 16r630C 16r9D68 16r62EE 16r9D69 16r62F1 16r9D6A 16r6327 16r9D6B 16r6302 16r9D6C 16r6308 16r9D6D 16r62EF 16r9D6E 16r62F5 16r9D6F 16r6350 16r9D70 16r633E 16r9D71 16r634D 16r9D72 16r641C 16r9D73 16r634F 16r9D74 16r6396 16r9D75 16r638E 16r9D76 16r6380 16r9D77 16r63AB 16r9D78 16r6376 16r9D79 16r63A3 16r9D7A 16r638F 16r9D7B 16r6389 16r9D7C 16r639F 16r9D7D 16r63B5 16r9D7E 16r636B 16r9D80 16r6369 16r9D81 16r63BE 16r9D82 16r63E9 16r9D83 16r63C0 16r9D84 16r63C6 16r9D85 16r63E3 16r9D86 16r63C9 16r9D87 16r63D2 16r9D88 16r63F6 16r9D89 16r63C4 16r9D8A 16r6416 16r9D8B 16r6434 16r9D8C 16r6406 16r9D8D 16r6413 16r9D8E 16r6426 16r9D8F 16r6436 16r9D90 16r651D 16r9D91 16r6417 16r9D92 16r6428 16r9D93 16r640F 16r9D94 16r6467 16r9D95 16r646F 16r9D96 16r6476 16r9D97 16r644E 16r9D98 16r652A 16r9D99 16r6495 16r9D9A 16r6493 16r9D9B 16r64A5 16r9D9C 16r64A9 16r9D9D 16r6488 16r9D9E 16r64BC 16r9D9F 16r64DA 16r9DA0 16r64D2 16r9DA1 16r64C5 16r9DA2 16r64C7 16r9DA3 16r64BB 16r9DA4 16r64D8 16r9DA5 16r64C2 16r9DA6 16r64F1 16r9DA7 16r64E7 16r9DA8 16r8209 16r9DA9 16r64E0 16r9DAA 16r64E1 16r9DAB 16r62AC 16r9DAC 16r64E3 16r9DAD 16r64EF 16r9DAE 16r652C 16r9DAF 16r64F6 16r9DB0 16r64F4 16r9DB1 16r64F2 16r9DB2 16r64FA 16r9DB3 16r6500 16r9DB4 16r64FD 16r9DB5 16r6518 16r9DB6 16r651C 16r9DB7 16r6505 16r9DB8 16r6524 16r9DB9 16r6523 16r9DBA 16r652B 16r9DBB 16r6534 16r9DBC 16r6535 16r9DBD 16r6537 16r9DBE 16r6536 16r9DBF 16r6538 16r9DC0 16r754B 16r9DC1 16r6548 16r9DC2 16r6556 16r9DC3 16r6555 16r9DC4 16r654D 16r9DC5 16r6558 16r9DC6 16r655E 16r9DC7 16r655D 16r9DC8 16r6572 16r9DC9 16r6578 16r9DCA 16r6582 16r9DCB 16r6583 16r9DCC 16r8B8A 16r9DCD 16r659B 16r9DCE 16r659F 16r9DCF 16r65AB 16r9DD0 16r65B7 16r9DD1 16r65C3 16r9DD2 16r65C6 16r9DD3 16r65C1 16r9DD4 16r65C4 16r9DD5 16r65CC 16r9DD6 16r65D2 16r9DD7 16r65DB 16r9DD8 16r65D9 16r9DD9 16r65E0 16r9DDA 16r65E1 16r9DDB 16r65F1 16r9DDC 16r6772 16r9DDD 16r660A 16r9DDE 16r6603 16r9DDF 16r65FB 16r9DE0 16r6773 16r9DE1 16r6635 16r9DE2 16r6636 16r9DE3 16r6634 16r9DE4 16r661C 16r9DE5 16r664F 16r9DE6 16r6644 16r9DE7 16r6649 16r9DE8 16r6641 16r9DE9 16r665E 16r9DEA 16r665D 16r9DEB 16r6664 16r9DEC 16r6667 16r9DED 16r6668 16r9DEE 16r665F 16r9DEF 16r6662 16r9DF0 16r6670 16r9DF1 16r6683 16r9DF2 16r6688 16r9DF3 16r668E 16r9DF4 16r6689 16r9DF5 16r6684 16r9DF6 16r6698 16r9DF7 16r669D 16r9DF8 16r66C1 16r9DF9 16r66B9 16r9DFA 16r66C9 16r9DFB 16r66BE 16r9DFC 16r66BC 16r9E40 16r66C4 16r9E41 16r66B8 16r9E42 16r66D6 16r9E43 16r66DA 16r9E44 16r66E0 16r9E45 16r663F 16r9E46 16r66E6 16r9E47 16r66E9 16r9E48 16r66F0 16r9E49 16r66F5 16r9E4A 16r66F7 16r9E4B 16r670F 16r9E4C 16r6716 16r9E4D 16r671E 16r9E4E 16r6726 16r9E4F 16r6727 16r9E50 16r9738 16r9E51 16r672E 16r9E52 16r673F 16r9E53 16r6736 16r9E54 16r6741 16r9E55 16r6738 16r9E56 16r6737 16r9E57 16r6746 16r9E58 16r675E 16r9E59 16r6760 16r9E5A 16r6759 16r9E5B 16r6763 16r9E5C 16r6764 16r9E5D 16r6789 16r9E5E 16r6770 16r9E5F 16r67A9 16r9E60 16r677C 16r9E61 16r676A 16r9E62 16r678C 16r9E63 16r678B 16r9E64 16r67A6 16r9E65 16r67A1 16r9E66 16r6785 16r9E67 16r67B7 16r9E68 16r67EF 16r9E69 16r67B4 16r9E6A 16r67EC 16r9E6B 16r67B3 16r9E6C 16r67E9 16r9E6D 16r67B8 16r9E6E 16r67E4 16r9E6F 16r67DE 16r9E70 16r67DD 16r9E71 16r67E2 16r9E72 16r67EE 16r9E73 16r67B9 16r9E74 16r67CE 16r9E75 16r67C6 16r9E76 16r67E7 16r9E77 16r6A9C 16r9E78 16r681E 16r9E79 16r6846 16r9E7A 16r6829 16r9E7B 16r6840 16r9E7C 16r684D 16r9E7D 16r6832 16r9E7E 16r684E 16r9E80 16r68B3 16r9E81 16r682B 16r9E82 16r6859 16r9E83 16r6863 16r9E84 16r6877 16r9E85 16r687F 16r9E86 16r689F 16r9E87 16r688F 16r9E88 16r68AD 16r9E89 16r6894 16r9E8A 16r689D 16r9E8B 16r689B 16r9E8C 16r6883 16r9E8D 16r6AAE 16r9E8E 16r68B9 16r9E8F 16r6874 16r9E90 16r68B5 16r9E91 16r68A0 16r9E92 16r68BA 16r9E93 16r690F 16r9E94 16r688D 16r9E95 16r687E 16r9E96 16r6901 16r9E97 16r68CA 16r9E98 16r6908 16r9E99 16r68D8 16r9E9A 16r6922 16r9E9B 16r6926 16r9E9C 16r68E1 16r9E9D 16r690C 16r9E9E 16r68CD 16r9E9F 16r68D4 16r9EA0 16r68E7 16r9EA1 16r68D5 16r9EA2 16r6936 16r9EA3 16r6912 16r9EA4 16r6904 16r9EA5 16r68D7 16r9EA6 16r68E3 16r9EA7 16r6925 16r9EA8 16r68F9 16r9EA9 16r68E0 16r9EAA 16r68EF 16r9EAB 16r6928 16r9EAC 16r692A 16r9EAD 16r691A 16r9EAE 16r6923 16r9EAF 16r6921 16r9EB0 16r68C6 16r9EB1 16r6979 16r9EB2 16r6977 16r9EB3 16r695C 16r9EB4 16r6978 16r9EB5 16r696B 16r9EB6 16r6954 16r9EB7 16r697E 16r9EB8 16r696E 16r9EB9 16r6939 16r9EBA 16r6974 16r9EBB 16r693D 16r9EBC 16r6959 16r9EBD 16r6930 16r9EBE 16r6961 16r9EBF 16r695E 16r9EC0 16r695D 16r9EC1 16r6981 16r9EC2 16r696A 16r9EC3 16r69B2 16r9EC4 16r69AE 16r9EC5 16r69D0 16r9EC6 16r69BF 16r9EC7 16r69C1 16r9EC8 16r69D3 16r9EC9 16r69BE 16r9ECA 16r69CE 16r9ECB 16r5BE8 16r9ECC 16r69CA 16r9ECD 16r69DD 16r9ECE 16r69BB 16r9ECF 16r69C3 16r9ED0 16r69A7 16r9ED1 16r6A2E 16r9ED2 16r6991 16r9ED3 16r69A0 16r9ED4 16r699C 16r9ED5 16r6995 16r9ED6 16r69B4 16r9ED7 16r69DE 16r9ED8 16r69E8 16r9ED9 16r6A02 16r9EDA 16r6A1B 16r9EDB 16r69FF 16r9EDC 16r6B0A 16r9EDD 16r69F9 16r9EDE 16r69F2 16r9EDF 16r69E7 16r9EE0 16r6A05 16r9EE1 16r69B1 16r9EE2 16r6A1E 16r9EE3 16r69ED 16r9EE4 16r6A14 16r9EE5 16r69EB 16r9EE6 16r6A0A 16r9EE7 16r6A12 16r9EE8 16r6AC1 16r9EE9 16r6A23 16r9EEA 16r6A13 16r9EEB 16r6A44 16r9EEC 16r6A0C 16r9EED 16r6A72 16r9EEE 16r6A36 16r9EEF 16r6A78 16r9EF0 16r6A47 16r9EF1 16r6A62 16r9EF2 16r6A59 16r9EF3 16r6A66 16r9EF4 16r6A48 16r9EF5 16r6A38 16r9EF6 16r6A22 16r9EF7 16r6A90 16r9EF8 16r6A8D 16r9EF9 16r6AA0 16r9EFA 16r6A84 16r9EFB 16r6AA2 16r9EFC 16r6AA3 16r9F40 16r6A97 16r9F41 16r8617 16r9F42 16r6ABB 16r9F43 16r6AC3 16r9F44 16r6AC2 16r9F45 16r6AB8 16r9F46 16r6AB3 16r9F47 16r6AAC 16r9F48 16r6ADE 16r9F49 16r6AD1 16r9F4A 16r6ADF 16r9F4B 16r6AAA 16r9F4C 16r6ADA 16r9F4D 16r6AEA 16r9F4E 16r6AFB 16r9F4F 16r6B05 16r9F50 16r8616 16r9F51 16r6AFA 16r9F52 16r6B12 16r9F53 16r6B16 16r9F54 16r9B31 16r9F55 16r6B1F 16r9F56 16r6B38 16r9F57 16r6B37 16r9F58 16r76DC 16r9F59 16r6B39 16r9F5A 16r98EE 16r9F5B 16r6B47 16r9F5C 16r6B43 16r9F5D 16r6B49 16r9F5E 16r6B50 16r9F5F 16r6B59 16r9F60 16r6B54 16r9F61 16r6B5B 16r9F62 16r6B5F 16r9F63 16r6B61 16r9F64 16r6B78 16r9F65 16r6B79 16r9F66 16r6B7F 16r9F67 16r6B80 16r9F68 16r6B84 16r9F69 16r6B83 16r9F6A 16r6B8D 16r9F6B 16r6B98 16r9F6C 16r6B95 16r9F6D 16r6B9E 16r9F6E 16r6BA4 16r9F6F 16r6BAA 16r9F70 16r6BAB 16r9F71 16r6BAF 16r9F72 16r6BB2 16r9F73 16r6BB1 16r9F74 16r6BB3 16r9F75 16r6BB7 16r9F76 16r6BBC 16r9F77 16r6BC6 16r9F78 16r6BCB 16r9F79 16r6BD3 16r9F7A 16r6BDF 16r9F7B 16r6BEC 16r9F7C 16r6BEB 16r9F7D 16r6BF3 16r9F7E 16r6BEF 16r9F80 16r9EBE 16r9F81 16r6C08 16r9F82 16r6C13 16r9F83 16r6C14 16r9F84 16r6C1B 16r9F85 16r6C24 16r9F86 16r6C23 16r9F87 16r6C5E 16r9F88 16r6C55 16r9F89 16r6C62 16r9F8A 16r6C6A 16r9F8B 16r6C82 16r9F8C 16r6C8D 16r9F8D 16r6C9A 16r9F8E 16r6C81 16r9F8F 16r6C9B 16r9F90 16r6C7E 16r9F91 16r6C68 16r9F92 16r6C73 16r9F93 16r6C92 16r9F94 16r6C90 16r9F95 16r6CC4 16r9F96 16r6CF1 16r9F97 16r6CD3 16r9F98 16r6CBD 16r9F99 16r6CD7 16r9F9A 16r6CC5 16r9F9B 16r6CDD 16r9F9C 16r6CAE 16r9F9D 16r6CB1 16r9F9E 16r6CBE 16r9F9F 16r6CBA 16r9FA0 16r6CDB 16r9FA1 16r6CEF 16r9FA2 16r6CD9 16r9FA3 16r6CEA 16r9FA4 16r6D1F 16r9FA5 16r884D 16r9FA6 16r6D36 16r9FA7 16r6D2B 16r9FA8 16r6D3D 16r9FA9 16r6D38 16r9FAA 16r6D19 16r9FAB 16r6D35 16r9FAC 16r6D33 16r9FAD 16r6D12 16r9FAE 16r6D0C 16r9FAF 16r6D63 16r9FB0 16r6D93 16r9FB1 16r6D64 16r9FB2 16r6D5A 16r9FB3 16r6D79 16r9FB4 16r6D59 16r9FB5 16r6D8E 16r9FB6 16r6D95 16r9FB7 16r6FE4 16r9FB8 16r6D85 16r9FB9 16r6DF9 16r9FBA 16r6E15 16r9FBB 16r6E0A 16r9FBC 16r6DB5 16r9FBD 16r6DC7 16r9FBE 16r6DE6 16r9FBF 16r6DB8 16r9FC0 16r6DC6 16r9FC1 16r6DEC 16r9FC2 16r6DDE 16r9FC3 16r6DCC 16r9FC4 16r6DE8 16r9FC5 16r6DD2 16r9FC6 16r6DC5 16r9FC7 16r6DFA 16r9FC8 16r6DD9 16r9FC9 16r6DE4 16r9FCA 16r6DD5 16r9FCB 16r6DEA 16r9FCC 16r6DEE 16r9FCD 16r6E2D 16r9FCE 16r6E6E 16r9FCF 16r6E2E 16r9FD0 16r6E19 16r9FD1 16r6E72 16r9FD2 16r6E5F 16r9FD3 16r6E3E 16r9FD4 16r6E23 16r9FD5 16r6E6B 16r9FD6 16r6E2B 16r9FD7 16r6E76 16r9FD8 16r6E4D 16r9FD9 16r6E1F 16r9FDA 16r6E43 16r9FDB 16r6E3A 16r9FDC 16r6E4E 16r9FDD 16r6E24 16r9FDE 16r6EFF 16r9FDF 16r6E1D 16r9FE0 16r6E38 16r9FE1 16r6E82 16r9FE2 16r6EAA 16r9FE3 16r6E98 16r9FE4 16r6EC9 16r9FE5 16r6EB7 16r9FE6 16r6ED3 16r9FE7 16r6EBD 16r9FE8 16r6EAF 16r9FE9 16r6EC4 16r9FEA 16r6EB2 16r9FEB 16r6ED4 16r9FEC 16r6ED5 16r9FED 16r6E8F 16r9FEE 16r6EA5 16r9FEF 16r6EC2 16r9FF0 16r6E9F 16r9FF1 16r6F41 16r9FF2 16r6F11 16r9FF3 16r704C 16r9FF4 16r6EEC 16r9FF5 16r6EF8 16r9FF6 16r6EFE 16r9FF7 16r6F3F 16r9FF8 16r6EF2 16r9FF9 16r6F31 16r9FFA 16r6EEF 16r9FFB 16r6F32 16r9FFC 16r6ECC 16rA1 16rFF61 16rA2 16rFF62 16rA3 16rFF63 16rA4 16rFF64 16rA5 16rFF65 16rA6 16rFF66 16rA7 16rFF67 16rA8 16rFF68 16rA9 16rFF69 16rAA 16rFF6A 16rAB 16rFF6B 16rAC 16rFF6C 16rAD 16rFF6D 16rAE 16rFF6E 16rAF 16rFF6F 16rB0 16rFF70 16rB1 16rFF71 16rB2 16rFF72 16rB3 16rFF73 16rB4 16rFF74 16rB5 16rFF75 16rB6 16rFF76 16rB7 16rFF77 16rB8 16rFF78 16rB9 16rFF79 16rBA 16rFF7A 16rBB 16rFF7B 16rBC 16rFF7C 16rBD 16rFF7D 16rBE 16rFF7E 16rBF 16rFF7F 16rC0 16rFF80 16rC1 16rFF81 16rC2 16rFF82 16rC3 16rFF83 16rC4 16rFF84 16rC5 16rFF85 16rC6 16rFF86 16rC7 16rFF87 16rC8 16rFF88 16rC9 16rFF89 16rCA 16rFF8A 16rCB 16rFF8B 16rCC 16rFF8C 16rCD 16rFF8D 16rCE 16rFF8E 16rCF 16rFF8F 16rD0 16rFF90 16rD1 16rFF91 16rD2 16rFF92 16rD3 16rFF93 16rD4 16rFF94 16rD5 16rFF95 16rD6 16rFF96 16rD7 16rFF97 16rD8 16rFF98 16rD9 16rFF99 16rDA 16rFF9A 16rDB 16rFF9B 16rDC 16rFF9C 16rDD 16rFF9D 16rDE 16rFF9E 16rDF 16rFF9F 16rE040 16r6F3E 16rE041 16r6F13 16rE042 16r6EF7 16rE043 16r6F86 16rE044 16r6F7A 16rE045 16r6F78 16rE046 16r6F81 16rE047 16r6F80 16rE048 16r6F6F 16rE049 16r6F5B 16rE04A 16r6FF3 16rE04B 16r6F6D 16rE04C 16r6F82 16rE04D 16r6F7C 16rE04E 16r6F58 16rE04F 16r6F8E 16rE050 16r6F91 16rE051 16r6FC2 16rE052 16r6F66 16rE053 16r6FB3 16rE054 16r6FA3 16rE055 16r6FA1 16rE056 16r6FA4 16rE057 16r6FB9 16rE058 16r6FC6 16rE059 16r6FAA 16rE05A 16r6FDF 16rE05B 16r6FD5 16rE05C 16r6FEC 16rE05D 16r6FD4 16rE05E 16r6FD8 16rE05F 16r6FF1 16rE060 16r6FEE 16rE061 16r6FDB 16rE062 16r7009 16rE063 16r700B 16rE064 16r6FFA 16rE065 16r7011 16rE066 16r7001 16rE067 16r700F 16rE068 16r6FFE 16rE069 16r701B 16rE06A 16r701A 16rE06B 16r6F74 16rE06C 16r701D 16rE06D 16r7018 16rE06E 16r701F 16rE06F 16r7030 16rE070 16r703E 16rE071 16r7032 16rE072 16r7051 16rE073 16r7063 16rE074 16r7099 16rE075 16r7092 16rE076 16r70AF 16rE077 16r70F1 16rE078 16r70AC 16rE079 16r70B8 16rE07A 16r70B3 16rE07B 16r70AE 16rE07C 16r70DF 16rE07D 16r70CB 16rE07E 16r70DD 16rE080 16r70D9 16rE081 16r7109 16rE082 16r70FD 16rE083 16r711C 16rE084 16r7119 16rE085 16r7165 16rE086 16r7155 16rE087 16r7188 16rE088 16r7166 16rE089 16r7162 16rE08A 16r714C 16rE08B 16r7156 16rE08C 16r716C 16rE08D 16r718F 16rE08E 16r71FB 16rE08F 16r7184 16rE090 16r7195 16rE091 16r71A8 16rE092 16r71AC 16rE093 16r71D7 16rE094 16r71B9 16rE095 16r71BE 16rE096 16r71D2 16rE097 16r71C9 16rE098 16r71D4 16rE099 16r71CE 16rE09A 16r71E0 16rE09B 16r71EC 16rE09C 16r71E7 16rE09D 16r71F5 16rE09E 16r71FC 16rE09F 16r71F9 16rE0A0 16r71FF 16rE0A1 16r720D 16rE0A2 16r7210 16rE0A3 16r721B 16rE0A4 16r7228 16rE0A5 16r722D 16rE0A6 16r722C 16rE0A7 16r7230 16rE0A8 16r7232 16rE0A9 16r723B 16rE0AA 16r723C 16rE0AB 16r723F 16rE0AC 16r7240 16rE0AD 16r7246 16rE0AE 16r724B 16rE0AF 16r7258 16rE0B0 16r7274 16rE0B1 16r727E 16rE0B2 16r7282 16rE0B3 16r7281 16rE0B4 16r7287 16rE0B5 16r7292 16rE0B6 16r7296 16rE0B7 16r72A2 16rE0B8 16r72A7 16rE0B9 16r72B9 16rE0BA 16r72B2 16rE0BB 16r72C3 16rE0BC 16r72C6 16rE0BD 16r72C4 16rE0BE 16r72CE 16rE0BF 16r72D2 16rE0C0 16r72E2 16rE0C1 16r72E0 16rE0C2 16r72E1 16rE0C3 16r72F9 16rE0C4 16r72F7 16rE0C5 16r500F 16rE0C6 16r7317 16rE0C7 16r730A 16rE0C8 16r731C 16rE0C9 16r7316 16rE0CA 16r731D 16rE0CB 16r7334 16rE0CC 16r732F 16rE0CD 16r7329 16rE0CE 16r7325 16rE0CF 16r733E 16rE0D0 16r734E 16rE0D1 16r734F 16rE0D2 16r9ED8 16rE0D3 16r7357 16rE0D4 16r736A 16rE0D5 16r7368 16rE0D6 16r7370 16rE0D7 16r7378 16rE0D8 16r7375 16rE0D9 16r737B 16rE0DA 16r737A 16rE0DB 16r73C8 16rE0DC 16r73B3 16rE0DD 16r73CE 16rE0DE 16r73BB 16rE0DF 16r73C0 16rE0E0 16r73E5 16rE0E1 16r73EE 16rE0E2 16r73DE 16rE0E3 16r74A2 16rE0E4 16r7405 16rE0E5 16r746F 16rE0E6 16r7425 16rE0E7 16r73F8 16rE0E8 16r7432 16rE0E9 16r743A 16rE0EA 16r7455 16rE0EB 16r743F 16rE0EC 16r745F 16rE0ED 16r7459 16rE0EE 16r7441 16rE0EF 16r745C 16rE0F0 16r7469 16rE0F1 16r7470 16rE0F2 16r7463 16rE0F3 16r746A 16rE0F4 16r7476 16rE0F5 16r747E 16rE0F6 16r748B 16rE0F7 16r749E 16rE0F8 16r74A7 16rE0F9 16r74CA 16rE0FA 16r74CF 16rE0FB 16r74D4 16rE0FC 16r73F1 16rE140 16r74E0 16rE141 16r74E3 16rE142 16r74E7 16rE143 16r74E9 16rE144 16r74EE 16rE145 16r74F2 16rE146 16r74F0 16rE147 16r74F1 16rE148 16r74F8 16rE149 16r74F7 16rE14A 16r7504 16rE14B 16r7503 16rE14C 16r7505 16rE14D 16r750C 16rE14E 16r750E 16rE14F 16r750D 16rE150 16r7515 16rE151 16r7513 16rE152 16r751E 16rE153 16r7526 16rE154 16r752C 16rE155 16r753C 16rE156 16r7544 16rE157 16r754D 16rE158 16r754A 16rE159 16r7549 16rE15A 16r755B 16rE15B 16r7546 16rE15C 16r755A 16rE15D 16r7569 16rE15E 16r7564 16rE15F 16r7567 16rE160 16r756B 16rE161 16r756D 16rE162 16r7578 16rE163 16r7576 16rE164 16r7586 16rE165 16r7587 16rE166 16r7574 16rE167 16r758A 16rE168 16r7589 16rE169 16r7582 16rE16A 16r7594 16rE16B 16r759A 16rE16C 16r759D 16rE16D 16r75A5 16rE16E 16r75A3 16rE16F 16r75C2 16rE170 16r75B3 16rE171 16r75C3 16rE172 16r75B5 16rE173 16r75BD 16rE174 16r75B8 16rE175 16r75BC 16rE176 16r75B1 16rE177 16r75CD 16rE178 16r75CA 16rE179 16r75D2 16rE17A 16r75D9 16rE17B 16r75E3 16rE17C 16r75DE 16rE17D 16r75FE 16rE17E 16r75FF 16rE180 16r75FC 16rE181 16r7601 16rE182 16r75F0 16rE183 16r75FA 16rE184 16r75F2 16rE185 16r75F3 16rE186 16r760B 16rE187 16r760D 16rE188 16r7609 16rE189 16r761F 16rE18A 16r7627 16rE18B 16r7620 16rE18C 16r7621 16rE18D 16r7622 16rE18E 16r7624 16rE18F 16r7634 16rE190 16r7630 16rE191 16r763B 16rE192 16r7647 16rE193 16r7648 16rE194 16r7646 16rE195 16r765C 16rE196 16r7658 16rE197 16r7661 16rE198 16r7662 16rE199 16r7668 16rE19A 16r7669 16rE19B 16r766A 16rE19C 16r7667 16rE19D 16r766C 16rE19E 16r7670 16rE19F 16r7672 16rE1A0 16r7676 16rE1A1 16r7678 16rE1A2 16r767C 16rE1A3 16r7680 16rE1A4 16r7683 16rE1A5 16r7688 16rE1A6 16r768B 16rE1A7 16r768E 16rE1A8 16r7696 16rE1A9 16r7693 16rE1AA 16r7699 16rE1AB 16r769A 16rE1AC 16r76B0 16rE1AD 16r76B4 16rE1AE 16r76B8 16rE1AF 16r76B9 16rE1B0 16r76BA 16rE1B1 16r76C2 16rE1B2 16r76CD 16rE1B3 16r76D6 16rE1B4 16r76D2 16rE1B5 16r76DE 16rE1B6 16r76E1 16rE1B7 16r76E5 16rE1B8 16r76E7 16rE1B9 16r76EA 16rE1BA 16r862F 16rE1BB 16r76FB 16rE1BC 16r7708 16rE1BD 16r7707 16rE1BE 16r7704 16rE1BF 16r7729 16rE1C0 16r7724 16rE1C1 16r771E 16rE1C2 16r7725 16rE1C3 16r7726 16rE1C4 16r771B 16rE1C5 16r7737 16rE1C6 16r7738 16rE1C7 16r7747 16rE1C8 16r775A 16rE1C9 16r7768 16rE1CA 16r776B 16rE1CB 16r775B 16rE1CC 16r7765 16rE1CD 16r777F 16rE1CE 16r777E 16rE1CF 16r7779 16rE1D0 16r778E 16rE1D1 16r778B 16rE1D2 16r7791 16rE1D3 16r77A0 16rE1D4 16r779E 16rE1D5 16r77B0 16rE1D6 16r77B6 16rE1D7 16r77B9 16rE1D8 16r77BF 16rE1D9 16r77BC 16rE1DA 16r77BD 16rE1DB 16r77BB 16rE1DC 16r77C7 16rE1DD 16r77CD 16rE1DE 16r77D7 16rE1DF 16r77DA 16rE1E0 16r77DC 16rE1E1 16r77E3 16rE1E2 16r77EE 16rE1E3 16r77FC 16rE1E4 16r780C 16rE1E5 16r7812 16rE1E6 16r7926 16rE1E7 16r7820 16rE1E8 16r792A 16rE1E9 16r7845 16rE1EA 16r788E 16rE1EB 16r7874 16rE1EC 16r7886 16rE1ED 16r787C 16rE1EE 16r789A 16rE1EF 16r788C 16rE1F0 16r78A3 16rE1F1 16r78B5 16rE1F2 16r78AA 16rE1F3 16r78AF 16rE1F4 16r78D1 16rE1F5 16r78C6 16rE1F6 16r78CB 16rE1F7 16r78D4 16rE1F8 16r78BE 16rE1F9 16r78BC 16rE1FA 16r78C5 16rE1FB 16r78CA 16rE1FC 16r78EC 16rE240 16r78E7 16rE241 16r78DA 16rE242 16r78FD 16rE243 16r78F4 16rE244 16r7907 16rE245 16r7912 16rE246 16r7911 16rE247 16r7919 16rE248 16r792C 16rE249 16r792B 16rE24A 16r7940 16rE24B 16r7960 16rE24C 16r7957 16rE24D 16r795F 16rE24E 16r795A 16rE24F 16r7955 16rE250 16r7953 16rE251 16r797A 16rE252 16r797F 16rE253 16r798A 16rE254 16r799D 16rE255 16r79A7 16rE256 16r9F4B 16rE257 16r79AA 16rE258 16r79AE 16rE259 16r79B3 16rE25A 16r79B9 16rE25B 16r79BA 16rE25C 16r79C9 16rE25D 16r79D5 16rE25E 16r79E7 16rE25F 16r79EC 16rE260 16r79E1 16rE261 16r79E3 16rE262 16r7A08 16rE263 16r7A0D 16rE264 16r7A18 16rE265 16r7A19 16rE266 16r7A20 16rE267 16r7A1F 16rE268 16r7980 16rE269 16r7A31 16rE26A 16r7A3B 16rE26B 16r7A3E 16rE26C 16r7A37 16rE26D 16r7A43 16rE26E 16r7A57 16rE26F 16r7A49 16rE270 16r7A61 16rE271 16r7A62 16rE272 16r7A69 16rE273 16r9F9D 16rE274 16r7A70 16rE275 16r7A79 16rE276 16r7A7D 16rE277 16r7A88 16rE278 16r7A97 16rE279 16r7A95 16rE27A 16r7A98 16rE27B 16r7A96 16rE27C 16r7AA9 16rE27D 16r7AC8 16rE27E 16r7AB0 16rE280 16r7AB6 16rE281 16r7AC5 16rE282 16r7AC4 16rE283 16r7ABF 16rE284 16r9083 16rE285 16r7AC7 16rE286 16r7ACA 16rE287 16r7ACD 16rE288 16r7ACF 16rE289 16r7AD5 16rE28A 16r7AD3 16rE28B 16r7AD9 16rE28C 16r7ADA 16rE28D 16r7ADD 16rE28E 16r7AE1 16rE28F 16r7AE2 16rE290 16r7AE6 16rE291 16r7AED 16rE292 16r7AF0 16rE293 16r7B02 16rE294 16r7B0F 16rE295 16r7B0A 16rE296 16r7B06 16rE297 16r7B33 16rE298 16r7B18 16rE299 16r7B19 16rE29A 16r7B1E 16rE29B 16r7B35 16rE29C 16r7B28 16rE29D 16r7B36 16rE29E 16r7B50 16rE29F 16r7B7A 16rE2A0 16r7B04 16rE2A1 16r7B4D 16rE2A2 16r7B0B 16rE2A3 16r7B4C 16rE2A4 16r7B45 16rE2A5 16r7B75 16rE2A6 16r7B65 16rE2A7 16r7B74 16rE2A8 16r7B67 16rE2A9 16r7B70 16rE2AA 16r7B71 16rE2AB 16r7B6C 16rE2AC 16r7B6E 16rE2AD 16r7B9D 16rE2AE 16r7B98 16rE2AF 16r7B9F 16rE2B0 16r7B8D 16rE2B1 16r7B9C 16rE2B2 16r7B9A 16rE2B3 16r7B8B 16rE2B4 16r7B92 16rE2B5 16r7B8F 16rE2B6 16r7B5D 16rE2B7 16r7B99 16rE2B8 16r7BCB 16rE2B9 16r7BC1 16rE2BA 16r7BCC 16rE2BB 16r7BCF 16rE2BC 16r7BB4 16rE2BD 16r7BC6 16rE2BE 16r7BDD 16rE2BF 16r7BE9 16rE2C0 16r7C11 16rE2C1 16r7C14 16rE2C2 16r7BE6 16rE2C3 16r7BE5 16rE2C4 16r7C60 16rE2C5 16r7C00 16rE2C6 16r7C07 16rE2C7 16r7C13 16rE2C8 16r7BF3 16rE2C9 16r7BF7 16rE2CA 16r7C17 16rE2CB 16r7C0D 16rE2CC 16r7BF6 16rE2CD 16r7C23 16rE2CE 16r7C27 16rE2CF 16r7C2A 16rE2D0 16r7C1F 16rE2D1 16r7C37 16rE2D2 16r7C2B 16rE2D3 16r7C3D 16rE2D4 16r7C4C 16rE2D5 16r7C43 16rE2D6 16r7C54 16rE2D7 16r7C4F 16rE2D8 16r7C40 16rE2D9 16r7C50 16rE2DA 16r7C58 16rE2DB 16r7C5F 16rE2DC 16r7C64 16rE2DD 16r7C56 16rE2DE 16r7C65 16rE2DF 16r7C6C 16rE2E0 16r7C75 16rE2E1 16r7C83 16rE2E2 16r7C90 16rE2E3 16r7CA4 16rE2E4 16r7CAD 16rE2E5 16r7CA2 16rE2E6 16r7CAB 16rE2E7 16r7CA1 16rE2E8 16r7CA8 16rE2E9 16r7CB3 16rE2EA 16r7CB2 16rE2EB 16r7CB1 16rE2EC 16r7CAE 16rE2ED 16r7CB9 16rE2EE 16r7CBD 16rE2EF 16r7CC0 16rE2F0 16r7CC5 16rE2F1 16r7CC2 16rE2F2 16r7CD8 16rE2F3 16r7CD2 16rE2F4 16r7CDC 16rE2F5 16r7CE2 16rE2F6 16r9B3B 16rE2F7 16r7CEF 16rE2F8 16r7CF2 16rE2F9 16r7CF4 16rE2FA 16r7CF6 16rE2FB 16r7CFA 16rE2FC 16r7D06 16rE340 16r7D02 16rE341 16r7D1C 16rE342 16r7D15 16rE343 16r7D0A 16rE344 16r7D45 16rE345 16r7D4B 16rE346 16r7D2E 16rE347 16r7D32 16rE348 16r7D3F 16rE349 16r7D35 16rE34A 16r7D46 16rE34B 16r7D73 16rE34C 16r7D56 16rE34D 16r7D4E 16rE34E 16r7D72 16rE34F 16r7D68 16rE350 16r7D6E 16rE351 16r7D4F 16rE352 16r7D63 16rE353 16r7D93 16rE354 16r7D89 16rE355 16r7D5B 16rE356 16r7D8F 16rE357 16r7D7D 16rE358 16r7D9B 16rE359 16r7DBA 16rE35A 16r7DAE 16rE35B 16r7DA3 16rE35C 16r7DB5 16rE35D 16r7DC7 16rE35E 16r7DBD 16rE35F 16r7DAB 16rE360 16r7E3D 16rE361 16r7DA2 16rE362 16r7DAF 16rE363 16r7DDC 16rE364 16r7DB8 16rE365 16r7D9F 16rE366 16r7DB0 16rE367 16r7DD8 16rE368 16r7DDD 16rE369 16r7DE4 16rE36A 16r7DDE 16rE36B 16r7DFB 16rE36C 16r7DF2 16rE36D 16r7DE1 16rE36E 16r7E05 16rE36F 16r7E0A 16rE370 16r7E23 16rE371 16r7E21 16rE372 16r7E12 16rE373 16r7E31 16rE374 16r7E1F 16rE375 16r7E09 16rE376 16r7E0B 16rE377 16r7E22 16rE378 16r7E46 16rE379 16r7E66 16rE37A 16r7E3B 16rE37B 16r7E35 16rE37C 16r7E39 16rE37D 16r7E43 16rE37E 16r7E37 16rE380 16r7E32 16rE381 16r7E3A 16rE382 16r7E67 16rE383 16r7E5D 16rE384 16r7E56 16rE385 16r7E5E 16rE386 16r7E59 16rE387 16r7E5A 16rE388 16r7E79 16rE389 16r7E6A 16rE38A 16r7E69 16rE38B 16r7E7C 16rE38C 16r7E7B 16rE38D 16r7E83 16rE38E 16r7DD5 16rE38F 16r7E7D 16rE390 16r8FAE 16rE391 16r7E7F 16rE392 16r7E88 16rE393 16r7E89 16rE394 16r7E8C 16rE395 16r7E92 16rE396 16r7E90 16rE397 16r7E93 16rE398 16r7E94 16rE399 16r7E96 16rE39A 16r7E8E 16rE39B 16r7E9B 16rE39C 16r7E9C 16rE39D 16r7F38 16rE39E 16r7F3A 16rE39F 16r7F45 16rE3A0 16r7F4C 16rE3A1 16r7F4D 16rE3A2 16r7F4E 16rE3A3 16r7F50 16rE3A4 16r7F51 16rE3A5 16r7F55 16rE3A6 16r7F54 16rE3A7 16r7F58 16rE3A8 16r7F5F 16rE3A9 16r7F60 16rE3AA 16r7F68 16rE3AB 16r7F69 16rE3AC 16r7F67 16rE3AD 16r7F78 16rE3AE 16r7F82 16rE3AF 16r7F86 16rE3B0 16r7F83 16rE3B1 16r7F88 16rE3B2 16r7F87 16rE3B3 16r7F8C 16rE3B4 16r7F94 16rE3B5 16r7F9E 16rE3B6 16r7F9D 16rE3B7 16r7F9A 16rE3B8 16r7FA3 16rE3B9 16r7FAF 16rE3BA 16r7FB2 16rE3BB 16r7FB9 16rE3BC 16r7FAE 16rE3BD 16r7FB6 16rE3BE 16r7FB8 16rE3BF 16r8B71 16rE3C0 16r7FC5 16rE3C1 16r7FC6 16rE3C2 16r7FCA 16rE3C3 16r7FD5 16rE3C4 16r7FD4 16rE3C5 16r7FE1 16rE3C6 16r7FE6 16rE3C7 16r7FE9 16rE3C8 16r7FF3 16rE3C9 16r7FF9 16rE3CA 16r98DC 16rE3CB 16r8006 16rE3CC 16r8004 16rE3CD 16r800B 16rE3CE 16r8012 16rE3CF 16r8018 16rE3D0 16r8019 16rE3D1 16r801C 16rE3D2 16r8021 16rE3D3 16r8028 16rE3D4 16r803F 16rE3D5 16r803B 16rE3D6 16r804A 16rE3D7 16r8046 16rE3D8 16r8052 16rE3D9 16r8058 16rE3DA 16r805A 16rE3DB 16r805F 16rE3DC 16r8062 16rE3DD 16r8068 16rE3DE 16r8073 16rE3DF 16r8072 16rE3E0 16r8070 16rE3E1 16r8076 16rE3E2 16r8079 16rE3E3 16r807D 16rE3E4 16r807F 16rE3E5 16r8084 16rE3E6 16r8086 16rE3E7 16r8085 16rE3E8 16r809B 16rE3E9 16r8093 16rE3EA 16r809A 16rE3EB 16r80AD 16rE3EC 16r5190 16rE3ED 16r80AC 16rE3EE 16r80DB 16rE3EF 16r80E5 16rE3F0 16r80D9 16rE3F1 16r80DD 16rE3F2 16r80C4 16rE3F3 16r80DA 16rE3F4 16r80D6 16rE3F5 16r8109 16rE3F6 16r80EF 16rE3F7 16r80F1 16rE3F8 16r811B 16rE3F9 16r8129 16rE3FA 16r8123 16rE3FB 16r812F 16rE3FC 16r814B 16rE440 16r968B 16rE441 16r8146 16rE442 16r813E 16rE443 16r8153 16rE444 16r8151 16rE445 16r80FC 16rE446 16r8171 16rE447 16r816E 16rE448 16r8165 16rE449 16r8166 16rE44A 16r8174 16rE44B 16r8183 16rE44C 16r8188 16rE44D 16r818A 16rE44E 16r8180 16rE44F 16r8182 16rE450 16r81A0 16rE451 16r8195 16rE452 16r81A4 16rE453 16r81A3 16rE454 16r815F 16rE455 16r8193 16rE456 16r81A9 16rE457 16r81B0 16rE458 16r81B5 16rE459 16r81BE 16rE45A 16r81B8 16rE45B 16r81BD 16rE45C 16r81C0 16rE45D 16r81C2 16rE45E 16r81BA 16rE45F 16r81C9 16rE460 16r81CD 16rE461 16r81D1 16rE462 16r81D9 16rE463 16r81D8 16rE464 16r81C8 16rE465 16r81DA 16rE466 16r81DF 16rE467 16r81E0 16rE468 16r81E7 16rE469 16r81FA 16rE46A 16r81FB 16rE46B 16r81FE 16rE46C 16r8201 16rE46D 16r8202 16rE46E 16r8205 16rE46F 16r8207 16rE470 16r820A 16rE471 16r820D 16rE472 16r8210 16rE473 16r8216 16rE474 16r8229 16rE475 16r822B 16rE476 16r8238 16rE477 16r8233 16rE478 16r8240 16rE479 16r8259 16rE47A 16r8258 16rE47B 16r825D 16rE47C 16r825A 16rE47D 16r825F 16rE47E 16r8264 16rE480 16r8262 16rE481 16r8268 16rE482 16r826A 16rE483 16r826B 16rE484 16r822E 16rE485 16r8271 16rE486 16r8277 16rE487 16r8278 16rE488 16r827E 16rE489 16r828D 16rE48A 16r8292 16rE48B 16r82AB 16rE48C 16r829F 16rE48D 16r82BB 16rE48E 16r82AC 16rE48F 16r82E1 16rE490 16r82E3 16rE491 16r82DF 16rE492 16r82D2 16rE493 16r82F4 16rE494 16r82F3 16rE495 16r82FA 16rE496 16r8393 16rE497 16r8303 16rE498 16r82FB 16rE499 16r82F9 16rE49A 16r82DE 16rE49B 16r8306 16rE49C 16r82DC 16rE49D 16r8309 16rE49E 16r82D9 16rE49F 16r8335 16rE4A0 16r8334 16rE4A1 16r8316 16rE4A2 16r8332 16rE4A3 16r8331 16rE4A4 16r8340 16rE4A5 16r8339 16rE4A6 16r8350 16rE4A7 16r8345 16rE4A8 16r832F 16rE4A9 16r832B 16rE4AA 16r8317 16rE4AB 16r8318 16rE4AC 16r8385 16rE4AD 16r839A 16rE4AE 16r83AA 16rE4AF 16r839F 16rE4B0 16r83A2 16rE4B1 16r8396 16rE4B2 16r8323 16rE4B3 16r838E 16rE4B4 16r8387 16rE4B5 16r838A 16rE4B6 16r837C 16rE4B7 16r83B5 16rE4B8 16r8373 16rE4B9 16r8375 16rE4BA 16r83A0 16rE4BB 16r8389 16rE4BC 16r83A8 16rE4BD 16r83F4 16rE4BE 16r8413 16rE4BF 16r83EB 16rE4C0 16r83CE 16rE4C1 16r83FD 16rE4C2 16r8403 16rE4C3 16r83D8 16rE4C4 16r840B 16rE4C5 16r83C1 16rE4C6 16r83F7 16rE4C7 16r8407 16rE4C8 16r83E0 16rE4C9 16r83F2 16rE4CA 16r840D 16rE4CB 16r8422 16rE4CC 16r8420 16rE4CD 16r83BD 16rE4CE 16r8438 16rE4CF 16r8506 16rE4D0 16r83FB 16rE4D1 16r846D 16rE4D2 16r842A 16rE4D3 16r843C 16rE4D4 16r855A 16rE4D5 16r8484 16rE4D6 16r8477 16rE4D7 16r846B 16rE4D8 16r84AD 16rE4D9 16r846E 16rE4DA 16r8482 16rE4DB 16r8469 16rE4DC 16r8446 16rE4DD 16r842C 16rE4DE 16r846F 16rE4DF 16r8479 16rE4E0 16r8435 16rE4E1 16r84CA 16rE4E2 16r8462 16rE4E3 16r84B9 16rE4E4 16r84BF 16rE4E5 16r849F 16rE4E6 16r84D9 16rE4E7 16r84CD 16rE4E8 16r84BB 16rE4E9 16r84DA 16rE4EA 16r84D0 16rE4EB 16r84C1 16rE4EC 16r84C6 16rE4ED 16r84D6 16rE4EE 16r84A1 16rE4EF 16r8521 16rE4F0 16r84FF 16rE4F1 16r84F4 16rE4F2 16r8517 16rE4F3 16r8518 16rE4F4 16r852C 16rE4F5 16r851F 16rE4F6 16r8515 16rE4F7 16r8514 16rE4F8 16r84FC 16rE4F9 16r8540 16rE4FA 16r8563 16rE4FB 16r8558 16rE4FC 16r8548 16rE540 16r8541 16rE541 16r8602 16rE542 16r854B 16rE543 16r8555 16rE544 16r8580 16rE545 16r85A4 16rE546 16r8588 16rE547 16r8591 16rE548 16r858A 16rE549 16r85A8 16rE54A 16r856D 16rE54B 16r8594 16rE54C 16r859B 16rE54D 16r85EA 16rE54E 16r8587 16rE54F 16r859C 16rE550 16r8577 16rE551 16r857E 16rE552 16r8590 16rE553 16r85C9 16rE554 16r85BA 16rE555 16r85CF 16rE556 16r85B9 16rE557 16r85D0 16rE558 16r85D5 16rE559 16r85DD 16rE55A 16r85E5 16rE55B 16r85DC 16rE55C 16r85F9 16rE55D 16r860A 16rE55E 16r8613 16rE55F 16r860B 16rE560 16r85FE 16rE561 16r85FA 16rE562 16r8606 16rE563 16r8622 16rE564 16r861A 16rE565 16r8630 16rE566 16r863F 16rE567 16r864D 16rE568 16r4E55 16rE569 16r8654 16rE56A 16r865F 16rE56B 16r8667 16rE56C 16r8671 16rE56D 16r8693 16rE56E 16r86A3 16rE56F 16r86A9 16rE570 16r86AA 16rE571 16r868B 16rE572 16r868C 16rE573 16r86B6 16rE574 16r86AF 16rE575 16r86C4 16rE576 16r86C6 16rE577 16r86B0 16rE578 16r86C9 16rE579 16r8823 16rE57A 16r86AB 16rE57B 16r86D4 16rE57C 16r86DE 16rE57D 16r86E9 16rE57E 16r86EC 16rE580 16r86DF 16rE581 16r86DB 16rE582 16r86EF 16rE583 16r8712 16rE584 16r8706 16rE585 16r8708 16rE586 16r8700 16rE587 16r8703 16rE588 16r86FB 16rE589 16r8711 16rE58A 16r8709 16rE58B 16r870D 16rE58C 16r86F9 16rE58D 16r870A 16rE58E 16r8734 16rE58F 16r873F 16rE590 16r8737 16rE591 16r873B 16rE592 16r8725 16rE593 16r8729 16rE594 16r871A 16rE595 16r8760 16rE596 16r875F 16rE597 16r8778 16rE598 16r874C 16rE599 16r874E 16rE59A 16r8774 16rE59B 16r8757 16rE59C 16r8768 16rE59D 16r876E 16rE59E 16r8759 16rE59F 16r8753 16rE5A0 16r8763 16rE5A1 16r876A 16rE5A2 16r8805 16rE5A3 16r87A2 16rE5A4 16r879F 16rE5A5 16r8782 16rE5A6 16r87AF 16rE5A7 16r87CB 16rE5A8 16r87BD 16rE5A9 16r87C0 16rE5AA 16r87D0 16rE5AB 16r96D6 16rE5AC 16r87AB 16rE5AD 16r87C4 16rE5AE 16r87B3 16rE5AF 16r87C7 16rE5B0 16r87C6 16rE5B1 16r87BB 16rE5B2 16r87EF 16rE5B3 16r87F2 16rE5B4 16r87E0 16rE5B5 16r880F 16rE5B6 16r880D 16rE5B7 16r87FE 16rE5B8 16r87F6 16rE5B9 16r87F7 16rE5BA 16r880E 16rE5BB 16r87D2 16rE5BC 16r8811 16rE5BD 16r8816 16rE5BE 16r8815 16rE5BF 16r8822 16rE5C0 16r8821 16rE5C1 16r8831 16rE5C2 16r8836 16rE5C3 16r8839 16rE5C4 16r8827 16rE5C5 16r883B 16rE5C6 16r8844 16rE5C7 16r8842 16rE5C8 16r8852 16rE5C9 16r8859 16rE5CA 16r885E 16rE5CB 16r8862 16rE5CC 16r886B 16rE5CD 16r8881 16rE5CE 16r887E 16rE5CF 16r889E 16rE5D0 16r8875 16rE5D1 16r887D 16rE5D2 16r88B5 16rE5D3 16r8872 16rE5D4 16r8882 16rE5D5 16r8897 16rE5D6 16r8892 16rE5D7 16r88AE 16rE5D8 16r8899 16rE5D9 16r88A2 16rE5DA 16r888D 16rE5DB 16r88A4 16rE5DC 16r88B0 16rE5DD 16r88BF 16rE5DE 16r88B1 16rE5DF 16r88C3 16rE5E0 16r88C4 16rE5E1 16r88D4 16rE5E2 16r88D8 16rE5E3 16r88D9 16rE5E4 16r88DD 16rE5E5 16r88F9 16rE5E6 16r8902 16rE5E7 16r88FC 16rE5E8 16r88F4 16rE5E9 16r88E8 16rE5EA 16r88F2 16rE5EB 16r8904 16rE5EC 16r890C 16rE5ED 16r890A 16rE5EE 16r8913 16rE5EF 16r8943 16rE5F0 16r891E 16rE5F1 16r8925 16rE5F2 16r892A 16rE5F3 16r892B 16rE5F4 16r8941 16rE5F5 16r8944 16rE5F6 16r893B 16rE5F7 16r8936 16rE5F8 16r8938 16rE5F9 16r894C 16rE5FA 16r891D 16rE5FB 16r8960 16rE5FC 16r895E 16rE640 16r8966 16rE641 16r8964 16rE642 16r896D 16rE643 16r896A 16rE644 16r896F 16rE645 16r8974 16rE646 16r8977 16rE647 16r897E 16rE648 16r8983 16rE649 16r8988 16rE64A 16r898A 16rE64B 16r8993 16rE64C 16r8998 16rE64D 16r89A1 16rE64E 16r89A9 16rE64F 16r89A6 16rE650 16r89AC 16rE651 16r89AF 16rE652 16r89B2 16rE653 16r89BA 16rE654 16r89BD 16rE655 16r89BF 16rE656 16r89C0 16rE657 16r89DA 16rE658 16r89DC 16rE659 16r89DD 16rE65A 16r89E7 16rE65B 16r89F4 16rE65C 16r89F8 16rE65D 16r8A03 16rE65E 16r8A16 16rE65F 16r8A10 16rE660 16r8A0C 16rE661 16r8A1B 16rE662 16r8A1D 16rE663 16r8A25 16rE664 16r8A36 16rE665 16r8A41 16rE666 16r8A5B 16rE667 16r8A52 16rE668 16r8A46 16rE669 16r8A48 16rE66A 16r8A7C 16rE66B 16r8A6D 16rE66C 16r8A6C 16rE66D 16r8A62 16rE66E 16r8A85 16rE66F 16r8A82 16rE670 16r8A84 16rE671 16r8AA8 16rE672 16r8AA1 16rE673 16r8A91 16rE674 16r8AA5 16rE675 16r8AA6 16rE676 16r8A9A 16rE677 16r8AA3 16rE678 16r8AC4 16rE679 16r8ACD 16rE67A 16r8AC2 16rE67B 16r8ADA 16rE67C 16r8AEB 16rE67D 16r8AF3 16rE67E 16r8AE7 16rE680 16r8AE4 16rE681 16r8AF1 16rE682 16r8B14 16rE683 16r8AE0 16rE684 16r8AE2 16rE685 16r8AF7 16rE686 16r8ADE 16rE687 16r8ADB 16rE688 16r8B0C 16rE689 16r8B07 16rE68A 16r8B1A 16rE68B 16r8AE1 16rE68C 16r8B16 16rE68D 16r8B10 16rE68E 16r8B17 16rE68F 16r8B20 16rE690 16r8B33 16rE691 16r97AB 16rE692 16r8B26 16rE693 16r8B2B 16rE694 16r8B3E 16rE695 16r8B28 16rE696 16r8B41 16rE697 16r8B4C 16rE698 16r8B4F 16rE699 16r8B4E 16rE69A 16r8B49 16rE69B 16r8B56 16rE69C 16r8B5B 16rE69D 16r8B5A 16rE69E 16r8B6B 16rE69F 16r8B5F 16rE6A0 16r8B6C 16rE6A1 16r8B6F 16rE6A2 16r8B74 16rE6A3 16r8B7D 16rE6A4 16r8B80 16rE6A5 16r8B8C 16rE6A6 16r8B8E 16rE6A7 16r8B92 16rE6A8 16r8B93 16rE6A9 16r8B96 16rE6AA 16r8B99 16rE6AB 16r8B9A 16rE6AC 16r8C3A 16rE6AD 16r8C41 16rE6AE 16r8C3F 16rE6AF 16r8C48 16rE6B0 16r8C4C 16rE6B1 16r8C4E 16rE6B2 16r8C50 16rE6B3 16r8C55 16rE6B4 16r8C62 16rE6B5 16r8C6C 16rE6B6 16r8C78 16rE6B7 16r8C7A 16rE6B8 16r8C82 16rE6B9 16r8C89 16rE6BA 16r8C85 16rE6BB 16r8C8A 16rE6BC 16r8C8D 16rE6BD 16r8C8E 16rE6BE 16r8C94 16rE6BF 16r8C7C 16rE6C0 16r8C98 16rE6C1 16r621D 16rE6C2 16r8CAD 16rE6C3 16r8CAA 16rE6C4 16r8CBD 16rE6C5 16r8CB2 16rE6C6 16r8CB3 16rE6C7 16r8CAE 16rE6C8 16r8CB6 16rE6C9 16r8CC8 16rE6CA 16r8CC1 16rE6CB 16r8CE4 16rE6CC 16r8CE3 16rE6CD 16r8CDA 16rE6CE 16r8CFD 16rE6CF 16r8CFA 16rE6D0 16r8CFB 16rE6D1 16r8D04 16rE6D2 16r8D05 16rE6D3 16r8D0A 16rE6D4 16r8D07 16rE6D5 16r8D0F 16rE6D6 16r8D0D 16rE6D7 16r8D10 16rE6D8 16r9F4E 16rE6D9 16r8D13 16rE6DA 16r8CCD 16rE6DB 16r8D14 16rE6DC 16r8D16 16rE6DD 16r8D67 16rE6DE 16r8D6D 16rE6DF 16r8D71 16rE6E0 16r8D73 16rE6E1 16r8D81 16rE6E2 16r8D99 16rE6E3 16r8DC2 16rE6E4 16r8DBE 16rE6E5 16r8DBA 16rE6E6 16r8DCF 16rE6E7 16r8DDA 16rE6E8 16r8DD6 16rE6E9 16r8DCC 16rE6EA 16r8DDB 16rE6EB 16r8DCB 16rE6EC 16r8DEA 16rE6ED 16r8DEB 16rE6EE 16r8DDF 16rE6EF 16r8DE3 16rE6F0 16r8DFC 16rE6F1 16r8E08 16rE6F2 16r8E09 16rE6F3 16r8DFF 16rE6F4 16r8E1D 16rE6F5 16r8E1E 16rE6F6 16r8E10 16rE6F7 16r8E1F 16rE6F8 16r8E42 16rE6F9 16r8E35 16rE6FA 16r8E30 16rE6FB 16r8E34 16rE6FC 16r8E4A 16rE740 16r8E47 16rE741 16r8E49 16rE742 16r8E4C 16rE743 16r8E50 16rE744 16r8E48 16rE745 16r8E59 16rE746 16r8E64 16rE747 16r8E60 16rE748 16r8E2A 16rE749 16r8E63 16rE74A 16r8E55 16rE74B 16r8E76 16rE74C 16r8E72 16rE74D 16r8E7C 16rE74E 16r8E81 16rE74F 16r8E87 16rE750 16r8E85 16rE751 16r8E84 16rE752 16r8E8B 16rE753 16r8E8A 16rE754 16r8E93 16rE755 16r8E91 16rE756 16r8E94 16rE757 16r8E99 16rE758 16r8EAA 16rE759 16r8EA1 16rE75A 16r8EAC 16rE75B 16r8EB0 16rE75C 16r8EC6 16rE75D 16r8EB1 16rE75E 16r8EBE 16rE75F 16r8EC5 16rE760 16r8EC8 16rE761 16r8ECB 16rE762 16r8EDB 16rE763 16r8EE3 16rE764 16r8EFC 16rE765 16r8EFB 16rE766 16r8EEB 16rE767 16r8EFE 16rE768 16r8F0A 16rE769 16r8F05 16rE76A 16r8F15 16rE76B 16r8F12 16rE76C 16r8F19 16rE76D 16r8F13 16rE76E 16r8F1C 16rE76F 16r8F1F 16rE770 16r8F1B 16rE771 16r8F0C 16rE772 16r8F26 16rE773 16r8F33 16rE774 16r8F3B 16rE775 16r8F39 16rE776 16r8F45 16rE777 16r8F42 16rE778 16r8F3E 16rE779 16r8F4C 16rE77A 16r8F49 16rE77B 16r8F46 16rE77C 16r8F4E 16rE77D 16r8F57 16rE77E 16r8F5C 16rE780 16r8F62 16rE781 16r8F63 16rE782 16r8F64 16rE783 16r8F9C 16rE784 16r8F9F 16rE785 16r8FA3 16rE786 16r8FAD 16rE787 16r8FAF 16rE788 16r8FB7 16rE789 16r8FDA 16rE78A 16r8FE5 16rE78B 16r8FE2 16rE78C 16r8FEA 16rE78D 16r8FEF 16rE78E 16r9087 16rE78F 16r8FF4 16rE790 16r9005 16rE791 16r8FF9 16rE792 16r8FFA 16rE793 16r9011 16rE794 16r9015 16rE795 16r9021 16rE796 16r900D 16rE797 16r901E 16rE798 16r9016 16rE799 16r900B 16rE79A 16r9027 16rE79B 16r9036 16rE79C 16r9035 16rE79D 16r9039 16rE79E 16r8FF8 16rE79F 16r904F 16rE7A0 16r9050 16rE7A1 16r9051 16rE7A2 16r9052 16rE7A3 16r900E 16rE7A4 16r9049 16rE7A5 16r903E 16rE7A6 16r9056 16rE7A7 16r9058 16rE7A8 16r905E 16rE7A9 16r9068 16rE7AA 16r906F 16rE7AB 16r9076 16rE7AC 16r96A8 16rE7AD 16r9072 16rE7AE 16r9082 16rE7AF 16r907D 16rE7B0 16r9081 16rE7B1 16r9080 16rE7B2 16r908A 16rE7B3 16r9089 16rE7B4 16r908F 16rE7B5 16r90A8 16rE7B6 16r90AF 16rE7B7 16r90B1 16rE7B8 16r90B5 16rE7B9 16r90E2 16rE7BA 16r90E4 16rE7BB 16r6248 16rE7BC 16r90DB 16rE7BD 16r9102 16rE7BE 16r9112 16rE7BF 16r9119 16rE7C0 16r9132 16rE7C1 16r9130 16rE7C2 16r914A 16rE7C3 16r9156 16rE7C4 16r9158 16rE7C5 16r9163 16rE7C6 16r9165 16rE7C7 16r9169 16rE7C8 16r9173 16rE7C9 16r9172 16rE7CA 16r918B 16rE7CB 16r9189 16rE7CC 16r9182 16rE7CD 16r91A2 16rE7CE 16r91AB 16rE7CF 16r91AF 16rE7D0 16r91AA 16rE7D1 16r91B5 16rE7D2 16r91B4 16rE7D3 16r91BA 16rE7D4 16r91C0 16rE7D5 16r91C1 16rE7D6 16r91C9 16rE7D7 16r91CB 16rE7D8 16r91D0 16rE7D9 16r91D6 16rE7DA 16r91DF 16rE7DB 16r91E1 16rE7DC 16r91DB 16rE7DD 16r91FC 16rE7DE 16r91F5 16rE7DF 16r91F6 16rE7E0 16r921E 16rE7E1 16r91FF 16rE7E2 16r9214 16rE7E3 16r922C 16rE7E4 16r9215 16rE7E5 16r9211 16rE7E6 16r925E 16rE7E7 16r9257 16rE7E8 16r9245 16rE7E9 16r9249 16rE7EA 16r9264 16rE7EB 16r9248 16rE7EC 16r9295 16rE7ED 16r923F 16rE7EE 16r924B 16rE7EF 16r9250 16rE7F0 16r929C 16rE7F1 16r9296 16rE7F2 16r9293 16rE7F3 16r929B 16rE7F4 16r925A 16rE7F5 16r92CF 16rE7F6 16r92B9 16rE7F7 16r92B7 16rE7F8 16r92E9 16rE7F9 16r930F 16rE7FA 16r92FA 16rE7FB 16r9344 16rE7FC 16r932E 16rE840 16r9319 16rE841 16r9322 16rE842 16r931A 16rE843 16r9323 16rE844 16r933A 16rE845 16r9335 16rE846 16r933B 16rE847 16r935C 16rE848 16r9360 16rE849 16r937C 16rE84A 16r936E 16rE84B 16r9356 16rE84C 16r93B0 16rE84D 16r93AC 16rE84E 16r93AD 16rE84F 16r9394 16rE850 16r93B9 16rE851 16r93D6 16rE852 16r93D7 16rE853 16r93E8 16rE854 16r93E5 16rE855 16r93D8 16rE856 16r93C3 16rE857 16r93DD 16rE858 16r93D0 16rE859 16r93C8 16rE85A 16r93E4 16rE85B 16r941A 16rE85C 16r9414 16rE85D 16r9413 16rE85E 16r9403 16rE85F 16r9407 16rE860 16r9410 16rE861 16r9436 16rE862 16r942B 16rE863 16r9435 16rE864 16r9421 16rE865 16r943A 16rE866 16r9441 16rE867 16r9452 16rE868 16r9444 16rE869 16r945B 16rE86A 16r9460 16rE86B 16r9462 16rE86C 16r945E 16rE86D 16r946A 16rE86E 16r9229 16rE86F 16r9470 16rE870 16r9475 16rE871 16r9477 16rE872 16r947D 16rE873 16r945A 16rE874 16r947C 16rE875 16r947E 16rE876 16r9481 16rE877 16r947F 16rE878 16r9582 16rE879 16r9587 16rE87A 16r958A 16rE87B 16r9594 16rE87C 16r9596 16rE87D 16r9598 16rE87E 16r9599 16rE880 16r95A0 16rE881 16r95A8 16rE882 16r95A7 16rE883 16r95AD 16rE884 16r95BC 16rE885 16r95BB 16rE886 16r95B9 16rE887 16r95BE 16rE888 16r95CA 16rE889 16r6FF6 16rE88A 16r95C3 16rE88B 16r95CD 16rE88C 16r95CC 16rE88D 16r95D5 16rE88E 16r95D4 16rE88F 16r95D6 16rE890 16r95DC 16rE891 16r95E1 16rE892 16r95E5 16rE893 16r95E2 16rE894 16r9621 16rE895 16r9628 16rE896 16r962E 16rE897 16r962F 16rE898 16r9642 16rE899 16r964C 16rE89A 16r964F 16rE89B 16r964B 16rE89C 16r9677 16rE89D 16r965C 16rE89E 16r965E 16rE89F 16r965D 16rE8A0 16r965F 16rE8A1 16r9666 16rE8A2 16r9672 16rE8A3 16r966C 16rE8A4 16r968D 16rE8A5 16r9698 16rE8A6 16r9695 16rE8A7 16r9697 16rE8A8 16r96AA 16rE8A9 16r96A7 16rE8AA 16r96B1 16rE8AB 16r96B2 16rE8AC 16r96B0 16rE8AD 16r96B4 16rE8AE 16r96B6 16rE8AF 16r96B8 16rE8B0 16r96B9 16rE8B1 16r96CE 16rE8B2 16r96CB 16rE8B3 16r96C9 16rE8B4 16r96CD 16rE8B5 16r894D 16rE8B6 16r96DC 16rE8B7 16r970D 16rE8B8 16r96D5 16rE8B9 16r96F9 16rE8BA 16r9704 16rE8BB 16r9706 16rE8BC 16r9708 16rE8BD 16r9713 16rE8BE 16r970E 16rE8BF 16r9711 16rE8C0 16r970F 16rE8C1 16r9716 16rE8C2 16r9719 16rE8C3 16r9724 16rE8C4 16r972A 16rE8C5 16r9730 16rE8C6 16r9739 16rE8C7 16r973D 16rE8C8 16r973E 16rE8C9 16r9744 16rE8CA 16r9746 16rE8CB 16r9748 16rE8CC 16r9742 16rE8CD 16r9749 16rE8CE 16r975C 16rE8CF 16r9760 16rE8D0 16r9764 16rE8D1 16r9766 16rE8D2 16r9768 16rE8D3 16r52D2 16rE8D4 16r976B 16rE8D5 16r9771 16rE8D6 16r9779 16rE8D7 16r9785 16rE8D8 16r977C 16rE8D9 16r9781 16rE8DA 16r977A 16rE8DB 16r9786 16rE8DC 16r978B 16rE8DD 16r978F 16rE8DE 16r9790 16rE8DF 16r979C 16rE8E0 16r97A8 16rE8E1 16r97A6 16rE8E2 16r97A3 16rE8E3 16r97B3 16rE8E4 16r97B4 16rE8E5 16r97C3 16rE8E6 16r97C6 16rE8E7 16r97C8 16rE8E8 16r97CB 16rE8E9 16r97DC 16rE8EA 16r97ED 16rE8EB 16r9F4F 16rE8EC 16r97F2 16rE8ED 16r7ADF 16rE8EE 16r97F6 16rE8EF 16r97F5 16rE8F0 16r980F 16rE8F1 16r980C 16rE8F2 16r9838 16rE8F3 16r9824 16rE8F4 16r9821 16rE8F5 16r9837 16rE8F6 16r983D 16rE8F7 16r9846 16rE8F8 16r984F 16rE8F9 16r984B 16rE8FA 16r986B 16rE8FB 16r986F 16rE8FC 16r9870 16rE940 16r9871 16rE941 16r9874 16rE942 16r9873 16rE943 16r98AA 16rE944 16r98AF 16rE945 16r98B1 16rE946 16r98B6 16rE947 16r98C4 16rE948 16r98C3 16rE949 16r98C6 16rE94A 16r98E9 16rE94B 16r98EB 16rE94C 16r9903 16rE94D 16r9909 16rE94E 16r9912 16rE94F 16r9914 16rE950 16r9918 16rE951 16r9921 16rE952 16r991D 16rE953 16r991E 16rE954 16r9924 16rE955 16r9920 16rE956 16r992C 16rE957 16r992E 16rE958 16r993D 16rE959 16r993E 16rE95A 16r9942 16rE95B 16r9949 16rE95C 16r9945 16rE95D 16r9950 16rE95E 16r994B 16rE95F 16r9951 16rE960 16r9952 16rE961 16r994C 16rE962 16r9955 16rE963 16r9997 16rE964 16r9998 16rE965 16r99A5 16rE966 16r99AD 16rE967 16r99AE 16rE968 16r99BC 16rE969 16r99DF 16rE96A 16r99DB 16rE96B 16r99DD 16rE96C 16r99D8 16rE96D 16r99D1 16rE96E 16r99ED 16rE96F 16r99EE 16rE970 16r99F1 16rE971 16r99F2 16rE972 16r99FB 16rE973 16r99F8 16rE974 16r9A01 16rE975 16r9A0F 16rE976 16r9A05 16rE977 16r99E2 16rE978 16r9A19 16rE979 16r9A2B 16rE97A 16r9A37 16rE97B 16r9A45 16rE97C 16r9A42 16rE97D 16r9A40 16rE97E 16r9A43 16rE980 16r9A3E 16rE981 16r9A55 16rE982 16r9A4D 16rE983 16r9A5B 16rE984 16r9A57 16rE985 16r9A5F 16rE986 16r9A62 16rE987 16r9A65 16rE988 16r9A64 16rE989 16r9A69 16rE98A 16r9A6B 16rE98B 16r9A6A 16rE98C 16r9AAD 16rE98D 16r9AB0 16rE98E 16r9ABC 16rE98F 16r9AC0 16rE990 16r9ACF 16rE991 16r9AD1 16rE992 16r9AD3 16rE993 16r9AD4 16rE994 16r9ADE 16rE995 16r9ADF 16rE996 16r9AE2 16rE997 16r9AE3 16rE998 16r9AE6 16rE999 16r9AEF 16rE99A 16r9AEB 16rE99B 16r9AEE 16rE99C 16r9AF4 16rE99D 16r9AF1 16rE99E 16r9AF7 16rE99F 16r9AFB 16rE9A0 16r9B06 16rE9A1 16r9B18 16rE9A2 16r9B1A 16rE9A3 16r9B1F 16rE9A4 16r9B22 16rE9A5 16r9B23 16rE9A6 16r9B25 16rE9A7 16r9B27 16rE9A8 16r9B28 16rE9A9 16r9B29 16rE9AA 16r9B2A 16rE9AB 16r9B2E 16rE9AC 16r9B2F 16rE9AD 16r9B32 16rE9AE 16r9B44 16rE9AF 16r9B43 16rE9B0 16r9B4F 16rE9B1 16r9B4D 16rE9B2 16r9B4E 16rE9B3 16r9B51 16rE9B4 16r9B58 16rE9B5 16r9B74 16rE9B6 16r9B93 16rE9B7 16r9B83 16rE9B8 16r9B91 16rE9B9 16r9B96 16rE9BA 16r9B97 16rE9BB 16r9B9F 16rE9BC 16r9BA0 16rE9BD 16r9BA8 16rE9BE 16r9BB4 16rE9BF 16r9BC0 16rE9C0 16r9BCA 16rE9C1 16r9BB9 16rE9C2 16r9BC6 16rE9C3 16r9BCF 16rE9C4 16r9BD1 16rE9C5 16r9BD2 16rE9C6 16r9BE3 16rE9C7 16r9BE2 16rE9C8 16r9BE4 16rE9C9 16r9BD4 16rE9CA 16r9BE1 16rE9CB 16r9C3A 16rE9CC 16r9BF2 16rE9CD 16r9BF1 16rE9CE 16r9BF0 16rE9CF 16r9C15 16rE9D0 16r9C14 16rE9D1 16r9C09 16rE9D2 16r9C13 16rE9D3 16r9C0C 16rE9D4 16r9C06 16rE9D5 16r9C08 16rE9D6 16r9C12 16rE9D7 16r9C0A 16rE9D8 16r9C04 16rE9D9 16r9C2E 16rE9DA 16r9C1B 16rE9DB 16r9C25 16rE9DC 16r9C24 16rE9DD 16r9C21 16rE9DE 16r9C30 16rE9DF 16r9C47 16rE9E0 16r9C32 16rE9E1 16r9C46 16rE9E2 16r9C3E 16rE9E3 16r9C5A 16rE9E4 16r9C60 16rE9E5 16r9C67 16rE9E6 16r9C76 16rE9E7 16r9C78 16rE9E8 16r9CE7 16rE9E9 16r9CEC 16rE9EA 16r9CF0 16rE9EB 16r9D09 16rE9EC 16r9D08 16rE9ED 16r9CEB 16rE9EE 16r9D03 16rE9EF 16r9D06 16rE9F0 16r9D2A 16rE9F1 16r9D26 16rE9F2 16r9DAF 16rE9F3 16r9D23 16rE9F4 16r9D1F 16rE9F5 16r9D44 16rE9F6 16r9D15 16rE9F7 16r9D12 16rE9F8 16r9D41 16rE9F9 16r9D3F 16rE9FA 16r9D3E 16rE9FB 16r9D46 16rE9FC 16r9D48 16rEA40 16r9D5D 16rEA41 16r9D5E 16rEA42 16r9D64 16rEA43 16r9D51 16rEA44 16r9D50 16rEA45 16r9D59 16rEA46 16r9D72 16rEA47 16r9D89 16rEA48 16r9D87 16rEA49 16r9DAB 16rEA4A 16r9D6F 16rEA4B 16r9D7A 16rEA4C 16r9D9A 16rEA4D 16r9DA4 16rEA4E 16r9DA9 16rEA4F 16r9DB2 16rEA50 16r9DC4 16rEA51 16r9DC1 16rEA52 16r9DBB 16rEA53 16r9DB8 16rEA54 16r9DBA 16rEA55 16r9DC6 16rEA56 16r9DCF 16rEA57 16r9DC2 16rEA58 16r9DD9 16rEA59 16r9DD3 16rEA5A 16r9DF8 16rEA5B 16r9DE6 16rEA5C 16r9DED 16rEA5D 16r9DEF 16rEA5E 16r9DFD 16rEA5F 16r9E1A 16rEA60 16r9E1B 16rEA61 16r9E1E 16rEA62 16r9E75 16rEA63 16r9E79 16rEA64 16r9E7D 16rEA65 16r9E81 16rEA66 16r9E88 16rEA67 16r9E8B 16rEA68 16r9E8C 16rEA69 16r9E92 16rEA6A 16r9E95 16rEA6B 16r9E91 16rEA6C 16r9E9D 16rEA6D 16r9EA5 16rEA6E 16r9EA9 16rEA6F 16r9EB8 16rEA70 16r9EAA 16rEA71 16r9EAD 16rEA72 16r9761 16rEA73 16r9ECC 16rEA74 16r9ECE 16rEA75 16r9ECF 16rEA76 16r9ED0 16rEA77 16r9ED4 16rEA78 16r9EDC 16rEA79 16r9EDE 16rEA7A 16r9EDD 16rEA7B 16r9EE0 16rEA7C 16r9EE5 16rEA7D 16r9EE8 16rEA7E 16r9EEF 16rEA80 16r9EF4 16rEA81 16r9EF6 16rEA82 16r9EF7 16rEA83 16r9EF9 16rEA84 16r9EFB 16rEA85 16r9EFC 16rEA86 16r9EFD 16rEA87 16r9F07 16rEA88 16r9F08 16rEA89 16r76B7 16rEA8A 16r9F15 16rEA8B 16r9F21 16rEA8C 16r9F2C 16rEA8D 16r9F3E 16rEA8E 16r9F4A 16rEA8F 16r9F52 16rEA90 16r9F54 16rEA91 16r9F63 16rEA92 16r9F5F 16rEA93 16r9F60 16rEA94 16r9F61 16rEA95 16r9F66 16rEA96 16r9F67 16rEA97 16r9F6C 16rEA98 16r9F6A 16rEA99 16r9F77 16rEA9A 16r9F72 16rEA9B 16r9F76 16rEA9C 16r9F95 16rEA9D 16r9F9C 16rEA9E 16r9FA0 16rEA9F 16r582F 16rEAA0 16r69C7 16rEAA1 16r9059 16rEAA2 16r7464 16rEAA3 16r51DC 16rEAA4 16r7199).
	(0 to: 16r1F) , #(16r7F) do: 
			[:i | 
			"control-code"
			encoder encode: i asCharacter as: i].
	encoder encode: 16r5C asCharacter as: 16r5C.
	encoder encode: 16r7E asCharacter as: 16r7E.
	encoder name: #ShiftJIS.
	^encoder'</body>

<body package="Jpl" selector="uninstallMiscCharacterSetsInCharacterEncoderClass">uninstallMiscCharacterSetsInCharacterEncoderClass
	self 
		installEnhanceClass: CharacterEncoder class
		protocol: 'private-character set'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'uninstallMiscCharacterSets
	"CharacterEncoder uninstallMiscCharacterSets."

	Encoders == nil 
		ifFalse: 
			[Encoders removeKey: #common ifAbsent: [].
			(Encoders at: #win32) removeKey: #kanji ifAbsent: []]'</body>
</methods>

<methods>
<class-id>JplSystem class</class-id> <category>enhancements WindowsInputManager</category>

<body package="Jpl" selector="initializeInWindowsInputManager">initializeInWindowsInputManager
	self 
		installEnhanceClass: WindowsInputManager
		protocol: 'initialize-release'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'initialize
	self reinitialize'</body>

<body package="Jpl" selector="redefineWindowsInputManager">redefineWindowsInputManager
	Smalltalk.UI 
		defineClass: #WindowsInputManager
		superclass: #{UI.NullInputManager}
		indexedType: #none
		private: false
		instanceVariableNames: 'byteArray '
		classInstanceVariableNames: ''
		imports: '
			UI.WindowsInputManagerDictionary.*
			'
		category: 'Internationalization'
		attributes: #(
			#(#includeFiles #())
			#(#includeDirectories #())
			#(#libraryFiles #())
			#(#libraryDirectories #())
			#(#beVirtual false)
			#(#optimizationLevel #full))</body>

<body package="Jpl" selector="reinitializeInWindowsInputManager">reinitializeInWindowsInputManager
	self 
		installEnhanceClass: WindowsInputManager
		protocol: 'initialize-release'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'reinitialize
	byteArray := ByteArray new: 0.
	^true'</body>

<body package="Jpl" selector="retrieveConvertedTextInWindowsInputManager">retrieveConvertedTextInWindowsInputManager
	self 
		installEnhanceClass: WindowsInputManager
		protocol: 'notification'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'retrieveConvertedText: event 
	| aCharacter anInteger aString |
	aCharacter := event at: 8.
	(aCharacter isKindOf: Character) ifFalse: [^nil].
	(anInteger := aCharacter asInteger) &lt; 32 ifTrue: [^nil].
	byteArray := byteArray copyWith: anInteger.
	aCharacter := (byteArray withEncoding: #default) readStream next.
	aCharacter ifNil: [aString := String new]
		ifNotNil: 
			[:it | 
			self reinitialize.
			aString := String with: it].
	^aString'</body>

<body package="Jpl" selector="styleInWindowsInputManager">styleInWindowsInputManager
	self 
		installEnhanceClass: WindowsInputManager
		protocol: 'private'
		attributes: ((Dictionary new)
				add: #package -&gt; 'Jpl';
				yourself)
		code: 'style
	^InputManager rootStyle'</body>
</methods>

<methods>
<class-id>JplSystem class</class-id> <category>accessing</category>

<body package="Jpl" selector="classes">classes
	"JplSystem classes."

	| definedClasses |
	definedClasses := OrderedCollection new.
	definedClasses add: #{JplStreamEncoder} value.
	definedClasses add: #{JplEucStreamEncoder} value.
	definedClasses add: #{JplJisStreamEncoder} value.
	definedClasses add: #{JplSjisStreamEncoder} value.
	definedClasses add: #{JplAutoStreamEncoder} value.
	definedClasses add: #{JplSystem} value.
	^definedClasses asArray</body>

<body package="Jpl" selector="date">date
	^'2007/11/29' copy</body>

<body package="Jpl" selector="propagateComments">propagateComments
	"JplSystem propagateComments."

	| comment |
	comment := self system , self version , ' (' , self date , ')'.
	self classes do: [:class | class comment: comment].
	(Smalltalk at: self system asSymbol ifAbsent: [nil]) 
		ifNotNil: [:namespace | namespace comment: comment].
	(Parcel parcelNamed: self system) 
		ifNotNil: [:parcel | parcel comment: comment].
	(Store.Registry pundleNamed: self system) 
		ifNotNil: [:pundle | pundle comment: comment].
	(Store.Registry bundleNamed: self system) 
		ifNotNil: [:bundle | bundle allItems do: [:each | each comment: comment]]</body>

<body package="Jpl" selector="releaseVersionOfSmalltalk">releaseVersionOfSmalltalk
	"JplSystem releaseVersionOfSmalltalk."

	^ObjectMemory versionId at: 5</body>

<body package="Jpl" selector="system">system
	^'Jpl' copy</body>

<body package="Jpl" selector="version">version
	^'023' copy</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>JplSystem</class-id>
<body>Jpl022 (2007/03/12)</body>
</comment>

<initialize>
<class-id>JplSystem</class-id>
</initialize>

</st-source>
